/* BluetoothFuse.c generated by valac 0.56.13, the Vala compiler
 * generated from BluetoothFuse.vala, do not modify */

/*
 * Copyright (c) 2023 Fyra Labs
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "fuse-bluetooth.h"
#include <gtk/gtk.h>
#include <libhelium-1.h>
#include "fusebox-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <gmodule.h>

enum  {
	BLUETOOTH_FUSE_0_PROPERTY,
	BLUETOOTH_FUSE_NUM_PROPERTIES
};
static GParamSpec* bluetooth_fuse_properties[BLUETOOTH_FUSE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _BluetoothFuseSearchData BluetoothFuseSearchData;

struct _BluetoothFusePrivate {
	GtkGrid* main_grid;
	HeSwitchBar* status_switch;
	HeAppBar* appbar;
	BluetoothServicesObjectManager* manager;
};

struct _BluetoothFuseSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothFuse* self;
	gchar* search;
	GHashTable* result;
	GHashTable* search_results;
	GHashTable* _tmp0_;
};

static gint BluetoothFuse_private_offset;
static gpointer bluetooth_fuse_parent_class = NULL;

static void _g_free0_ (gpointer var);
static void bluetooth_fuse_connect_manager (BluetoothFuse* self);
static void __lambda23_ (BluetoothFuse* self,
                  BluetoothServicesAdapter* adapter);
static void bluetooth_fuse_update_description (BluetoothFuse* self);
static void ___lambda23__bluetooth_services_object_manager_adapter_added (BluetoothServicesObjectManager* _sender,
                                                                   BluetoothServicesAdapter* adapter,
                                                                   gpointer self);
static void __lambda24_ (BluetoothFuse* self,
                  BluetoothServicesAdapter* adapter);
static void ___lambda24__bluetooth_services_object_manager_adapter_removed (BluetoothServicesObjectManager* _sender,
                                                                     BluetoothServicesAdapter* adapter,
                                                                     gpointer self);
static void __lambda25_ (BluetoothFuse* self);
static void ___lambda25__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda26_ (BluetoothFuse* self);
static void ___lambda26__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static GtkWidget* bluetooth_fuse_real_get_widget (FuseboxFuse* base);
static void ___lambda34_ (BluetoothFuse* self);
static void ____lambda34__bluetooth_main_view_quit_fuse (BluetoothMainView* _sender,
                                                  gpointer self);
static void ___lambda36_ (BluetoothFuse* self);
static void ____lambda36__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void bluetooth_fuse_real_shown (FuseboxFuse* base);
static void bluetooth_fuse_real_hidden (FuseboxFuse* base);
static void __lambda35_ (BluetoothFuse* self);
static void ___lambda35__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
static void bluetooth_fuse_real_search_callback (FuseboxFuse* base,
                                          const gchar* location);
static void bluetooth_fuse_real_search_data_free (gpointer _data);
static void bluetooth_fuse_real_search (FuseboxFuse* base,
                                 const gchar* search,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_);
static gboolean bluetooth_fuse_real_search_co (BluetoothFuseSearchData* _data_);
static void bluetooth_fuse_finalize (GObject * obj);
static GType bluetooth_fuse_get_type_once (void);

static inline gpointer
bluetooth_fuse_get_instance_private (BluetoothFuse* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothFuse_private_offset);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

BluetoothFuse*
bluetooth_fuse_construct (GType object_type)
{
	BluetoothFuse * self = NULL;
	GHashTable* settings = NULL;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	BluetoothServicesObjectManager* _tmp2_;
	_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_free0_);
	settings = _tmp0_;
	_tmp1_ = g_strdup ("bluetooth");
	g_hash_table_insert (settings, _tmp1_, NULL);
	self = (BluetoothFuse*) g_object_new (object_type, "category", FUSEBOX_FUSE_CATEGORY_NETWORK, "code-name", "com.fyralabs.Fusebox.Bluetooth", "display-name", _ ("Bluetooth"), "description", _ ("Configure Bluetooth Settings"), "icon", "settings-bluetooth-symbolic", "supported-settings", settings, "index", 0, NULL);
	_tmp2_ = bluetooth_services_object_manager_new ();
	_g_object_unref0 (self->priv->manager);
	self->priv->manager = _tmp2_;
	_g_hash_table_unref0 (settings);
	return self;
}

BluetoothFuse*
bluetooth_fuse_new (void)
{
	return bluetooth_fuse_construct (BLUETOOTH_TYPE_FUSE);
}

static void
__lambda23_ (BluetoothFuse* self,
             BluetoothServicesAdapter* adapter)
{
	g_return_if_fail (adapter != NULL);
	bluetooth_fuse_update_description (self);
}

static void
___lambda23__bluetooth_services_object_manager_adapter_added (BluetoothServicesObjectManager* _sender,
                                                              BluetoothServicesAdapter* adapter,
                                                              gpointer self)
{
	__lambda23_ ((BluetoothFuse*) self, adapter);
}

static void
__lambda24_ (BluetoothFuse* self,
             BluetoothServicesAdapter* adapter)
{
	BluetoothServicesObjectManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (adapter != NULL);
	_tmp0_ = self->priv->manager;
	_tmp1_ = bluetooth_services_object_manager_get_has_object (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		bluetooth_fuse_update_description (self);
	}
}

static void
___lambda24__bluetooth_services_object_manager_adapter_removed (BluetoothServicesObjectManager* _sender,
                                                                BluetoothServicesAdapter* adapter,
                                                                gpointer self)
{
	__lambda24_ ((BluetoothFuse*) self, adapter);
}

static void
__lambda25_ (BluetoothFuse* self)
{
	bluetooth_fuse_update_description (self);
}

static void
___lambda25__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda25_ ((BluetoothFuse*) self);
}

static void
__lambda26_ (BluetoothFuse* self)
{
	bluetooth_fuse_update_description (self);
}

static void
___lambda26__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda26_ ((BluetoothFuse*) self);
}

static void
bluetooth_fuse_connect_manager (BluetoothFuse* self)
{
	BluetoothServicesObjectManager* _tmp0_;
	HeSwitchBar* _tmp1_;
	BluetoothServicesObjectManager* _tmp2_;
	BluetoothServicesObjectManager* _tmp3_;
	BluetoothServicesObjectManager* _tmp4_;
	BluetoothServicesObjectManager* _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manager;
	_tmp1_ = self->priv->status_switch;
	g_object_bind_property_with_closures ((GObject*) _tmp0_, "is-powered", (GObject*) _tmp1_, "active", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp2_ = self->priv->manager;
	g_signal_connect_object (_tmp2_, "adapter-added", (GCallback) ___lambda23__bluetooth_services_object_manager_adapter_added, self, 0);
	_tmp3_ = self->priv->manager;
	g_signal_connect_object (_tmp3_, "adapter-removed", (GCallback) ___lambda24__bluetooth_services_object_manager_adapter_removed, self, 0);
	_tmp4_ = self->priv->manager;
	g_signal_connect_object ((GObject*) _tmp4_, "notify::discoverable", (GCallback) ___lambda25__g_object_notify, self, 0);
	_tmp5_ = self->priv->manager;
	g_signal_connect_object ((GObject*) _tmp5_, "notify::is-powered", (GCallback) ___lambda26__g_object_notify, self, 0);
}

static void
___lambda34_ (BluetoothFuse* self)
{
	fusebox_fuse_hidden ((FuseboxFuse*) self);
}

static void
____lambda34__bluetooth_main_view_quit_fuse (BluetoothMainView* _sender,
                                             gpointer self)
{
	___lambda34_ ((BluetoothFuse*) self);
}

static void
___lambda36_ (BluetoothFuse* self)
{
	BluetoothServicesObjectManager* _tmp0_;
	HeSwitchBar* _tmp1_;
	GtkSwitch* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	_tmp0_ = self->priv->manager;
	_tmp1_ = self->priv->status_switch;
	_tmp2_ = _tmp1_->main_switch;
	_tmp3_ = gtk_switch_get_active (_tmp2_);
	_tmp4_ = _tmp3_;
	bluetooth_services_object_manager_set_global_state (_tmp0_, _tmp4_, NULL, NULL);
}

static void
____lambda36__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
	___lambda36_ ((BluetoothFuse*) self);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkWidget*
bluetooth_fuse_real_get_widget (FuseboxFuse* base)
{
	BluetoothFuse * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp21_;
	GtkWidget* _tmp22_;
	GtkWidget* result;
	self = (BluetoothFuse*) base;
	_tmp0_ = self->priv->main_grid;
	if (_tmp0_ == NULL) {
		BluetoothMainView* main_view = NULL;
		BluetoothServicesObjectManager* _tmp1_;
		BluetoothMainView* _tmp2_;
		BluetoothMainView* _tmp3_;
		gchar* _tmp4_;
		HeSwitchBar* _tmp5_ = NULL;
		HeSwitchBar* _tmp6_;
		GtkSwitch* _tmp7_;
		BluetoothServicesObjectManager* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		HeSwitchBar* _tmp11_;
		GtkSwitch* _tmp12_;
		HeSwitchBar* _tmp13_;
		GtkWidget* _tmp14_;
		HeAppBar* _tmp15_ = NULL;
		GtkGrid* _tmp16_ = NULL;
		GtkGrid* _tmp17_;
		HeAppBar* _tmp18_;
		GtkGrid* _tmp19_;
		BluetoothMainView* _tmp20_;
		_tmp1_ = self->priv->manager;
		_tmp2_ = bluetooth_main_view_new (_tmp1_);
		g_object_ref_sink (_tmp2_);
		main_view = _tmp2_;
		_tmp3_ = main_view;
		g_signal_connect_object (_tmp3_, "quit-fuse", (GCallback) ____lambda34__bluetooth_main_view_quit_fuse, self, 0);
		_tmp4_ = g_strdup (_ ("Bluetooth"));
		_tmp5_ = he_switch_bar_new ();
		gtk_widget_set_hexpand ((GtkWidget*) _tmp5_, TRUE);
		he_switch_bar_set_title (_tmp5_, _tmp4_);
		_g_free0 (_tmp4_);
		g_object_ref_sink (_tmp5_);
		_g_object_unref0 (self->priv->status_switch);
		self->priv->status_switch = _tmp5_;
		_tmp6_ = self->priv->status_switch;
		_tmp7_ = _tmp6_->main_switch;
		_tmp8_ = self->priv->manager;
		_tmp9_ = bluetooth_services_object_manager_get_is_powered (_tmp8_);
		_tmp10_ = _tmp9_;
		gtk_switch_set_active (_tmp7_, _tmp10_);
		_tmp11_ = self->priv->status_switch;
		_tmp12_ = _tmp11_->main_switch;
		g_signal_connect_object ((GObject*) _tmp12_, "notify::active", (GCallback) ____lambda36__g_object_notify, self, 0);
		_tmp13_ = self->priv->status_switch;
		_tmp14_ = _g_object_ref0 ((GtkWidget*) _tmp13_);
		_tmp15_ = he_app_bar_new ();
		he_app_bar_set_viewtitle_widget (_tmp15_, _tmp14_);
		_g_object_unref0 (_tmp14_);
		he_app_bar_set_show_back (_tmp15_, FALSE);
		gtk_widget_set_hexpand ((GtkWidget*) _tmp15_, TRUE);
		g_object_ref_sink (_tmp15_);
		_g_object_unref0 (self->priv->appbar);
		self->priv->appbar = _tmp15_;
		_tmp16_ = (GtkGrid*) gtk_grid_new ();
		gtk_grid_set_row_spacing (_tmp16_, 12);
		g_object_ref_sink (_tmp16_);
		_g_object_unref0 (self->priv->main_grid);
		self->priv->main_grid = _tmp16_;
		_tmp17_ = self->priv->main_grid;
		_tmp18_ = self->priv->appbar;
		gtk_grid_attach (_tmp17_, (GtkWidget*) _tmp18_, 0, 0, 1, 1);
		_tmp19_ = self->priv->main_grid;
		_tmp20_ = main_view;
		gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 0, 1, 1, 1);
		_g_object_unref0 (main_view);
	}
	bluetooth_fuse_connect_manager (self);
	_tmp21_ = self->priv->main_grid;
	_tmp22_ = _g_object_ref0 ((GtkWidget*) _tmp21_);
	result = _tmp22_;
	return result;
}

static void
bluetooth_fuse_real_shown (FuseboxFuse* base)
{
	BluetoothFuse * self;
	BluetoothServicesObjectManager* _tmp0_;
	GtkGrid* _tmp1_;
	GtkRoot* _tmp2_;
	BluetoothServicesObjectManager* _tmp3_;
	self = (BluetoothFuse*) base;
	_tmp0_ = self->priv->manager;
	_tmp1_ = self->priv->main_grid;
	_tmp2_ = gtk_widget_get_root ((GtkWidget*) _tmp1_);
	bluetooth_services_object_manager_register_agent (_tmp0_, G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_window_get_type ()) ? ((GtkWindow*) _tmp2_) : NULL, NULL, NULL);
	_tmp3_ = self->priv->manager;
	bluetooth_services_object_manager_set_global_state (_tmp3_, TRUE, NULL, NULL);
}

static void
__lambda35_ (BluetoothFuse* self)
{
	GApplication* _tmp0_;
	_tmp0_ = g_application_get_default ();
	g_application_release (_tmp0_);
}

static void
___lambda35__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
	__lambda35_ ((BluetoothFuse*) self);
	g_object_unref (self);
}

static void
bluetooth_fuse_real_hidden (FuseboxFuse* base)
{
	BluetoothFuse * self;
	GApplication* _tmp0_;
	BluetoothServicesObjectManager* _tmp1_;
	BluetoothServicesObjectManager* _tmp2_;
	BluetoothServicesObjectManager* _tmp3_;
	self = (BluetoothFuse*) base;
	_tmp0_ = g_application_get_default ();
	g_application_hold (_tmp0_);
	_tmp1_ = self->priv->manager;
	bluetooth_services_object_manager_unregister_agent (_tmp1_, NULL, NULL);
	_tmp2_ = self->priv->manager;
	bluetooth_services_object_manager_set_discoverable (_tmp2_, FALSE);
	_tmp3_ = self->priv->manager;
	bluetooth_services_object_manager_stop_discovery (_tmp3_, ___lambda35__gasync_ready_callback, g_object_ref (self));
}

static void
bluetooth_fuse_real_search_callback (FuseboxFuse* base,
                                     const gchar* location)
{
	BluetoothFuse * self;
	self = (BluetoothFuse*) base;
	g_return_if_fail (location != NULL);
}

static void
bluetooth_fuse_real_search_data_free (gpointer _data)
{
	BluetoothFuseSearchData* _data_;
	_data_ = _data;
	_g_free0 (_data_->search);
	_g_hash_table_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (BluetoothFuseSearchData, _data_);
}

static void
bluetooth_fuse_real_search (FuseboxFuse* base,
                            const gchar* search,
                            GAsyncReadyCallback _callback_,
                            gpointer _user_data_)
{
	BluetoothFuse * self;
	BluetoothFuseSearchData* _data_;
	BluetoothFuse* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (search != NULL);
	self = (BluetoothFuse*) base;
	_data_ = g_slice_new0 (BluetoothFuseSearchData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_fuse_real_search_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (search);
	_g_free0 (_data_->search);
	_data_->search = _tmp1_;
	bluetooth_fuse_real_search_co (_data_);
}

static GHashTable*
bluetooth_fuse_search_finish (FuseboxFuse* base,
                              GAsyncResult* _res_)
{
	GHashTable* result;
	BluetoothFuseSearchData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static gboolean
bluetooth_fuse_real_search_co (BluetoothFuseSearchData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_free0_);
	_data_->search_results = _data_->_tmp0_;
	_data_->result = _data_->search_results;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
bluetooth_fuse_update_description (BluetoothFuse* self)
{
	gchar* name = NULL;
	BluetoothServicesObjectManager* _tmp0_;
	gchar* _tmp1_;
	gboolean powered = FALSE;
	BluetoothServicesObjectManager* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_ = FALSE;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->manager;
	_tmp1_ = bluetooth_services_object_manager_get_name (_tmp0_);
	name = _tmp1_;
	_tmp2_ = self->priv->manager;
	_tmp3_ = bluetooth_services_object_manager_get_is_powered (_tmp2_);
	_tmp4_ = _tmp3_;
	powered = _tmp4_;
	if (powered) {
		BluetoothServicesObjectManager* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
		_tmp6_ = self->priv->manager;
		_tmp7_ = bluetooth_services_object_manager_get_discoverable (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp5_ = _tmp8_;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		const gchar* _tmp9_ = NULL;
		const gchar* _tmp10_;
		HeSwitchBar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		_tmp10_ = name;
		_tmp9_ = _tmp10_;
		if (_tmp9_ == NULL) {
			_tmp9_ = _ ("Unknown");
		}
		_tmp11_ = self->priv->status_switch;
		_tmp12_ = g_strdup_printf (_ ("Now discoverable as \"%s\"."), _tmp9_);
		_tmp13_ = _tmp12_;
		he_switch_bar_set_subtitle (_tmp11_, _tmp13_);
		_g_free0 (_tmp13_);
	} else {
		if (!powered) {
			HeSwitchBar* _tmp14_;
			_tmp14_ = self->priv->status_switch;
			he_switch_bar_set_subtitle (_tmp14_, _ ("Not discoverable while Bluetooth is powered off."));
		} else {
			HeSwitchBar* _tmp15_;
			_tmp15_ = self->priv->status_switch;
			he_switch_bar_set_subtitle (_tmp15_, _ ("Not discoverable."));
		}
	}
	_g_free0 (name);
}

static void
bluetooth_fuse_class_init (BluetoothFuseClass * klass,
                           gpointer klass_data)
{
	bluetooth_fuse_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BluetoothFuse_private_offset);
	((FuseboxFuseClass *) klass)->get_widget = (GtkWidget* (*) (FuseboxFuse*)) bluetooth_fuse_real_get_widget;
	((FuseboxFuseClass *) klass)->shown = (void (*) (FuseboxFuse*)) bluetooth_fuse_real_shown;
	((FuseboxFuseClass *) klass)->hidden = (void (*) (FuseboxFuse*)) bluetooth_fuse_real_hidden;
	((FuseboxFuseClass *) klass)->search_callback = (void (*) (FuseboxFuse*, const gchar*)) bluetooth_fuse_real_search_callback;
	((FuseboxFuseClass *) klass)->search = (void (*) (FuseboxFuse*, const gchar*, GAsyncReadyCallback, gpointer)) bluetooth_fuse_real_search;
	((FuseboxFuseClass *) klass)->search_finish = (GHashTable* (*) (FuseboxFuse*, GAsyncResult*)) bluetooth_fuse_search_finish;
	G_OBJECT_CLASS (klass)->finalize = bluetooth_fuse_finalize;
}

static void
bluetooth_fuse_instance_init (BluetoothFuse * self,
                              gpointer klass)
{
	self->priv = bluetooth_fuse_get_instance_private (self);
}

static void
bluetooth_fuse_finalize (GObject * obj)
{
	BluetoothFuse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_FUSE, BluetoothFuse);
	_g_object_unref0 (self->priv->main_grid);
	_g_object_unref0 (self->priv->status_switch);
	_g_object_unref0 (self->priv->appbar);
	_g_object_unref0 (self->priv->manager);
	G_OBJECT_CLASS (bluetooth_fuse_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
bluetooth_fuse_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothFuseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_fuse_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothFuse), 0, (GInstanceInitFunc) bluetooth_fuse_instance_init, NULL };
	GType bluetooth_fuse_type_id;
	bluetooth_fuse_type_id = g_type_register_static (FUSEBOX_TYPE_FUSE, "BluetoothFuse", &g_define_type_info, 0);
	BluetoothFuse_private_offset = g_type_add_instance_private (bluetooth_fuse_type_id, sizeof (BluetoothFusePrivate));
	return bluetooth_fuse_type_id;
}

GType
bluetooth_fuse_get_type (void)
{
	static gsize bluetooth_fuse_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_fuse_type_id__once)) {
		GType bluetooth_fuse_type_id;
		bluetooth_fuse_type_id = bluetooth_fuse_get_type_once ();
		g_once_init_leave (&bluetooth_fuse_type_id__once, bluetooth_fuse_type_id);
	}
	return bluetooth_fuse_type_id__once;
}

FuseboxFuse*
get_fuse (GModule* module)
{
	BluetoothFuse* fuse = NULL;
	BluetoothFuse* _tmp0_;
	FuseboxFuse* result;
	g_return_val_if_fail (module != NULL, NULL);
	g_debug ("BluetoothFuse.vala:136: Activating Bluetooth fuse");
	_tmp0_ = bluetooth_fuse_new ();
	fuse = _tmp0_;
	result = (FuseboxFuse*) fuse;
	return result;
}

