/* DeviceRow.c generated by valac 0.56.13, the Vala compiler
 * generated from DeviceRow.vala, do not modify */

/*
 * Copyright (c) 2023 Fyra Labs
 * Copyright (c) 2016-2022 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "fuse-bluetooth.h"
#include <libhelium-1.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <float.h>
#include <math.h>
#include <pango/pango.h>

enum  {
	BLUETOOTH_DEVICE_ROW_0_PROPERTY,
	BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY,
	BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY,
	BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES
};
static GParamSpec* bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_NUM_PROPERTIES];
typedef enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED,
	BLUETOOTH_DEVICE_ROW_STATUS_PAIRING,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING,
	BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT,
	BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED
} BluetoothDeviceRowStatus;

#define BLUETOOTH_DEVICE_ROW_TYPE_STATUS (bluetooth_device_row_status_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _BluetoothDeviceRowButtonClickedData BluetoothDeviceRowButtonClickedData;
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block1Data Block1Data;
#define _g_variant_type_free0(var) ((var == NULL) ? NULL : (var = (g_variant_type_free (var), NULL)))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
enum  {
	BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL,
	BLUETOOTH_DEVICE_ROW_NUM_SIGNALS
};
static guint bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_NUM_SIGNALS] = {0};

struct _BluetoothDeviceRowPrivate {
	BluetoothServicesDevice* _device;
	BluetoothServicesAdapter* _adapter;
	HeFillButton* connect_button;
	HeTintButton* forget_button;
	HeModifierBadge* state;
	GtkLabel* state_label;
	GtkLinkButton* settings_button;
};

struct _BluetoothDeviceRowButtonClickedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	BluetoothDeviceRow* self;
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	HeModifierBadge* _tmp3_;
	BluetoothServicesDevice* _tmp4_;
	GError* e;
	HeModifierBadge* _tmp5_;
	GError* _tmp6_;
	const gchar* _tmp7_;
	BluetoothServicesDevice* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	HeModifierBadge* _tmp11_;
	BluetoothServicesDevice* _tmp12_;
	GError* _vala1_e;
	HeModifierBadge* _tmp13_;
	GError* _tmp14_;
	const gchar* _tmp15_;
	HeModifierBadge* _tmp16_;
	BluetoothServicesDevice* _tmp17_;
	GError* _vala2_e;
	GError* _tmp18_;
	const gchar* _tmp19_;
	GError* _inner_error0_;
};

struct _Block1Data {
	int _ref_count_;
	BluetoothDeviceRow* self;
	GtkImage* image;
	GtkLabel* label;
};

static gint BluetoothDeviceRow_private_offset;
static gpointer bluetooth_device_row_parent_class = NULL;
static GtkSizeGroup* bluetooth_device_row_size_group;
static GtkSizeGroup* bluetooth_device_row_size_group = NULL;

static GType bluetooth_device_row_status_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static gchar* bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self);
static void bluetooth_device_row_button_clicked_data_free (gpointer _data);
static void bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                                 GAsyncResult* _res_);
static gboolean bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_);
static void bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                      BluetoothDeviceRowStatus status);
static void bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void bluetooth_device_row_compute_status (BluetoothDeviceRow* self);
static GObject * bluetooth_device_row_constructor (GType type,
                                            guint n_construct_properties,
                                            GObjectConstructParam * construct_properties);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static void _bluetooth_device_row___lambda27_ (BluetoothDeviceRow* self,
                                        GVariant* changed,
                                        gchar** invalid);
static void __bluetooth_device_row___lambda27__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self);
static void _bluetooth_device_row___lambda28_ (Block1Data* _data1_,
                                        GVariant* changed,
                                        gchar** invalid);
static void __bluetooth_device_row___lambda28__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                           GVariant* changed_properties,
                                                                           gchar** invalidated_properties,
                                                                           gpointer self);
static void _bluetooth_device_row___lambda29_ (BluetoothDeviceRow* self);
static void __bluetooth_device_row___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void _bluetooth_device_row___lambda30_ (BluetoothDeviceRow* self);
static void __bluetooth_device_row___lambda30__gtk_button_clicked (GtkButton* _sender,
                                                            gpointer self);
static void bluetooth_device_row_finalize (GObject * obj);
static GType bluetooth_device_row_get_type_once (void);
static void _vala_bluetooth_device_row_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_bluetooth_device_row_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

static inline gpointer
bluetooth_device_row_get_instance_private (BluetoothDeviceRow* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothDeviceRow_private_offset);
}

static gchar*
bluetooth_device_row_status_to_string (BluetoothDeviceRowStatus self)
{
	gchar* result;
	switch (self) {
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
		{
			gchar* _tmp0_;
			_tmp0_ = g_strdup (_ ("Available"));
			result = _tmp0_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
		{
			gchar* _tmp1_;
			_tmp1_ = g_strdup (_ ("Pairing…"));
			result = _tmp1_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
		{
			gchar* _tmp2_;
			_tmp2_ = g_strdup (_ ("Connected"));
			result = _tmp2_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
		{
			gchar* _tmp3_;
			_tmp3_ = g_strdup (_ ("Connecting…"));
			result = _tmp3_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
		{
			gchar* _tmp4_;
			_tmp4_ = g_strdup (_ ("Disconnecting…"));
			result = _tmp4_;
			return result;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED:
		{
			gchar* _tmp5_;
			_tmp5_ = g_strdup (_ ("Unable to Connect"));
			result = _tmp5_;
			return result;
		}
		default:
		{
			gchar* _tmp6_;
			_tmp6_ = g_strdup (_ ("Not Connected"));
			result = _tmp6_;
			return result;
		}
	}
}

 G_GNUC_NO_INLINE static GType
bluetooth_device_row_status_get_type_once (void)
{
	static const GEnumValue values[] = {{BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED, "BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED", "unpaired"}, {BLUETOOTH_DEVICE_ROW_STATUS_PAIRING, "BLUETOOTH_DEVICE_ROW_STATUS_PAIRING", "pairing"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED", "connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING", "connecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING, "BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING", "disconnecting"}, {BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED, "BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED", "not-connected"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT", "unable-to-connect"}, {BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED, "BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED", "unable-to-connect-paired"}, {0, NULL, NULL}};
	GType bluetooth_device_row_status_type_id;
	bluetooth_device_row_status_type_id = g_enum_register_static ("BluetoothDeviceRowStatus", values);
	return bluetooth_device_row_status_type_id;
}

static GType
bluetooth_device_row_status_get_type (void)
{
	static gsize bluetooth_device_row_status_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_device_row_status_type_id__once)) {
		GType bluetooth_device_row_status_type_id;
		bluetooth_device_row_status_type_id = bluetooth_device_row_status_get_type_once ();
		g_once_init_leave (&bluetooth_device_row_status_type_id__once, bluetooth_device_row_status_type_id);
	}
	return bluetooth_device_row_status_type_id__once;
}

BluetoothDeviceRow*
bluetooth_device_row_construct (GType object_type,
                                BluetoothServicesDevice* device,
                                BluetoothServicesAdapter* adapter)
{
	BluetoothDeviceRow * self = NULL;
	g_return_val_if_fail (device != NULL, NULL);
	g_return_val_if_fail (adapter != NULL, NULL);
	self = (BluetoothDeviceRow*) g_object_new (object_type, "device", device, "adapter", adapter, NULL);
	return self;
}

BluetoothDeviceRow*
bluetooth_device_row_new (BluetoothServicesDevice* device,
                          BluetoothServicesAdapter* adapter)
{
	return bluetooth_device_row_construct (BLUETOOTH_TYPE_DEVICE_ROW, device, adapter);
}

static void
bluetooth_device_row_button_clicked_data_free (gpointer _data)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (BluetoothDeviceRowButtonClickedData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
bluetooth_device_row_button_clicked (BluetoothDeviceRow* self,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	BluetoothDeviceRow* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (BluetoothDeviceRowButtonClickedData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, bluetooth_device_row_button_clicked_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	bluetooth_device_row_button_clicked_co (_data_);
}

static void
bluetooth_device_row_button_clicked_finish (BluetoothDeviceRow* self,
                                            GAsyncResult* _res_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
bluetooth_device_row_button_clicked_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	BluetoothDeviceRowButtonClickedData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	bluetooth_device_row_button_clicked_co (_data_);
}

static gboolean
bluetooth_device_row_button_clicked_co (BluetoothDeviceRowButtonClickedData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		case 2:
		goto _state_2;
		case 3:
		goto _state_3;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = _data_->self->priv->_device;
	_data_->_tmp1_ = bluetooth_services_device_get_paired (_data_->_tmp0_);
	_data_->_tmp2_ = _data_->_tmp1_;
	if (!_data_->_tmp2_) {
		bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_PAIRING);
		_data_->_tmp3_ = _data_->self->priv->state;
		gtk_widget_set_visible ((GtkWidget*) _data_->_tmp3_, TRUE);
		{
			_data_->_tmp4_ = _data_->self->priv->_device;
			_data_->_state_ = 1;
			bluetooth_services_device_pair (_data_->_tmp4_, bluetooth_device_row_button_clicked_ready, _data_);
			return FALSE;
			_state_1:
			bluetooth_services_device_pair_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error0_);
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			_data_->e = _data_->_inner_error0_;
			_data_->_inner_error0_ = NULL;
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT);
			_data_->_tmp5_ = _data_->self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _data_->_tmp5_, FALSE);
			_data_->_tmp6_ = _data_->e;
			_data_->_tmp7_ = _data_->_tmp6_->message;
			g_critical ("DeviceRow.vala:253: %s", _data_->_tmp7_);
			_g_error_free0 (_data_->e);
		}
		__finally0:
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
			g_clear_error (&_data_->_inner_error0_);
			g_object_unref (_data_->_async_result);
			return FALSE;
		}
	} else {
		_data_->_tmp8_ = _data_->self->priv->_device;
		_data_->_tmp9_ = bluetooth_services_device_get_connected (_data_->_tmp8_);
		_data_->_tmp10_ = _data_->_tmp9_;
		if (!_data_->_tmp10_) {
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING);
			_data_->_tmp11_ = _data_->self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _data_->_tmp11_, TRUE);
			{
				_data_->_tmp12_ = _data_->self->priv->_device;
				_data_->_state_ = 2;
				bluetooth_services_device_connect (_data_->_tmp12_, bluetooth_device_row_button_clicked_ready, _data_);
				return FALSE;
				_state_2:
				bluetooth_services_device_connect_finish (_data_->_tmp12_, _data_->_res_, &_data_->_inner_error0_);
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					goto __catch1_g_error;
				}
			}
			goto __finally1;
			__catch1_g_error:
			{
				_data_->_vala1_e = _data_->_inner_error0_;
				_data_->_inner_error0_ = NULL;
				bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED);
				_data_->_tmp13_ = _data_->self->priv->state;
				gtk_widget_set_visible ((GtkWidget*) _data_->_tmp13_, FALSE);
				_data_->_tmp14_ = _data_->_vala1_e;
				_data_->_tmp15_ = _data_->_tmp14_->message;
				g_critical ("DeviceRow.vala:263: %s", _data_->_tmp15_);
				_g_error_free0 (_data_->_vala1_e);
			}
			__finally1:
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		} else {
			bluetooth_device_row_set_status (_data_->self, BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING);
			_data_->_tmp16_ = _data_->self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _data_->_tmp16_, FALSE);
			{
				_data_->_tmp17_ = _data_->self->priv->_device;
				_data_->_state_ = 3;
				bluetooth_services_device_disconnect (_data_->_tmp17_, bluetooth_device_row_button_clicked_ready, _data_);
				return FALSE;
				_state_3:
				bluetooth_services_device_disconnect_finish (_data_->_tmp17_, _data_->_res_, &_data_->_inner_error0_);
				if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
					goto __catch2_g_error;
				}
			}
			goto __finally2;
			__catch2_g_error:
			{
				_data_->_vala2_e = _data_->_inner_error0_;
				_data_->_inner_error0_ = NULL;
				_data_->_tmp18_ = _data_->_vala2_e;
				_data_->_tmp19_ = _data_->_tmp18_->message;
				g_critical ("DeviceRow.vala:271: %s", _data_->_tmp19_);
				_g_error_free0 (_data_->_vala2_e);
			}
			__finally2:
			if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
				g_clear_error (&_data_->_inner_error0_);
				g_object_unref (_data_->_async_result);
				return FALSE;
			}
		}
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
bluetooth_device_row_compute_status (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = bluetooth_services_device_get_paired (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED);
	} else {
		BluetoothServicesDevice* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
		_tmp3_ = self->priv->_device;
		_tmp4_ = bluetooth_services_device_get_connected (_tmp3_);
		_tmp5_ = _tmp4_;
		if (_tmp5_) {
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED);
		} else {
			bluetooth_device_row_set_status (self, BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED);
		}
	}
}

static void
bluetooth_device_row_set_status (BluetoothDeviceRow* self,
                                 BluetoothDeviceRowStatus status)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->state_label;
	_tmp1_ = bluetooth_device_row_status_to_string (status);
	_tmp2_ = _tmp1_;
	_tmp3_ = g_markup_printf_escaped ("%s", _tmp2_);
	_tmp4_ = _tmp3_;
	gtk_label_set_label (_tmp0_, _tmp4_);
	_g_free0 (_tmp4_);
	_g_free0 (_tmp2_);
	switch (status) {
		case BLUETOOTH_DEVICE_ROW_STATUS_UNPAIRED:
		{
			HeFillButton* _tmp5_;
			HeFillButton* _tmp6_;
			GtkLinkButton* _tmp7_;
			HeModifierBadge* _tmp8_;
			HeTintButton* _tmp9_;
			_tmp5_ = self->priv->connect_button;
			gtk_button_set_label ((GtkButton*) _tmp5_, _ ("Pair"));
			_tmp6_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, TRUE);
			_tmp7_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp7_, FALSE);
			_tmp8_ = self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _tmp8_, FALSE);
			_tmp9_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp9_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_PAIRING:
		{
			HeFillButton* _tmp10_;
			GtkLinkButton* _tmp11_;
			HeTintButton* _tmp12_;
			_tmp10_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
			_tmp11_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp11_, FALSE);
			_tmp12_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp12_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTED:
		{
			HeFillButton* _tmp13_;
			HeFillButton* _tmp14_;
			GtkLinkButton* _tmp15_;
			const gchar* _tmp16_;
			const gchar* _tmp17_;
			HeTintButton* _tmp19_;
			HeTintButton* _tmp20_;
			HeModifierBadge* _tmp21_;
			_tmp13_ = self->priv->connect_button;
			gtk_button_set_label ((GtkButton*) _tmp13_, _ ("Disconnect"));
			_tmp14_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp14_, TRUE);
			_tmp15_ = self->priv->settings_button;
			_tmp16_ = gtk_link_button_get_uri (_tmp15_);
			_tmp17_ = _tmp16_;
			if (g_strcmp0 (_tmp17_, "") != 0) {
				GtkLinkButton* _tmp18_;
				_tmp18_ = self->priv->settings_button;
				gtk_widget_set_visible ((GtkWidget*) _tmp18_, TRUE);
			}
			_tmp19_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, TRUE);
			_tmp20_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp20_, TRUE);
			_tmp21_ = self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _tmp21_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_CONNECTING:
		{
			HeFillButton* _tmp22_;
			GtkLinkButton* _tmp23_;
			HeTintButton* _tmp24_;
			HeTintButton* _tmp25_;
			_tmp22_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp22_, FALSE);
			_tmp23_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp23_, FALSE);
			_tmp24_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, FALSE);
			_tmp25_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp25_, TRUE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_DISCONNECTING:
		{
			HeFillButton* _tmp26_;
			GtkLinkButton* _tmp27_;
			HeTintButton* _tmp28_;
			HeTintButton* _tmp29_;
			_tmp26_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp26_, FALSE);
			_tmp27_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp27_, FALSE);
			_tmp28_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp28_, FALSE);
			_tmp29_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp29_, TRUE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_NOT_CONNECTED:
		{
			HeFillButton* _tmp30_;
			HeFillButton* _tmp31_;
			GtkLinkButton* _tmp32_;
			HeTintButton* _tmp33_;
			HeTintButton* _tmp34_;
			HeModifierBadge* _tmp35_;
			_tmp30_ = self->priv->connect_button;
			gtk_button_set_label ((GtkButton*) _tmp30_, _ ("Connect"));
			_tmp31_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp31_, TRUE);
			_tmp32_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp32_, FALSE);
			_tmp33_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp33_, TRUE);
			_tmp34_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp34_, TRUE);
			_tmp35_ = self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _tmp35_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT:
		{
			HeFillButton* _tmp36_;
			GtkLinkButton* _tmp37_;
			HeTintButton* _tmp38_;
			HeModifierBadge* _tmp39_;
			_tmp36_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp36_, TRUE);
			_tmp37_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp37_, FALSE);
			_tmp38_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp38_, FALSE);
			_tmp39_ = self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _tmp39_, FALSE);
			break;
		}
		case BLUETOOTH_DEVICE_ROW_STATUS_UNABLE_TO_CONNECT_PAIRED:
		{
			HeFillButton* _tmp40_;
			GtkLinkButton* _tmp41_;
			HeTintButton* _tmp42_;
			HeTintButton* _tmp43_;
			HeModifierBadge* _tmp44_;
			_tmp40_ = self->priv->connect_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp40_, TRUE);
			_tmp41_ = self->priv->settings_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp41_, FALSE);
			_tmp42_ = self->priv->forget_button;
			gtk_widget_set_sensitive ((GtkWidget*) _tmp42_, TRUE);
			_tmp43_ = self->priv->forget_button;
			gtk_widget_set_visible ((GtkWidget*) _tmp43_, TRUE);
			_tmp44_ = self->priv->state;
			gtk_widget_set_visible ((GtkWidget*) _tmp44_, FALSE);
			break;
		}
		default:
		break;
	}
	g_signal_emit (self, bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL], 0);
}

BluetoothServicesDevice*
bluetooth_device_row_get_device (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* result;
	BluetoothServicesDevice* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_device;
	result = _tmp0_;
	return result;
}

static void
bluetooth_device_row_set_device (BluetoothDeviceRow* self,
                                 BluetoothServicesDevice* value)
{
	BluetoothServicesDevice* old_value;
	g_return_if_fail (self != NULL);
	old_value = bluetooth_device_row_get_device (self);
	if (old_value != value) {
		BluetoothServicesDevice* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_device);
		self->priv->_device = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY]);
	}
}

BluetoothServicesAdapter*
bluetooth_device_row_get_adapter (BluetoothDeviceRow* self)
{
	BluetoothServicesAdapter* result;
	BluetoothServicesAdapter* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_adapter;
	result = _tmp0_;
	return result;
}

static void
bluetooth_device_row_set_adapter (BluetoothDeviceRow* self,
                                  BluetoothServicesAdapter* value)
{
	BluetoothServicesAdapter* old_value;
	g_return_if_fail (self != NULL);
	old_value = bluetooth_device_row_get_adapter (self);
	if (old_value != value) {
		self->priv->_adapter = value;
		g_object_notify_by_pspec ((GObject *) self, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY]);
	}
}

static Block1Data*
block1_data_ref (Block1Data* _data1_)
{
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}

static void
block1_data_unref (void * _userdata_)
{
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		BluetoothDeviceRow* self;
		self = _data1_->self;
		_g_object_unref0 (_data1_->label);
		_g_object_unref0 (_data1_->image);
		_g_object_unref0 (self);
		g_slice_free (Block1Data, _data1_);
	}
}

static void
_bluetooth_device_row___lambda27_ (BluetoothDeviceRow* self,
                                   GVariant* changed,
                                   gchar** invalid)
{
	GVariant* powered = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	g_return_if_fail (changed != NULL);
	_tmp0_ = g_variant_type_new ("b");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_lookup_value (changed, "Powered", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	powered = _tmp3_;
	_tmp4_ = powered;
	if (_tmp4_ != NULL) {
		BluetoothServicesAdapter* _tmp5_;
		gboolean _tmp6_;
		gboolean _tmp7_;
		_tmp5_ = self->priv->_adapter;
		_tmp6_ = bluetooth_services_adapter_get_powered (_tmp5_);
		_tmp7_ = _tmp6_;
		gtk_widget_set_sensitive ((GtkWidget*) self, _tmp7_);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_g_variant_unref0 (powered);
}

static void
__bluetooth_device_row___lambda27__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                      GVariant* changed_properties,
                                                                      gchar** invalidated_properties,
                                                                      gpointer self)
{
	_bluetooth_device_row___lambda27_ ((BluetoothDeviceRow*) self, changed_properties, invalidated_properties);
}

static void
_bluetooth_device_row___lambda28_ (Block1Data* _data1_,
                                   GVariant* changed,
                                   gchar** invalid)
{
	BluetoothDeviceRow* self;
	GVariant* paired = NULL;
	GVariantType* _tmp0_;
	GVariantType* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant* _tmp4_;
	GVariant* connected = NULL;
	GVariantType* _tmp6_;
	GVariantType* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* _tmp10_;
	GVariant* name = NULL;
	GVariantType* _tmp11_;
	GVariantType* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	GVariant* _tmp15_;
	GVariant* icon = NULL;
	GVariantType* _tmp21_;
	GVariantType* _tmp22_;
	GVariant* _tmp23_;
	GVariant* _tmp24_;
	GVariant* _tmp25_;
	self = _data1_->self;
	g_return_if_fail (changed != NULL);
	_tmp0_ = g_variant_type_new ("b");
	_tmp1_ = _tmp0_;
	_tmp2_ = g_variant_lookup_value (changed, "Paired", _tmp1_);
	_tmp3_ = _tmp2_;
	_g_variant_type_free0 (_tmp1_);
	paired = _tmp3_;
	_tmp4_ = paired;
	if (_tmp4_ != NULL) {
		BluetoothServicesDevice* _tmp5_;
		bluetooth_device_row_compute_status (self);
		_tmp5_ = self->priv->_device;
		bluetooth_services_device_connect (_tmp5_, NULL, NULL);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_tmp6_ = g_variant_type_new ("b");
	_tmp7_ = _tmp6_;
	_tmp8_ = g_variant_lookup_value (changed, "Connected", _tmp7_);
	_tmp9_ = _tmp8_;
	_g_variant_type_free0 (_tmp7_);
	connected = _tmp9_;
	_tmp10_ = connected;
	if (_tmp10_ != NULL) {
		bluetooth_device_row_compute_status (self);
		gtk_list_box_row_changed ((GtkListBoxRow*) self);
	}
	_tmp11_ = g_variant_type_new ("s");
	_tmp12_ = _tmp11_;
	_tmp13_ = g_variant_lookup_value (changed, "Name", _tmp12_);
	_tmp14_ = _tmp13_;
	_g_variant_type_free0 (_tmp12_);
	name = _tmp14_;
	_tmp15_ = name;
	if (_tmp15_ != NULL) {
		GtkLabel* _tmp16_;
		BluetoothServicesDevice* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		_tmp16_ = _data1_->label;
		_tmp17_ = self->priv->_device;
		_tmp18_ = bluetooth_services_device_get_name (_tmp17_);
		_tmp19_ = _tmp18_;
		_tmp20_ = _tmp19_;
		gtk_label_set_label (_tmp16_, _tmp20_);
		_g_free0 (_tmp20_);
	}
	_tmp21_ = g_variant_type_new ("s");
	_tmp22_ = _tmp21_;
	_tmp23_ = g_variant_lookup_value (changed, "Icon", _tmp22_);
	_tmp24_ = _tmp23_;
	_g_variant_type_free0 (_tmp22_);
	icon = _tmp24_;
	_tmp25_ = icon;
	if (_tmp25_ != NULL) {
		gchar* _tmp26_ = NULL;
		BluetoothServicesDevice* _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		GtkImage* _tmp34_;
		_tmp27_ = self->priv->_device;
		_tmp28_ = bluetooth_services_device_get_icon (_tmp27_);
		_tmp29_ = _tmp28_;
		_tmp30_ = _tmp29_;
		_tmp31_ = g_strconcat (_tmp30_, "-symbolic", NULL);
		_tmp32_ = _tmp31_;
		_g_free0 (_tmp30_);
		_tmp26_ = _tmp32_;
		if (_tmp26_ == NULL) {
			gchar* _tmp33_;
			_tmp33_ = g_strdup ("settings-bluetooth-symbolic");
			_g_free0 (_tmp26_);
			_tmp26_ = _tmp33_;
		}
		_tmp34_ = _data1_->image;
		g_object_set (_tmp34_, "icon-name", _tmp26_, NULL);
		_g_free0 (_tmp26_);
	}
	_g_variant_unref0 (icon);
	_g_variant_unref0 (name);
	_g_variant_unref0 (connected);
	_g_variant_unref0 (paired);
}

static void
__bluetooth_device_row___lambda28__g_dbus_proxy_g_properties_changed (GDBusProxy* _sender,
                                                                      GVariant* changed_properties,
                                                                      gchar** invalidated_properties,
                                                                      gpointer self)
{
	_bluetooth_device_row___lambda28_ (self, changed_properties, invalidated_properties);
}

static void
_bluetooth_device_row___lambda29_ (BluetoothDeviceRow* self)
{
	BluetoothServicesDevice* _tmp0_;
	BluetoothServicesDevice* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	bluetooth_device_row_button_clicked (self, NULL, NULL);
	_tmp0_ = self->priv->_device;
	_tmp1_ = self->priv->_device;
	_tmp2_ = bluetooth_services_device_get_paired (_tmp1_);
	_tmp3_ = _tmp2_;
	bluetooth_services_device_set_trusted (_tmp0_, _tmp3_);
}

static void
__bluetooth_device_row___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	_bluetooth_device_row___lambda29_ ((BluetoothDeviceRow*) self);
}

static void
_bluetooth_device_row___lambda30_ (BluetoothDeviceRow* self)
{
	GError* _inner_error0_ = NULL;
	{
		BluetoothServicesAdapter* _tmp0_;
		BluetoothServicesDevice* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		char* _tmp5_;
		char* _tmp6_;
		_tmp0_ = self->priv->_adapter;
		_tmp1_ = self->priv->_device;
		g_object_get (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, g_dbus_proxy_get_type (), GDBusProxy), "g-object-path", &_tmp2_, NULL);
		_tmp3_ = _tmp2_;
		_tmp4_ = _tmp3_;
		_tmp5_ = g_strdup (_tmp4_);
		_tmp6_ = _tmp5_;
		bluetooth_services_adapter_remove_device (_tmp0_, _tmp6_, &_inner_error0_);
		_g_free0 (_tmp6_);
		_g_free0 (_tmp4_);
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp7_;
		const gchar* _tmp8_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp7_ = e;
		_tmp8_ = _tmp7_->message;
		g_debug ("DeviceRow.vala:238: Forget bluetooth device failed: %s", _tmp8_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
}

static void
__bluetooth_device_row___lambda30__gtk_button_clicked (GtkButton* _sender,
                                                       gpointer self)
{
	_bluetooth_device_row___lambda30_ ((BluetoothDeviceRow*) self);
}

static GObject *
bluetooth_device_row_constructor (GType type,
                                  guint n_construct_properties,
                                  GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothDeviceRow * self;
	Block1Data* _data1_;
	gchar* _tmp0_ = NULL;
	BluetoothServicesDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkImage* _tmp8_ = NULL;
	HeModifierBadge* _tmp9_;
	HeModifierBadge* _tmp10_;
	HeModifierBadge* _tmp11_;
	HeModifierBadge* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* _tmp16_;
	GtkOverlay* overlay = NULL;
	GtkImage* _tmp17_;
	GtkWidget* _tmp18_;
	BluetoothServicesDevice* _tmp19_;
	gchar* _tmp20_;
	gchar* _tmp21_;
	GtkOverlay* _tmp22_ = NULL;
	GtkOverlay* _tmp23_;
	HeModifierBadge* _tmp24_;
	gchar* device_name = NULL;
	BluetoothServicesDevice* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	const gchar* _tmp28_;
	const gchar* _tmp53_;
	GtkLabel* _tmp54_ = NULL;
	GtkLabel* _tmp55_;
	GtkImage* _tmp56_;
	GtkLinkButton* _tmp57_ = NULL;
	GtkLinkButton* _tmp58_;
	gchar* _tmp59_;
	gchar* _tmp60_;
	HeTintButton* _tmp61_ = NULL;
	HeFillButton* _tmp62_ = NULL;
	GtkSizeGroup* _tmp63_;
	HeFillButton* _tmp64_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp65_ = NULL;
	GtkGrid* _tmp66_;
	GtkOverlay* _tmp67_;
	GtkGrid* _tmp68_;
	GtkLabel* _tmp69_;
	GtkGrid* _tmp70_;
	GtkLabel* _tmp71_;
	GtkGrid* _tmp72_;
	GtkLinkButton* _tmp73_;
	GtkGrid* _tmp74_;
	HeTintButton* _tmp75_;
	GtkGrid* _tmp76_;
	HeFillButton* _tmp77_;
	GtkGrid* _tmp78_;
	GtkGrid* _tmp79_;
	BluetoothServicesDevice* _tmp80_;
	gchar* _tmp81_;
	gchar* _tmp82_;
	gchar* _tmp83_;
	GQuark _tmp85_ = 0U;
	static GQuark _tmp84_label0 = 0;
	static GQuark _tmp84_label1 = 0;
	static GQuark _tmp84_label2 = 0;
	static GQuark _tmp84_label3 = 0;
	static GQuark _tmp84_label4 = 0;
	static GQuark _tmp84_label5 = 0;
	BluetoothServicesAdapter* _tmp96_;
	gboolean _tmp97_;
	gboolean _tmp98_;
	BluetoothServicesAdapter* _tmp99_;
	BluetoothServicesDevice* _tmp100_;
	HeFillButton* _tmp101_;
	HeTintButton* _tmp102_;
	parent_class = G_OBJECT_CLASS (bluetooth_device_row_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_data1_->self = g_object_ref (self);
	_tmp1_ = self->priv->_device;
	_tmp2_ = bluetooth_services_device_get_icon (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = _tmp3_;
	_tmp5_ = g_strconcat (_tmp4_, "-symbolic", NULL);
	_tmp6_ = _tmp5_;
	_g_free0 (_tmp4_);
	_tmp0_ = _tmp6_;
	if (_tmp0_ == NULL) {
		gchar* _tmp7_;
		_tmp7_ = g_strdup ("settings-bluetooth-symbolic");
		_g_free0 (_tmp0_);
		_tmp0_ = _tmp7_;
	}
	_tmp8_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp0_);
	gtk_image_set_pixel_size (_tmp8_, 32);
	g_object_ref_sink (_tmp8_);
	_data1_->image = _tmp8_;
	_tmp9_ = he_modifier_badge_new (NULL);
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->state);
	self->priv->state = _tmp9_;
	_tmp10_ = self->priv->state;
	gtk_widget_set_halign ((GtkWidget*) _tmp10_, GTK_ALIGN_END);
	_tmp11_ = self->priv->state;
	gtk_widget_set_valign ((GtkWidget*) _tmp11_, GTK_ALIGN_END);
	_tmp12_ = self->priv->state;
	gtk_widget_set_visible ((GtkWidget*) _tmp12_, FALSE);
	_tmp13_ = (GtkLabel*) gtk_label_new (NULL);
	g_object_ref_sink (_tmp13_);
	_g_object_unref0 (self->priv->state_label);
	self->priv->state_label = _tmp13_;
	_tmp14_ = self->priv->state_label;
	gtk_label_set_xalign (_tmp14_, (gfloat) 0);
	_tmp15_ = self->priv->state_label;
	gtk_label_set_use_markup (_tmp15_, TRUE);
	_tmp16_ = self->priv->state_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp16_, "cb-subtitle");
	_tmp17_ = _data1_->image;
	_tmp18_ = _g_object_ref0 ((GtkWidget*) _tmp17_);
	_tmp19_ = self->priv->_device;
	_tmp20_ = bluetooth_services_device_get_address (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = (GtkOverlay*) gtk_overlay_new ();
	gtk_overlay_set_child (_tmp22_, _tmp18_);
	_g_object_unref0 (_tmp18_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp22_, _tmp21_);
	_g_free0 (_tmp21_);
	g_object_ref_sink (_tmp22_);
	overlay = _tmp22_;
	_tmp23_ = overlay;
	_tmp24_ = self->priv->state;
	gtk_overlay_add_overlay (_tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = self->priv->_device;
	_tmp26_ = bluetooth_services_device_get_name (_tmp25_);
	_tmp27_ = _tmp26_;
	device_name = _tmp27_;
	_tmp28_ = device_name;
	if (_tmp28_ == NULL) {
		BluetoothServicesDevice* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gboolean _tmp33_;
		_tmp29_ = self->priv->_device;
		_tmp30_ = bluetooth_services_device_get_icon (_tmp29_);
		_tmp31_ = _tmp30_;
		_tmp32_ = _tmp31_;
		_tmp33_ = _tmp32_ != NULL;
		_g_free0 (_tmp32_);
		if (_tmp33_) {
			BluetoothServicesDevice* _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			GQuark _tmp39_ = 0U;
			static GQuark _tmp38_label0 = 0;
			static GQuark _tmp38_label1 = 0;
			static GQuark _tmp38_label2 = 0;
			static GQuark _tmp38_label3 = 0;
			static GQuark _tmp38_label4 = 0;
			static GQuark _tmp38_label5 = 0;
			static GQuark _tmp38_label6 = 0;
			_tmp34_ = self->priv->_device;
			_tmp35_ = bluetooth_services_device_get_icon (_tmp34_);
			_tmp36_ = _tmp35_;
			_tmp37_ = _tmp36_;
			_tmp39_ = (NULL == _tmp37_) ? 0 : g_quark_from_string (_tmp37_);
			g_free (_tmp37_);
			if (_tmp39_ == ((0 != _tmp38_label0) ? _tmp38_label0 : (_tmp38_label0 = g_quark_from_static_string ("audio-card")))) {
				switch (0) {
					default:
					{
						gchar* _tmp40_;
						_tmp40_ = g_strdup (_ ("Speaker"));
						_g_free0 (device_name);
						device_name = _tmp40_;
						break;
					}
				}
			} else if (_tmp39_ == ((0 != _tmp38_label1) ? _tmp38_label1 : (_tmp38_label1 = g_quark_from_static_string ("input-gaming")))) {
				switch (0) {
					default:
					{
						gchar* _tmp41_;
						_tmp41_ = g_strdup (_ ("Controller"));
						_g_free0 (device_name);
						device_name = _tmp41_;
						break;
					}
				}
			} else if (_tmp39_ == ((0 != _tmp38_label2) ? _tmp38_label2 : (_tmp38_label2 = g_quark_from_static_string ("input-keyboard")))) {
				switch (0) {
					default:
					{
						gchar* _tmp42_;
						_tmp42_ = g_strdup (_ ("Keyboard"));
						_g_free0 (device_name);
						device_name = _tmp42_;
						break;
					}
				}
			} else if (_tmp39_ == ((0 != _tmp38_label3) ? _tmp38_label3 : (_tmp38_label3 = g_quark_from_static_string ("input-mouse")))) {
				switch (0) {
					default:
					{
						gchar* _tmp43_;
						_tmp43_ = g_strdup (_ ("Mouse"));
						_g_free0 (device_name);
						device_name = _tmp43_;
						break;
					}
				}
			} else if (_tmp39_ == ((0 != _tmp38_label4) ? _tmp38_label4 : (_tmp38_label4 = g_quark_from_static_string ("input-tablet")))) {
				switch (0) {
					default:
					{
						gchar* _tmp44_;
						_tmp44_ = g_strdup (_ ("Tablet"));
						_g_free0 (device_name);
						device_name = _tmp44_;
						break;
					}
				}
			} else if (_tmp39_ == ((0 != _tmp38_label5) ? _tmp38_label5 : (_tmp38_label5 = g_quark_from_static_string ("input-touchpad")))) {
				switch (0) {
					default:
					{
						gchar* _tmp45_;
						_tmp45_ = g_strdup (_ ("Touchpad"));
						_g_free0 (device_name);
						device_name = _tmp45_;
						break;
					}
				}
			} else if (_tmp39_ == ((0 != _tmp38_label6) ? _tmp38_label6 : (_tmp38_label6 = g_quark_from_static_string ("phone")))) {
				switch (0) {
					default:
					{
						gchar* _tmp46_;
						_tmp46_ = g_strdup (_ ("Phone"));
						_g_free0 (device_name);
						device_name = _tmp46_;
						break;
					}
				}
			} else {
				switch (0) {
					default:
					{
						BluetoothServicesDevice* _tmp47_;
						gchar* _tmp48_;
						gchar* _tmp49_;
						_tmp47_ = self->priv->_device;
						_tmp48_ = bluetooth_services_device_get_address (_tmp47_);
						_tmp49_ = _tmp48_;
						_g_free0 (device_name);
						device_name = _tmp49_;
					}
				}
			}
		} else {
			BluetoothServicesDevice* _tmp50_;
			gchar* _tmp51_;
			gchar* _tmp52_;
			_tmp50_ = self->priv->_device;
			_tmp51_ = bluetooth_services_device_get_address (_tmp50_);
			_tmp52_ = _tmp51_;
			_g_free0 (device_name);
			device_name = _tmp52_;
		}
	}
	_tmp53_ = device_name;
	_tmp54_ = (GtkLabel*) gtk_label_new (_tmp53_);
	gtk_label_set_ellipsize (_tmp54_, PANGO_ELLIPSIZE_END);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp54_, TRUE);
	gtk_label_set_xalign (_tmp54_, (gfloat) 0);
	g_object_ref_sink (_tmp54_);
	_data1_->label = _tmp54_;
	_tmp55_ = _data1_->label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp55_, "cb-title");
	_tmp56_ = (GtkImage*) gtk_image_new_from_icon_name ("view-more-horizontal-symbolic");
	g_object_ref_sink (_tmp56_);
	_tmp57_ = (GtkLinkButton*) gtk_link_button_new ("");
	gtk_button_set_child ((GtkButton*) _tmp57_, (GtkWidget*) _tmp56_);
	_g_object_unref0 (_tmp56_);
	gtk_widget_set_valign ((GtkWidget*) _tmp57_, GTK_ALIGN_CENTER);
	gtk_widget_set_visible ((GtkWidget*) _tmp57_, FALSE);
	g_object_ref_sink (_tmp57_);
	_g_object_unref0 (self->priv->settings_button);
	self->priv->settings_button = _tmp57_;
	_tmp58_ = self->priv->settings_button;
	gtk_widget_add_css_class ((GtkWidget*) _tmp58_, "disclosure-button");
	_tmp59_ = g_strdup (_ ("Forget"));
	_tmp60_ = g_strdup (_ ("Forget this device"));
	_tmp61_ = he_tint_button_new ("");
	gtk_widget_set_margin_end ((GtkWidget*) _tmp61_, 3);
	gtk_button_set_label ((GtkButton*) _tmp61_, _tmp59_);
	_g_free0 (_tmp59_);
	gtk_widget_set_visible ((GtkWidget*) _tmp61_, FALSE);
	gtk_widget_set_valign ((GtkWidget*) _tmp61_, GTK_ALIGN_CENTER);
	he_button_set_color ((HeButton*) _tmp61_, HE_COLORS_RED);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp61_, _tmp60_);
	_g_free0 (_tmp60_);
	g_object_ref_sink (_tmp61_);
	_g_object_unref0 (self->priv->forget_button);
	self->priv->forget_button = _tmp61_;
	_tmp62_ = he_fill_button_new ("");
	gtk_widget_set_valign ((GtkWidget*) _tmp62_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp62_);
	_g_object_unref0 (self->priv->connect_button);
	self->priv->connect_button = _tmp62_;
	_tmp63_ = bluetooth_device_row_size_group;
	_tmp64_ = self->priv->connect_button;
	gtk_size_group_add_widget (_tmp63_, (GtkWidget*) _tmp64_);
	_tmp65_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp65_, 6);
	g_object_ref_sink (_tmp65_);
	grid = _tmp65_;
	_tmp66_ = grid;
	_tmp67_ = overlay;
	gtk_grid_attach (_tmp66_, (GtkWidget*) _tmp67_, 0, 0, 1, 2);
	_tmp68_ = grid;
	_tmp69_ = _data1_->label;
	gtk_grid_attach (_tmp68_, (GtkWidget*) _tmp69_, 1, 0, 1, 1);
	_tmp70_ = grid;
	_tmp71_ = self->priv->state_label;
	gtk_grid_attach (_tmp70_, (GtkWidget*) _tmp71_, 1, 1, 1, 1);
	_tmp72_ = grid;
	_tmp73_ = self->priv->settings_button;
	gtk_grid_attach (_tmp72_, (GtkWidget*) _tmp73_, 2, 0, 1, 2);
	_tmp74_ = grid;
	_tmp75_ = self->priv->forget_button;
	gtk_grid_attach (_tmp74_, (GtkWidget*) _tmp75_, 3, 0, 1, 2);
	_tmp76_ = grid;
	_tmp77_ = self->priv->connect_button;
	gtk_grid_attach (_tmp76_, (GtkWidget*) _tmp77_, 4, 0, 1, 2);
	_tmp78_ = grid;
	gtk_widget_add_css_class ((GtkWidget*) _tmp78_, "mini-content-block");
	_tmp79_ = grid;
	gtk_list_box_row_set_child ((GtkListBoxRow*) self, (GtkWidget*) _tmp79_);
	_tmp80_ = self->priv->_device;
	_tmp81_ = bluetooth_services_device_get_icon (_tmp80_);
	_tmp82_ = _tmp81_;
	_tmp83_ = _tmp82_;
	_tmp85_ = (NULL == _tmp83_) ? 0 : g_quark_from_string (_tmp83_);
	g_free (_tmp83_);
	if ((_tmp85_ == ((0 != _tmp84_label0) ? _tmp84_label0 : (_tmp84_label0 = g_quark_from_static_string ("audio-card")))) || (_tmp85_ == ((0 != _tmp84_label1) ? _tmp84_label1 : (_tmp84_label1 = g_quark_from_static_string ("audio-headset"))))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp86_;
				GtkLinkButton* _tmp87_;
				_tmp86_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp86_, "settings://sound");
				_tmp87_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp87_, _ ("Sound"));
				break;
			}
		}
	} else if ((_tmp85_ == ((0 != _tmp84_label2) ? _tmp84_label2 : (_tmp84_label2 = g_quark_from_static_string ("input-gaming")))) || (_tmp85_ == ((0 != _tmp84_label3) ? _tmp84_label3 : (_tmp84_label3 = g_quark_from_static_string ("input-keyboard"))))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp88_;
				GtkLinkButton* _tmp89_;
				_tmp88_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp88_, "settings://keyboard");
				_tmp89_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp89_, _ ("Mouse & Keyboard"));
				break;
			}
		}
	} else if (_tmp85_ == ((0 != _tmp84_label4) ? _tmp84_label4 : (_tmp84_label4 = g_quark_from_static_string ("input-mouse")))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp90_;
				GtkLinkButton* _tmp91_;
				_tmp90_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp90_, "settings://keyboard");
				_tmp91_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp91_, _ ("Mouse & Keyboard"));
				break;
			}
		}
	} else if (_tmp85_ == ((0 != _tmp84_label5) ? _tmp84_label5 : (_tmp84_label5 = g_quark_from_static_string ("printer")))) {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp92_;
				GtkLinkButton* _tmp93_;
				_tmp92_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp92_, "settings://printer");
				_tmp93_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp93_, _ ("Printers"));
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				GtkLinkButton* _tmp94_;
				GtkLinkButton* _tmp95_;
				_tmp94_ = self->priv->settings_button;
				gtk_link_button_set_uri (_tmp94_, "");
				_tmp95_ = self->priv->settings_button;
				gtk_widget_set_tooltip_text ((GtkWidget*) _tmp95_, NULL);
				break;
			}
		}
	}
	bluetooth_device_row_compute_status (self);
	_tmp96_ = self->priv->_adapter;
	_tmp97_ = bluetooth_services_adapter_get_powered (_tmp96_);
	_tmp98_ = _tmp97_;
	gtk_widget_set_sensitive ((GtkWidget*) self, _tmp98_);
	_tmp99_ = self->priv->_adapter;
	g_signal_connect_object (G_TYPE_CHECK_INSTANCE_CAST (_tmp99_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) __bluetooth_device_row___lambda27__g_dbus_proxy_g_properties_changed, self, 0);
	_tmp100_ = self->priv->_device;
	g_signal_connect_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp100_, g_dbus_proxy_get_type (), GDBusProxy), "g-properties-changed", (GCallback) __bluetooth_device_row___lambda28__g_dbus_proxy_g_properties_changed, block1_data_ref (_data1_), (GClosureNotify) block1_data_unref, 0);
	_tmp101_ = self->priv->connect_button;
	g_signal_connect_object ((GtkButton*) _tmp101_, "clicked", (GCallback) __bluetooth_device_row___lambda29__gtk_button_clicked, self, 0);
	_tmp102_ = self->priv->forget_button;
	g_signal_connect_object ((GtkButton*) _tmp102_, "clicked", (GCallback) __bluetooth_device_row___lambda30__gtk_button_clicked, self, 0);
	_g_object_unref0 (grid);
	_g_free0 (device_name);
	_g_object_unref0 (overlay);
	_g_free0 (_tmp0_);
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return obj;
}

static void
bluetooth_device_row_class_init (BluetoothDeviceRowClass * klass,
                                 gpointer klass_data)
{
	GtkSizeGroup* _tmp0_;
	bluetooth_device_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BluetoothDeviceRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_device_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_device_row_set_property;
	G_OBJECT_CLASS (klass)->constructor = bluetooth_device_row_constructor;
	G_OBJECT_CLASS (klass)->finalize = bluetooth_device_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", BLUETOOTH_SERVICES_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY, bluetooth_device_row_properties[BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY] = g_param_spec_object ("adapter", "adapter", "adapter", BLUETOOTH_SERVICES_TYPE_ADAPTER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	bluetooth_device_row_signals[BLUETOOTH_DEVICE_ROW_STATUS_CHANGED_SIGNAL] = g_signal_new ("status-changed", BLUETOOTH_TYPE_DEVICE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	_tmp0_ = gtk_size_group_new (GTK_SIZE_GROUP_HORIZONTAL);
	_g_object_unref0 (bluetooth_device_row_size_group);
	bluetooth_device_row_size_group = _tmp0_;
}

static void
bluetooth_device_row_instance_init (BluetoothDeviceRow * self,
                                    gpointer klass)
{
	self->priv = bluetooth_device_row_get_instance_private (self);
}

static void
bluetooth_device_row_finalize (GObject * obj)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	_g_object_unref0 (self->priv->_device);
	_g_object_unref0 (self->priv->connect_button);
	_g_object_unref0 (self->priv->forget_button);
	_g_object_unref0 (self->priv->state);
	_g_object_unref0 (self->priv->state_label);
	_g_object_unref0 (self->priv->settings_button);
	G_OBJECT_CLASS (bluetooth_device_row_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
bluetooth_device_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothDeviceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_device_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothDeviceRow), 0, (GInstanceInitFunc) bluetooth_device_row_instance_init, NULL };
	GType bluetooth_device_row_type_id;
	bluetooth_device_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "BluetoothDeviceRow", &g_define_type_info, 0);
	BluetoothDeviceRow_private_offset = g_type_add_instance_private (bluetooth_device_row_type_id, sizeof (BluetoothDeviceRowPrivate));
	return bluetooth_device_row_type_id;
}

GType
bluetooth_device_row_get_type (void)
{
	static gsize bluetooth_device_row_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_device_row_type_id__once)) {
		GType bluetooth_device_row_type_id;
		bluetooth_device_row_type_id = bluetooth_device_row_get_type_once ();
		g_once_init_leave (&bluetooth_device_row_type_id__once, bluetooth_device_row_type_id);
	}
	return bluetooth_device_row_type_id__once;
}

static void
_vala_bluetooth_device_row_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	switch (property_id) {
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
		g_value_set_object (value, bluetooth_device_row_get_device (self));
		break;
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
		g_value_set_object (value, bluetooth_device_row_get_adapter (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_bluetooth_device_row_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	BluetoothDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow);
	switch (property_id) {
		case BLUETOOTH_DEVICE_ROW_DEVICE_PROPERTY:
		bluetooth_device_row_set_device (self, g_value_get_object (value));
		break;
		case BLUETOOTH_DEVICE_ROW_ADAPTER_PROPERTY:
		bluetooth_device_row_set_adapter (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

