/* MainView.c generated by valac 0.56.13, the Vala compiler
 * generated from MainView.vala, do not modify */

/*
 * Copyright (c) 2023 Fyra Labs
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "fuse-bluetooth.h"
#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <libhelium-1.h>
#include <bismuth.h>

enum  {
	BLUETOOTH_MAIN_VIEW_0_PROPERTY,
	BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY,
	BLUETOOTH_MAIN_VIEW_NUM_PROPERTIES
};
static GParamSpec* bluetooth_main_view_properties[BLUETOOTH_MAIN_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	BLUETOOTH_MAIN_VIEW_QUIT_FUSE_SIGNAL,
	BLUETOOTH_MAIN_VIEW_NUM_SIGNALS
};
static guint bluetooth_main_view_signals[BLUETOOTH_MAIN_VIEW_NUM_SIGNALS] = {0};

struct _BluetoothMainViewPrivate {
	GtkListBox* list_box;
	BluetoothServicesObjectManager* _manager;
};

static gint BluetoothMainView_private_offset;
static gpointer bluetooth_main_view_parent_class = NULL;

static void bluetooth_main_view_complete_setup (BluetoothMainView* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void __lambda31_ (BluetoothMainView* self,
                  BluetoothServicesDevice* device);
static void ___lambda31__bluetooth_services_object_manager_device_added (BluetoothServicesObjectManager* _sender,
                                                                  BluetoothServicesDevice* device,
                                                                  gpointer self);
static void __lambda32_ (BluetoothMainView* self,
                  BluetoothServicesDevice* device);
static void ___lambda32__bluetooth_services_object_manager_device_removed (BluetoothServicesObjectManager* _sender,
                                                                    BluetoothServicesDevice* device,
                                                                    gpointer self);
static void __lambda33_ (BluetoothMainView* self,
                  BluetoothServicesAdapter* adapter);
static void ___lambda33__bluetooth_services_object_manager_adapter_removed (BluetoothServicesObjectManager* _sender,
                                                                     BluetoothServicesAdapter* adapter,
                                                                     gpointer self);
static gint bluetooth_main_view_compare_rows (BluetoothDeviceRow* row1,
                                       BluetoothDeviceRow* row2,
                                       BluetoothMainView* self);
static void bluetooth_main_view_title_rows (BluetoothDeviceRow* row1,
                                     BluetoothDeviceRow* row2,
                                     BluetoothMainView* self);
static GObject * bluetooth_main_view_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void _bluetooth_main_view_complete_setup_g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void bluetooth_main_view_finalize (GObject * obj);
static GType bluetooth_main_view_get_type_once (void);
static void _vala_bluetooth_main_view_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_bluetooth_main_view_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec);

static inline gpointer
bluetooth_main_view_get_instance_private (BluetoothMainView* self)
{
	return G_STRUCT_MEMBER_P (self, BluetoothMainView_private_offset);
}

BluetoothMainView*
bluetooth_main_view_construct (GType object_type,
                               BluetoothServicesObjectManager* manager)
{
	BluetoothMainView * self = NULL;
	g_return_val_if_fail (manager != NULL, NULL);
	self = (BluetoothMainView*) g_object_new (object_type, "manager", manager, NULL);
	return self;
}

BluetoothMainView*
bluetooth_main_view_new (BluetoothServicesObjectManager* manager)
{
	return bluetooth_main_view_construct (BLUETOOTH_TYPE_MAIN_VIEW, manager);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
__lambda31_ (BluetoothMainView* self,
             BluetoothServicesDevice* device)
{
	BluetoothServicesAdapter* adapter = NULL;
	BluetoothServicesObjectManager* _tmp0_;
	char* _tmp1_;
	char* _tmp2_;
	char* _tmp3_;
	BluetoothServicesAdapter* _tmp4_;
	BluetoothServicesAdapter* _tmp5_;
	BluetoothDeviceRow* row = NULL;
	BluetoothServicesAdapter* _tmp6_;
	BluetoothDeviceRow* _tmp7_;
	GtkListBox* _tmp8_;
	BluetoothDeviceRow* _tmp9_;
	GtkListBox* _tmp10_;
	GtkListBoxRow* _tmp11_;
	g_return_if_fail (device != NULL);
	_tmp0_ = self->priv->_manager;
	_tmp1_ = bluetooth_services_device_get_adapter (device);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = bluetooth_services_object_manager_get_adapter_from_path (_tmp0_, (const gchar*) _tmp3_);
	_tmp5_ = _tmp4_;
	_g_free0 (_tmp3_);
	adapter = _tmp5_;
	_tmp6_ = adapter;
	_tmp7_ = bluetooth_device_row_new (device, _tmp6_);
	g_object_ref_sink (_tmp7_);
	row = _tmp7_;
	_tmp8_ = self->priv->list_box;
	_tmp9_ = row;
	gtk_list_box_append (_tmp8_, (GtkWidget*) _tmp9_);
	_tmp10_ = self->priv->list_box;
	_tmp11_ = gtk_list_box_get_selected_row (_tmp10_);
	if (_tmp11_ == NULL) {
		GtkListBox* _tmp12_;
		BluetoothDeviceRow* _tmp13_;
		GtkListBox* _tmp14_;
		BluetoothDeviceRow* _tmp15_;
		_tmp12_ = self->priv->list_box;
		_tmp13_ = row;
		gtk_list_box_select_row (_tmp12_, (GtkListBoxRow*) _tmp13_);
		_tmp14_ = self->priv->list_box;
		_tmp15_ = row;
		g_signal_emit_by_name (_tmp14_, "row-activated", (GtkListBoxRow*) _tmp15_);
	}
	_g_object_unref0 (row);
	_g_object_unref0 (adapter);
}

static void
___lambda31__bluetooth_services_object_manager_device_added (BluetoothServicesObjectManager* _sender,
                                                             BluetoothServicesDevice* device,
                                                             gpointer self)
{
	__lambda31_ ((BluetoothMainView*) self, device);
}

static void
__lambda32_ (BluetoothMainView* self,
             BluetoothServicesDevice* device)
{
	GtkWidget* child = NULL;
	GtkListBox* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	g_return_if_fail (device != NULL);
	_tmp0_ = self->priv->list_box;
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
	_tmp2_ = _g_object_ref0 (_tmp1_);
	child = _tmp2_;
	while (TRUE) {
		GtkWidget* _tmp3_;
		GtkWidget* _tmp4_;
		BluetoothServicesDevice* _tmp5_;
		BluetoothServicesDevice* _tmp6_;
		GtkWidget* _tmp9_;
		GtkWidget* _tmp10_;
		GtkWidget* _tmp11_;
		_tmp3_ = child;
		if (!(_tmp3_ != NULL)) {
			break;
		}
		_tmp4_ = child;
		_tmp5_ = bluetooth_device_row_get_device (G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, BLUETOOTH_TYPE_DEVICE_ROW, BluetoothDeviceRow));
		_tmp6_ = _tmp5_;
		if (_tmp6_ == device) {
			GtkListBox* _tmp7_;
			GtkWidget* _tmp8_;
			_tmp7_ = self->priv->list_box;
			_tmp8_ = child;
			gtk_list_box_remove (_tmp7_, _tmp8_);
			break;
		}
		_tmp9_ = child;
		_tmp10_ = gtk_widget_get_next_sibling (_tmp9_);
		_tmp11_ = _g_object_ref0 (_tmp10_);
		_g_object_unref0 (child);
		child = _tmp11_;
	}
	_g_object_unref0 (child);
}

static void
___lambda32__bluetooth_services_object_manager_device_removed (BluetoothServicesObjectManager* _sender,
                                                               BluetoothServicesDevice* device,
                                                               gpointer self)
{
	__lambda32_ ((BluetoothMainView*) self, device);
}

static void
__lambda33_ (BluetoothMainView* self,
             BluetoothServicesAdapter* adapter)
{
	BluetoothServicesObjectManager* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	g_return_if_fail (adapter != NULL);
	_tmp0_ = self->priv->_manager;
	_tmp1_ = bluetooth_services_object_manager_get_has_object (_tmp0_);
	_tmp2_ = _tmp1_;
	if (!_tmp2_) {
		g_signal_emit (self, bluetooth_main_view_signals[BLUETOOTH_MAIN_VIEW_QUIT_FUSE_SIGNAL], 0);
	}
}

static void
___lambda33__bluetooth_services_object_manager_adapter_removed (BluetoothServicesObjectManager* _sender,
                                                                BluetoothServicesAdapter* adapter,
                                                                gpointer self)
{
	__lambda33_ ((BluetoothMainView*) self, adapter);
}

static void
bluetooth_main_view_complete_setup (BluetoothMainView* self)
{
	BluetoothServicesObjectManager* _tmp0_;
	GList* _tmp1_;
	GtkListBoxRow* first_row = NULL;
	GtkListBox* _tmp15_;
	GtkListBoxRow* _tmp16_;
	GtkListBoxRow* _tmp17_;
	GtkListBoxRow* _tmp18_;
	BluetoothServicesObjectManager* _tmp23_;
	BluetoothServicesObjectManager* _tmp24_;
	BluetoothServicesObjectManager* _tmp25_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_manager;
	_tmp1_ = bluetooth_services_object_manager_get_devices (_tmp0_);
	{
		GList* device_collection = NULL;
		GList* device_it = NULL;
		device_collection = _tmp1_;
		for (device_it = device_collection; device_it != NULL; device_it = device_it->next) {
			BluetoothServicesDevice* _tmp2_;
			BluetoothServicesDevice* device = NULL;
			_tmp2_ = _g_object_ref0 ((BluetoothServicesDevice*) device_it->data);
			device = _tmp2_;
			{
				BluetoothServicesAdapter* adapter = NULL;
				BluetoothServicesObjectManager* _tmp3_;
				BluetoothServicesDevice* _tmp4_;
				char* _tmp5_;
				char* _tmp6_;
				char* _tmp7_;
				BluetoothServicesAdapter* _tmp8_;
				BluetoothServicesAdapter* _tmp9_;
				BluetoothDeviceRow* row = NULL;
				BluetoothServicesDevice* _tmp10_;
				BluetoothServicesAdapter* _tmp11_;
				BluetoothDeviceRow* _tmp12_;
				GtkListBox* _tmp13_;
				BluetoothDeviceRow* _tmp14_;
				_tmp3_ = self->priv->_manager;
				_tmp4_ = device;
				_tmp5_ = bluetooth_services_device_get_adapter (_tmp4_);
				_tmp6_ = _tmp5_;
				_tmp7_ = _tmp6_;
				_tmp8_ = bluetooth_services_object_manager_get_adapter_from_path (_tmp3_, (const gchar*) _tmp7_);
				_tmp9_ = _tmp8_;
				_g_free0 (_tmp7_);
				adapter = _tmp9_;
				_tmp10_ = device;
				_tmp11_ = adapter;
				_tmp12_ = bluetooth_device_row_new (_tmp10_, _tmp11_);
				g_object_ref_sink (_tmp12_);
				row = _tmp12_;
				_tmp13_ = self->priv->list_box;
				_tmp14_ = row;
				gtk_list_box_append (_tmp13_, (GtkWidget*) _tmp14_);
				_g_object_unref0 (row);
				_g_object_unref0 (adapter);
				_g_object_unref0 (device);
			}
		}
		(device_collection == NULL) ? NULL : (device_collection = (_g_list_free__g_object_unref0_ (device_collection), NULL));
	}
	_tmp15_ = self->priv->list_box;
	_tmp16_ = gtk_list_box_get_row_at_index (_tmp15_, 0);
	_tmp17_ = _g_object_ref0 (_tmp16_);
	first_row = _tmp17_;
	_tmp18_ = first_row;
	if (_tmp18_ != NULL) {
		GtkListBox* _tmp19_;
		GtkListBoxRow* _tmp20_;
		GtkListBox* _tmp21_;
		GtkListBoxRow* _tmp22_;
		_tmp19_ = self->priv->list_box;
		_tmp20_ = first_row;
		gtk_list_box_select_row (_tmp19_, _tmp20_);
		_tmp21_ = self->priv->list_box;
		_tmp22_ = first_row;
		g_signal_emit_by_name (_tmp21_, "row-activated", _tmp22_);
	}
	_tmp23_ = self->priv->_manager;
	g_signal_connect_object (_tmp23_, "device-added", (GCallback) ___lambda31__bluetooth_services_object_manager_device_added, self, 0);
	_tmp24_ = self->priv->_manager;
	g_signal_connect_object (_tmp24_, "device-removed", (GCallback) ___lambda32__bluetooth_services_object_manager_device_removed, self, G_CONNECT_AFTER);
	_tmp25_ = self->priv->_manager;
	g_signal_connect_object (_tmp25_, "adapter-removed", (GCallback) ___lambda33__bluetooth_services_object_manager_adapter_removed, self, 0);
	_g_object_unref0 (first_row);
}

static gint
bluetooth_main_view_compare_rows (BluetoothDeviceRow* row1,
                                  BluetoothDeviceRow* row2,
                                  BluetoothMainView* self)
{
	BluetoothServicesDevice* device1 = NULL;
	BluetoothServicesDevice* _tmp0_;
	BluetoothServicesDevice* _tmp1_;
	BluetoothServicesDevice* device2 = NULL;
	BluetoothServicesDevice* _tmp2_;
	BluetoothServicesDevice* _tmp3_;
	gboolean _tmp4_ = FALSE;
	BluetoothServicesDevice* _tmp5_;
	gboolean _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp11_ = FALSE;
	BluetoothServicesDevice* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp18_ = FALSE;
	BluetoothServicesDevice* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp25_ = FALSE;
	BluetoothServicesDevice* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
	gboolean _tmp32_ = FALSE;
	BluetoothServicesDevice* _tmp33_;
	gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	gboolean _tmp37_;
	gboolean _tmp42_ = FALSE;
	BluetoothServicesDevice* _tmp43_;
	gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	gboolean _tmp47_;
	gchar* _tmp52_ = NULL;
	BluetoothServicesDevice* _tmp53_;
	gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* name1 = NULL;
	gchar* _tmp59_;
	gchar* _tmp60_ = NULL;
	BluetoothServicesDevice* _tmp61_;
	gchar* _tmp62_;
	gchar* _tmp63_;
	gchar* name2 = NULL;
	gchar* _tmp67_;
	const gchar* _tmp68_;
	const gchar* _tmp69_;
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	g_return_val_if_fail (row1 != NULL, 0);
	g_return_val_if_fail (row2 != NULL, 0);
	_tmp0_ = bluetooth_device_row_get_device (row1);
	_tmp1_ = _tmp0_;
	device1 = _tmp1_;
	_tmp2_ = bluetooth_device_row_get_device (row2);
	_tmp3_ = _tmp2_;
	device2 = _tmp3_;
	_tmp5_ = device1;
	_tmp6_ = bluetooth_services_device_get_paired (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_) {
		BluetoothServicesDevice* _tmp8_;
		gboolean _tmp9_;
		gboolean _tmp10_;
		_tmp8_ = device2;
		_tmp9_ = bluetooth_services_device_get_paired (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp4_ = !_tmp10_;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		result = -1;
		return result;
	}
	_tmp12_ = device1;
	_tmp13_ = bluetooth_services_device_get_paired (_tmp12_);
	_tmp14_ = _tmp13_;
	if (!_tmp14_) {
		BluetoothServicesDevice* _tmp15_;
		gboolean _tmp16_;
		gboolean _tmp17_;
		_tmp15_ = device2;
		_tmp16_ = bluetooth_services_device_get_paired (_tmp15_);
		_tmp17_ = _tmp16_;
		_tmp11_ = _tmp17_;
	} else {
		_tmp11_ = FALSE;
	}
	if (_tmp11_) {
		result = 1;
		return result;
	}
	_tmp19_ = device1;
	_tmp20_ = bluetooth_services_device_get_connected (_tmp19_);
	_tmp21_ = _tmp20_;
	if (_tmp21_) {
		BluetoothServicesDevice* _tmp22_;
		gboolean _tmp23_;
		gboolean _tmp24_;
		_tmp22_ = device2;
		_tmp23_ = bluetooth_services_device_get_connected (_tmp22_);
		_tmp24_ = _tmp23_;
		_tmp18_ = !_tmp24_;
	} else {
		_tmp18_ = FALSE;
	}
	if (_tmp18_) {
		result = -1;
		return result;
	}
	_tmp26_ = device1;
	_tmp27_ = bluetooth_services_device_get_connected (_tmp26_);
	_tmp28_ = _tmp27_;
	if (!_tmp28_) {
		BluetoothServicesDevice* _tmp29_;
		gboolean _tmp30_;
		gboolean _tmp31_;
		_tmp29_ = device2;
		_tmp30_ = bluetooth_services_device_get_connected (_tmp29_);
		_tmp31_ = _tmp30_;
		_tmp25_ = _tmp31_;
	} else {
		_tmp25_ = FALSE;
	}
	if (_tmp25_) {
		result = 1;
		return result;
	}
	_tmp33_ = device1;
	_tmp34_ = bluetooth_services_device_get_name (_tmp33_);
	_tmp35_ = _tmp34_;
	_tmp36_ = _tmp35_;
	_tmp37_ = _tmp36_ != NULL;
	_g_free0 (_tmp36_);
	if (_tmp37_) {
		BluetoothServicesDevice* _tmp38_;
		gchar* _tmp39_;
		gchar* _tmp40_;
		gchar* _tmp41_;
		_tmp38_ = device2;
		_tmp39_ = bluetooth_services_device_get_name (_tmp38_);
		_tmp40_ = _tmp39_;
		_tmp41_ = _tmp40_;
		_tmp32_ = _tmp41_ == NULL;
		_g_free0 (_tmp41_);
	} else {
		_tmp32_ = FALSE;
	}
	if (_tmp32_) {
		result = -1;
		return result;
	}
	_tmp43_ = device1;
	_tmp44_ = bluetooth_services_device_get_name (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = _tmp45_;
	_tmp47_ = _tmp46_ == NULL;
	_g_free0 (_tmp46_);
	if (_tmp47_) {
		BluetoothServicesDevice* _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		_tmp48_ = device2;
		_tmp49_ = bluetooth_services_device_get_name (_tmp48_);
		_tmp50_ = _tmp49_;
		_tmp51_ = _tmp50_;
		_tmp42_ = _tmp51_ != NULL;
		_g_free0 (_tmp51_);
	} else {
		_tmp42_ = FALSE;
	}
	if (_tmp42_) {
		result = 1;
		return result;
	}
	_tmp53_ = device1;
	_tmp54_ = bluetooth_services_device_get_name (_tmp53_);
	_tmp55_ = _tmp54_;
	_tmp52_ = _tmp55_;
	if (_tmp52_ == NULL) {
		BluetoothServicesDevice* _tmp56_;
		gchar* _tmp57_;
		gchar* _tmp58_;
		_tmp56_ = device1;
		_tmp57_ = bluetooth_services_device_get_address (_tmp56_);
		_tmp58_ = _tmp57_;
		_g_free0 (_tmp52_);
		_tmp52_ = _tmp58_;
	}
	_tmp59_ = _tmp52_;
	_tmp52_ = NULL;
	name1 = _tmp59_;
	_tmp61_ = device2;
	_tmp62_ = bluetooth_services_device_get_name (_tmp61_);
	_tmp63_ = _tmp62_;
	_tmp60_ = _tmp63_;
	if (_tmp60_ == NULL) {
		BluetoothServicesDevice* _tmp64_;
		gchar* _tmp65_;
		gchar* _tmp66_;
		_tmp64_ = device2;
		_tmp65_ = bluetooth_services_device_get_address (_tmp64_);
		_tmp66_ = _tmp65_;
		_g_free0 (_tmp60_);
		_tmp60_ = _tmp66_;
	}
	_tmp67_ = _tmp60_;
	_tmp60_ = NULL;
	name2 = _tmp67_;
	_tmp68_ = name1;
	_tmp69_ = name2;
	result = g_utf8_collate (_tmp68_, _tmp69_);
	_g_free0 (name2);
	_g_free0 (_tmp60_);
	_g_free0 (name1);
	_g_free0 (_tmp52_);
	return result;
}

static void
bluetooth_main_view_title_rows (BluetoothDeviceRow* row1,
                                BluetoothDeviceRow* row2,
                                BluetoothMainView* self)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	g_return_if_fail (row1 != NULL);
	if (row2 == NULL) {
		BluetoothServicesDevice* _tmp1_;
		BluetoothServicesDevice* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		_tmp1_ = bluetooth_device_row_get_device (row1);
		_tmp2_ = _tmp1_;
		_tmp3_ = bluetooth_services_device_get_paired (_tmp2_);
		_tmp4_ = _tmp3_;
		_tmp0_ = _tmp4_;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		GtkLabel* label = NULL;
		GtkLabel* _tmp5_;
		GtkLabel* _tmp6_;
		GtkLabel* _tmp7_;
		GtkLabel* _tmp8_;
		GtkLabel* _tmp9_;
		GtkLabel* _tmp10_;
		_tmp5_ = (GtkLabel*) gtk_label_new (_ ("My Devices"));
		g_object_ref_sink (_tmp5_);
		label = _tmp5_;
		_tmp6_ = label;
		gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_START);
		_tmp7_ = label;
		gtk_widget_set_margin_top ((GtkWidget*) _tmp7_, 12);
		_tmp8_ = label;
		gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "heading");
		_tmp9_ = label;
		gtk_widget_add_css_class ((GtkWidget*) _tmp9_, "dim-label");
		_tmp10_ = label;
		gtk_list_box_row_set_header ((GtkListBoxRow*) row1, (GtkWidget*) _tmp10_);
		_g_object_unref0 (label);
	} else {
		gboolean _tmp11_ = FALSE;
		if (row2 == NULL) {
			_tmp11_ = TRUE;
		} else {
			BluetoothServicesDevice* _tmp12_;
			BluetoothServicesDevice* _tmp13_;
			gboolean _tmp14_;
			gboolean _tmp15_;
			BluetoothServicesDevice* _tmp16_;
			BluetoothServicesDevice* _tmp17_;
			gboolean _tmp18_;
			gboolean _tmp19_;
			_tmp12_ = bluetooth_device_row_get_device (row1);
			_tmp13_ = _tmp12_;
			_tmp14_ = bluetooth_services_device_get_paired (_tmp13_);
			_tmp15_ = _tmp14_;
			_tmp16_ = bluetooth_device_row_get_device (row2);
			_tmp17_ = _tmp16_;
			_tmp18_ = bluetooth_services_device_get_paired (_tmp17_);
			_tmp19_ = _tmp18_;
			_tmp11_ = _tmp15_ != _tmp19_;
		}
		if (_tmp11_) {
			GtkLabel* label = NULL;
			GtkLabel* _tmp20_;
			GtkLabel* _tmp21_;
			GtkLabel* _tmp22_;
			GtkLabel* _tmp23_;
			GtkLabel* _tmp24_;
			GtkLabel* _tmp25_;
			_tmp20_ = (GtkLabel*) gtk_label_new (_ ("Nearby Devices"));
			g_object_ref_sink (_tmp20_);
			label = _tmp20_;
			_tmp21_ = label;
			gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_START);
			_tmp22_ = label;
			gtk_widget_set_margin_top ((GtkWidget*) _tmp22_, 12);
			_tmp23_ = label;
			gtk_widget_add_css_class ((GtkWidget*) _tmp23_, "heading");
			_tmp24_ = label;
			gtk_widget_add_css_class ((GtkWidget*) _tmp24_, "dim-label");
			_tmp25_ = label;
			gtk_list_box_row_set_header ((GtkListBoxRow*) row1, (GtkWidget*) _tmp25_);
			_g_object_unref0 (label);
		} else {
			gtk_list_box_row_set_header ((GtkListBoxRow*) row1, NULL);
		}
	}
}

BluetoothServicesObjectManager*
bluetooth_main_view_get_manager (BluetoothMainView* self)
{
	BluetoothServicesObjectManager* result;
	BluetoothServicesObjectManager* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_manager;
	result = _tmp0_;
	return result;
}

void
bluetooth_main_view_set_manager (BluetoothMainView* self,
                                 BluetoothServicesObjectManager* value)
{
	BluetoothServicesObjectManager* old_value;
	g_return_if_fail (self != NULL);
	old_value = bluetooth_main_view_get_manager (self);
	if (old_value != value) {
		BluetoothServicesObjectManager* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_manager);
		self->priv->_manager = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, bluetooth_main_view_properties[BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY]);
	}
}

static void
_bluetooth_main_view_complete_setup_g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	bluetooth_main_view_complete_setup ((BluetoothMainView*) self);
}

static GObject *
bluetooth_main_view_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	BluetoothMainView * self;
	HeEmptyPage* empty_alert = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	HeEmptyPage* _tmp3_ = NULL;
	HeEmptyPage* _tmp4_;
	HePillButton* _tmp5_;
	GtkListBox* _tmp6_ = NULL;
	GtkListBox* _tmp7_;
	GtkListBox* _tmp8_;
	GtkListBox* _tmp9_;
	GtkListBox* _tmp10_;
	HeEmptyPage* _tmp11_;
	GtkListBox* _tmp12_;
	GtkScrolledWindow* scrolled = NULL;
	GtkListBox* _tmp13_;
	GtkWidget* _tmp14_;
	GtkScrolledWindow* _tmp15_ = NULL;
	BisLatch* clamp = NULL;
	BisLatch* _tmp16_ = NULL;
	BisLatch* _tmp17_;
	GtkScrolledWindow* _tmp18_;
	BisLatch* _tmp19_;
	BluetoothServicesObjectManager* _tmp20_;
	gboolean _tmp21_;
	gboolean _tmp22_;
	parent_class = G_OBJECT_CLASS (bluetooth_main_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainView);
	_tmp0_ = g_strdup ("eye-not-looking-symbolic");
	_tmp1_ = g_strdup (_ ("No Devices Found"));
	_tmp2_ = g_strdup (_ ("Please ensure that your devices are visible and ready for pairing."));
	_tmp3_ = he_empty_page_new ();
	he_empty_page_set_icon (_tmp3_, _tmp0_);
	_g_free0 (_tmp0_);
	he_empty_page_set_title (_tmp3_, _tmp1_);
	_g_free0 (_tmp1_);
	he_empty_page_set_description (_tmp3_, _tmp2_);
	_g_free0 (_tmp2_);
	g_object_ref_sink (_tmp3_);
	empty_alert = _tmp3_;
	_tmp4_ = empty_alert;
	_tmp5_ = _tmp4_->action_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp5_, FALSE);
	_tmp6_ = (GtkListBox*) gtk_list_box_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp6_, TRUE);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->list_box);
	self->priv->list_box = _tmp6_;
	_tmp7_ = self->priv->list_box;
	gtk_widget_add_css_class ((GtkWidget*) _tmp7_, "content-list");
	_tmp8_ = self->priv->list_box;
	gtk_list_box_set_sort_func (_tmp8_, (GtkListBoxSortFunc) bluetooth_main_view_compare_rows, g_object_ref (self), g_object_unref);
	_tmp9_ = self->priv->list_box;
	gtk_list_box_set_header_func (_tmp9_, (GtkListBoxUpdateHeaderFunc) bluetooth_main_view_title_rows, g_object_ref (self), g_object_unref);
	_tmp10_ = self->priv->list_box;
	_tmp11_ = empty_alert;
	gtk_list_box_set_placeholder (_tmp10_, (GtkWidget*) _tmp11_);
	_tmp12_ = self->priv->list_box;
	gtk_list_box_set_selection_mode (_tmp12_, GTK_SELECTION_NONE);
	_tmp13_ = self->priv->list_box;
	_tmp14_ = _g_object_ref0 ((GtkWidget*) _tmp13_);
	_tmp15_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
	gtk_scrolled_window_set_child (_tmp15_, _tmp14_);
	_g_object_unref0 (_tmp14_);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp15_, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp15_, TRUE);
	g_object_ref_sink (_tmp15_);
	scrolled = _tmp15_;
	_tmp16_ = (BisLatch*) bis_latch_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp16_, TRUE);
	g_object_ref_sink (_tmp16_);
	clamp = _tmp16_;
	_tmp17_ = clamp;
	_tmp18_ = scrolled;
	bis_latch_set_child (_tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = clamp;
	gtk_widget_set_parent ((GtkWidget*) _tmp19_, (GtkWidget*) self);
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
	_tmp20_ = self->priv->_manager;
	_tmp21_ = bluetooth_services_object_manager_get_retrieve_finished (_tmp20_);
	_tmp22_ = _tmp21_;
	if (_tmp22_) {
		bluetooth_main_view_complete_setup (self);
	} else {
		BluetoothServicesObjectManager* _tmp23_;
		_tmp23_ = self->priv->_manager;
		g_signal_connect_object ((GObject*) _tmp23_, "notify::retrieve-finished", (GCallback) _bluetooth_main_view_complete_setup_g_object_notify, self, 0);
	}
	_g_object_unref0 (clamp);
	_g_object_unref0 (scrolled);
	_g_object_unref0 (empty_alert);
	return obj;
}

static void
bluetooth_main_view_class_init (BluetoothMainViewClass * klass,
                                gpointer klass_data)
{
	bluetooth_main_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &BluetoothMainView_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_bluetooth_main_view_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_bluetooth_main_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = bluetooth_main_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = bluetooth_main_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY, bluetooth_main_view_properties[BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY] = g_param_spec_object ("manager", "manager", "manager", BLUETOOTH_SERVICES_TYPE_OBJECT_MANAGER, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	bluetooth_main_view_signals[BLUETOOTH_MAIN_VIEW_QUIT_FUSE_SIGNAL] = g_signal_new ("quit-fuse", BLUETOOTH_TYPE_MAIN_VIEW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
bluetooth_main_view_instance_init (BluetoothMainView * self,
                                   gpointer klass)
{
	self->priv = bluetooth_main_view_get_instance_private (self);
}

static void
bluetooth_main_view_finalize (GObject * obj)
{
	BluetoothMainView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainView);
	_g_object_unref0 (self->priv->list_box);
	_g_object_unref0 (self->priv->_manager);
	G_OBJECT_CLASS (bluetooth_main_view_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
bluetooth_main_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (BluetoothMainViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bluetooth_main_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BluetoothMainView), 0, (GInstanceInitFunc) bluetooth_main_view_instance_init, NULL };
	GType bluetooth_main_view_type_id;
	bluetooth_main_view_type_id = g_type_register_static (HE_TYPE_BIN, "BluetoothMainView", &g_define_type_info, 0);
	BluetoothMainView_private_offset = g_type_add_instance_private (bluetooth_main_view_type_id, sizeof (BluetoothMainViewPrivate));
	return bluetooth_main_view_type_id;
}

GType
bluetooth_main_view_get_type (void)
{
	static gsize bluetooth_main_view_type_id__once = 0;
	if (g_once_init_enter (&bluetooth_main_view_type_id__once)) {
		GType bluetooth_main_view_type_id;
		bluetooth_main_view_type_id = bluetooth_main_view_get_type_once ();
		g_once_init_leave (&bluetooth_main_view_type_id__once, bluetooth_main_view_type_id);
	}
	return bluetooth_main_view_type_id__once;
}

static void
_vala_bluetooth_main_view_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	BluetoothMainView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainView);
	switch (property_id) {
		case BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY:
		g_value_set_object (value, bluetooth_main_view_get_manager (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_bluetooth_main_view_set_property (GObject * object,
                                        guint property_id,
                                        const GValue * value,
                                        GParamSpec * pspec)
{
	BluetoothMainView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, BLUETOOTH_TYPE_MAIN_VIEW, BluetoothMainView);
	switch (property_id) {
		case BLUETOOTH_MAIN_VIEW_MANAGER_PROPERTY:
		bluetooth_main_view_set_manager (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

