/* PairDialog.c generated by valac 0.56.13, the Vala compiler
 * generated from PairDialog.vala, do not modify */

/*
 * Copyright (c) 2023 Fyra Labs
 * Copyright (c) 2016-2022 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "fuse-bluetooth.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <libhelium-1.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>

enum  {
	PAIR_DIALOG_0_PROPERTY,
	PAIR_DIALOG_OBJECT_PATH_PROPERTY,
	PAIR_DIALOG_AUTH_TYPE_PROPERTY,
	PAIR_DIALOG_PASSKEY_PROPERTY,
	PAIR_DIALOG_CANCELLED_PROPERTY,
	PAIR_DIALOG_NUM_PROPERTIES
};
static GParamSpec* pair_dialog_properties[PAIR_DIALOG_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

struct _PairDialogPrivate {
	char* _object_path;
	PairDialogAuthType _auth_type;
	gchar* _passkey;
	gboolean _cancelled;
};

static gint PairDialog_private_offset;
static gpointer pair_dialog_parent_class = NULL;

static PairDialog* pair_dialog_new (GtkWindow* main_window);
static PairDialog* pair_dialog_construct (GType object_type,
                                   GtkWindow* main_window);
static GObject * pair_dialog_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void pair_dialog_finalize (GObject * obj);
static GType pair_dialog_get_type_once (void);
static void _vala_pair_dialog_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_pair_dialog_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);

static inline gpointer
pair_dialog_get_instance_private (PairDialog* self)
{
	return G_STRUCT_MEMBER_P (self, PairDialog_private_offset);
}

 G_GNUC_NO_INLINE static GType
pair_dialog_auth_type_get_type_once (void)
{
	static const GEnumValue values[] = {{PAIR_DIALOG_AUTH_TYPE_REQUEST_CONFIRMATION, "PAIR_DIALOG_AUTH_TYPE_REQUEST_CONFIRMATION", "request-confirmation"}, {PAIR_DIALOG_AUTH_TYPE_REQUEST_AUTHORIZATION, "PAIR_DIALOG_AUTH_TYPE_REQUEST_AUTHORIZATION", "request-authorization"}, {PAIR_DIALOG_AUTH_TYPE_DISPLAY_PASSKEY, "PAIR_DIALOG_AUTH_TYPE_DISPLAY_PASSKEY", "display-passkey"}, {PAIR_DIALOG_AUTH_TYPE_DISPLAY_PIN_CODE, "PAIR_DIALOG_AUTH_TYPE_DISPLAY_PIN_CODE", "display-pin-code"}, {0, NULL, NULL}};
	GType pair_dialog_auth_type_type_id;
	pair_dialog_auth_type_type_id = g_enum_register_static ("PairDialogAuthType", values);
	return pair_dialog_auth_type_type_id;
}

GType
pair_dialog_auth_type_get_type (void)
{
	static gsize pair_dialog_auth_type_type_id__once = 0;
	if (g_once_init_enter (&pair_dialog_auth_type_type_id__once)) {
		GType pair_dialog_auth_type_type_id;
		pair_dialog_auth_type_type_id = pair_dialog_auth_type_get_type_once ();
		g_once_init_leave (&pair_dialog_auth_type_type_id__once, pair_dialog_auth_type_type_id);
	}
	return pair_dialog_auth_type_type_id__once;
}

static PairDialog*
pair_dialog_construct (GType object_type,
                       GtkWindow* main_window)
{
	PairDialog * self = NULL;
	self = (PairDialog*) he_dialog_construct (object_type, TRUE, main_window, "", "", "", "", NULL, NULL);
	return self;
}

static PairDialog*
pair_dialog_new (GtkWindow* main_window)
{
	return pair_dialog_construct (TYPE_PAIR_DIALOG, main_window);
}

PairDialog*
pair_dialog_construct_request_authorization (GType object_type,
                                             const char* object_path,
                                             GtkWindow* main_window)
{
	PairDialog * self = NULL;
	g_return_val_if_fail (object_path != NULL, NULL);
	self = (PairDialog*) g_object_new (object_type, "auth-type", PAIR_DIALOG_AUTH_TYPE_REQUEST_AUTHORIZATION, "object-path", object_path, "title", _ ("Confirm Bluetooth Pairing"), "transient-for", main_window, NULL);
	return self;
}

PairDialog*
pair_dialog_new_request_authorization (const char* object_path,
                                       GtkWindow* main_window)
{
	return pair_dialog_construct_request_authorization (TYPE_PAIR_DIALOG, object_path, main_window);
}

PairDialog*
pair_dialog_construct_display_passkey (GType object_type,
                                       const char* object_path,
                                       guint32 passkey,
                                       guint16 entered,
                                       GtkWindow* main_window)
{
	PairDialog * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (object_path != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%u", (guint) passkey);
	_tmp1_ = _tmp0_;
	self = (PairDialog*) g_object_new (object_type, "auth-type", PAIR_DIALOG_AUTH_TYPE_DISPLAY_PASSKEY, "object-path", object_path, "passkey", _tmp1_, "title", _ ("Confirm Bluetooth Passkey"), "transient-for", main_window, NULL);
	_g_free0 (_tmp1_);
	return self;
}

PairDialog*
pair_dialog_new_display_passkey (const char* object_path,
                                 guint32 passkey,
                                 guint16 entered,
                                 GtkWindow* main_window)
{
	return pair_dialog_construct_display_passkey (TYPE_PAIR_DIALOG, object_path, passkey, entered, main_window);
}

PairDialog*
pair_dialog_construct_request_confirmation (GType object_type,
                                            const char* object_path,
                                            guint32 passkey,
                                            GtkWindow* main_window)
{
	PairDialog * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	g_return_val_if_fail (object_path != NULL, NULL);
	_tmp0_ = g_strdup_printf ("%u", (guint) passkey);
	_tmp1_ = _tmp0_;
	self = (PairDialog*) g_object_new (object_type, "auth-type", PAIR_DIALOG_AUTH_TYPE_REQUEST_CONFIRMATION, "object-path", object_path, "passkey", _tmp1_, "title", _ ("Confirm Bluetooth Passkey"), "transient-for", main_window, NULL);
	_g_free0 (_tmp1_);
	return self;
}

PairDialog*
pair_dialog_new_request_confirmation (const char* object_path,
                                      guint32 passkey,
                                      GtkWindow* main_window)
{
	return pair_dialog_construct_request_confirmation (TYPE_PAIR_DIALOG, object_path, passkey, main_window);
}

PairDialog*
pair_dialog_construct_display_pin_code (GType object_type,
                                        const char* object_path,
                                        const gchar* pincode,
                                        GtkWindow* main_window)
{
	PairDialog * self = NULL;
	g_return_val_if_fail (object_path != NULL, NULL);
	g_return_val_if_fail (pincode != NULL, NULL);
	self = (PairDialog*) g_object_new (object_type, "auth-type", PAIR_DIALOG_AUTH_TYPE_DISPLAY_PIN_CODE, "object-path", object_path, "passkey", pincode, "title", _ ("Enter Bluetooth PIN"), "transient-for", main_window, NULL);
	return self;
}

PairDialog*
pair_dialog_new_display_pin_code (const char* object_path,
                                  const gchar* pincode,
                                  GtkWindow* main_window)
{
	return pair_dialog_construct_display_pin_code (TYPE_PAIR_DIALOG, object_path, pincode, main_window);
}

const char*
pair_dialog_get_object_path (PairDialog* self)
{
	const char* result;
	const char* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_object_path;
	result = _tmp0_;
	return result;
}

static void
pair_dialog_set_object_path (PairDialog* self,
                             const char* value)
{
	char* old_value;
	g_return_if_fail (self != NULL);
	old_value = pair_dialog_get_object_path (self);
	if (g_strcmp0 (value, old_value) != 0) {
		char* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_object_path);
		self->priv->_object_path = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pair_dialog_properties[PAIR_DIALOG_OBJECT_PATH_PROPERTY]);
	}
}

PairDialogAuthType
pair_dialog_get_auth_type (PairDialog* self)
{
	PairDialogAuthType result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_auth_type;
	return result;
}

static void
pair_dialog_set_auth_type (PairDialog* self,
                           PairDialogAuthType value)
{
	PairDialogAuthType old_value;
	g_return_if_fail (self != NULL);
	old_value = pair_dialog_get_auth_type (self);
	if (old_value != value) {
		self->priv->_auth_type = value;
		g_object_notify_by_pspec ((GObject *) self, pair_dialog_properties[PAIR_DIALOG_AUTH_TYPE_PROPERTY]);
	}
}

const gchar*
pair_dialog_get_passkey (PairDialog* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_passkey;
	result = _tmp0_;
	return result;
}

static void
pair_dialog_set_passkey (PairDialog* self,
                         const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = pair_dialog_get_passkey (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_passkey);
		self->priv->_passkey = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, pair_dialog_properties[PAIR_DIALOG_PASSKEY_PROPERTY]);
	}
}

gboolean
pair_dialog_get_cancelled (PairDialog* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_cancelled;
	return result;
}

void
pair_dialog_set_cancelled (PairDialog* self,
                           gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = pair_dialog_get_cancelled (self);
	if (old_value != value) {
		self->priv->_cancelled = value;
		g_object_notify_by_pspec ((GObject *) self, pair_dialog_properties[PAIR_DIALOG_CANCELLED_PROPERTY]);
	}
}

static GObject *
pair_dialog_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PairDialog * self;
	BluetoothServicesDevice* device = NULL;
	gchar* device_name = NULL;
	gchar* _tmp0_;
	PairDialogAuthType _tmp20_;
	gboolean _tmp40_ = FALSE;
	const gchar* _tmp41_;
	GError* _inner_error0_ = NULL;
	parent_class = G_OBJECT_CLASS (pair_dialog_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAIR_DIALOG, PairDialog);
	_tmp0_ = g_strdup (_ ("Unknown Bluetooth Device"));
	device_name = _tmp0_;
	{
		BluetoothServicesDevice* _tmp1_ = NULL;
		const char* _tmp2_;
		BluetoothServicesDevice* _tmp3_;
		BluetoothServicesDevice* _tmp4_;
		gchar* _tmp5_ = NULL;
		BluetoothServicesDevice* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp10_ = NULL;
		BluetoothServicesDevice* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp17_;
		_tmp2_ = self->priv->_object_path;
		_tmp3_ = (BluetoothServicesDevice*) g_initable_new (BLUETOOTH_SERVICES_TYPE_DEVICE_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_GET_INVALIDATED_PROPERTIES, "g-name", "org.bluez", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", (const gchar*) _tmp2_, "g-interface-name", "org.bluez.Device1", NULL);
		_tmp1_ = (BluetoothServicesDevice*) _tmp3_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_IO_ERROR) {
				goto __catch0_g_io_error;
			}
			_g_free0 (device_name);
			_g_object_unref0 (device);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
		}
		_tmp4_ = _tmp1_;
		_tmp1_ = NULL;
		_g_object_unref0 (device);
		device = _tmp4_;
		_tmp6_ = device;
		_tmp7_ = bluetooth_services_device_get_icon (_tmp6_);
		_tmp8_ = _tmp7_;
		_tmp5_ = _tmp8_;
		if (_tmp5_ == NULL) {
			gchar* _tmp9_;
			_tmp9_ = g_strdup ("settings-bluetooth-symbolic");
			_g_free0 (_tmp5_);
			_tmp5_ = _tmp9_;
		}
		he_dialog_set_icon ((HeDialog*) self, _tmp5_);
		_tmp11_ = device;
		_tmp12_ = bluetooth_services_device_get_name (_tmp11_);
		_tmp13_ = _tmp12_;
		_tmp10_ = _tmp13_;
		if (_tmp10_ == NULL) {
			BluetoothServicesDevice* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			_tmp14_ = device;
			_tmp15_ = bluetooth_services_device_get_address (_tmp14_);
			_tmp16_ = _tmp15_;
			_g_free0 (_tmp10_);
			_tmp10_ = _tmp16_;
		}
		_tmp17_ = _tmp10_;
		_tmp10_ = NULL;
		_g_free0 (device_name);
		device_name = _tmp17_;
		_g_free0 (_tmp10_);
		_g_free0 (_tmp5_);
		_g_object_unref0 (_tmp1_);
	}
	goto __finally0;
	__catch0_g_io_error:
	{
		GError* e = NULL;
		GError* _tmp18_;
		const gchar* _tmp19_;
		e = _inner_error0_;
		_inner_error0_ = NULL;
		he_dialog_set_icon ((HeDialog*) self, "settings-bluetooth-symbolic");
		_tmp18_ = e;
		_tmp19_ = _tmp18_->message;
		g_critical ("PairDialog.vala:95: %s", _tmp19_);
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_free0 (device_name);
		_g_object_unref0 (device);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
	}
	_tmp20_ = self->priv->_auth_type;
	switch (_tmp20_) {
		case PAIR_DIALOG_AUTH_TYPE_REQUEST_CONFIRMATION:
		{
			const gchar* _tmp21_;
			gchar* _tmp22_;
			gchar* _tmp23_;
			HeFillButton* confirm_button = NULL;
			HeFillButton* _tmp24_;
			HeFillButton* _tmp25_;
			_tmp21_ = device_name;
			_tmp22_ = g_strdup_printf (_ ("See if the code displayed on “%s” matches below."), _tmp21_);
			_tmp23_ = _tmp22_;
			he_dialog_set_info ((HeDialog*) self, _tmp23_);
			_g_free0 (_tmp23_);
			_tmp24_ = he_fill_button_new (_ ("Pair"));
			g_object_ref_sink (_tmp24_);
			confirm_button = _tmp24_;
			_tmp25_ = confirm_button;
			he_dialog_set_primary_button ((HeDialog*) self, _tmp25_);
			_g_object_unref0 (confirm_button);
			break;
		}
		case PAIR_DIALOG_AUTH_TYPE_DISPLAY_PASSKEY:
		{
			const gchar* _tmp26_;
			const gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
			HeFillButton* confirm_button = NULL;
			HeFillButton* _tmp30_;
			HeFillButton* _tmp31_;
			_tmp26_ = device_name;
			_tmp27_ = device_name;
			_tmp28_ = g_strdup_printf (_ ("“%s” wants to pair with this device. See if the code displayed on “%s”" \
" matches below."), _tmp26_, _tmp27_);
			_tmp29_ = _tmp28_;
			he_dialog_set_info ((HeDialog*) self, _tmp29_);
			_g_free0 (_tmp29_);
			_tmp30_ = he_fill_button_new (_ ("Pair"));
			g_object_ref_sink (_tmp30_);
			confirm_button = _tmp30_;
			_tmp31_ = confirm_button;
			he_dialog_set_primary_button ((HeDialog*) self, _tmp31_);
			_g_object_unref0 (confirm_button);
			break;
		}
		case PAIR_DIALOG_AUTH_TYPE_DISPLAY_PIN_CODE:
		{
			const gchar* _tmp32_;
			gchar* _tmp33_;
			gchar* _tmp34_;
			_tmp32_ = device_name;
			_tmp33_ = g_strdup_printf (_ ("Type the code displayed below on “%s”, followed by Enter."), _tmp32_);
			_tmp34_ = _tmp33_;
			he_dialog_set_info ((HeDialog*) self, _tmp34_);
			_g_free0 (_tmp34_);
			break;
		}
		case PAIR_DIALOG_AUTH_TYPE_REQUEST_AUTHORIZATION:
		{
			const gchar* _tmp35_;
			gchar* _tmp36_;
			gchar* _tmp37_;
			HeFillButton* confirm_button = NULL;
			HeFillButton* _tmp38_;
			HeFillButton* _tmp39_;
			_tmp35_ = device_name;
			_tmp36_ = g_strdup_printf (_ ("“%s” wants to pair with this device."), _tmp35_);
			_tmp37_ = _tmp36_;
			he_dialog_set_info ((HeDialog*) self, _tmp37_);
			_g_free0 (_tmp37_);
			_tmp38_ = he_fill_button_new (_ ("Pair"));
			g_object_ref_sink (_tmp38_);
			confirm_button = _tmp38_;
			_tmp39_ = confirm_button;
			he_dialog_set_primary_button ((HeDialog*) self, _tmp39_);
			_g_object_unref0 (confirm_button);
			break;
		}
		default:
		break;
	}
	_tmp41_ = self->priv->_passkey;
	if (_tmp41_ != NULL) {
		const gchar* _tmp42_;
		_tmp42_ = self->priv->_passkey;
		_tmp40_ = g_strcmp0 (_tmp42_, "") != 0;
	} else {
		_tmp40_ = FALSE;
	}
	if (_tmp40_) {
		GtkLabel* passkey_label = NULL;
		const gchar* _tmp43_;
		GtkLabel* _tmp44_;
		GtkLabel* _tmp45_;
		GtkLabel* _tmp46_;
		_tmp43_ = self->priv->_passkey;
		_tmp44_ = (GtkLabel*) gtk_label_new (_tmp43_);
		g_object_ref_sink (_tmp44_);
		passkey_label = _tmp44_;
		_tmp45_ = passkey_label;
		gtk_widget_add_css_class ((GtkWidget*) _tmp45_, "display");
		_tmp46_ = passkey_label;
		he_dialog_add ((HeDialog*) self, (GtkWidget*) _tmp46_);
		_g_object_unref0 (passkey_label);
	}
	gtk_window_set_modal ((GtkWindow*) self, TRUE);
	_g_free0 (device_name);
	_g_object_unref0 (device);
	return obj;
}

static void
pair_dialog_class_init (PairDialogClass * klass,
                        gpointer klass_data)
{
	pair_dialog_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &PairDialog_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_pair_dialog_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_pair_dialog_set_property;
	G_OBJECT_CLASS (klass)->constructor = pair_dialog_constructor;
	G_OBJECT_CLASS (klass)->finalize = pair_dialog_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAIR_DIALOG_OBJECT_PATH_PROPERTY, pair_dialog_properties[PAIR_DIALOG_OBJECT_PATH_PROPERTY] = g_param_spec_string ("object-path", "object-path", "object-path", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAIR_DIALOG_AUTH_TYPE_PROPERTY, pair_dialog_properties[PAIR_DIALOG_AUTH_TYPE_PROPERTY] = g_param_spec_enum ("auth-type", "auth-type", "auth-type", PAIR_DIALOG_TYPE_AUTH_TYPE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAIR_DIALOG_PASSKEY_PROPERTY, pair_dialog_properties[PAIR_DIALOG_PASSKEY_PROPERTY] = g_param_spec_string ("passkey", "passkey", "passkey", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), PAIR_DIALOG_CANCELLED_PROPERTY, pair_dialog_properties[PAIR_DIALOG_CANCELLED_PROPERTY] = g_param_spec_boolean ("cancelled", "cancelled", "cancelled", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
pair_dialog_instance_init (PairDialog * self,
                           gpointer klass)
{
	self->priv = pair_dialog_get_instance_private (self);
}

static void
pair_dialog_finalize (GObject * obj)
{
	PairDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PAIR_DIALOG, PairDialog);
	_g_free0 (self->priv->_object_path);
	_g_free0 (self->priv->_passkey);
	G_OBJECT_CLASS (pair_dialog_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
pair_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PairDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pair_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PairDialog), 0, (GInstanceInitFunc) pair_dialog_instance_init, NULL };
	GType pair_dialog_type_id;
	pair_dialog_type_id = g_type_register_static (HE_TYPE_DIALOG, "PairDialog", &g_define_type_info, 0);
	PairDialog_private_offset = g_type_add_instance_private (pair_dialog_type_id, sizeof (PairDialogPrivate));
	return pair_dialog_type_id;
}

GType
pair_dialog_get_type (void)
{
	static gsize pair_dialog_type_id__once = 0;
	if (g_once_init_enter (&pair_dialog_type_id__once)) {
		GType pair_dialog_type_id;
		pair_dialog_type_id = pair_dialog_get_type_once ();
		g_once_init_leave (&pair_dialog_type_id__once, pair_dialog_type_id);
	}
	return pair_dialog_type_id__once;
}

static void
_vala_pair_dialog_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	PairDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAIR_DIALOG, PairDialog);
	switch (property_id) {
		case PAIR_DIALOG_OBJECT_PATH_PROPERTY:
		g_value_set_string (value, pair_dialog_get_object_path (self));
		break;
		case PAIR_DIALOG_AUTH_TYPE_PROPERTY:
		g_value_set_enum (value, pair_dialog_get_auth_type (self));
		break;
		case PAIR_DIALOG_PASSKEY_PROPERTY:
		g_value_set_string (value, pair_dialog_get_passkey (self));
		break;
		case PAIR_DIALOG_CANCELLED_PROPERTY:
		g_value_set_boolean (value, pair_dialog_get_cancelled (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_pair_dialog_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	PairDialog * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_PAIR_DIALOG, PairDialog);
	switch (property_id) {
		case PAIR_DIALOG_OBJECT_PATH_PROPERTY:
		pair_dialog_set_object_path (self, g_value_get_string (value));
		break;
		case PAIR_DIALOG_AUTH_TYPE_PROPERTY:
		pair_dialog_set_auth_type (self, g_value_get_enum (value));
		break;
		case PAIR_DIALOG_PASSKEY_PROPERTY:
		pair_dialog_set_passkey (self, g_value_get_string (value));
		break;
		case PAIR_DIALOG_CANCELLED_PROPERTY:
		pair_dialog_set_cancelled (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

