/* WorldLocationFinder.c generated by valac 0.56.13, the Vala compiler
 * generated from WorldLocationFinder.vala, do not modify */

/*
 * Copyright (c) 2022 Fyra Labs
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA
 */

#include "fuse-datetime.h"
#include <libgweather/gweather.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <gio/gio.h>
#include <libhelium-1.h>
#include <glib/gi18n-lib.h>

#define DATE_TIME_WORLD_LOCATION_FINDER_RESULT_COUNT_LIMIT 6

enum  {
	DATE_TIME_WEATHER_LOCATION_0_PROPERTY,
	DATE_TIME_WEATHER_LOCATION_LOC_PROPERTY,
	DATE_TIME_WEATHER_LOCATION_SELECTED_PROPERTY,
	DATE_TIME_WEATHER_LOCATION_NUM_PROPERTIES
};
static GParamSpec* date_time_weather_location_properties[DATE_TIME_WEATHER_LOCATION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	DATE_TIME_LOCATION_ROW_0_PROPERTY,
	DATE_TIME_LOCATION_ROW_DATA_PROPERTY,
	DATE_TIME_LOCATION_ROW_LNAME_PROPERTY,
	DATE_TIME_LOCATION_ROW_LOCATION_PROPERTY,
	DATE_TIME_LOCATION_ROW_LOC_SELECTED_PROPERTY,
	DATE_TIME_LOCATION_ROW_NUM_PROPERTIES
};
static GParamSpec* date_time_location_row_properties[DATE_TIME_LOCATION_ROW_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
enum  {
	DATE_TIME_WORLD_LOCATION_FINDER_0_PROPERTY,
	DATE_TIME_WORLD_LOCATION_FINDER_SELECTED_ROW_PROPERTY,
	DATE_TIME_WORLD_LOCATION_FINDER_NUM_PROPERTIES
};
static GParamSpec* date_time_world_location_finder_properties[DATE_TIME_WORLD_LOCATION_FINDER_NUM_PROPERTIES];
enum  {
	DATE_TIME_WORLD_LOCATION_FINDER_LOCATION_ADDED_SIGNAL,
	DATE_TIME_WORLD_LOCATION_FINDER_NUM_SIGNALS
};
static guint date_time_world_location_finder_signals[DATE_TIME_WORLD_LOCATION_FINDER_NUM_SIGNALS] = {0};

struct _DateTimeWeatherLocationPrivate {
	GWeatherLocation* _loc;
	gboolean _selected;
};

struct _DateTimeLocationRowPrivate {
	DateTimeWeatherLocation* _data;
	gchar* _lname;
	gchar* _location;
	gboolean _loc_selected;
};

struct _DateTimeWorldLocationFinderPrivate {
	GListStore* locations;
	DateTimeLocationRow* _selected_row;
	HeEmptyPage* search_label;
	GtkStack* search_stack;
	GtkListBox* listbox;
	GtkSearchEntry* search_entry;
	HePillButton* add_button;
};

static gint DateTimeWeatherLocation_private_offset;
static gpointer date_time_weather_location_parent_class = NULL;
static gint DateTimeLocationRow_private_offset;
static gpointer date_time_location_row_parent_class = NULL;
static gint DateTimeWorldLocationFinder_private_offset;
static gpointer date_time_world_location_finder_parent_class = NULL;

static void date_time_weather_location_finalize (GObject * obj);
static GType date_time_weather_location_get_type_once (void);
static void _vala_date_time_weather_location_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec);
static void _vala_date_time_weather_location_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec);
static void date_time_location_row_finalize (GObject * obj);
static GType date_time_location_row_get_type_once (void);
static void _vala_date_time_location_row_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_date_time_location_row_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);
static void date_time_world_location_finder_add_button_clicked (DateTimeWorldLocationFinder* self);
static void date_time_world_location_finder_query_locations (DateTimeWorldLocationFinder* self,
                                                      GWeatherLocation* lc,
                                                      const gchar* search);
static void date_time_world_location_finder_item_activated (DateTimeWorldLocationFinder* self,
                                                     GtkListBoxRow* listbox_row);
static GObject * date_time_world_location_finder_constructor (GType type,
                                                       guint n_construct_properties,
                                                       GObjectConstructParam * construct_properties);
static GtkWidget* _date_time_world_location_finder___lambda5_ (DateTimeWorldLocationFinder* self,
                                                        GObject* data);
static GtkWidget* __date_time_world_location_finder___lambda5__gtk_list_box_create_widget_func (GObject* item,
                                                                                         gpointer self);
static void _date_time_world_location_finder_item_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                                 GtkListBoxRow* row,
                                                                                 gpointer self);
static void _date_time_world_location_finder_add_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                             gpointer self);
static void _date_time_world_location_finder___lambda6_ (DateTimeWorldLocationFinder* self);
static gint __lambda7_ (DateTimeWorldLocationFinder* self,
                 GObject* a,
                 GObject* b);
static gint ___lambda7__gcompare_data_func (gconstpointer a,
                                     gconstpointer b,
                                     gpointer self);
static void __date_time_world_location_finder___lambda6__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                                   gpointer self);
static void _date_time_world_location_finder___lambda8_ (DateTimeWorldLocationFinder* self);
static void __date_time_world_location_finder___lambda8__g_object_notify (GObject* _sender,
                                                                   GParamSpec* pspec,
                                                                   gpointer self);
static void date_time_world_location_finder_finalize (GObject * obj);
static GType date_time_world_location_finder_get_type_once (void);
static void _vala_date_time_world_location_finder_get_property (GObject * object,
                                                         guint property_id,
                                                         GValue * value,
                                                         GParamSpec * pspec);
static void _vala_date_time_world_location_finder_set_property (GObject * object,
                                                         guint property_id,
                                                         const GValue * value,
                                                         GParamSpec * pspec);

static inline gpointer
date_time_weather_location_get_instance_private (DateTimeWeatherLocation* self)
{
	return G_STRUCT_MEMBER_P (self, DateTimeWeatherLocation_private_offset);
}

DateTimeWeatherLocation*
date_time_weather_location_construct (GType object_type,
                                      GWeatherLocation* loc,
                                      gboolean selected)
{
	DateTimeWeatherLocation * self = NULL;
	g_return_val_if_fail (loc != NULL, NULL);
	self = (DateTimeWeatherLocation*) g_object_new (object_type, "loc", loc, "selected", selected, NULL);
	return self;
}

DateTimeWeatherLocation*
date_time_weather_location_new (GWeatherLocation* loc,
                                gboolean selected)
{
	return date_time_weather_location_construct (DATE_TIME_TYPE_WEATHER_LOCATION, loc, selected);
}

GWeatherLocation*
date_time_weather_location_get_loc (DateTimeWeatherLocation* self)
{
	GWeatherLocation* result;
	GWeatherLocation* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_loc;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

void
date_time_weather_location_set_loc (DateTimeWeatherLocation* self,
                                    GWeatherLocation* value)
{
	GWeatherLocation* old_value;
	g_return_if_fail (self != NULL);
	old_value = date_time_weather_location_get_loc (self);
	if (old_value != value) {
		GWeatherLocation* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_loc);
		self->priv->_loc = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, date_time_weather_location_properties[DATE_TIME_WEATHER_LOCATION_LOC_PROPERTY]);
	}
}

gboolean
date_time_weather_location_get_selected (DateTimeWeatherLocation* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_selected;
	return result;
}

void
date_time_weather_location_set_selected (DateTimeWeatherLocation* self,
                                         gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = date_time_weather_location_get_selected (self);
	if (old_value != value) {
		self->priv->_selected = value;
		g_object_notify_by_pspec ((GObject *) self, date_time_weather_location_properties[DATE_TIME_WEATHER_LOCATION_SELECTED_PROPERTY]);
	}
}

static void
date_time_weather_location_class_init (DateTimeWeatherLocationClass * klass,
                                       gpointer klass_data)
{
	date_time_weather_location_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DateTimeWeatherLocation_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_date_time_weather_location_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_date_time_weather_location_set_property;
	G_OBJECT_CLASS (klass)->finalize = date_time_weather_location_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_WEATHER_LOCATION_LOC_PROPERTY, date_time_weather_location_properties[DATE_TIME_WEATHER_LOCATION_LOC_PROPERTY] = g_param_spec_object ("loc", "loc", "loc", gweather_location_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_WEATHER_LOCATION_SELECTED_PROPERTY, date_time_weather_location_properties[DATE_TIME_WEATHER_LOCATION_SELECTED_PROPERTY] = g_param_spec_boolean ("selected", "selected", "selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
date_time_weather_location_instance_init (DateTimeWeatherLocation * self,
                                          gpointer klass)
{
	self->priv = date_time_weather_location_get_instance_private (self);
}

static void
date_time_weather_location_finalize (GObject * obj)
{
	DateTimeWeatherLocation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_TYPE_WEATHER_LOCATION, DateTimeWeatherLocation);
	_g_object_unref0 (self->priv->_loc);
	G_OBJECT_CLASS (date_time_weather_location_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
date_time_weather_location_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DateTimeWeatherLocationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) date_time_weather_location_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DateTimeWeatherLocation), 0, (GInstanceInitFunc) date_time_weather_location_instance_init, NULL };
	GType date_time_weather_location_type_id;
	date_time_weather_location_type_id = g_type_register_static (G_TYPE_OBJECT, "DateTimeWeatherLocation", &g_define_type_info, 0);
	DateTimeWeatherLocation_private_offset = g_type_add_instance_private (date_time_weather_location_type_id, sizeof (DateTimeWeatherLocationPrivate));
	return date_time_weather_location_type_id;
}

GType
date_time_weather_location_get_type (void)
{
	static gsize date_time_weather_location_type_id__once = 0;
	if (g_once_init_enter (&date_time_weather_location_type_id__once)) {
		GType date_time_weather_location_type_id;
		date_time_weather_location_type_id = date_time_weather_location_get_type_once ();
		g_once_init_leave (&date_time_weather_location_type_id__once, date_time_weather_location_type_id);
	}
	return date_time_weather_location_type_id__once;
}

static void
_vala_date_time_weather_location_get_property (GObject * object,
                                               guint property_id,
                                               GValue * value,
                                               GParamSpec * pspec)
{
	DateTimeWeatherLocation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_TYPE_WEATHER_LOCATION, DateTimeWeatherLocation);
	switch (property_id) {
		case DATE_TIME_WEATHER_LOCATION_LOC_PROPERTY:
		g_value_set_object (value, date_time_weather_location_get_loc (self));
		break;
		case DATE_TIME_WEATHER_LOCATION_SELECTED_PROPERTY:
		g_value_set_boolean (value, date_time_weather_location_get_selected (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_date_time_weather_location_set_property (GObject * object,
                                               guint property_id,
                                               const GValue * value,
                                               GParamSpec * pspec)
{
	DateTimeWeatherLocation * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_TYPE_WEATHER_LOCATION, DateTimeWeatherLocation);
	switch (property_id) {
		case DATE_TIME_WEATHER_LOCATION_LOC_PROPERTY:
		date_time_weather_location_set_loc (self, g_value_get_object (value));
		break;
		case DATE_TIME_WEATHER_LOCATION_SELECTED_PROPERTY:
		date_time_weather_location_set_selected (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
date_time_location_row_get_instance_private (DateTimeLocationRow* self)
{
	return G_STRUCT_MEMBER_P (self, DateTimeLocationRow_private_offset);
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	if ((*((gchar*) self)) == '\0') {
		_tmp1_ = TRUE;
	} else {
		_tmp1_ = (*((gchar*) old)) == '\0';
	}
	if (_tmp1_) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
	}
	if (_tmp0_) {
		gchar* _tmp2_;
		_tmp2_ = g_strdup (self);
		result = _tmp2_;
		return result;
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		_tmp3_ = g_regex_escape_string (old, -1);
		_tmp4_ = _tmp3_;
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
		_tmp6_ = _tmp5_;
		_g_free0 (_tmp4_);
		regex = _tmp6_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp8_ = regex;
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
		_tmp7_ = _tmp9_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_regex_unref0 (regex);
			if (_inner_error0_->domain == G_REGEX_ERROR) {
				goto __catch0_g_regex_error;
			}
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_tmp10_ = _tmp7_;
		_tmp7_ = NULL;
		result = _tmp10_;
		_g_free0 (_tmp7_);
		_g_regex_unref0 (regex);
		return result;
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
		g_clear_error (&_inner_error0_);
		g_assert_not_reached ();
	}
	__finally0:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
	g_clear_error (&_inner_error0_);
	return NULL;
}

DateTimeLocationRow*
date_time_location_row_construct (GType object_type,
                                  DateTimeWeatherLocation* data)
{
	DateTimeLocationRow * self = NULL;
	GWeatherLocation* _tmp0_;
	GWeatherLocation* _tmp1_;
	const gchar* _tmp2_;
	GWeatherLocation* _tmp3_;
	GWeatherLocation* _tmp4_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	GtkLabel* loc_label = NULL;
	const gchar* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkLabel* loc_ct_label = NULL;
	const gchar* _tmp16_;
	GtkLabel* _tmp17_;
	GtkLabel* _tmp18_;
	GtkLabel* _tmp19_;
	GtkImage* loc_icon = NULL;
	GtkImage* _tmp20_;
	GtkImage* _tmp21_;
	gboolean _tmp22_ = FALSE;
	gboolean _tmp23_;
	gboolean _tmp24_;
	GtkImage* _tmp25_;
	GtkBox* loc_box = NULL;
	GtkBox* _tmp26_;
	GtkLabel* _tmp27_;
	GtkLabel* _tmp28_;
	GtkImage* _tmp29_;
	GtkBox* _tmp30_;
	GtkBox* _tmp31_;
	GtkBox* _tmp32_;
	GtkBox* _tmp33_;
	g_return_val_if_fail (data != NULL, NULL);
	self = (DateTimeLocationRow*) g_object_new (object_type, "data", data, NULL);
	_tmp0_ = date_time_weather_location_get_loc (data);
	_tmp1_ = _tmp0_;
	_tmp2_ = gweather_location_get_name (_tmp1_);
	date_time_location_row_set_lname (self, _tmp2_);
	_tmp3_ = date_time_weather_location_get_loc (data);
	_tmp4_ = _tmp3_;
	_tmp5_ = gweather_location_get_timezone_str (_tmp4_);
	_tmp6_ = string_replace (_tmp5_, "_", " ");
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat ("(", _tmp7_, NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat (_tmp9_, ")", NULL);
	_tmp11_ = _tmp10_;
	date_time_location_row_set_location (self, _tmp11_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	g_object_bind_property_with_closures ((GObject*) data, "selected", (GObject*) self, "loc-selected", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp12_ = self->priv->_lname;
	_tmp13_ = (GtkLabel*) gtk_label_new (_tmp12_);
	g_object_ref_sink (_tmp13_);
	loc_label = _tmp13_;
	_tmp14_ = loc_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_START);
	_tmp15_ = loc_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp15_, "cb-title");
	_tmp16_ = self->priv->_location;
	_tmp17_ = (GtkLabel*) gtk_label_new (_tmp16_);
	g_object_ref_sink (_tmp17_);
	loc_ct_label = _tmp17_;
	_tmp18_ = loc_ct_label;
	gtk_widget_set_halign ((GtkWidget*) _tmp18_, GTK_ALIGN_START);
	_tmp19_ = loc_ct_label;
	gtk_widget_add_css_class ((GtkWidget*) _tmp19_, "cb-subtitle");
	_tmp20_ = (GtkImage*) gtk_image_new_from_icon_name ("list-add-symbolic");
	g_object_ref_sink (_tmp20_);
	loc_icon = _tmp20_;
	_tmp21_ = loc_icon;
	gtk_widget_set_halign ((GtkWidget*) _tmp21_, GTK_ALIGN_END);
	_tmp23_ = date_time_weather_location_get_selected (data);
	_tmp24_ = _tmp23_;
	if (_tmp24_) {
		_tmp22_ = TRUE;
	} else {
		_tmp22_ = FALSE;
	}
	_tmp25_ = loc_icon;
	gtk_widget_set_visible ((GtkWidget*) _tmp25_, _tmp22_);
	_tmp26_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp26_);
	loc_box = _tmp26_;
	_tmp27_ = loc_label;
	gtk_box_append (loc_box, (GtkWidget*) _tmp27_);
	_tmp28_ = loc_ct_label;
	gtk_box_append (loc_box, (GtkWidget*) _tmp28_);
	_tmp29_ = loc_icon;
	gtk_box_append (loc_box, (GtkWidget*) _tmp29_);
	_tmp30_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 0);
	g_object_ref_sink (_tmp30_);
	_g_object_unref0 (self->main_box);
	self->main_box = _tmp30_;
	_tmp31_ = self->main_box;
	gtk_widget_add_css_class ((GtkWidget*) _tmp31_, "mini-content-block");
	_tmp32_ = self->main_box;
	gtk_box_append (_tmp32_, (GtkWidget*) loc_box);
	_tmp33_ = self->main_box;
	gtk_list_box_row_set_child ((GtkListBoxRow*) self, (GtkWidget*) _tmp33_);
	g_object_bind_property_with_closures ((GObject*) data, "selected", (GObject*) self, "loc-selected", G_BINDING_SYNC_CREATE, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_g_object_unref0 (loc_box);
	_g_object_unref0 (loc_icon);
	_g_object_unref0 (loc_ct_label);
	_g_object_unref0 (loc_label);
	return self;
}

DateTimeLocationRow*
date_time_location_row_new (DateTimeWeatherLocation* data)
{
	return date_time_location_row_construct (DATE_TIME_TYPE_LOCATION_ROW, data);
}

DateTimeWeatherLocation*
date_time_location_row_get_data (DateTimeLocationRow* self)
{
	DateTimeWeatherLocation* result;
	DateTimeWeatherLocation* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_data;
	result = _tmp0_;
	return result;
}

void
date_time_location_row_set_data (DateTimeLocationRow* self,
                                 DateTimeWeatherLocation* value)
{
	DateTimeWeatherLocation* old_value;
	g_return_if_fail (self != NULL);
	old_value = date_time_location_row_get_data (self);
	if (old_value != value) {
		DateTimeWeatherLocation* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_data);
		self->priv->_data = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, date_time_location_row_properties[DATE_TIME_LOCATION_ROW_DATA_PROPERTY]);
	}
}

const gchar*
date_time_location_row_get_lname (DateTimeLocationRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_lname;
	result = _tmp0_;
	return result;
}

void
date_time_location_row_set_lname (DateTimeLocationRow* self,
                                  const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = date_time_location_row_get_lname (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_lname);
		self->priv->_lname = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, date_time_location_row_properties[DATE_TIME_LOCATION_ROW_LNAME_PROPERTY]);
	}
}

const gchar*
date_time_location_row_get_location (DateTimeLocationRow* self)
{
	const gchar* result;
	const gchar* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_location;
	result = _tmp0_;
	return result;
}

void
date_time_location_row_set_location (DateTimeLocationRow* self,
                                     const gchar* value)
{
	gchar* old_value;
	g_return_if_fail (self != NULL);
	old_value = date_time_location_row_get_location (self);
	if (g_strcmp0 (value, old_value) != 0) {
		gchar* _tmp0_;
		_tmp0_ = g_strdup (value);
		_g_free0 (self->priv->_location);
		self->priv->_location = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, date_time_location_row_properties[DATE_TIME_LOCATION_ROW_LOCATION_PROPERTY]);
	}
}

gboolean
date_time_location_row_get_loc_selected (DateTimeLocationRow* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_loc_selected;
	return result;
}

void
date_time_location_row_set_loc_selected (DateTimeLocationRow* self,
                                         gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = date_time_location_row_get_loc_selected (self);
	if (old_value != value) {
		self->priv->_loc_selected = value;
		g_object_notify_by_pspec ((GObject *) self, date_time_location_row_properties[DATE_TIME_LOCATION_ROW_LOC_SELECTED_PROPERTY]);
	}
}

static void
date_time_location_row_class_init (DateTimeLocationRowClass * klass,
                                   gpointer klass_data)
{
	date_time_location_row_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DateTimeLocationRow_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_date_time_location_row_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_date_time_location_row_set_property;
	G_OBJECT_CLASS (klass)->finalize = date_time_location_row_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_LOCATION_ROW_DATA_PROPERTY, date_time_location_row_properties[DATE_TIME_LOCATION_ROW_DATA_PROPERTY] = g_param_spec_object ("data", "data", "data", DATE_TIME_TYPE_WEATHER_LOCATION, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_LOCATION_ROW_LNAME_PROPERTY, date_time_location_row_properties[DATE_TIME_LOCATION_ROW_LNAME_PROPERTY] = g_param_spec_string ("lname", "lname", "lname", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_LOCATION_ROW_LOCATION_PROPERTY, date_time_location_row_properties[DATE_TIME_LOCATION_ROW_LOCATION_PROPERTY] = g_param_spec_string ("location", "location", "location", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_LOCATION_ROW_LOC_SELECTED_PROPERTY, date_time_location_row_properties[DATE_TIME_LOCATION_ROW_LOC_SELECTED_PROPERTY] = g_param_spec_boolean ("loc-selected", "loc-selected", "loc-selected", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
}

static void
date_time_location_row_instance_init (DateTimeLocationRow * self,
                                      gpointer klass)
{
	self->priv = date_time_location_row_get_instance_private (self);
	self->priv->_lname = NULL;
	self->priv->_location = NULL;
	self->priv->_loc_selected = FALSE;
}

static void
date_time_location_row_finalize (GObject * obj)
{
	DateTimeLocationRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_TYPE_LOCATION_ROW, DateTimeLocationRow);
	_g_object_unref0 (self->priv->_data);
	_g_free0 (self->priv->_lname);
	_g_free0 (self->priv->_location);
	_g_object_unref0 (self->main_box);
	G_OBJECT_CLASS (date_time_location_row_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
date_time_location_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DateTimeLocationRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) date_time_location_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DateTimeLocationRow), 0, (GInstanceInitFunc) date_time_location_row_instance_init, NULL };
	GType date_time_location_row_type_id;
	date_time_location_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "DateTimeLocationRow", &g_define_type_info, 0);
	DateTimeLocationRow_private_offset = g_type_add_instance_private (date_time_location_row_type_id, sizeof (DateTimeLocationRowPrivate));
	return date_time_location_row_type_id;
}

GType
date_time_location_row_get_type (void)
{
	static gsize date_time_location_row_type_id__once = 0;
	if (g_once_init_enter (&date_time_location_row_type_id__once)) {
		GType date_time_location_row_type_id;
		date_time_location_row_type_id = date_time_location_row_get_type_once ();
		g_once_init_leave (&date_time_location_row_type_id__once, date_time_location_row_type_id);
	}
	return date_time_location_row_type_id__once;
}

static void
_vala_date_time_location_row_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	DateTimeLocationRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_TYPE_LOCATION_ROW, DateTimeLocationRow);
	switch (property_id) {
		case DATE_TIME_LOCATION_ROW_DATA_PROPERTY:
		g_value_set_object (value, date_time_location_row_get_data (self));
		break;
		case DATE_TIME_LOCATION_ROW_LNAME_PROPERTY:
		g_value_set_string (value, date_time_location_row_get_lname (self));
		break;
		case DATE_TIME_LOCATION_ROW_LOCATION_PROPERTY:
		g_value_set_string (value, date_time_location_row_get_location (self));
		break;
		case DATE_TIME_LOCATION_ROW_LOC_SELECTED_PROPERTY:
		g_value_set_boolean (value, date_time_location_row_get_loc_selected (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_date_time_location_row_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	DateTimeLocationRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_TYPE_LOCATION_ROW, DateTimeLocationRow);
	switch (property_id) {
		case DATE_TIME_LOCATION_ROW_DATA_PROPERTY:
		date_time_location_row_set_data (self, g_value_get_object (value));
		break;
		case DATE_TIME_LOCATION_ROW_LNAME_PROPERTY:
		date_time_location_row_set_lname (self, g_value_get_string (value));
		break;
		case DATE_TIME_LOCATION_ROW_LOCATION_PROPERTY:
		date_time_location_row_set_location (self, g_value_get_string (value));
		break;
		case DATE_TIME_LOCATION_ROW_LOC_SELECTED_PROPERTY:
		date_time_location_row_set_loc_selected (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
date_time_world_location_finder_get_instance_private (DateTimeWorldLocationFinder* self)
{
	return G_STRUCT_MEMBER_P (self, DateTimeWorldLocationFinder_private_offset);
}

static void
date_time_world_location_finder_add_button_clicked (DateTimeWorldLocationFinder* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, date_time_world_location_finder_signals[DATE_TIME_WORLD_LOCATION_FINDER_LOCATION_ADDED_SIGNAL], 0);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

static void
date_time_world_location_finder_query_locations (DateTimeWorldLocationFinder* self,
                                                 GWeatherLocation* lc,
                                                 const gchar* search)
{
	GListStore* _tmp0_;
	GWeatherLocation* l = NULL;
	GWeatherLocation* _tmp15_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (lc != NULL);
	g_return_if_fail (search != NULL);
	_tmp0_ = self->priv->locations;
	if (g_list_model_get_n_items ((GListModel*) _tmp0_) >= ((guint) DATE_TIME_WORLD_LOCATION_FINDER_RESULT_COUNT_LIMIT)) {
		return;
	}
	switch (gweather_location_get_level (lc)) {
		case GWEATHER_LOCATION_CITY:
		{
			gboolean contains_name = FALSE;
			const gchar* _tmp1_;
			gchar* country_name = NULL;
			gchar* _tmp2_;
			const gchar* _tmp3_;
			gboolean _tmp8_ = FALSE;
			const gchar* _tmp9_;
			gboolean contains_country_name = FALSE;
			gboolean _tmp11_ = FALSE;
			_tmp1_ = gweather_location_get_sort_name (lc);
			contains_name = string_contains (_tmp1_, search);
			_tmp2_ = gweather_location_get_country_name (lc);
			country_name = _tmp2_;
			_tmp3_ = country_name;
			if (_tmp3_ != NULL) {
				const gchar* _tmp4_;
				gchar* _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				_tmp4_ = country_name;
				_tmp5_ = g_utf8_normalize ((const gchar*) _tmp4_, (gssize) -1, G_NORMALIZE_DEFAULT);
				_tmp6_ = _tmp5_;
				_tmp7_ = g_utf8_casefold (_tmp6_, (gssize) -1);
				_g_free0 (country_name);
				country_name = _tmp7_;
				_g_free0 (_tmp6_);
			}
			_tmp9_ = country_name;
			if (_tmp9_ != NULL) {
				const gchar* _tmp10_;
				_tmp10_ = country_name;
				_tmp8_ = string_contains ((const gchar*) _tmp10_, search);
			} else {
				_tmp8_ = FALSE;
			}
			contains_country_name = _tmp8_;
			if (contains_name) {
				_tmp11_ = TRUE;
			} else {
				_tmp11_ = contains_country_name;
			}
			if (_tmp11_) {
				gboolean selected = FALSE;
				GListStore* _tmp12_;
				DateTimeWeatherLocation* _tmp13_;
				DateTimeWeatherLocation* _tmp14_;
				selected = date_time_world_location_finder_location_exists (self, lc);
				_tmp12_ = self->priv->locations;
				_tmp13_ = date_time_weather_location_new (lc, selected);
				_tmp14_ = _tmp13_;
				g_list_store_append (_tmp12_, (GObject*) _tmp14_);
				_g_object_unref0 (_tmp14_);
			}
			_g_free0 (country_name);
			return;
		}
		default:
		{
			break;
		}
	}
	_tmp15_ = gweather_location_next_child (lc, NULL);
	l = _tmp15_;
	while (TRUE) {
		GWeatherLocation* _tmp16_;
		GWeatherLocation* _tmp17_;
		GListStore* _tmp18_;
		GWeatherLocation* _tmp19_;
		GWeatherLocation* _tmp20_;
		GWeatherLocation* _tmp21_;
		_tmp16_ = l;
		if (!(_tmp16_ != NULL)) {
			break;
		}
		_tmp17_ = l;
		date_time_world_location_finder_query_locations (self, _tmp17_, search);
		_tmp18_ = self->priv->locations;
		if (g_list_model_get_n_items ((GListModel*) _tmp18_) >= ((guint) DATE_TIME_WORLD_LOCATION_FINDER_RESULT_COUNT_LIMIT)) {
			_g_object_unref0 (l);
			return;
		}
		_tmp19_ = l;
		_tmp20_ = _g_object_ref0 (_tmp19_);
		_tmp21_ = gweather_location_next_child (lc, _tmp20_);
		_g_object_unref0 (l);
		l = _tmp21_;
	}
	_g_object_unref0 (l);
}

gboolean
date_time_world_location_finder_location_exists (DateTimeWorldLocationFinder* self,
                                                 GWeatherLocation* loc)
{
	gboolean exists = FALSE;
	guint n = 0U;
	GListStore* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (loc != NULL, FALSE);
	exists = FALSE;
	_tmp0_ = self->priv->locations;
	n = g_list_model_get_n_items ((GListModel*) _tmp0_);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				GObject* l = NULL;
				GListStore* _tmp3_;
				GObject* _tmp4_;
				GObject* _tmp5_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(((guint) i) < n)) {
					break;
				}
				_tmp3_ = self->priv->locations;
				_tmp4_ = g_list_model_get_object ((GListModel*) _tmp3_, (guint) i);
				l = _tmp4_;
				_tmp5_ = l;
				if (_tmp5_ == G_TYPE_CHECK_INSTANCE_CAST (loc, G_TYPE_OBJECT, GObject)) {
					exists = TRUE;
					_g_object_unref0 (l);
					break;
				}
				_g_object_unref0 (l);
			}
		}
	}
	result = exists;
	return result;
}

GWeatherLocation*
date_time_world_location_finder_get_selected_location (DateTimeWorldLocationFinder* self)
{
	DateTimeLocationRow* _tmp0_;
	DateTimeLocationRow* _tmp1_;
	DateTimeLocationRow* _tmp2_;
	DateTimeLocationRow* _tmp3_;
	DateTimeWeatherLocation* _tmp4_;
	DateTimeWeatherLocation* _tmp5_;
	GWeatherLocation* _tmp6_;
	GWeatherLocation* _tmp7_;
	GWeatherLocation* _tmp8_;
	GWeatherLocation* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = date_time_world_location_finder_get_selected_row (self);
	_tmp1_ = _tmp0_;
	if (_tmp1_ == NULL) {
		result = NULL;
		return result;
	}
	_tmp2_ = date_time_world_location_finder_get_selected_row (self);
	_tmp3_ = _tmp2_;
	_tmp4_ = date_time_location_row_get_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, DATE_TIME_TYPE_LOCATION_ROW, DateTimeLocationRow));
	_tmp5_ = _tmp4_;
	_tmp6_ = date_time_weather_location_get_loc (_tmp5_);
	_tmp7_ = _tmp6_;
	_tmp8_ = _g_object_ref0 (_tmp7_);
	result = _tmp8_;
	return result;
}

static void
date_time_world_location_finder_item_activated (DateTimeWorldLocationFinder* self,
                                                GtkListBoxRow* listbox_row)
{
	DateTimeLocationRow* row = NULL;
	DateTimeLocationRow* _tmp0_;
	gboolean _tmp1_ = FALSE;
	DateTimeLocationRow* _tmp2_;
	DateTimeLocationRow* _tmp3_;
	DateTimeLocationRow* _tmp11_;
	DateTimeWeatherLocation* _tmp12_;
	DateTimeWeatherLocation* _tmp13_;
	DateTimeLocationRow* _tmp14_;
	DateTimeWeatherLocation* _tmp15_;
	DateTimeWeatherLocation* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	DateTimeLocationRow* _tmp19_;
	DateTimeWeatherLocation* _tmp20_;
	DateTimeWeatherLocation* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	HePillButton* _tmp25_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (listbox_row != NULL);
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (listbox_row, DATE_TIME_TYPE_LOCATION_ROW, DateTimeLocationRow));
	row = _tmp0_;
	_tmp2_ = date_time_world_location_finder_get_selected_row (self);
	_tmp3_ = _tmp2_;
	if (_tmp3_ != NULL) {
		DateTimeLocationRow* _tmp4_;
		DateTimeLocationRow* _tmp5_;
		DateTimeLocationRow* _tmp6_;
		_tmp4_ = date_time_world_location_finder_get_selected_row (self);
		_tmp5_ = _tmp4_;
		_tmp6_ = row;
		_tmp1_ = _tmp5_ != _tmp6_;
	} else {
		_tmp1_ = FALSE;
	}
	if (_tmp1_) {
		DateTimeLocationRow* _tmp7_;
		DateTimeLocationRow* _tmp8_;
		DateTimeWeatherLocation* _tmp9_;
		DateTimeWeatherLocation* _tmp10_;
		_tmp7_ = date_time_world_location_finder_get_selected_row (self);
		_tmp8_ = _tmp7_;
		_tmp9_ = date_time_location_row_get_data (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, DATE_TIME_TYPE_LOCATION_ROW, DateTimeLocationRow));
		_tmp10_ = _tmp9_;
		date_time_weather_location_set_selected (_tmp10_, FALSE);
	}
	_tmp11_ = row;
	_tmp12_ = date_time_location_row_get_data (_tmp11_);
	_tmp13_ = _tmp12_;
	_tmp14_ = row;
	_tmp15_ = date_time_location_row_get_data (_tmp14_);
	_tmp16_ = _tmp15_;
	_tmp17_ = date_time_weather_location_get_selected (_tmp16_);
	_tmp18_ = _tmp17_;
	date_time_weather_location_set_selected (_tmp13_, !_tmp18_);
	_tmp19_ = row;
	_tmp20_ = date_time_location_row_get_data (_tmp19_);
	_tmp21_ = _tmp20_;
	_tmp22_ = date_time_weather_location_get_selected (_tmp21_);
	_tmp23_ = _tmp22_;
	if (_tmp23_) {
		DateTimeLocationRow* _tmp24_;
		_tmp24_ = row;
		date_time_world_location_finder_set_selected_row (self, _tmp24_);
	} else {
		date_time_world_location_finder_set_selected_row (self, NULL);
	}
	_tmp25_ = self->priv->add_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, TRUE);
	_g_object_unref0 (row);
}

DateTimeWorldLocationFinder*
date_time_world_location_finder_construct (GType object_type)
{
	DateTimeWorldLocationFinder * self = NULL;
	self = (DateTimeWorldLocationFinder*) g_object_new (object_type, NULL);
	return self;
}

DateTimeWorldLocationFinder*
date_time_world_location_finder_new (void)
{
	return date_time_world_location_finder_construct (DATE_TIME_TYPE_WORLD_LOCATION_FINDER);
}

DateTimeLocationRow*
date_time_world_location_finder_get_selected_row (DateTimeWorldLocationFinder* self)
{
	DateTimeLocationRow* result;
	DateTimeLocationRow* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_selected_row;
	result = _tmp0_;
	return result;
}

void
date_time_world_location_finder_set_selected_row (DateTimeWorldLocationFinder* self,
                                                  DateTimeLocationRow* value)
{
	DateTimeLocationRow* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = _g_object_ref0 (value);
	_g_object_unref0 (self->priv->_selected_row);
	self->priv->_selected_row = _tmp0_;
	g_object_notify_by_pspec ((GObject *) self, date_time_world_location_finder_properties[DATE_TIME_WORLD_LOCATION_FINDER_SELECTED_ROW_PROPERTY]);
}

static GtkWidget*
_date_time_world_location_finder___lambda5_ (DateTimeWorldLocationFinder* self,
                                             GObject* data)
{
	DateTimeLocationRow* _tmp0_;
	GtkWidget* result;
	g_return_val_if_fail (data != NULL, NULL);
	_tmp0_ = date_time_location_row_new (G_TYPE_CHECK_INSTANCE_CAST (data, DATE_TIME_TYPE_WEATHER_LOCATION, DateTimeWeatherLocation));
	g_object_ref_sink (_tmp0_);
	result = (GtkWidget*) _tmp0_;
	return result;
}

static GtkWidget*
__date_time_world_location_finder___lambda5__gtk_list_box_create_widget_func (GObject* item,
                                                                              gpointer self)
{
	GtkWidget* result;
	result = _date_time_world_location_finder___lambda5_ ((DateTimeWorldLocationFinder*) self, item);
	return result;
}

static void
_date_time_world_location_finder_item_activated_gtk_list_box_row_activated (GtkListBox* _sender,
                                                                            GtkListBoxRow* row,
                                                                            gpointer self)
{
	date_time_world_location_finder_item_activated ((DateTimeWorldLocationFinder*) self, row);
}

static void
_date_time_world_location_finder_add_button_clicked_gtk_button_clicked (GtkButton* _sender,
                                                                        gpointer self)
{
	date_time_world_location_finder_add_button_clicked ((DateTimeWorldLocationFinder*) self);
}

static gint
__lambda7_ (DateTimeWorldLocationFinder* self,
            GObject* a,
            GObject* b)
{
	gchar* name_a = NULL;
	GWeatherLocation* _tmp0_;
	GWeatherLocation* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* name_b = NULL;
	GWeatherLocation* _tmp4_;
	GWeatherLocation* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	GCompareFunc _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gint result;
	g_return_val_if_fail (a != NULL, 0);
	g_return_val_if_fail (b != NULL, 0);
	_tmp0_ = date_time_weather_location_get_loc (G_TYPE_CHECK_INSTANCE_CAST (a, DATE_TIME_TYPE_WEATHER_LOCATION, DateTimeWeatherLocation));
	_tmp1_ = _tmp0_;
	_tmp2_ = gweather_location_get_sort_name (_tmp1_);
	_tmp3_ = g_strdup (_tmp2_);
	name_a = _tmp3_;
	_tmp4_ = date_time_weather_location_get_loc (G_TYPE_CHECK_INSTANCE_CAST (b, DATE_TIME_TYPE_WEATHER_LOCATION, DateTimeWeatherLocation));
	_tmp5_ = _tmp4_;
	_tmp6_ = gweather_location_get_sort_name (_tmp5_);
	_tmp7_ = g_strdup (_tmp6_);
	name_b = _tmp7_;
	_tmp8_ = ((GCompareFunc) g_strcmp0);
	_tmp9_ = name_a;
	_tmp10_ = name_b;
	result = _tmp8_ (_tmp9_, _tmp10_);
	_g_free0 (name_b);
	_g_free0 (name_a);
	return result;
}

static gint
___lambda7__gcompare_data_func (gconstpointer a,
                                gconstpointer b,
                                gpointer self)
{
	gint result;
	result = __lambda7_ ((DateTimeWorldLocationFinder*) self, (GObject*) a, (GObject*) b);
	return result;
}

static void
_date_time_world_location_finder___lambda6_ (DateTimeWorldLocationFinder* self)
{
	GListStore* _tmp0_;
	GtkSearchEntry* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	gchar* search = NULL;
	GtkSearchEntry* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GWeatherLocation* world = NULL;
	GWeatherLocation* _tmp11_;
	GWeatherLocation* _tmp12_;
	GWeatherLocation* _tmp13_;
	const gchar* _tmp14_;
	GListStore* _tmp15_;
	GListStore* _tmp16_;
	GtkStack* _tmp17_;
	date_time_world_location_finder_set_selected_row (self, NULL);
	_tmp0_ = self->priv->locations;
	g_list_store_remove_all (_tmp0_);
	_tmp1_ = self->priv->search_entry;
	_tmp2_ = gtk_editable_get_text ((GtkEditable*) _tmp1_);
	_tmp3_ = _tmp2_;
	if (g_strcmp0 (_tmp3_, "") == 0) {
		return;
	}
	_tmp4_ = self->priv->search_entry;
	_tmp5_ = gtk_editable_get_text ((GtkEditable*) _tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = g_utf8_normalize (_tmp6_, (gssize) -1, G_NORMALIZE_DEFAULT);
	_tmp8_ = _tmp7_;
	_tmp9_ = g_utf8_casefold (_tmp8_, (gssize) -1);
	_tmp10_ = _tmp9_;
	_g_free0 (_tmp8_);
	search = _tmp10_;
	_tmp11_ = gweather_location_get_world ();
	world = _tmp11_;
	_tmp12_ = world;
	if (_tmp12_ == NULL) {
		_g_object_unref0 (world);
		_g_free0 (search);
		return;
	}
	_tmp13_ = world;
	_tmp14_ = search;
	date_time_world_location_finder_query_locations (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp13_, gweather_location_get_type (), GWeatherLocation), _tmp14_);
	_tmp15_ = self->priv->locations;
	if (g_list_model_get_n_items ((GListModel*) _tmp15_) == ((guint) 0)) {
		_g_object_unref0 (world);
		_g_free0 (search);
		return;
	}
	_tmp16_ = self->priv->locations;
	g_list_store_sort (_tmp16_, ___lambda7__gcompare_data_func, self);
	_tmp17_ = self->priv->search_stack;
	gtk_stack_set_visible_child_name (_tmp17_, "results");
	_g_object_unref0 (world);
	_g_free0 (search);
}

static void
__date_time_world_location_finder___lambda6__gtk_search_entry_search_changed (GtkSearchEntry* _sender,
                                                                              gpointer self)
{
	_date_time_world_location_finder___lambda6_ ((DateTimeWorldLocationFinder*) self);
}

static void
_date_time_world_location_finder___lambda8_ (DateTimeWorldLocationFinder* self)
{
	GtkSearchEntry* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	_tmp0_ = self->priv->search_entry;
	_tmp1_ = gtk_editable_get_text ((GtkEditable*) _tmp0_);
	_tmp2_ = _tmp1_;
	if (g_strcmp0 (_tmp2_, "") == 0) {
		GtkStack* _tmp3_;
		_tmp3_ = self->priv->search_stack;
		gtk_stack_set_visible_child_name (_tmp3_, "empty");
	}
}

static void
__date_time_world_location_finder___lambda8__g_object_notify (GObject* _sender,
                                                              GParamSpec* pspec,
                                                              gpointer self)
{
	_date_time_world_location_finder___lambda8_ ((DateTimeWorldLocationFinder*) self);
}

static GObject *
date_time_world_location_finder_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DateTimeWorldLocationFinder * self;
	GtkBox* main_box = NULL;
	GtkBox* _tmp0_;
	GtkSearchEntry* _tmp1_ = NULL;
	GtkStack* _tmp2_ = NULL;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	HeEmptyPage* _tmp6_ = NULL;
	GtkListBox* _tmp7_ = NULL;
	GtkListBox* _tmp8_;
	GtkStack* _tmp9_;
	HeEmptyPage* _tmp10_;
	GtkStack* _tmp11_;
	GtkListBox* _tmp12_;
	gchar* _tmp13_;
	HePillButton* _tmp14_ = NULL;
	GtkBox* content_box = NULL;
	GtkBox* _tmp15_;
	GtkBox* _tmp16_;
	GtkSearchEntry* _tmp17_;
	GtkBox* _tmp18_;
	GtkStack* _tmp19_;
	GtkBox* _tmp20_;
	GtkBox* _tmp21_;
	GtkBox* _tmp22_;
	GtkSearchEntry* _tmp23_;
	HePillButton* _tmp24_;
	GListStore* _tmp25_;
	GtkListBox* _tmp26_;
	GListStore* _tmp27_;
	GtkListBox* _tmp28_;
	HePillButton* _tmp29_;
	GtkSearchEntry* _tmp30_;
	GtkSearchEntry* _tmp31_;
	HeEmptyPage* _tmp32_;
	HePillButton* _tmp33_;
	parent_class = G_OBJECT_CLASS (date_time_world_location_finder_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_TYPE_WORLD_LOCATION_FINDER, DateTimeWorldLocationFinder);
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 12);
	g_object_ref_sink (_tmp0_);
	main_box = _tmp0_;
	_tmp1_ = (GtkSearchEntry*) gtk_search_entry_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp1_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp1_);
	_g_object_unref0 (self->priv->search_entry);
	self->priv->search_entry = _tmp1_;
	_tmp2_ = (GtkStack*) gtk_stack_new ();
	gtk_widget_set_margin_top ((GtkWidget*) _tmp2_, 12);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp2_, 12);
	gtk_stack_set_vhomogeneous (_tmp2_, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp2_, TRUE);
	gtk_stack_set_transition_type (_tmp2_, GTK_STACK_TRANSITION_TYPE_CROSSFADE);
	g_object_ref_sink (_tmp2_);
	_g_object_unref0 (self->priv->search_stack);
	self->priv->search_stack = _tmp2_;
	_tmp3_ = g_strdup (_ ("No Location Searched"));
	_tmp4_ = g_strdup (_ ("Search for a location."));
	_tmp5_ = g_strdup ("location-services-disabled-symbolic");
	_tmp6_ = he_empty_page_new ();
	he_empty_page_set_title (_tmp6_, _tmp3_);
	_g_free0 (_tmp3_);
	he_empty_page_set_description (_tmp6_, _tmp4_);
	_g_free0 (_tmp4_);
	he_empty_page_set_icon (_tmp6_, _tmp5_);
	_g_free0 (_tmp5_);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp6_, 18);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp6_, 18);
	g_object_ref_sink (_tmp6_);
	_g_object_unref0 (self->priv->search_label);
	self->priv->search_label = _tmp6_;
	_tmp7_ = (GtkListBox*) gtk_list_box_new ();
	gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_START);
	gtk_list_box_set_selection_mode (_tmp7_, GTK_SELECTION_NONE);
	g_object_ref_sink (_tmp7_);
	_g_object_unref0 (self->priv->listbox);
	self->priv->listbox = _tmp7_;
	_tmp8_ = self->priv->listbox;
	gtk_widget_add_css_class ((GtkWidget*) _tmp8_, "content-list");
	_tmp9_ = self->priv->search_stack;
	_tmp10_ = self->priv->search_label;
	gtk_stack_add_named (_tmp9_, (GtkWidget*) _tmp10_, "empty");
	_tmp11_ = self->priv->search_stack;
	_tmp12_ = self->priv->listbox;
	gtk_stack_add_named (_tmp11_, (GtkWidget*) _tmp12_, "results");
	_tmp13_ = g_strdup (_ ("Add Location"));
	_tmp14_ = he_pill_button_new ("");
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp14_, 18);
	gtk_button_set_label ((GtkButton*) _tmp14_, _tmp13_);
	_g_free0 (_tmp13_);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->add_button);
	self->priv->add_button = _tmp14_;
	_tmp15_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
	g_object_ref_sink (_tmp15_);
	content_box = _tmp15_;
	_tmp16_ = content_box;
	_tmp17_ = self->priv->search_entry;
	gtk_box_append (_tmp16_, (GtkWidget*) _tmp17_);
	_tmp18_ = content_box;
	_tmp19_ = self->priv->search_stack;
	gtk_box_append (_tmp18_, (GtkWidget*) _tmp19_);
	_tmp20_ = main_box;
	_tmp21_ = content_box;
	gtk_box_append (_tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = main_box;
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp22_);
	_tmp23_ = self->priv->search_entry;
	gtk_search_entry_set_key_capture_widget (_tmp23_, (GtkWidget*) self);
	_tmp24_ = self->priv->add_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp24_, FALSE);
	_tmp25_ = g_list_store_new (DATE_TIME_TYPE_WEATHER_LOCATION);
	_g_object_unref0 (self->priv->locations);
	self->priv->locations = _tmp25_;
	_tmp26_ = self->priv->listbox;
	_tmp27_ = self->priv->locations;
	gtk_list_box_bind_model (_tmp26_, (GListModel*) _tmp27_, __date_time_world_location_finder___lambda5__gtk_list_box_create_widget_func, g_object_ref (self), g_object_unref);
	_tmp28_ = self->priv->listbox;
	g_signal_connect_object (_tmp28_, "row-activated", (GCallback) _date_time_world_location_finder_item_activated_gtk_list_box_row_activated, self, 0);
	_tmp29_ = self->priv->add_button;
	g_signal_connect_object ((GtkButton*) _tmp29_, "clicked", (GCallback) _date_time_world_location_finder_add_button_clicked_gtk_button_clicked, self, 0);
	_tmp30_ = self->priv->search_entry;
	g_signal_connect_object (_tmp30_, "search-changed", (GCallback) __date_time_world_location_finder___lambda6__gtk_search_entry_search_changed, self, 0);
	_tmp31_ = self->priv->search_entry;
	g_signal_connect_object ((GObject*) _tmp31_, "notify::text", (GCallback) __date_time_world_location_finder___lambda8__g_object_notify, self, 0);
	_tmp32_ = self->priv->search_label;
	_tmp33_ = _tmp32_->action_button;
	gtk_widget_set_visible ((GtkWidget*) _tmp33_, FALSE);
	_g_object_unref0 (content_box);
	_g_object_unref0 (main_box);
	return obj;
}

static void
date_time_world_location_finder_class_init (DateTimeWorldLocationFinderClass * klass,
                                            gpointer klass_data)
{
	date_time_world_location_finder_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DateTimeWorldLocationFinder_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_date_time_world_location_finder_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_date_time_world_location_finder_set_property;
	G_OBJECT_CLASS (klass)->constructor = date_time_world_location_finder_constructor;
	G_OBJECT_CLASS (klass)->finalize = date_time_world_location_finder_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DATE_TIME_WORLD_LOCATION_FINDER_SELECTED_ROW_PROPERTY, date_time_world_location_finder_properties[DATE_TIME_WORLD_LOCATION_FINDER_SELECTED_ROW_PROPERTY] = g_param_spec_object ("selected-row", "selected-row", "selected-row", DATE_TIME_TYPE_LOCATION_ROW, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	date_time_world_location_finder_signals[DATE_TIME_WORLD_LOCATION_FINDER_LOCATION_ADDED_SIGNAL] = g_signal_new ("location-added", DATE_TIME_TYPE_WORLD_LOCATION_FINDER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
date_time_world_location_finder_instance_init (DateTimeWorldLocationFinder * self,
                                               gpointer klass)
{
	self->priv = date_time_world_location_finder_get_instance_private (self);
	self->priv->_selected_row = NULL;
}

static void
date_time_world_location_finder_finalize (GObject * obj)
{
	DateTimeWorldLocationFinder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DATE_TIME_TYPE_WORLD_LOCATION_FINDER, DateTimeWorldLocationFinder);
	_g_object_unref0 (self->priv->locations);
	_g_object_unref0 (self->priv->_selected_row);
	_g_object_unref0 (self->priv->search_label);
	_g_object_unref0 (self->priv->search_stack);
	_g_object_unref0 (self->priv->listbox);
	_g_object_unref0 (self->priv->search_entry);
	_g_object_unref0 (self->priv->add_button);
	G_OBJECT_CLASS (date_time_world_location_finder_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
date_time_world_location_finder_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DateTimeWorldLocationFinderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) date_time_world_location_finder_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DateTimeWorldLocationFinder), 0, (GInstanceInitFunc) date_time_world_location_finder_instance_init, NULL };
	GType date_time_world_location_finder_type_id;
	date_time_world_location_finder_type_id = g_type_register_static (gtk_box_get_type (), "DateTimeWorldLocationFinder", &g_define_type_info, 0);
	DateTimeWorldLocationFinder_private_offset = g_type_add_instance_private (date_time_world_location_finder_type_id, sizeof (DateTimeWorldLocationFinderPrivate));
	return date_time_world_location_finder_type_id;
}

GType
date_time_world_location_finder_get_type (void)
{
	static gsize date_time_world_location_finder_type_id__once = 0;
	if (g_once_init_enter (&date_time_world_location_finder_type_id__once)) {
		GType date_time_world_location_finder_type_id;
		date_time_world_location_finder_type_id = date_time_world_location_finder_get_type_once ();
		g_once_init_leave (&date_time_world_location_finder_type_id__once, date_time_world_location_finder_type_id);
	}
	return date_time_world_location_finder_type_id__once;
}

static void
_vala_date_time_world_location_finder_get_property (GObject * object,
                                                    guint property_id,
                                                    GValue * value,
                                                    GParamSpec * pspec)
{
	DateTimeWorldLocationFinder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_TYPE_WORLD_LOCATION_FINDER, DateTimeWorldLocationFinder);
	switch (property_id) {
		case DATE_TIME_WORLD_LOCATION_FINDER_SELECTED_ROW_PROPERTY:
		g_value_set_object (value, date_time_world_location_finder_get_selected_row (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_date_time_world_location_finder_set_property (GObject * object,
                                                    guint property_id,
                                                    const GValue * value,
                                                    GParamSpec * pspec)
{
	DateTimeWorldLocationFinder * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DATE_TIME_TYPE_WORLD_LOCATION_FINDER, DateTimeWorldLocationFinder);
	switch (property_id) {
		case DATE_TIME_WORLD_LOCATION_FINDER_SELECTED_ROW_PROPERTY:
		date_time_world_location_finder_set_selected_row (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

