/* DisplayFuse.c generated by valac 0.56.13, the Vala compiler
 * generated from DisplayFuse.vala, do not modify */

/*-
 * Copyright (c) 2023 Fyra Labs
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 *
 */

#include "fuse-display.h"
#include <gtk/gtk.h>
#include "fusebox-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <bismuth.h>
#include <libhelium-1.h>
#include <gmodule.h>

enum  {
	DISPLAY_FUSE_0_PROPERTY,
	DISPLAY_FUSE_NUM_PROPERTIES
};
static GParamSpec* display_fuse_properties[DISPLAY_FUSE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _DisplayFuseSearchData DisplayFuseSearchData;

struct _DisplayFusePrivate {
	GtkGrid* main_grid;
};

struct _DisplayFuseSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DisplayFuse* self;
	gchar* search;
	GHashTable* result;
	GHashTable* search_results;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
};

static gint DisplayFuse_private_offset;
static gpointer display_fuse_parent_class = NULL;
DisplayFuse* display_fuse_fuse = NULL;

static void _g_free0_ (gpointer var);
static GtkWidget* display_fuse_real_get_widget (FuseboxFuse* base);
static void display_fuse_real_shown (FuseboxFuse* base);
static void display_fuse_real_hidden (FuseboxFuse* base);
static void display_fuse_real_search_callback (FuseboxFuse* base,
                                        const gchar* location);
static void display_fuse_real_search_data_free (gpointer _data);
static void display_fuse_real_search (FuseboxFuse* base,
                               const gchar* search,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
static gboolean display_fuse_real_search_co (DisplayFuseSearchData* _data_);
static void display_fuse_finalize (GObject * obj);
static GType display_fuse_get_type_once (void);

static inline gpointer
display_fuse_get_instance_private (DisplayFuse* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayFuse_private_offset);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

DisplayFuse*
display_fuse_construct (GType object_type)
{
	DisplayFuse * self = NULL;
	GHashTable* settings = NULL;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	DisplayFuse* _tmp4_;
	_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_free0_);
	settings = _tmp0_;
	_tmp1_ = g_strdup ("display");
	g_hash_table_insert (settings, _tmp1_, NULL);
	_tmp2_ = g_strdup ("display/night-light");
	_tmp3_ = g_strdup ("night-light");
	g_hash_table_insert (settings, _tmp2_, _tmp3_);
	self = (DisplayFuse*) g_object_new (object_type, "category", FUSEBOX_FUSE_CATEGORY_SYSTEM, "code-name", "com.fyralabs.Fusebox.display", "display-name", _ ("Displays"), "description", _ ("Configure resolution and position of monitors and projectors"), "icon", "settings-display-symbolic", "supported-settings", settings, "index", 2, NULL);
	_tmp4_ = _g_object_ref0 (self);
	_g_object_unref0 (display_fuse_fuse);
	display_fuse_fuse = _tmp4_;
	_g_hash_table_unref0 (settings);
	return self;
}

DisplayFuse*
display_fuse_new (void)
{
	return display_fuse_construct (DISPLAY_TYPE_FUSE);
}

static GtkWidget*
display_fuse_real_get_widget (FuseboxFuse* base)
{
	DisplayFuse * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp22_;
	GtkWidget* _tmp23_;
	GtkWidget* result;
	self = (DisplayFuse*) base;
	_tmp0_ = self->priv->main_grid;
	if (_tmp0_ == NULL) {
		GtkGrid* _tmp1_ = NULL;
		DisplayDisplaysView* displays_view = NULL;
		DisplayDisplaysView* _tmp2_;
		DisplayNightLightView* nightlight_view = NULL;
		DisplayNightLightView* _tmp3_;
		BisLatch* latch2 = NULL;
		BisLatch* _tmp4_;
		BisLatch* _tmp5_;
		DisplayNightLightView* _tmp6_;
		GtkStack* stack = NULL;
		GtkStack* _tmp7_;
		HeViewSwitcher* stack_switcher = NULL;
		HeViewSwitcher* _tmp8_;
		HeViewSwitcher* _tmp9_;
		GtkStack* _tmp10_;
		GtkStack* _tmp11_;
		DisplayDisplaysView* _tmp12_;
		GtkStack* _tmp13_;
		BisLatch* _tmp14_;
		HeAppBar* appbar = NULL;
		HeViewSwitcher* _tmp15_;
		GtkWidget* _tmp16_;
		HeAppBar* _tmp17_ = NULL;
		GtkGrid* _tmp18_;
		HeAppBar* _tmp19_;
		GtkGrid* _tmp20_;
		GtkStack* _tmp21_;
		_tmp1_ = (GtkGrid*) gtk_grid_new ();
		gtk_grid_set_row_spacing (_tmp1_, 12);
		gtk_grid_set_column_homogeneous (_tmp1_, TRUE);
		g_object_ref_sink (_tmp1_);
		_g_object_unref0 (self->priv->main_grid);
		self->priv->main_grid = _tmp1_;
		_tmp2_ = display_displays_view_new ();
		g_object_ref_sink (_tmp2_);
		displays_view = _tmp2_;
		_tmp3_ = display_night_light_view_new ();
		g_object_ref_sink (_tmp3_);
		nightlight_view = _tmp3_;
		_tmp4_ = (BisLatch*) bis_latch_new ();
		g_object_ref_sink (_tmp4_);
		latch2 = _tmp4_;
		_tmp5_ = latch2;
		_tmp6_ = nightlight_view;
		bis_latch_set_child (_tmp5_, (GtkWidget*) _tmp6_);
		_tmp7_ = (GtkStack*) gtk_stack_new ();
		g_object_ref_sink (_tmp7_);
		stack = _tmp7_;
		_tmp8_ = he_view_switcher_new ();
		g_object_ref_sink (_tmp8_);
		stack_switcher = _tmp8_;
		_tmp9_ = stack_switcher;
		_tmp10_ = stack;
		he_view_switcher_set_stack (_tmp9_, _tmp10_);
		_tmp11_ = stack;
		_tmp12_ = displays_view;
		gtk_stack_add_titled (_tmp11_, (GtkWidget*) _tmp12_, "displays", _ ("Displays"));
		_tmp13_ = stack;
		_tmp14_ = latch2;
		gtk_stack_add_titled (_tmp13_, (GtkWidget*) _tmp14_, "night-light", _ ("Night Light"));
		_tmp15_ = stack_switcher;
		_tmp16_ = _g_object_ref0 ((GtkWidget*) _tmp15_);
		_tmp17_ = he_app_bar_new ();
		he_app_bar_set_viewtitle_widget (_tmp17_, _tmp16_);
		_g_object_unref0 (_tmp16_);
		he_app_bar_set_show_back (_tmp17_, FALSE);
		gtk_widget_set_hexpand ((GtkWidget*) _tmp17_, TRUE);
		g_object_ref_sink (_tmp17_);
		appbar = _tmp17_;
		_tmp18_ = self->priv->main_grid;
		_tmp19_ = appbar;
		gtk_grid_attach (_tmp18_, (GtkWidget*) _tmp19_, 0, 0, 1, 1);
		_tmp20_ = self->priv->main_grid;
		_tmp21_ = stack;
		gtk_grid_attach (_tmp20_, (GtkWidget*) _tmp21_, 0, 1, 1, 1);
		_g_object_unref0 (appbar);
		_g_object_unref0 (stack_switcher);
		_g_object_unref0 (stack);
		_g_object_unref0 (latch2);
		_g_object_unref0 (nightlight_view);
		_g_object_unref0 (displays_view);
	}
	_tmp22_ = self->priv->main_grid;
	_tmp23_ = _g_object_ref0 ((GtkWidget*) _tmp22_);
	result = _tmp23_;
	return result;
}

static void
display_fuse_real_shown (FuseboxFuse* base)
{
	DisplayFuse * self;
	self = (DisplayFuse*) base;
}

static void
display_fuse_real_hidden (FuseboxFuse* base)
{
	DisplayFuse * self;
	self = (DisplayFuse*) base;
}

static void
display_fuse_real_search_callback (FuseboxFuse* base,
                                   const gchar* location)
{
	DisplayFuse * self;
	self = (DisplayFuse*) base;
	g_return_if_fail (location != NULL);
}

static void
display_fuse_real_search_data_free (gpointer _data)
{
	DisplayFuseSearchData* _data_;
	_data_ = _data;
	_g_free0 (_data_->search);
	_g_hash_table_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (DisplayFuseSearchData, _data_);
}

static void
display_fuse_real_search (FuseboxFuse* base,
                          const gchar* search,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	DisplayFuse * self;
	DisplayFuseSearchData* _data_;
	DisplayFuse* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (search != NULL);
	self = (DisplayFuse*) base;
	_data_ = g_slice_new0 (DisplayFuseSearchData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, display_fuse_real_search_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (search);
	_g_free0 (_data_->search);
	_data_->search = _tmp1_;
	display_fuse_real_search_co (_data_);
}

static GHashTable*
display_fuse_search_finish (FuseboxFuse* base,
                            GAsyncResult* _res_)
{
	GHashTable* result;
	DisplayFuseSearchData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static gboolean
display_fuse_real_search_co (DisplayFuseSearchData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_free0_);
	_data_->search_results = _data_->_tmp0_;
	_data_->_tmp1_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = g_strdup_printf ("%s → %s", _data_->_tmp2_, _ ("Screen Resolution"));
	_data_->_tmp4_ = g_strdup ("");
	g_hash_table_insert (_data_->search_results, _data_->_tmp3_, _data_->_tmp4_);
	_data_->_tmp5_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp6_ = _data_->_tmp5_;
	_data_->_tmp7_ = g_strdup_printf ("%s → %s", _data_->_tmp6_, _ ("Screen Rotation"));
	_data_->_tmp8_ = g_strdup ("");
	g_hash_table_insert (_data_->search_results, _data_->_tmp7_, _data_->_tmp8_);
	_data_->_tmp9_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp10_ = _data_->_tmp9_;
	_data_->_tmp11_ = g_strdup_printf ("%s → %s", _data_->_tmp10_, _ ("Primary display"));
	_data_->_tmp12_ = g_strdup ("");
	g_hash_table_insert (_data_->search_results, _data_->_tmp11_, _data_->_tmp12_);
	_data_->_tmp13_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp14_ = _data_->_tmp13_;
	_data_->_tmp15_ = g_strdup_printf ("%s → %s", _data_->_tmp14_, _ ("Screen mirroring"));
	_data_->_tmp16_ = g_strdup ("");
	g_hash_table_insert (_data_->search_results, _data_->_tmp15_, _data_->_tmp16_);
	_data_->_tmp17_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp18_ = _data_->_tmp17_;
	_data_->_tmp19_ = g_strdup_printf ("%s → %s", _data_->_tmp18_, _ ("Scaling factor"));
	_data_->_tmp20_ = g_strdup ("");
	g_hash_table_insert (_data_->search_results, _data_->_tmp19_, _data_->_tmp20_);
	_data_->_tmp21_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp22_ = _data_->_tmp21_;
	_data_->_tmp23_ = g_strdup_printf ("%s → %s", _data_->_tmp22_, _ ("Rotation lock"));
	_data_->_tmp24_ = g_strdup ("");
	g_hash_table_insert (_data_->search_results, _data_->_tmp23_, _data_->_tmp24_);
	_data_->_tmp25_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp26_ = _data_->_tmp25_;
	_data_->_tmp27_ = g_strdup_printf ("%s → %s", _data_->_tmp26_, _ ("Night Light"));
	_data_->_tmp28_ = g_strdup ("night-light");
	g_hash_table_insert (_data_->search_results, _data_->_tmp27_, _data_->_tmp28_);
	_data_->_tmp29_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp30_ = _data_->_tmp29_;
	_data_->_tmp31_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp30_, _ ("Night Light"), _ ("Schedule"));
	_data_->_tmp32_ = g_strdup ("night-light");
	g_hash_table_insert (_data_->search_results, _data_->_tmp31_, _data_->_tmp32_);
	_data_->_tmp33_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp34_ = _data_->_tmp33_;
	_data_->_tmp35_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp34_, _ ("Night Light"), _ ("Color temperature"));
	_data_->_tmp36_ = g_strdup ("night-light");
	g_hash_table_insert (_data_->search_results, _data_->_tmp35_, _data_->_tmp36_);
	_data_->result = _data_->search_results;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
display_fuse_class_init (DisplayFuseClass * klass,
                         gpointer klass_data)
{
	display_fuse_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DisplayFuse_private_offset);
	((FuseboxFuseClass *) klass)->get_widget = (GtkWidget* (*) (FuseboxFuse*)) display_fuse_real_get_widget;
	((FuseboxFuseClass *) klass)->shown = (void (*) (FuseboxFuse*)) display_fuse_real_shown;
	((FuseboxFuseClass *) klass)->hidden = (void (*) (FuseboxFuse*)) display_fuse_real_hidden;
	((FuseboxFuseClass *) klass)->search_callback = (void (*) (FuseboxFuse*, const gchar*)) display_fuse_real_search_callback;
	((FuseboxFuseClass *) klass)->search = (void (*) (FuseboxFuse*, const gchar*, GAsyncReadyCallback, gpointer)) display_fuse_real_search;
	((FuseboxFuseClass *) klass)->search_finish = (GHashTable* (*) (FuseboxFuse*, GAsyncResult*)) display_fuse_search_finish;
	G_OBJECT_CLASS (klass)->finalize = display_fuse_finalize;
}

static void
display_fuse_instance_init (DisplayFuse * self,
                            gpointer klass)
{
	self->priv = display_fuse_get_instance_private (self);
}

static void
display_fuse_finalize (GObject * obj)
{
	DisplayFuse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_FUSE, DisplayFuse);
	_g_object_unref0 (self->priv->main_grid);
	G_OBJECT_CLASS (display_fuse_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
display_fuse_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayFuseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_fuse_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayFuse), 0, (GInstanceInitFunc) display_fuse_instance_init, NULL };
	GType display_fuse_type_id;
	display_fuse_type_id = g_type_register_static (FUSEBOX_TYPE_FUSE, "DisplayFuse", &g_define_type_info, 0);
	DisplayFuse_private_offset = g_type_add_instance_private (display_fuse_type_id, sizeof (DisplayFusePrivate));
	return display_fuse_type_id;
}

GType
display_fuse_get_type (void)
{
	static gsize display_fuse_type_id__once = 0;
	if (g_once_init_enter (&display_fuse_type_id__once)) {
		GType display_fuse_type_id;
		display_fuse_type_id = display_fuse_get_type_once ();
		g_once_init_leave (&display_fuse_type_id__once, display_fuse_type_id);
	}
	return display_fuse_type_id__once;
}

FuseboxFuse*
get_fuse (GModule* module)
{
	DisplayFuse* fuse = NULL;
	DisplayFuse* _tmp0_;
	FuseboxFuse* result;
	g_return_val_if_fail (module != NULL, NULL);
	g_debug ("DisplayFuse.vala:101: Activating Display fuse");
	_tmp0_ = display_fuse_new ();
	fuse = _tmp0_;
	result = (FuseboxFuse*) fuse;
	return result;
}

