/* DisplaysView.c generated by valac 0.56.13, the Vala compiler
 * generated from DisplaysView.vala, do not modify */

/*-
 * Copyright (c) 2023 Fyra Labs
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "fuse-display.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <libhelium-1.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define DISPLAY_DISPLAYS_VIEW_TOUCHSCREEN_SETTINGS_PATH "org.gnome.settings-daemon.peripherals.touchscreen"

enum  {
	DISPLAY_DISPLAYS_VIEW_0_PROPERTY,
	DISPLAY_DISPLAYS_VIEW_NUM_PROPERTIES
};
static GParamSpec* display_displays_view_properties[DISPLAY_DISPLAYS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY (display_displays_view_sensor_proxy_get_type ())
#define DISPLAY_DISPLAYS_VIEW_SENSOR_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY, DisplayDisplaysViewSensorProxy))
#define DISPLAY_DISPLAYS_VIEW_IS_SENSOR_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY))
#define DISPLAY_DISPLAYS_VIEW_SENSOR_PROXY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY, DisplayDisplaysViewSensorProxyIface))

typedef struct _DisplayDisplaysViewSensorProxy DisplayDisplaysViewSensorProxy;
typedef struct _DisplayDisplaysViewSensorProxyIface DisplayDisplaysViewSensorProxyIface;

#define DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY_PROXY (display_displays_view_sensor_proxy_proxy_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DisplayDisplaysViewDetectAccelerometerData DisplayDisplaysViewDetectAccelerometerData;
typedef GDBusProxy DisplayDisplaysViewSensorProxyProxy;
typedef GDBusProxyClass DisplayDisplaysViewSensorProxyProxyClass;
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))

struct _DisplayDisplaysViewPrivate {
	GtkComboBoxText* dpi_combo;
	GtkListBox* action_bar;
};

struct _DisplayDisplaysViewSensorProxyIface {
	GTypeInterface parent_iface;
	gboolean (*get_has_accelerometer) (DisplayDisplaysViewSensorProxy* self);
};

struct _DisplayDisplaysViewDetectAccelerometerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DisplayDisplaysView* self;
	gboolean has_accelerometer;
	DisplayDisplaysViewSensorProxy* sensors;
	DisplayDisplaysViewSensorProxy* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GSettings* touchscreen_settings;
	GSettings* _tmp5_;
	GtkSwitch* rotation_lock_switch;
	GtkSwitch* _tmp6_;
	HeSettingsRow* rotation_row;
	GtkSwitch* _tmp7_;
	HeSettingsRow* _tmp8_;
	GtkListBox* _tmp9_;
	HeSettingsRow* _tmp10_;
	GSettings* _tmp11_;
	GtkSwitch* _tmp12_;
	GError* _inner_error0_;
};

struct _Block3Data {
	int _ref_count_;
	DisplayDisplaysView* self;
	GtkSwitch* mirror_switch;
	HeSettingsRow* mirror_row;
	DisplayMonitorManager* monitor_manager;
};

static gint DisplayDisplaysView_private_offset;
static gpointer display_displays_view_parent_class = NULL;

static void display_displays_view_detect_accelerometer_data_free (gpointer _data);
static void display_displays_view_detect_accelerometer (DisplayDisplaysView* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void display_displays_view_detect_accelerometer_finish (DisplayDisplaysView* self,
                                                        GAsyncResult* _res_);
static gboolean display_displays_view_detect_accelerometer_co (DisplayDisplaysViewDetectAccelerometerData* _data_);
static GType display_displays_view_sensor_proxy_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN GType display_displays_view_sensor_proxy_proxy_get_type (void) G_GNUC_CONST ;
static guint display_displays_view_sensor_proxy_register_object (void* object,
                                                          GDBusConnection* connection,
                                                          const gchar* path,
                                                          GError** error);
static void display_displays_view_detect_accelerometer_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
VALA_EXTERN gboolean display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self);
static GType display_displays_view_sensor_proxy_get_type_once (void);
static void display_displays_view_sensor_proxy_proxy_g_signal (GDBusProxy* proxy,
                                                        const gchar* sender_name,
                                                        const gchar* signal_name,
                                                        GVariant* parameters);
static gboolean display_displays_view_sensor_proxy_dbus_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self);
static void display_displays_view_sensor_proxy_proxy_display_displays_view_sensor_proxy_interface_init (DisplayDisplaysViewSensorProxyIface* iface);
static void display_displays_view_sensor_proxy_dbus_interface_method_call (GDBusConnection* connection,
                                                                    const gchar* sender,
                                                                    const gchar* object_path,
                                                                    const gchar* interface_name,
                                                                    const gchar* method_name,
                                                                    GVariant* parameters,
                                                                    GDBusMethodInvocation* invocation,
                                                                    gpointer user_data);
static GVariant* display_displays_view_sensor_proxy_dbus_interface_get_property (GDBusConnection* connection,
                                                                          const gchar* sender,
                                                                          const gchar* object_path,
                                                                          const gchar* interface_name,
                                                                          const gchar* property_name,
                                                                          GError** error,
                                                                          gpointer user_data);
static GVariant* _dbus_display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self);
static gboolean display_displays_view_sensor_proxy_dbus_interface_set_property (GDBusConnection* connection,
                                                                         const gchar* sender,
                                                                         const gchar* object_path,
                                                                         const gchar* interface_name,
                                                                         const gchar* property_name,
                                                                         GVariant* value,
                                                                         GError** error,
                                                                         gpointer user_data);
static void _display_displays_view_sensor_proxy_unregister_object (gpointer user_data);
static GObject * display_displays_view_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void _display_displays_view___lambda18_ (Block3Data* _data3_,
                                         gboolean changed);
static void __display_displays_view___lambda18__display_displays_overlay_configuration_changed (DisplayDisplaysOverlay* _sender,
                                                                                         gboolean changed,
                                                                                         gpointer self);
static void _display_displays_view___lambda19_ (Block3Data* _data3_);
static void __display_displays_view___lambda19__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _display_displays_view___lambda20_ (DisplayDisplaysView* self);
static void __display_displays_view___lambda20__he_overlay_button_clicked (HeOverlayButton* _sender,
                                                                    gpointer self);
static void _display_displays_view___lambda21_ (Block3Data* _data3_);
static void __display_displays_view___lambda21__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self);
static void _display_displays_view___lambda22_ (Block3Data* _data3_);
static void __display_displays_view___lambda22__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void display_displays_view_finalize (GObject * obj);
static GType display_displays_view_get_type_once (void);

static const GDBusMethodInfo * const _display_displays_view_sensor_proxy_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _display_displays_view_sensor_proxy_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _display_displays_view_sensor_proxy_dbus_property_info_has_accelerometer = {-1, "HasAccelerometer", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _display_displays_view_sensor_proxy_dbus_property_info[] = {&_display_displays_view_sensor_proxy_dbus_property_info_has_accelerometer, NULL};
static const GDBusInterfaceInfo _display_displays_view_sensor_proxy_dbus_interface_info = {-1, "net.hadess.SensorProxy", (GDBusMethodInfo **) (&_display_displays_view_sensor_proxy_dbus_method_info), (GDBusSignalInfo **) (&_display_displays_view_sensor_proxy_dbus_signal_info), (GDBusPropertyInfo **) (&_display_displays_view_sensor_proxy_dbus_property_info), NULL};
static const GDBusInterfaceVTable _display_displays_view_sensor_proxy_dbus_interface_vtable = {display_displays_view_sensor_proxy_dbus_interface_method_call, display_displays_view_sensor_proxy_dbus_interface_get_property, display_displays_view_sensor_proxy_dbus_interface_set_property};

static inline gpointer
display_displays_view_get_instance_private (DisplayDisplaysView* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayDisplaysView_private_offset);
}

static void
display_displays_view_detect_accelerometer_data_free (gpointer _data)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (DisplayDisplaysViewDetectAccelerometerData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
display_displays_view_detect_accelerometer (DisplayDisplaysView* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
	DisplayDisplaysView* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (DisplayDisplaysViewDetectAccelerometerData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, display_displays_view_detect_accelerometer_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	display_displays_view_detect_accelerometer_co (_data_);
}

static void
display_displays_view_detect_accelerometer_finish (DisplayDisplaysView* self,
                                                   GAsyncResult* _res_)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
display_displays_view_detect_accelerometer_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	display_displays_view_detect_accelerometer_co (_data_);
}

static gboolean
display_displays_view_detect_accelerometer_co (DisplayDisplaysViewDetectAccelerometerData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->has_accelerometer = FALSE;
	{
		_data_->_state_ = 1;
		g_async_initable_new_async (DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY_PROXY, 0, NULL, display_displays_view_detect_accelerometer_ready, _data_, "g-flags", 0, "g-name", "net.hadess.SensorProxy", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/net/hadess/SensorProxy", "g-interface-name", "net.hadess.SensorProxy", NULL);
		return FALSE;
		_state_1:
		_data_->_tmp0_ = (DisplayDisplaysViewSensorProxy*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
		_data_->sensors = (DisplayDisplaysViewSensorProxy*) _data_->_tmp0_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp1_ = display_displays_view_sensor_proxy_get_has_accelerometer (_data_->sensors);
		_data_->_tmp2_ = _data_->_tmp1_;
		_data_->has_accelerometer = _data_->_tmp2_;
		_g_object_unref0 (_data_->sensors);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp3_ = _data_->e;
		_data_->_tmp4_ = _data_->_tmp3_->message;
		g_info ("DisplaysView.vala:104: Unable to connect to SensorProxy bus, probably " \
"means no accelerometer supported: %s", _data_->_tmp4_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (_data_->has_accelerometer) {
		_data_->_tmp5_ = g_settings_new (DISPLAY_DISPLAYS_VIEW_TOUCHSCREEN_SETTINGS_PATH);
		_data_->touchscreen_settings = _data_->_tmp5_;
		_data_->_tmp6_ = (GtkSwitch*) gtk_switch_new ();
		g_object_ref_sink (_data_->_tmp6_);
		_data_->rotation_lock_switch = _data_->_tmp6_;
		_data_->_tmp7_ = _data_->rotation_lock_switch;
		_data_->_tmp8_ = he_settings_row_new_with_details (_ ("Rotation Lock"), NULL, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp7_, HE_TYPE_BUTTON, HeButton));
		g_object_ref_sink (_data_->_tmp8_);
		_data_->rotation_row = _data_->_tmp8_;
		_data_->_tmp9_ = _data_->self->priv->action_bar;
		_data_->_tmp10_ = _data_->rotation_row;
		gtk_list_box_append (_data_->_tmp9_, (GtkWidget*) _data_->_tmp10_);
		_data_->_tmp11_ = _data_->touchscreen_settings;
		_data_->_tmp12_ = _data_->rotation_lock_switch;
		g_settings_bind (_data_->_tmp11_, "orientation-lock", (GObject*) _data_->_tmp12_, "state", G_SETTINGS_BIND_DEFAULT);
		_g_object_unref0 (_data_->rotation_row);
		_g_object_unref0 (_data_->rotation_lock_switch);
		_g_object_unref0 (_data_->touchscreen_settings);
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

DisplayDisplaysView*
display_displays_view_construct (GType object_type)
{
	DisplayDisplaysView * self = NULL;
	self = (DisplayDisplaysView*) g_object_new (object_type, NULL);
	return self;
}

DisplayDisplaysView*
display_displays_view_new (void)
{
	return display_displays_view_construct (DISPLAY_TYPE_DISPLAYS_VIEW);
}

gboolean
display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self)
{
	DisplayDisplaysViewSensorProxyIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DISPLAY_DISPLAYS_VIEW_SENSOR_PROXY_GET_INTERFACE (self);
	if (_iface_->get_has_accelerometer) {
		return _iface_->get_has_accelerometer (self);
	}
	return FALSE;
}

static void
display_displays_view_sensor_proxy_default_init (DisplayDisplaysViewSensorProxyIface * iface,
                                                 gpointer iface_data)
{
}

 G_GNUC_NO_INLINE static GType
display_displays_view_sensor_proxy_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplaysViewSensorProxyIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_displays_view_sensor_proxy_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType display_displays_view_sensor_proxy_type_id;
	display_displays_view_sensor_proxy_type_id = g_type_register_static (G_TYPE_INTERFACE, "DisplayDisplaysViewSensorProxy", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (display_displays_view_sensor_proxy_type_id, g_dbus_proxy_get_type ());
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) display_displays_view_sensor_proxy_proxy_get_type);
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "net.hadess.SensorProxy");
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_display_displays_view_sensor_proxy_dbus_interface_info));
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) display_displays_view_sensor_proxy_register_object);
	return display_displays_view_sensor_proxy_type_id;
}

static GType
display_displays_view_sensor_proxy_get_type (void)
{
	static gsize display_displays_view_sensor_proxy_type_id__once = 0;
	if (g_once_init_enter (&display_displays_view_sensor_proxy_type_id__once)) {
		GType display_displays_view_sensor_proxy_type_id;
		display_displays_view_sensor_proxy_type_id = display_displays_view_sensor_proxy_get_type_once ();
		g_once_init_leave (&display_displays_view_sensor_proxy_type_id__once, display_displays_view_sensor_proxy_type_id);
	}
	return display_displays_view_sensor_proxy_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (DisplayDisplaysViewSensorProxyProxy, display_displays_view_sensor_proxy_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY, display_displays_view_sensor_proxy_proxy_display_displays_view_sensor_proxy_interface_init) )
static void
display_displays_view_sensor_proxy_proxy_class_init (DisplayDisplaysViewSensorProxyProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = display_displays_view_sensor_proxy_proxy_g_signal;
}

static void
display_displays_view_sensor_proxy_proxy_g_signal (GDBusProxy* proxy,
                                                   const gchar* sender_name,
                                                   const gchar* signal_name,
                                                   GVariant* parameters)
{
}

static void
display_displays_view_sensor_proxy_proxy_init (DisplayDisplaysViewSensorProxyProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_display_displays_view_sensor_proxy_dbus_interface_info));
}

static gboolean
display_displays_view_sensor_proxy_dbus_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "HasAccelerometer");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("net.hadess.SensorProxy"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("HasAccelerometer"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp0_ = FALSE;
			return _tmp0_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
display_displays_view_sensor_proxy_proxy_display_displays_view_sensor_proxy_interface_init (DisplayDisplaysViewSensorProxyIface* iface)
{
	iface->get_has_accelerometer = display_displays_view_sensor_proxy_dbus_proxy_get_has_accelerometer;
}

static void
display_displays_view_sensor_proxy_dbus_interface_method_call (GDBusConnection* connection,
                                                               const gchar* sender,
                                                               const gchar* object_path,
                                                               const gchar* interface_name,
                                                               const gchar* method_name,
                                                               GVariant* parameters,
                                                               GDBusMethodInvocation* invocation,
                                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
_dbus_display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self)
{
	gboolean result;
	GVariant* _reply;
	result = display_displays_view_sensor_proxy_get_has_accelerometer (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
display_displays_view_sensor_proxy_dbus_interface_get_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GError** error,
                                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "HasAccelerometer") == 0) {
		return _dbus_display_displays_view_sensor_proxy_get_has_accelerometer (object);
	}
	return NULL;
}

static gboolean
display_displays_view_sensor_proxy_dbus_interface_set_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GVariant* value,
                                                                GError** error,
                                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static guint
display_displays_view_sensor_proxy_register_object (gpointer object,
                                                    GDBusConnection* connection,
                                                    const gchar* path,
                                                    GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_display_displays_view_sensor_proxy_dbus_interface_info), &_display_displays_view_sensor_proxy_dbus_interface_vtable, data, _display_displays_view_sensor_proxy_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_display_displays_view_sensor_proxy_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		DisplayDisplaysView* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->mirror_row);
		_g_object_unref0 (_data3_->mirror_switch);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
	return self ? g_settings_schema_source_ref (self) : NULL;
}

static void
_display_displays_view___lambda18_ (Block3Data* _data3_,
                                    gboolean changed)
{
	DisplayDisplaysView* self;
	DisplayMonitorManager* _tmp0_;
	self = _data3_->self;
	_tmp0_ = _data3_->monitor_manager;
	display_monitor_manager_set_monitor_config (_tmp0_);
}

static void
__display_displays_view___lambda18__display_displays_overlay_configuration_changed (DisplayDisplaysOverlay* _sender,
                                                                                    gboolean changed,
                                                                                    gpointer self)
{
	_display_displays_view___lambda18_ (self, changed);
}

static void
_display_displays_view___lambda19_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	HeSettingsRow* _tmp0_;
	DisplayMonitorManager* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	self = _data3_->self;
	_tmp0_ = _data3_->mirror_row;
	_tmp1_ = _data3_->monitor_manager;
	_tmp2_ = display_monitor_manager_get_monitors (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp5_ > 1);
}

static void
__display_displays_view___lambda19__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_display_displays_view___lambda19_ (self);
}

static void
_display_displays_view___lambda20_ (DisplayDisplaysView* self)
{
	DisplayDisplaysOverlay* _tmp0_;
	_tmp0_ = self->displays_overlay;
	display_displays_overlay_rescan_displays (_tmp0_);
}

static void
__display_displays_view___lambda20__he_overlay_button_clicked (HeOverlayButton* _sender,
                                                               gpointer self)
{
	_display_displays_view___lambda20_ ((DisplayDisplaysView*) self);
}

static void
_display_displays_view___lambda21_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	DisplayMonitorManager* _tmp0_;
	GtkComboBoxText* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	DisplayMonitorManager* _tmp4_;
	self = _data3_->self;
	_tmp0_ = _data3_->monitor_manager;
	_tmp1_ = self->priv->dpi_combo;
	_tmp2_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp1_);
	_tmp3_ = _tmp2_;
	display_monitor_manager_set_scale_on_all_monitors (_tmp0_, (gdouble) (_tmp3_ + 1));
	_tmp4_ = _data3_->monitor_manager;
	display_monitor_manager_set_monitor_config (_tmp4_);
}

static void
__display_displays_view___lambda21__gtk_combo_box_changed (GtkComboBox* _sender,
                                                           gpointer self)
{
	_display_displays_view___lambda21_ (self);
}

static void
_display_displays_view___lambda22_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	self = _data3_->self;
	_tmp0_ = _data3_->mirror_switch;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		DisplayMonitorManager* _tmp3_;
		DisplayMonitorManager* _tmp4_;
		_tmp3_ = _data3_->monitor_manager;
		display_monitor_manager_enable_clone_mode (_tmp3_);
		_tmp4_ = _data3_->monitor_manager;
		display_monitor_manager_set_monitor_config (_tmp4_);
	} else {
		DisplayMonitorManager* _tmp5_;
		DisplayMonitorManager* _tmp6_;
		_tmp5_ = _data3_->monitor_manager;
		display_monitor_manager_disable_clone_mode (_tmp5_);
		_tmp6_ = _data3_->monitor_manager;
		display_monitor_manager_set_monitor_config (_tmp6_);
	}
}

static void
__display_displays_view___lambda22__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_display_displays_view___lambda22_ (self);
}

static GObject *
display_displays_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayDisplaysView * self;
	Block3Data* _data3_;
	DisplayDisplaysOverlay* _tmp0_;
	GtkSwitch* _tmp1_;
	GtkSwitch* _tmp2_;
	HeSettingsRow* _tmp3_;
	GtkComboBoxText* _tmp4_;
	GtkComboBoxText* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	GtkComboBoxText* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	GtkComboBoxText* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	HeSettingsRow* dpi_row = NULL;
	GtkComboBoxText* _tmp14_;
	HeSettingsRow* _tmp15_;
	HeOverlayButton* detect_button = NULL;
	HeOverlayButton* _tmp16_ = NULL;
	HeOverlayButton* _tmp17_;
	DisplayDisplaysOverlay* _tmp18_;
	GtkListBox* _tmp19_;
	GtkListBox* _tmp20_;
	GtkListBox* _tmp21_;
	HeSettingsRow* _tmp22_;
	GtkListBox* _tmp23_;
	HeSettingsRow* _tmp24_;
	GSettingsSchemaSource* schema_source = NULL;
	GSettingsSchemaSource* _tmp25_;
	GSettingsSchemaSource* _tmp26_;
	GSettingsSchema* rotation_lock_schema = NULL;
	GSettingsSchemaSource* _tmp27_;
	GSettingsSchema* _tmp28_;
	GSettingsSchema* _tmp29_;
	HeOverlayButton* _tmp30_;
	GtkListBox* _tmp31_;
	DisplayMonitorManager* _tmp32_;
	DisplayDisplaysOverlay* _tmp33_;
	HeSettingsRow* _tmp34_;
	DisplayMonitorManager* _tmp35_;
	GeeLinkedList* _tmp36_;
	GeeLinkedList* _tmp37_;
	gint _tmp38_;
	gint _tmp39_;
	DisplayMonitorManager* _tmp40_;
	HeOverlayButton* _tmp41_;
	GtkComboBoxText* _tmp42_;
	DisplayMonitorManager* _tmp43_;
	GeeLinkedList* _tmp44_;
	GeeLinkedList* _tmp45_;
	gpointer _tmp46_;
	DisplayVirtualMonitor* _tmp47_;
	gdouble _tmp48_;
	gdouble _tmp49_;
	GtkComboBoxText* _tmp50_;
	GtkSwitch* _tmp51_;
	DisplayMonitorManager* _tmp52_;
	gboolean _tmp53_;
	gboolean _tmp54_;
	GtkSwitch* _tmp55_;
	parent_class = G_OBJECT_CLASS (display_displays_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAYS_VIEW, DisplayDisplaysView);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = display_displays_overlay_new ();
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->displays_overlay);
	self->displays_overlay = _tmp0_;
	_tmp1_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp1_);
	_data3_->mirror_switch = _tmp1_;
	_tmp2_ = _data3_->mirror_switch;
	_tmp3_ = he_settings_row_new_with_details (_ ("Mirror Display"), NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, HE_TYPE_BUTTON, HeButton));
	g_object_ref_sink (_tmp3_);
	_data3_->mirror_row = _tmp3_;
	_tmp4_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp4_);
	_g_object_unref0 (self->priv->dpi_combo);
	self->priv->dpi_combo = _tmp4_;
	_tmp5_ = self->priv->dpi_combo;
	_tmp6_ = g_strconcat (_ ("LoDPI"), " (1×)", NULL);
	_tmp7_ = _tmp6_;
	gtk_combo_box_text_append_text (_tmp5_, _tmp7_);
	_g_free0 (_tmp7_);
	_tmp8_ = self->priv->dpi_combo;
	_tmp9_ = g_strconcat (_ ("HiDPI"), " (2×)", NULL);
	_tmp10_ = _tmp9_;
	gtk_combo_box_text_append_text (_tmp8_, _tmp10_);
	_g_free0 (_tmp10_);
	_tmp11_ = self->priv->dpi_combo;
	_tmp12_ = g_strconcat (_ ("HiDPI"), " (3×)", NULL);
	_tmp13_ = _tmp12_;
	gtk_combo_box_text_append_text (_tmp11_, _tmp13_);
	_g_free0 (_tmp13_);
	_tmp14_ = self->priv->dpi_combo;
	_tmp15_ = he_settings_row_new_with_details (_ ("Scaling"), NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp14_, HE_TYPE_BUTTON, HeButton));
	g_object_ref_sink (_tmp15_);
	dpi_row = _tmp15_;
	_tmp16_ = he_overlay_button_new ("tv-symbolic", _ ("Detect Displays"), NULL);
	he_overlay_button_set_typeb (_tmp16_, HE_OVERLAY_BUTTON_TYPE_BUTTON_PRIMARY);
	g_object_ref_sink (_tmp16_);
	detect_button = _tmp16_;
	_tmp17_ = detect_button;
	_tmp18_ = self->displays_overlay;
	he_overlay_button_set_child (_tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = (GtkListBox*) gtk_list_box_new ();
	g_object_ref_sink (_tmp19_);
	_g_object_unref0 (self->priv->action_bar);
	self->priv->action_bar = _tmp19_;
	_tmp20_ = self->priv->action_bar;
	gtk_widget_add_css_class ((GtkWidget*) _tmp20_, "content-list");
	_tmp21_ = self->priv->action_bar;
	_tmp22_ = dpi_row;
	gtk_list_box_prepend (_tmp21_, (GtkWidget*) _tmp22_);
	_tmp23_ = self->priv->action_bar;
	_tmp24_ = _data3_->mirror_row;
	gtk_list_box_prepend (_tmp23_, (GtkWidget*) _tmp24_);
	_tmp25_ = g_settings_schema_source_get_default ();
	_tmp26_ = _g_settings_schema_source_ref0 (_tmp25_);
	schema_source = _tmp26_;
	_tmp27_ = schema_source;
	_tmp28_ = g_settings_schema_source_lookup (_tmp27_, DISPLAY_DISPLAYS_VIEW_TOUCHSCREEN_SETTINGS_PATH, TRUE);
	rotation_lock_schema = _tmp28_;
	_tmp29_ = rotation_lock_schema;
	if (_tmp29_ != NULL) {
		display_displays_view_detect_accelerometer (self, NULL, NULL);
	} else {
		g_info ("DisplaysView.vala:57: Schema \"org.gnome.settings-daemon.peripherals.t" \
"ouchscreen\" is not installed on your system.");
	}
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	gtk_widget_set_margin_start ((GtkWidget*) self, 18);
	gtk_widget_set_margin_bottom ((GtkWidget*) self, 18);
	gtk_widget_set_margin_end ((GtkWidget*) self, 18);
	_tmp30_ = detect_button;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp30_, 0, 0, 1, 1);
	_tmp31_ = self->priv->action_bar;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp31_, 0, 1, 1, 1);
	_tmp32_ = display_monitor_manager_get_default ();
	_data3_->monitor_manager = _tmp32_;
	_tmp33_ = self->displays_overlay;
	g_signal_connect_data (_tmp33_, "configuration-changed", (GCallback) __display_displays_view___lambda18__display_displays_overlay_configuration_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp34_ = _data3_->mirror_row;
	_tmp35_ = _data3_->monitor_manager;
	_tmp36_ = display_monitor_manager_get_monitors (_tmp35_);
	_tmp37_ = _tmp36_;
	_tmp38_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp37_);
	_tmp39_ = _tmp38_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp34_, _tmp39_ > 1);
	_tmp40_ = _data3_->monitor_manager;
	g_signal_connect_data ((GObject*) _tmp40_, "notify::monitor-number", (GCallback) __display_displays_view___lambda19__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp41_ = detect_button;
	g_signal_connect_object (_tmp41_, "clicked", (GCallback) __display_displays_view___lambda20__he_overlay_button_clicked, self, 0);
	_tmp42_ = self->priv->dpi_combo;
	_tmp43_ = _data3_->monitor_manager;
	_tmp44_ = display_monitor_manager_get_virtual_monitors (_tmp43_);
	_tmp45_ = _tmp44_;
	_tmp46_ = gee_abstract_list_get ((GeeAbstractList*) _tmp45_, 0);
	_tmp47_ = (DisplayVirtualMonitor*) _tmp46_;
	_tmp48_ = display_virtual_monitor_get_scale (_tmp47_);
	_tmp49_ = _tmp48_;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp42_, ((gint) _tmp49_) - 1);
	_g_object_unref0 (_tmp47_);
	_tmp50_ = self->priv->dpi_combo;
	g_signal_connect_data ((GtkComboBox*) _tmp50_, "changed", (GCallback) __display_displays_view___lambda21__gtk_combo_box_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp51_ = _data3_->mirror_switch;
	_tmp52_ = _data3_->monitor_manager;
	_tmp53_ = display_monitor_manager_get_is_mirrored (_tmp52_);
	_tmp54_ = _tmp53_;
	gtk_switch_set_active (_tmp51_, _tmp54_);
	_tmp55_ = _data3_->mirror_switch;
	g_signal_connect_data ((GObject*) _tmp55_, "notify::active", (GCallback) __display_displays_view___lambda22__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_g_settings_schema_unref0 (rotation_lock_schema);
	_g_settings_schema_source_unref0 (schema_source);
	_g_object_unref0 (detect_button);
	_g_object_unref0 (dpi_row);
	block3_data_unref (_data3_);
	_data3_ = NULL;
	return obj;
}

static void
display_displays_view_class_init (DisplayDisplaysViewClass * klass,
                                  gpointer klass_data)
{
	display_displays_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DisplayDisplaysView_private_offset);
	G_OBJECT_CLASS (klass)->constructor = display_displays_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = display_displays_view_finalize;
}

static void
display_displays_view_instance_init (DisplayDisplaysView * self,
                                     gpointer klass)
{
	self->priv = display_displays_view_get_instance_private (self);
}

static void
display_displays_view_finalize (GObject * obj)
{
	DisplayDisplaysView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAYS_VIEW, DisplayDisplaysView);
	_g_object_unref0 (self->displays_overlay);
	_g_object_unref0 (self->priv->dpi_combo);
	_g_object_unref0 (self->priv->action_bar);
	G_OBJECT_CLASS (display_displays_view_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
display_displays_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplaysViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_displays_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplaysView), 0, (GInstanceInitFunc) display_displays_view_instance_init, NULL };
	GType display_displays_view_type_id;
	display_displays_view_type_id = g_type_register_static (gtk_grid_get_type (), "DisplayDisplaysView", &g_define_type_info, 0);
	DisplayDisplaysView_private_offset = g_type_add_instance_private (display_displays_view_type_id, sizeof (DisplayDisplaysViewPrivate));
	return display_displays_view_type_id;
}

GType
display_displays_view_get_type (void)
{
	static gsize display_displays_view_type_id__once = 0;
	if (g_once_init_enter (&display_displays_view_type_id__once)) {
		GType display_displays_view_type_id;
		display_displays_view_type_id = display_displays_view_get_type_once ();
		g_once_init_leave (&display_displays_view_type_id__once, display_displays_view_type_id);
	}
	return display_displays_view_type_id__once;
}

