/* NightLightView.c generated by valac 0.56.13, the Vala compiler
 * generated from NightLightView.vala, do not modify */

/*
* Copyright (c) 2023 Fyra Labs
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*/

#include "fuse-display.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <libhelium-1.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>

enum  {
	DISPLAY_NIGHT_LIGHT_VIEW_0_PROPERTY,
	DISPLAY_NIGHT_LIGHT_VIEW_TEMPERATURE_PROPERTY,
	DISPLAY_NIGHT_LIGHT_VIEW_NUM_PROPERTIES
};
static GParamSpec* display_night_light_view_properties[DISPLAY_NIGHT_LIGHT_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))

struct _DisplayNightLightViewPrivate {
	GtkScale* temp_scale;
};

struct _Block2Data {
	int _ref_count_;
	DisplayNightLightView* self;
	GSettings* settings;
	HeSwitchBar* status_switch;
	HeTimePicker* from_time;
	HeTimePicker* to_time;
};

static gint DisplayNightLightView_private_offset;
static gpointer display_night_light_view_parent_class = NULL;

static void display_night_light_view_clear_snooze (DisplayNightLightView* self);
static gdouble display_night_light_view_date_time_double (GDateTime* date_time);
static GDateTime* display_night_light_view_double_date_time (gdouble dbl);
static GObject * display_night_light_view_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _display_night_light_view___lambda24_ (Block2Data* _data2_);
static void __display_night_light_view___lambda24__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _display_night_light_view___lambda25_ (Block2Data* _data2_);
static void __display_night_light_view___lambda25__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _display_night_light_view___lambda26_ (Block2Data* _data2_);
static void __display_night_light_view___lambda26__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                       gpointer self);
static void _display_night_light_view___lambda27_ (Block2Data* _data2_);
static void __display_night_light_view___lambda27__gtk_range_value_changed (GtkRange* _sender,
                                                                     gpointer self);
static void _display_night_light_view___lambda28_ (Block2Data* _data2_);
static void __display_night_light_view___lambda28__he_time_picker_time_changed (HeTimePicker* _sender,
                                                                         gpointer self);
static void _display_night_light_view___lambda29_ (Block2Data* _data2_);
static void __display_night_light_view___lambda29__he_time_picker_time_changed (HeTimePicker* _sender,
                                                                         gpointer self);
static void _display_night_light_view___lambda30_ (Block2Data* _data2_);
static void __display_night_light_view___lambda30__g_object_notify (GObject* _sender,
                                                             GParamSpec* pspec,
                                                             gpointer self);
static void display_night_light_view_finalize (GObject * obj);
static GType display_night_light_view_get_type_once (void);
static void _vala_display_night_light_view_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
display_night_light_view_get_instance_private (DisplayNightLightView* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayNightLightView_private_offset);
}

static void
display_night_light_view_clear_snooze (DisplayNightLightView* self)
{
	DisplayNightLightManager* _tmp0_;
	DisplayNightLightManager* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = display_night_light_manager_get_instance ();
	_tmp1_ = _tmp0_;
	display_night_light_manager_set_snoozed (_tmp1_, FALSE);
	_g_object_unref0 (_tmp1_);
}

static gdouble
display_night_light_view_date_time_double (GDateTime* date_time)
{
	gdouble time_double = 0.0;
	gdouble result;
	g_return_val_if_fail (date_time != NULL, 0.0);
	time_double = (gdouble) 0;
	time_double += (gdouble) g_date_time_get_hour (date_time);
	time_double += ((gdouble) g_date_time_get_minute (date_time)) / 60;
	result = fmod (time_double, 24.0);
	return result;
}

static GDateTime*
display_night_light_view_double_date_time (gdouble dbl)
{
	gint hours = 0;
	gint minutes = 0;
	GDateTime* date_time = NULL;
	GDateTime* _tmp0_;
	GDateTime* result;
	hours = (gint) dbl;
	minutes = (gint) round ((dbl - hours) * 60);
	_tmp0_ = g_date_time_new_local (1, 1, 1, hours, minutes, 0.0);
	date_time = _tmp0_;
	result = date_time;
	return result;
}

DisplayNightLightView*
display_night_light_view_construct (GType object_type)
{
	DisplayNightLightView * self = NULL;
	self = (DisplayNightLightView*) g_object_new (object_type, NULL);
	return self;
}

DisplayNightLightView*
display_night_light_view_new (void)
{
	return display_night_light_view_construct (DISPLAY_TYPE_NIGHT_LIGHT_VIEW);
}

void
display_night_light_view_set_temperature (DisplayNightLightView* self,
                                          gint value)
{
	GtkScale* _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->temp_scale;
	gtk_range_set_value ((GtkRange*) _tmp0_, (gdouble) value);
	g_object_notify_by_pspec ((GObject *) self, display_night_light_view_properties[DISPLAY_NIGHT_LIGHT_VIEW_TEMPERATURE_PROPERTY]);
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
	g_atomic_int_inc (&_data2_->_ref_count_);
	return _data2_;
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
		DisplayNightLightView* self;
		self = _data2_->self;
		_g_object_unref0 (_data2_->to_time);
		_g_object_unref0 (_data2_->from_time);
		_g_object_unref0 (_data2_->status_switch);
		_g_object_unref0 (_data2_->settings);
		_g_object_unref0 (self);
		g_slice_free (Block2Data, _data2_);
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_display_night_light_view___lambda24_ (Block2Data* _data2_)
{
	DisplayNightLightView* self;
	GSettings* _tmp0_;
	HeTimePicker* _tmp1_;
	HeTimePicker* _tmp2_;
	self = _data2_->self;
	_tmp0_ = _data2_->settings;
	g_settings_set_boolean (_tmp0_, "night-light-schedule-automatic", FALSE);
	_tmp1_ = _data2_->from_time;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, TRUE);
	_tmp2_ = _data2_->to_time;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, TRUE);
	display_night_light_view_clear_snooze (self);
}

static void
__display_night_light_view___lambda24__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_display_night_light_view___lambda24_ (self);
}

static void
_display_night_light_view___lambda25_ (Block2Data* _data2_)
{
	DisplayNightLightView* self;
	GSettings* _tmp0_;
	HeTimePicker* _tmp1_;
	HeTimePicker* _tmp2_;
	self = _data2_->self;
	_tmp0_ = _data2_->settings;
	g_settings_set_boolean (_tmp0_, "night-light-schedule-automatic", TRUE);
	_tmp1_ = _data2_->from_time;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
	_tmp2_ = _data2_->to_time;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, FALSE);
}

static void
__display_night_light_view___lambda25__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_display_night_light_view___lambda25_ (self);
}

static void
_display_night_light_view___lambda26_ (Block2Data* _data2_)
{
	DisplayNightLightView* self;
	GSettings* _tmp0_;
	GSettings* _tmp1_;
	GSettings* _tmp2_;
	HeTimePicker* _tmp3_;
	HeTimePicker* _tmp4_;
	self = _data2_->self;
	_tmp0_ = _data2_->settings;
	g_settings_set_boolean (_tmp0_, "night-light-schedule-automatic", FALSE);
	_tmp1_ = _data2_->settings;
	g_settings_set_double (_tmp1_, "night-light-schedule-from", (gdouble) 16.0f);
	_tmp2_ = _data2_->settings;
	g_settings_set_double (_tmp2_, "night-light-schedule-to", (gdouble) 8.0f);
	_tmp3_ = _data2_->from_time;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp3_, FALSE);
	_tmp4_ = _data2_->to_time;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, FALSE);
}

static void
__display_night_light_view___lambda26__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                                  gpointer self)
{
	_display_night_light_view___lambda26_ (self);
}

static void
_display_night_light_view___lambda27_ (Block2Data* _data2_)
{
	DisplayNightLightView* self;
	GSettings* _tmp0_;
	GtkScale* _tmp1_;
	self = _data2_->self;
	_tmp0_ = _data2_->settings;
	_tmp1_ = self->priv->temp_scale;
	g_settings_set_uint (_tmp0_, "night-light-temperature", (guint) gtk_range_get_value ((GtkRange*) _tmp1_));
	display_night_light_view_clear_snooze (self);
}

static void
__display_night_light_view___lambda27__gtk_range_value_changed (GtkRange* _sender,
                                                                gpointer self)
{
	_display_night_light_view___lambda27_ (self);
}

static void
_display_night_light_view___lambda28_ (Block2Data* _data2_)
{
	DisplayNightLightView* self;
	GSettings* _tmp0_;
	HeTimePicker* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	self = _data2_->self;
	_tmp0_ = _data2_->settings;
	_tmp1_ = _data2_->from_time;
	_tmp2_ = he_time_picker_get_time (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_double (_tmp0_, "night-light-schedule-from", display_night_light_view_date_time_double (_tmp3_));
	display_night_light_view_clear_snooze (self);
}

static void
__display_night_light_view___lambda28__he_time_picker_time_changed (HeTimePicker* _sender,
                                                                    gpointer self)
{
	_display_night_light_view___lambda28_ (self);
}

static void
_display_night_light_view___lambda29_ (Block2Data* _data2_)
{
	DisplayNightLightView* self;
	GSettings* _tmp0_;
	HeTimePicker* _tmp1_;
	GDateTime* _tmp2_;
	GDateTime* _tmp3_;
	self = _data2_->self;
	_tmp0_ = _data2_->settings;
	_tmp1_ = _data2_->to_time;
	_tmp2_ = he_time_picker_get_time (_tmp1_);
	_tmp3_ = _tmp2_;
	g_settings_set_double (_tmp0_, "night-light-schedule-to", display_night_light_view_date_time_double (_tmp3_));
	display_night_light_view_clear_snooze (self);
}

static void
__display_night_light_view___lambda29__he_time_picker_time_changed (HeTimePicker* _sender,
                                                                    gpointer self)
{
	_display_night_light_view___lambda29_ (self);
}

static void
_display_night_light_view___lambda30_ (Block2Data* _data2_)
{
	DisplayNightLightView* self;
	HeSwitchBar* _tmp0_;
	GtkSwitch* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	self = _data2_->self;
	_tmp0_ = _data2_->status_switch;
	_tmp1_ = _tmp0_->main_switch;
	_tmp2_ = gtk_switch_get_active (_tmp1_);
	_tmp3_ = _tmp2_;
	if (_tmp3_) {
		display_night_light_view_clear_snooze (self);
	}
}

static void
__display_night_light_view___lambda30__g_object_notify (GObject* _sender,
                                                        GParamSpec* pspec,
                                                        gpointer self)
{
	_display_night_light_view___lambda30_ (self);
}

static GObject *
display_night_light_view_constructor (GType type,
                                      guint n_construct_properties,
                                      GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayNightLightView * self;
	Block2Data* _data2_;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	HeSwitchBar* _tmp3_ = NULL;
	GtkToggleButton* schedule_button_a = NULL;
	gchar* _tmp4_;
	GtkToggleButton* _tmp5_ = NULL;
	GtkToggleButton* schedule_button_b = NULL;
	gchar* _tmp6_;
	GtkToggleButton* _tmp7_;
	GtkToggleButton* _tmp8_;
	GtkToggleButton* _tmp9_ = NULL;
	GtkToggleButton* schedule_button_c = NULL;
	gchar* _tmp10_;
	GtkToggleButton* _tmp11_;
	GtkToggleButton* _tmp12_;
	GtkToggleButton* _tmp13_ = NULL;
	HeSegmentedButton* schedule_button = NULL;
	HeSegmentedButton* _tmp14_ = NULL;
	HeSegmentedButton* _tmp15_;
	GtkToggleButton* _tmp16_;
	HeSegmentedButton* _tmp17_;
	GtkToggleButton* _tmp18_;
	HeSegmentedButton* _tmp19_;
	GtkToggleButton* _tmp20_;
	HeTimePicker* _tmp21_;
	HeTimePicker* _tmp22_;
	GSettings* _tmp23_;
	GDateTime* _tmp24_;
	GDateTime* _tmp25_;
	HeTimePicker* _tmp26_;
	HeTimePicker* _tmp27_;
	GSettings* _tmp28_;
	GDateTime* _tmp29_;
	GDateTime* _tmp30_;
	GtkGrid* schedule_main_box = NULL;
	GtkGrid* _tmp31_ = NULL;
	GtkGrid* _tmp32_;
	HeSegmentedButton* _tmp33_;
	GtkGrid* _tmp34_;
	HeTimePicker* _tmp35_;
	GtkGrid* _tmp36_;
	HeTimePicker* _tmp37_;
	HeMiniContentBlock* schedule_box = NULL;
	HeMiniContentBlock* _tmp38_;
	HeMiniContentBlock* _tmp39_;
	GtkGrid* _tmp40_;
	HeMiniContentBlock* _tmp41_;
	GtkScale* _tmp42_;
	GtkScale* _tmp43_;
	GtkScale* _tmp44_;
	GtkScale* _tmp45_;
	GtkScale* _tmp46_;
	GtkScale* _tmp47_;
	GtkScale* _tmp48_;
	GtkScale* _tmp49_;
	GtkScale* _tmp50_;
	GtkStyleContext* _tmp51_;
	GtkScale* _tmp52_;
	GSettings* _tmp53_;
	HeMiniContentBlock* temp_box = NULL;
	HeMiniContentBlock* _tmp54_;
	HeMiniContentBlock* _tmp55_;
	GtkScale* _tmp56_;
	HeMiniContentBlock* _tmp57_;
	GtkGrid* content_grid = NULL;
	GtkGrid* _tmp58_;
	GtkGrid* _tmp59_;
	GtkGrid* _tmp60_;
	HeMiniContentBlock* _tmp61_;
	GtkGrid* _tmp62_;
	HeMiniContentBlock* _tmp63_;
	HeSwitchBar* _tmp64_;
	GtkGrid* _tmp65_;
	GSettings* _tmp66_;
	HeSwitchBar* _tmp67_;
	GtkSwitch* _tmp68_;
	GSettings* _tmp69_;
	GtkGrid* _tmp70_;
	GSettings* _tmp71_;
	gboolean automatic_schedule = FALSE;
	GSettings* _tmp72_;
	GtkToggleButton* _tmp81_;
	GtkToggleButton* _tmp82_;
	GtkToggleButton* _tmp83_;
	GtkScale* _tmp84_;
	HeTimePicker* _tmp85_;
	HeTimePicker* _tmp86_;
	HeSwitchBar* _tmp87_;
	GtkSwitch* _tmp88_;
	parent_class = G_OBJECT_CLASS (display_night_light_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_NIGHT_LIGHT_VIEW, DisplayNightLightView);
	_data2_ = g_slice_new0 (Block2Data);
	_data2_->_ref_count_ = 1;
	_data2_->self = g_object_ref (self);
	_tmp0_ = g_settings_new ("org.gnome.settings-daemon.plugins.color");
	_data2_->settings = _tmp0_;
	_tmp1_ = g_strdup (_ ("Night Light"));
	_tmp2_ = g_strdup (_ ("Use warm colors on your display to aid in sleep"));
	_tmp3_ = he_switch_bar_new ();
	gtk_widget_set_hexpand ((GtkWidget*) _tmp3_, TRUE);
	he_switch_bar_set_title (_tmp3_, _tmp1_);
	_g_free0 (_tmp1_);
	he_switch_bar_set_subtitle (_tmp3_, _tmp2_);
	_g_free0 (_tmp2_);
	g_object_ref_sink (_tmp3_);
	_data2_->status_switch = _tmp3_;
	_tmp4_ = g_strdup (_ ("Manual"));
	_tmp5_ = (GtkToggleButton*) gtk_toggle_button_new ();
	gtk_button_set_label ((GtkButton*) _tmp5_, _tmp4_);
	_g_free0 (_tmp4_);
	g_object_ref_sink (_tmp5_);
	schedule_button_a = _tmp5_;
	_tmp6_ = g_strdup (_ ("Automatic"));
	_tmp7_ = schedule_button_a;
	_tmp8_ = _g_object_ref0 (_tmp7_);
	_tmp9_ = (GtkToggleButton*) gtk_toggle_button_new ();
	gtk_button_set_label ((GtkButton*) _tmp9_, _tmp6_);
	_g_free0 (_tmp6_);
	gtk_toggle_button_set_group (_tmp9_, _tmp8_);
	_g_object_unref0 (_tmp8_);
	g_object_ref_sink (_tmp9_);
	schedule_button_b = _tmp9_;
	_tmp10_ = g_strdup (_ ("Sunset to Sunrise"));
	_tmp11_ = schedule_button_a;
	_tmp12_ = _g_object_ref0 (_tmp11_);
	_tmp13_ = (GtkToggleButton*) gtk_toggle_button_new ();
	gtk_button_set_label ((GtkButton*) _tmp13_, _tmp10_);
	_g_free0 (_tmp10_);
	gtk_toggle_button_set_group (_tmp13_, _tmp12_);
	_g_object_unref0 (_tmp12_);
	g_object_ref_sink (_tmp13_);
	schedule_button_c = _tmp13_;
	_tmp14_ = he_segmented_button_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_CENTER);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp14_, TRUE);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp14_, 6);
	g_object_ref_sink (_tmp14_);
	schedule_button = _tmp14_;
	_tmp15_ = schedule_button;
	_tmp16_ = schedule_button_b;
	gtk_box_append ((GtkBox*) _tmp15_, (GtkWidget*) _tmp16_);
	_tmp17_ = schedule_button;
	_tmp18_ = schedule_button_c;
	gtk_box_append ((GtkBox*) _tmp17_, (GtkWidget*) _tmp18_);
	_tmp19_ = schedule_button;
	_tmp20_ = schedule_button_a;
	gtk_box_append ((GtkBox*) _tmp19_, (GtkWidget*) _tmp20_);
	_tmp21_ = he_time_picker_new ();
	g_object_ref_sink (_tmp21_);
	_data2_->from_time = _tmp21_;
	_tmp22_ = _data2_->from_time;
	_tmp23_ = _data2_->settings;
	_tmp24_ = display_night_light_view_double_date_time (g_settings_get_double (_tmp23_, "night-light-schedule-from"));
	_tmp25_ = _tmp24_;
	he_time_picker_set_time (_tmp22_, _tmp25_);
	_g_date_time_unref0 (_tmp25_);
	_tmp26_ = he_time_picker_new ();
	g_object_ref_sink (_tmp26_);
	_data2_->to_time = _tmp26_;
	_tmp27_ = _data2_->to_time;
	_tmp28_ = _data2_->settings;
	_tmp29_ = display_night_light_view_double_date_time (g_settings_get_double (_tmp28_, "night-light-schedule-to"));
	_tmp30_ = _tmp29_;
	he_time_picker_set_time (_tmp27_, _tmp30_);
	_g_date_time_unref0 (_tmp30_);
	_tmp31_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_row_spacing (_tmp31_, 6);
	g_object_ref_sink (_tmp31_);
	schedule_main_box = _tmp31_;
	_tmp32_ = schedule_main_box;
	_tmp33_ = schedule_button;
	gtk_grid_attach (_tmp32_, (GtkWidget*) _tmp33_, 0, 0, 1, 1);
	_tmp34_ = schedule_main_box;
	_tmp35_ = _data2_->from_time;
	gtk_grid_attach (_tmp34_, (GtkWidget*) _tmp35_, 0, 1, 1, 1);
	_tmp36_ = schedule_main_box;
	_tmp37_ = _data2_->to_time;
	gtk_grid_attach (_tmp36_, (GtkWidget*) _tmp37_, 0, 2, 1, 1);
	_tmp38_ = he_mini_content_block_new ();
	g_object_ref_sink (_tmp38_);
	schedule_box = _tmp38_;
	_tmp39_ = schedule_box;
	he_mini_content_block_set_title (_tmp39_, _ ("Schedule"));
	_tmp40_ = schedule_main_box;
	_tmp41_ = schedule_box;
	gtk_widget_set_parent ((GtkWidget*) _tmp40_, (GtkWidget*) _tmp41_);
	_tmp42_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 3500, (gdouble) 6000, (gdouble) 10);
	g_object_ref_sink (_tmp42_);
	_g_object_unref0 (self->priv->temp_scale);
	self->priv->temp_scale = _tmp42_;
	_tmp43_ = self->priv->temp_scale;
	gtk_scale_set_draw_value (_tmp43_, FALSE);
	_tmp44_ = self->priv->temp_scale;
	gtk_scale_set_has_origin (_tmp44_, FALSE);
	_tmp45_ = self->priv->temp_scale;
	gtk_range_set_inverted ((GtkRange*) _tmp45_, TRUE);
	_tmp46_ = self->priv->temp_scale;
	gtk_widget_set_hexpand ((GtkWidget*) _tmp46_, TRUE);
	_tmp47_ = self->priv->temp_scale;
	gtk_scale_add_mark (_tmp47_, (gdouble) 3500, GTK_POS_BOTTOM, _ ("High"));
	_tmp48_ = self->priv->temp_scale;
	gtk_scale_add_mark (_tmp48_, (gdouble) 4500, GTK_POS_BOTTOM, NULL);
	_tmp49_ = self->priv->temp_scale;
	gtk_scale_add_mark (_tmp49_, (gdouble) 6000, GTK_POS_BOTTOM, _ ("Low"));
	_tmp50_ = self->priv->temp_scale;
	_tmp51_ = gtk_widget_get_style_context ((GtkWidget*) _tmp50_);
	gtk_style_context_add_class (_tmp51_, "warmth");
	_tmp52_ = self->priv->temp_scale;
	_tmp53_ = _data2_->settings;
	gtk_range_set_value ((GtkRange*) _tmp52_, (gdouble) g_settings_get_uint (_tmp53_, "night-light-temperature"));
	_tmp54_ = he_mini_content_block_new ();
	g_object_ref_sink (_tmp54_);
	temp_box = _tmp54_;
	_tmp55_ = temp_box;
	he_mini_content_block_set_title (_tmp55_, _ ("Intensity"));
	_tmp56_ = self->priv->temp_scale;
	_tmp57_ = temp_box;
	gtk_widget_set_parent ((GtkWidget*) _tmp56_, (GtkWidget*) _tmp57_);
	_tmp58_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp58_);
	content_grid = _tmp58_;
	_tmp59_ = content_grid;
	gtk_grid_set_column_homogeneous (_tmp59_, TRUE);
	_tmp60_ = content_grid;
	_tmp61_ = temp_box;
	gtk_grid_attach (_tmp60_, (GtkWidget*) _tmp61_, 0, 2, 1, 1);
	_tmp62_ = content_grid;
	_tmp63_ = schedule_box;
	gtk_grid_attach (_tmp62_, (GtkWidget*) _tmp63_, 0, 0, 1, 1);
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	_tmp64_ = _data2_->status_switch;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp64_, 0, 0, 1, 1);
	_tmp65_ = content_grid;
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp65_, 0, 2, 2, 1);
	gtk_widget_show ((GtkWidget*) self);
	_tmp66_ = _data2_->settings;
	_tmp67_ = _data2_->status_switch;
	_tmp68_ = _tmp67_->main_switch;
	g_settings_bind (_tmp66_, "night-light-enabled", (GObject*) _tmp68_, "active", G_SETTINGS_BIND_DEFAULT);
	_tmp69_ = _data2_->settings;
	_tmp70_ = content_grid;
	g_settings_bind (_tmp69_, "night-light-enabled", (GObject*) _tmp70_, "sensitive", G_SETTINGS_BIND_GET);
	_tmp71_ = _data2_->settings;
	g_settings_bind (_tmp71_, "night-light-temperature", (GObject*) self, "temperature", G_SETTINGS_BIND_GET);
	_tmp72_ = _data2_->settings;
	automatic_schedule = g_settings_get_boolean (_tmp72_, "night-light-schedule-automatic");
	if (automatic_schedule) {
		GtkToggleButton* _tmp73_;
		GtkToggleButton* _tmp74_;
		HeTimePicker* _tmp75_;
		HeTimePicker* _tmp76_;
		_tmp73_ = schedule_button_b;
		gtk_toggle_button_set_active (_tmp73_, TRUE);
		_tmp74_ = schedule_button_a;
		gtk_toggle_button_set_active (_tmp74_, FALSE);
		_tmp75_ = _data2_->from_time;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp75_, FALSE);
		_tmp76_ = _data2_->to_time;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp76_, FALSE);
	} else {
		GtkToggleButton* _tmp77_;
		GtkToggleButton* _tmp78_;
		HeTimePicker* _tmp79_;
		HeTimePicker* _tmp80_;
		_tmp77_ = schedule_button_a;
		gtk_toggle_button_set_active (_tmp77_, TRUE);
		_tmp78_ = schedule_button_b;
		gtk_toggle_button_set_active (_tmp78_, FALSE);
		_tmp79_ = _data2_->from_time;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp79_, TRUE);
		_tmp80_ = _data2_->to_time;
		gtk_widget_set_sensitive ((GtkWidget*) _tmp80_, TRUE);
	}
	_tmp81_ = schedule_button_a;
	g_signal_connect_data (_tmp81_, "toggled", (GCallback) __display_night_light_view___lambda24__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp82_ = schedule_button_b;
	g_signal_connect_data (_tmp82_, "toggled", (GCallback) __display_night_light_view___lambda25__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp83_ = schedule_button_c;
	g_signal_connect_data (_tmp83_, "toggled", (GCallback) __display_night_light_view___lambda26__gtk_toggle_button_toggled, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp84_ = self->priv->temp_scale;
	g_signal_connect_data ((GtkRange*) _tmp84_, "value-changed", (GCallback) __display_night_light_view___lambda27__gtk_range_value_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp85_ = _data2_->from_time;
	g_signal_connect_data (_tmp85_, "time-changed", (GCallback) __display_night_light_view___lambda28__he_time_picker_time_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp86_ = _data2_->to_time;
	g_signal_connect_data (_tmp86_, "time-changed", (GCallback) __display_night_light_view___lambda29__he_time_picker_time_changed, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_tmp87_ = _data2_->status_switch;
	_tmp88_ = _tmp87_->main_switch;
	g_signal_connect_data ((GObject*) _tmp88_, "notify::active", (GCallback) __display_night_light_view___lambda30__g_object_notify, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
	_g_object_unref0 (content_grid);
	_g_object_unref0 (temp_box);
	_g_object_unref0 (schedule_box);
	_g_object_unref0 (schedule_main_box);
	_g_object_unref0 (schedule_button);
	_g_object_unref0 (schedule_button_c);
	_g_object_unref0 (schedule_button_b);
	_g_object_unref0 (schedule_button_a);
	block2_data_unref (_data2_);
	_data2_ = NULL;
	return obj;
}

static void
display_night_light_view_class_init (DisplayNightLightViewClass * klass,
                                     gpointer klass_data)
{
	display_night_light_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DisplayNightLightView_private_offset);
	G_OBJECT_CLASS (klass)->set_property = _vala_display_night_light_view_set_property;
	G_OBJECT_CLASS (klass)->constructor = display_night_light_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = display_night_light_view_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_NIGHT_LIGHT_VIEW_TEMPERATURE_PROPERTY, display_night_light_view_properties[DISPLAY_NIGHT_LIGHT_VIEW_TEMPERATURE_PROPERTY] = g_param_spec_int ("temperature", "temperature", "temperature", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
}

static void
display_night_light_view_instance_init (DisplayNightLightView * self,
                                        gpointer klass)
{
	self->priv = display_night_light_view_get_instance_private (self);
}

static void
display_night_light_view_finalize (GObject * obj)
{
	DisplayNightLightView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_NIGHT_LIGHT_VIEW, DisplayNightLightView);
	_g_object_unref0 (self->priv->temp_scale);
	G_OBJECT_CLASS (display_night_light_view_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
display_night_light_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayNightLightViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_night_light_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayNightLightView), 0, (GInstanceInitFunc) display_night_light_view_instance_init, NULL };
	GType display_night_light_view_type_id;
	display_night_light_view_type_id = g_type_register_static (gtk_grid_get_type (), "DisplayNightLightView", &g_define_type_info, 0);
	DisplayNightLightView_private_offset = g_type_add_instance_private (display_night_light_view_type_id, sizeof (DisplayNightLightViewPrivate));
	return display_night_light_view_type_id;
}

GType
display_night_light_view_get_type (void)
{
	static gsize display_night_light_view_type_id__once = 0;
	if (g_once_init_enter (&display_night_light_view_type_id__once)) {
		GType display_night_light_view_type_id;
		display_night_light_view_type_id = display_night_light_view_get_type_once ();
		g_once_init_leave (&display_night_light_view_type_id__once, display_night_light_view_type_id);
	}
	return display_night_light_view_type_id__once;
}

static void
_vala_display_night_light_view_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	DisplayNightLightView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_NIGHT_LIGHT_VIEW, DisplayNightLightView);
	switch (property_id) {
		case DISPLAY_NIGHT_LIGHT_VIEW_TEMPERATURE_PROPERTY:
		display_night_light_view_set_temperature (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

