/* DisplayWidget.c generated by valac 0.56.13, the Vala compiler
 * generated from DisplayWidget.vala, do not modify */

/*-
 * Copyright (c) 2023 Fyra Labs
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "fuse-display.h"
#include <glib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <glib/gi18n-lib.h>
#include <libhelium-1.h>

enum  {
	DISPLAY_DISPLAY_WIDGET_0_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY,
	DISPLAY_DISPLAY_WIDGET_NUM_PROPERTIES
};
static GParamSpec* display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_NUM_PROPERTIES];
typedef enum  {
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME,
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH,
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT,
	DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL
} DisplayDisplayWidgetResolutionColumns;

#define DISPLAY_DISPLAY_WIDGET_TYPE_RESOLUTION_COLUMNS (display_display_widget_resolution_columns_get_type ())
typedef enum  {
	DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME,
	DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE,
	DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL
} DisplayDisplayWidgetRotationColumns;

#define DISPLAY_DISPLAY_WIDGET_TYPE_ROTATION_COLUMNS (display_display_widget_rotation_columns_get_type ())
typedef enum  {
	DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME,
	DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE,
	DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL
} DisplayDisplayWidgetRefreshColumns;

#define DISPLAY_DISPLAY_WIDGET_TYPE_REFRESH_COLUMNS (display_display_widget_refresh_columns_get_type ())
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;
typedef struct _Block6Data Block6Data;
typedef struct _Block7Data Block7Data;
enum  {
	DISPLAY_DISPLAY_WIDGET_SET_AS_PRIMARY_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_MOVE_DISPLAY_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_END_GRAB_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_ACTIVE_CHANGED_SIGNAL,
	DISPLAY_DISPLAY_WIDGET_NUM_SIGNALS
};
static guint display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_NUM_SIGNALS] = {0};

struct _DisplayDisplayWidgetPrivate {
	DisplayVirtualMonitor* _virtual_monitor;
	gdouble _window_ratio;
	gint _delta_x;
	gint _delta_y;
	gboolean _only_display;
	GtkButton* _primary_image;
	GtkMenuButton* _toggle_settings;
	GtkSwitch* use_switch;
	GtkComboBox* resolution_combobox;
	GtkTreeStore* resolution_tree_store;
	GtkComboBox* rotation_combobox;
	GtkListStore* rotation_list_store;
	GtkComboBox* refresh_combobox;
	GtkListStore* refresh_list_store;
	gint real_width;
	gint real_height;
};

struct _Block4Data {
	int _ref_count_;
	DisplayDisplayWidget* self;
	gboolean _result_;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	DisplayMonitorMode* mode;
};

struct _Block6Data {
	int _ref_count_;
	DisplayDisplayWidget* self;
	DisplayTransform transform;
};

struct _Block7Data {
	int _ref_count_;
	DisplayDisplayWidget* self;
	gchar* virtual_monitor_name;
	GtkLabel* label;
};

static gint DisplayDisplayWidget_private_offset;
static gpointer display_display_widget_parent_class = NULL;

static GType display_display_widget_resolution_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType display_display_widget_rotation_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static GType display_display_widget_refresh_columns_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
static void display_display_widget_populate_refresh_rates (DisplayDisplayWidget* self);
static gboolean _vala_double_array_contains (gdouble * stack,
                                      gssize stack_length,
                                      const gdouble needle);
static void _vala_array_add3 (gdouble* * array,
                       gint* length,
                       gint* size,
                       gdouble value);
static void display_display_widget_on_monitor_modes_changed (DisplayDisplayWidget* self);
static gboolean display_display_widget_set_active_resolution_from_current_mode (DisplayDisplayWidget* self);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static gboolean ____lambda6_ (Block5Data* _data5_,
                       GtkTreeModel* model,
                       GtkTreePath* path,
                       GtkTreeIter* iter);
static gboolean _____lambda6__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                    GtkTreePath* path,
                                                    GtkTreeIter* iter,
                                                    gpointer self);
static void display_display_widget_on_vm_transform_changed (DisplayDisplayWidget* self);
static Block6Data* block6_data_ref (Block6Data* _data6_);
static void block6_data_unref (void * _userdata_);
static gboolean __lambda7_ (Block6Data* _data6_,
                     GtkTreeModel* model,
                     GtkTreePath* path,
                     GtkTreeIter* iter);
static gboolean ___lambda7__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                                  GtkTreePath* path,
                                                  GtkTreeIter* iter,
                                                  gpointer self);
static void display_display_widget_set_window_ratio (DisplayDisplayWidget* self,
                                              gdouble value);
static void display_display_widget_set_primary_image (DisplayDisplayWidget* self,
                                               GtkButton* value);
static void display_display_widget_set_toggle_settings (DisplayDisplayWidget* self,
                                                 GtkMenuButton* value);
static void g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static GObject * display_display_widget_constructor (GType type,
                                              guint n_construct_properties,
                                              GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _display_display_widget___lambda8_ (DisplayDisplayWidget* self);
static void __display_display_widget___lambda8__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static gint _display_monitor_mode_resolution_compare_func_gcompare_data_func (gconstpointer a,
                                                                       gconstpointer b,
                                                                       gpointer self);
static void _vala_array_add4 (DisplayResolution* * array,
                       gint* length,
                       gint* size,
                       const DisplayResolution* value);
static void _vala_array_add5 (DisplayResolution* * array,
                       gint* length,
                       gint* size,
                       const DisplayResolution* value);
static void _vala_array_add6 (DisplayResolution* * array,
                       gint* length,
                       gint* size,
                       const DisplayResolution* value);
static void _display_display_widget___lambda9_ (DisplayDisplayWidget* self);
static void __display_display_widget___lambda9__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _display_display_widget___lambda10_ (DisplayDisplayWidget* self);
static void __display_display_widget___lambda10__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self);
static void _display_display_widget___lambda11_ (Block7Data* _data7_);
static void __display_display_widget___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self);
static void _display_display_widget___lambda12_ (DisplayDisplayWidget* self);
static void __display_display_widget___lambda12__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                 gpointer self);
static void _display_display_widget_on_monitor_modes_changed_display_virtual_monitor_modes_changed (DisplayVirtualMonitor* _sender,
                                                                                             gpointer self);
static void _display_display_widget_on_vm_transform_changed_g_object_notify (GObject* _sender,
                                                                      GParamSpec* pspec,
                                                                      gpointer self);
static void display_display_widget_finalize (GObject * obj);
static GType display_display_widget_get_type_once (void);
static void _vala_display_display_widget_get_property (GObject * object,
                                                guint property_id,
                                                GValue * value,
                                                GParamSpec * pspec);
static void _vala_display_display_widget_set_property (GObject * object,
                                                guint property_id,
                                                const GValue * value,
                                                GParamSpec * pspec);

DisplayResolution*
display_resolution_dup (const DisplayResolution* self)
{
	DisplayResolution* dup;
	dup = g_new0 (DisplayResolution, 1);
	memcpy (dup, self, sizeof (DisplayResolution));
	return dup;
}

void
display_resolution_free (DisplayResolution* self)
{
	g_free (self);
}

 G_GNUC_NO_INLINE static GType
display_resolution_get_type_once (void)
{
	GType display_resolution_type_id;
	display_resolution_type_id = g_boxed_type_register_static ("DisplayResolution", (GBoxedCopyFunc) display_resolution_dup, (GBoxedFreeFunc) display_resolution_free);
	return display_resolution_type_id;
}

GType
display_resolution_get_type (void)
{
	static gsize display_resolution_type_id__once = 0;
	if (g_once_init_enter (&display_resolution_type_id__once)) {
		GType display_resolution_type_id;
		display_resolution_type_id = display_resolution_get_type_once ();
		g_once_init_leave (&display_resolution_type_id__once, display_resolution_type_id);
	}
	return display_resolution_type_id__once;
}

static inline gpointer
display_display_widget_get_instance_private (DisplayDisplayWidget* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayDisplayWidget_private_offset);
}

 G_GNUC_NO_INLINE static GType
display_display_widget_resolution_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME", "name"}, {DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH", "width"}, {DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT", "height"}, {DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL, "DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL", "total"}, {0, NULL, NULL}};
	GType display_display_widget_resolution_columns_type_id;
	display_display_widget_resolution_columns_type_id = g_enum_register_static ("DisplayDisplayWidgetResolutionColumns", values);
	return display_display_widget_resolution_columns_type_id;
}

static GType
display_display_widget_resolution_columns_get_type (void)
{
	static gsize display_display_widget_resolution_columns_type_id__once = 0;
	if (g_once_init_enter (&display_display_widget_resolution_columns_type_id__once)) {
		GType display_display_widget_resolution_columns_type_id;
		display_display_widget_resolution_columns_type_id = display_display_widget_resolution_columns_get_type_once ();
		g_once_init_leave (&display_display_widget_resolution_columns_type_id__once, display_display_widget_resolution_columns_type_id);
	}
	return display_display_widget_resolution_columns_type_id__once;
}

 G_GNUC_NO_INLINE static GType
display_display_widget_rotation_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME, "DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME", "name"}, {DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, "DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE", "value"}, {DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL, "DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL", "total"}, {0, NULL, NULL}};
	GType display_display_widget_rotation_columns_type_id;
	display_display_widget_rotation_columns_type_id = g_enum_register_static ("DisplayDisplayWidgetRotationColumns", values);
	return display_display_widget_rotation_columns_type_id;
}

static GType
display_display_widget_rotation_columns_get_type (void)
{
	static gsize display_display_widget_rotation_columns_type_id__once = 0;
	if (g_once_init_enter (&display_display_widget_rotation_columns_type_id__once)) {
		GType display_display_widget_rotation_columns_type_id;
		display_display_widget_rotation_columns_type_id = display_display_widget_rotation_columns_get_type_once ();
		g_once_init_leave (&display_display_widget_rotation_columns_type_id__once, display_display_widget_rotation_columns_type_id);
	}
	return display_display_widget_rotation_columns_type_id__once;
}

 G_GNUC_NO_INLINE static GType
display_display_widget_refresh_columns_get_type_once (void)
{
	static const GEnumValue values[] = {{DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME, "DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME", "name"}, {DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE, "DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE", "value"}, {DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL, "DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL", "total"}, {0, NULL, NULL}};
	GType display_display_widget_refresh_columns_type_id;
	display_display_widget_refresh_columns_type_id = g_enum_register_static ("DisplayDisplayWidgetRefreshColumns", values);
	return display_display_widget_refresh_columns_type_id;
}

static GType
display_display_widget_refresh_columns_get_type (void)
{
	static gsize display_display_widget_refresh_columns_type_id__once = 0;
	if (g_once_init_enter (&display_display_widget_refresh_columns_type_id__once)) {
		GType display_display_widget_refresh_columns_type_id;
		display_display_widget_refresh_columns_type_id = display_display_widget_refresh_columns_get_type_once ();
		g_once_init_leave (&display_display_widget_refresh_columns_type_id__once, display_display_widget_refresh_columns_type_id);
	}
	return display_display_widget_refresh_columns_type_id__once;
}

DisplayDisplayWidget*
display_display_widget_construct (GType object_type,
                                  DisplayVirtualMonitor* virtual_monitor)
{
	DisplayDisplayWidget * self = NULL;
	g_return_val_if_fail (virtual_monitor != NULL, NULL);
	self = (DisplayDisplayWidget*) g_object_new (object_type, "virtual-monitor", virtual_monitor, NULL);
	return self;
}

DisplayDisplayWidget*
display_display_widget_new (DisplayVirtualMonitor* virtual_monitor)
{
	return display_display_widget_construct (DISPLAY_TYPE_DISPLAY_WIDGET, virtual_monitor);
}

static gboolean
_vala_double_array_contains (gdouble * stack,
                             gssize stack_length,
                             const gdouble needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

static void
_vala_array_add3 (gdouble* * array,
                  gint* length,
                  gint* size,
                  gdouble value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gdouble, *array, *size);
	}
	(*array)[(*length)++] = value;
}

static void
display_display_widget_populate_refresh_rates (DisplayDisplayWidget* self)
{
	GtkListStore* _tmp0_;
	GtkTreeIter iter = {0};
	gint added = 0;
	GtkComboBox* _tmp1_;
	GtkTreeIter _tmp2_ = {0};
	gboolean _tmp3_;
	GtkComboBox* _tmp56_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->refresh_list_store;
	gtk_list_store_clear (_tmp0_);
	added = 0;
	_tmp1_ = self->priv->resolution_combobox;
	_tmp3_ = gtk_combo_box_get_active_iter (_tmp1_, &_tmp2_);
	iter = _tmp2_;
	if (_tmp3_) {
		gint active_width = 0;
		gint active_height = 0;
		GtkComboBox* _tmp4_;
		GtkTreeIter _tmp5_ = {0};
		gboolean _tmp6_;
		gdouble* frequencies = NULL;
		gdouble* _tmp11_;
		gint frequencies_length1;
		gint _frequencies_size_;
		gboolean refresh_set = FALSE;
		_tmp4_ = self->priv->resolution_combobox;
		_tmp6_ = gtk_combo_box_get_active_iter (_tmp4_, &_tmp5_);
		iter = _tmp5_;
		if (_tmp6_) {
			GtkTreeStore* _tmp7_;
			GtkTreeIter _tmp8_;
			gint _tmp9_ = 0;
			gint _tmp10_ = 0;
			_tmp7_ = self->priv->resolution_tree_store;
			_tmp8_ = iter;
			gtk_tree_model_get ((GtkTreeModel*) _tmp7_, &_tmp8_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, &_tmp9_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, &_tmp10_, -1);
			active_width = _tmp9_;
			active_height = _tmp10_;
		} else {
			return;
		}
		_tmp11_ = g_new0 (gdouble, 0);
		frequencies = _tmp11_;
		frequencies_length1 = 0;
		_frequencies_size_ = frequencies_length1;
		refresh_set = FALSE;
		{
			GeeLinkedList* _mode_list = NULL;
			DisplayVirtualMonitor* _tmp12_;
			GeeLinkedList* _tmp13_;
			gint _mode_size = 0;
			GeeLinkedList* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			gint _mode_index = 0;
			_tmp12_ = self->priv->_virtual_monitor;
			_tmp13_ = display_virtual_monitor_get_available_modes (_tmp12_);
			_mode_list = _tmp13_;
			_tmp14_ = _mode_list;
			_tmp15_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp14_);
			_tmp16_ = _tmp15_;
			_mode_size = _tmp16_;
			_mode_index = -1;
			while (TRUE) {
				gint _tmp17_;
				gint _tmp18_;
				DisplayMonitorMode* mode = NULL;
				GeeLinkedList* _tmp19_;
				gpointer _tmp20_;
				gboolean _tmp21_ = FALSE;
				DisplayMonitorMode* _tmp22_;
				gint _tmp23_;
				gint _tmp24_;
				DisplayMonitorMode* _tmp28_;
				gdouble _tmp29_;
				gdouble _tmp30_;
				gdouble* _tmp31_;
				gint _tmp31__length1;
				gboolean freq_already_added = FALSE;
				gdouble* _tmp32_;
				gint _tmp32__length1;
				DisplayMonitorMode* _tmp36_;
				gdouble _tmp37_;
				gdouble _tmp38_;
				gchar* freq_name = NULL;
				DisplayMonitorMode* _tmp39_;
				gdouble _tmp40_;
				gdouble _tmp41_;
				gchar* _tmp42_;
				GtkListStore* _tmp43_;
				GtkTreeIter _tmp44_ = {0};
				GtkListStore* _tmp45_;
				GtkTreeIter _tmp46_;
				const gchar* _tmp47_;
				DisplayMonitorMode* _tmp48_;
				gint _tmp49_;
				DisplayMonitorMode* _tmp50_;
				gboolean _tmp51_;
				gboolean _tmp52_;
				_mode_index = _mode_index + 1;
				_tmp17_ = _mode_index;
				_tmp18_ = _mode_size;
				if (!(_tmp17_ < _tmp18_)) {
					break;
				}
				_tmp19_ = _mode_list;
				_tmp20_ = gee_abstract_list_get ((GeeAbstractList*) _tmp19_, _mode_index);
				mode = (DisplayMonitorMode*) _tmp20_;
				_tmp22_ = mode;
				_tmp23_ = display_monitor_mode_get_width (_tmp22_);
				_tmp24_ = _tmp23_;
				if (_tmp24_ != active_width) {
					_tmp21_ = TRUE;
				} else {
					DisplayMonitorMode* _tmp25_;
					gint _tmp26_;
					gint _tmp27_;
					_tmp25_ = mode;
					_tmp26_ = display_monitor_mode_get_height (_tmp25_);
					_tmp27_ = _tmp26_;
					_tmp21_ = _tmp27_ != active_height;
				}
				if (_tmp21_) {
					_g_object_unref0 (mode);
					continue;
				}
				_tmp28_ = mode;
				_tmp29_ = display_monitor_mode_get_frequency (_tmp28_);
				_tmp30_ = _tmp29_;
				_tmp31_ = frequencies;
				_tmp31__length1 = frequencies_length1;
				if (_vala_double_array_contains (_tmp31_, _tmp31__length1, _tmp30_)) {
					_g_object_unref0 (mode);
					continue;
				}
				freq_already_added = FALSE;
				_tmp32_ = frequencies;
				_tmp32__length1 = frequencies_length1;
				{
					gdouble* freq_collection = NULL;
					gint freq_collection_length1 = 0;
					gint _freq_collection_size_ = 0;
					gint freq_it = 0;
					freq_collection = _tmp32_;
					freq_collection_length1 = _tmp32__length1;
					for (freq_it = 0; freq_it < freq_collection_length1; freq_it = freq_it + 1) {
						gdouble freq = 0.0;
						freq = freq_collection[freq_it];
						{
							DisplayMonitorMode* _tmp33_;
							gdouble _tmp34_;
							gdouble _tmp35_;
							_tmp33_ = mode;
							_tmp34_ = display_monitor_mode_get_frequency (_tmp33_);
							_tmp35_ = _tmp34_;
							if (fabs (_tmp35_ - freq) < ((gdouble) 1)) {
								freq_already_added = TRUE;
								break;
							}
						}
					}
				}
				if (freq_already_added) {
					_g_object_unref0 (mode);
					continue;
				}
				_tmp36_ = mode;
				_tmp37_ = display_monitor_mode_get_frequency (_tmp36_);
				_tmp38_ = _tmp37_;
				_vala_array_add3 (&frequencies, &frequencies_length1, &_frequencies_size_, _tmp38_);
				_tmp39_ = mode;
				_tmp40_ = display_monitor_mode_get_frequency (_tmp39_);
				_tmp41_ = _tmp40_;
				_tmp42_ = g_strdup_printf (_ ("%g Hz"), (gdouble) roundf ((gfloat) _tmp41_));
				freq_name = _tmp42_;
				_tmp43_ = self->priv->refresh_list_store;
				gtk_list_store_append (_tmp43_, &_tmp44_);
				iter = _tmp44_;
				_tmp45_ = self->priv->refresh_list_store;
				_tmp46_ = iter;
				_tmp47_ = freq_name;
				_tmp48_ = mode;
				gtk_list_store_set (_tmp45_, &_tmp46_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, _tmp47_, DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE, _tmp48_, -1);
				_tmp49_ = added;
				added = _tmp49_ + 1;
				_tmp50_ = mode;
				_tmp51_ = display_monitor_mode_get_is_current (_tmp50_);
				_tmp52_ = _tmp51_;
				if (_tmp52_) {
					GtkComboBox* _tmp53_;
					GtkTreeIter _tmp54_;
					_tmp53_ = self->priv->refresh_combobox;
					_tmp54_ = iter;
					gtk_combo_box_set_active_iter (_tmp53_, &_tmp54_);
					refresh_set = TRUE;
				}
				_g_free0 (freq_name);
				_g_object_unref0 (mode);
			}
			_g_object_unref0 (_mode_list);
		}
		if (!refresh_set) {
			GtkComboBox* _tmp55_;
			_tmp55_ = self->priv->refresh_combobox;
			gtk_combo_box_set_active (_tmp55_, 0);
		}
		frequencies = (g_free (frequencies), NULL);
	}
	_tmp56_ = self->priv->refresh_combobox;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp56_, added > 1);
}

static void
display_display_widget_on_monitor_modes_changed (DisplayDisplayWidget* self)
{
	g_return_if_fail (self != NULL);
	display_display_widget_set_active_resolution_from_current_mode (self);
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
	g_atomic_int_inc (&_data4_->_ref_count_);
	return _data4_;
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
		DisplayDisplayWidget* self;
		self = _data4_->self;
		_g_object_unref0 (self);
		g_slice_free (Block4Data, _data4_);
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
	g_atomic_int_inc (&_data5_->_ref_count_);
	return _data5_;
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
		DisplayDisplayWidget* self;
		self = _data5_->_data4_->self;
		_g_object_unref0 (_data5_->mode);
		block4_data_unref (_data5_->_data4_);
		_data5_->_data4_ = NULL;
		g_slice_free (Block5Data, _data5_);
	}
}

static gboolean
____lambda6_ (Block5Data* _data5_,
              GtkTreeModel* model,
              GtkTreePath* path,
              GtkTreeIter* iter)
{
	Block4Data* _data4_;
	DisplayDisplayWidget* self;
	gint width = 0;
	gint height = 0;
	GtkTreeStore* _tmp0_;
	GtkTreeIter _tmp1_;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gboolean _tmp4_ = FALSE;
	DisplayMonitorMode* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gboolean result;
	_data4_ = _data5_->_data4_;
	self = _data4_->self;
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->resolution_tree_store;
	_tmp1_ = *iter;
	gtk_tree_model_get ((GtkTreeModel*) _tmp0_, &_tmp1_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, &_tmp2_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, &_tmp3_, -1);
	width = _tmp2_;
	height = _tmp3_;
	_tmp5_ = _data5_->mode;
	_tmp6_ = display_monitor_mode_get_width (_tmp5_);
	_tmp7_ = _tmp6_;
	if (_tmp7_ == width) {
		DisplayMonitorMode* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		_tmp8_ = _data5_->mode;
		_tmp9_ = display_monitor_mode_get_height (_tmp8_);
		_tmp10_ = _tmp9_;
		_tmp4_ = _tmp10_ == height;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		GtkComboBox* _tmp11_;
		GtkTreeIter _tmp12_;
		_tmp11_ = self->priv->resolution_combobox;
		_tmp12_ = *iter;
		gtk_combo_box_set_active_iter (_tmp11_, &_tmp12_);
		_data4_->_result_ = TRUE;
		result = TRUE;
		return result;
	}
	result = FALSE;
	return result;
}

static gboolean
_____lambda6__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                           GtkTreePath* path,
                                           GtkTreeIter* iter,
                                           gpointer self)
{
	gboolean result;
	result = ____lambda6_ (self, model, path, iter);
	return result;
}

static gboolean
display_display_widget_set_active_resolution_from_current_mode (DisplayDisplayWidget* self)
{
	Block4Data* _data4_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_data4_ = g_slice_new0 (Block4Data);
	_data4_->_ref_count_ = 1;
	_data4_->self = g_object_ref (self);
	_data4_->_result_ = FALSE;
	{
		GeeLinkedList* _mode_list = NULL;
		DisplayVirtualMonitor* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _mode_index = 0;
		_tmp0_ = self->priv->_virtual_monitor;
		_tmp1_ = display_virtual_monitor_get_available_modes (_tmp0_);
		_mode_list = _tmp1_;
		_tmp2_ = _mode_list;
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
		_tmp4_ = _tmp3_;
		_mode_size = _tmp4_;
		_mode_index = -1;
		while (TRUE) {
			Block5Data* _data5_;
			gint _tmp5_;
			gint _tmp6_;
			GeeLinkedList* _tmp7_;
			gpointer _tmp8_;
			DisplayMonitorMode* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
			GtkTreeStore* _tmp12_;
			_data5_ = g_slice_new0 (Block5Data);
			_data5_->_ref_count_ = 1;
			_data5_->_data4_ = block4_data_ref (_data4_);
			_mode_index = _mode_index + 1;
			_tmp5_ = _mode_index;
			_tmp6_ = _mode_size;
			if (!(_tmp5_ < _tmp6_)) {
				block5_data_unref (_data5_);
				_data5_ = NULL;
				break;
			}
			_tmp7_ = _mode_list;
			_tmp8_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _mode_index);
			_data5_->mode = (DisplayMonitorMode*) _tmp8_;
			_tmp9_ = _data5_->mode;
			_tmp10_ = display_monitor_mode_get_is_current (_tmp9_);
			_tmp11_ = _tmp10_;
			if (!_tmp11_) {
				block5_data_unref (_data5_);
				_data5_ = NULL;
				continue;
			}
			_tmp12_ = self->priv->resolution_tree_store;
			gtk_tree_model_foreach ((GtkTreeModel*) _tmp12_, _____lambda6__gtk_tree_model_foreach_func, _data5_);
			block5_data_unref (_data5_);
			_data5_ = NULL;
		}
		_g_object_unref0 (_mode_list);
	}
	result = _data4_->_result_;
	block4_data_unref (_data4_);
	_data4_ = NULL;
	return result;
}

static Block6Data*
block6_data_ref (Block6Data* _data6_)
{
	g_atomic_int_inc (&_data6_->_ref_count_);
	return _data6_;
}

static void
block6_data_unref (void * _userdata_)
{
	Block6Data* _data6_;
	_data6_ = (Block6Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data6_->_ref_count_)) {
		DisplayDisplayWidget* self;
		self = _data6_->self;
		_g_object_unref0 (self);
		g_slice_free (Block6Data, _data6_);
	}
}

static gboolean
__lambda7_ (Block6Data* _data6_,
            GtkTreeModel* model,
            GtkTreePath* path,
            GtkTreeIter* iter)
{
	DisplayDisplayWidget* self;
	GValue val = {0};
	GtkListStore* _tmp0_;
	GtkTreeIter _tmp1_;
	GValue _tmp2_ = {0};
	DisplayTransform iter_transform = 0;
	GValue _tmp3_;
	gboolean result;
	self = _data6_->self;
	g_return_val_if_fail (model != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	g_return_val_if_fail (iter != NULL, FALSE);
	_tmp0_ = self->priv->rotation_list_store;
	_tmp1_ = *iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp0_, &_tmp1_, (gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, &_tmp2_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp2_;
	_tmp3_ = val;
	iter_transform = (DisplayTransform) g_value_get_int (&_tmp3_);
	if (iter_transform == _data6_->transform) {
		GtkComboBox* _tmp4_;
		GtkTreeIter _tmp5_;
		_tmp4_ = self->priv->rotation_combobox;
		_tmp5_ = *iter;
		gtk_combo_box_set_active_iter (_tmp4_, &_tmp5_);
		result = TRUE;
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		return result;
	}
	result = FALSE;
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	return result;
}

static gboolean
___lambda7__gtk_tree_model_foreach_func (GtkTreeModel* model,
                                         GtkTreePath* path,
                                         GtkTreeIter* iter,
                                         gpointer self)
{
	gboolean result;
	result = __lambda7_ (self, model, path, iter);
	return result;
}

static void
display_display_widget_on_vm_transform_changed (DisplayDisplayWidget* self)
{
	Block6Data* _data6_;
	DisplayVirtualMonitor* _tmp0_;
	DisplayTransform _tmp1_;
	DisplayTransform _tmp2_;
	GtkListStore* _tmp3_;
	g_return_if_fail (self != NULL);
	_data6_ = g_slice_new0 (Block6Data);
	_data6_->_ref_count_ = 1;
	_data6_->self = g_object_ref (self);
	_tmp0_ = self->priv->_virtual_monitor;
	_tmp1_ = display_virtual_monitor_get_transform (_tmp0_);
	_tmp2_ = _tmp1_;
	_data6_->transform = _tmp2_;
	_tmp3_ = self->priv->rotation_list_store;
	gtk_tree_model_foreach ((GtkTreeModel*) _tmp3_, ___lambda7__gtk_tree_model_foreach_func, _data6_);
	block6_data_unref (_data6_);
	_data6_ = NULL;
}

void
display_display_widget_set_primary (DisplayDisplayWidget* self,
                                    gboolean is_primary)
{
	GtkSwitch* _tmp4_;
	g_return_if_fail (self != NULL);
	if (is_primary) {
		GtkButton* _tmp0_;
		GtkButton* _tmp1_;
		_tmp0_ = self->priv->_primary_image;
		gtk_button_set_icon_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, gtk_button_get_type (), GtkButton), "starred-symbolic");
		_tmp1_ = self->priv->_primary_image;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, _ ("Is the primary display"));
	} else {
		GtkButton* _tmp2_;
		GtkButton* _tmp3_;
		_tmp2_ = self->priv->_primary_image;
		gtk_button_set_icon_name (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_button_get_type (), GtkButton), "non-starred-symbolic");
		_tmp3_ = self->priv->_primary_image;
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp3_, _ ("Set as primary display"));
	}
	_tmp4_ = self->priv->use_switch;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp4_, !is_primary);
}

void
display_display_widget_get_preferred_width (DisplayDisplayWidget* self,
                                            gint* minimum_width,
                                            gint* natural_width)
{
	gint _vala_minimum_width = 0;
	gint _vala_natural_width = 0;
	gdouble _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_window_ratio;
	_vala_minimum_width = (gint) (self->priv->real_width * _tmp0_);
	_vala_natural_width = _vala_minimum_width;
	if (minimum_width) {
		*minimum_width = _vala_minimum_width;
	}
	if (natural_width) {
		*natural_width = _vala_natural_width;
	}
}

void
display_display_widget_get_preferred_height (DisplayDisplayWidget* self,
                                             gint* minimum_height,
                                             gint* natural_height)
{
	gint _vala_minimum_height = 0;
	gint _vala_natural_height = 0;
	gdouble _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_window_ratio;
	_vala_minimum_height = (gint) (self->priv->real_height * _tmp0_);
	_vala_natural_height = _vala_minimum_height;
	if (minimum_height) {
		*minimum_height = _vala_minimum_height;
	}
	if (natural_height) {
		*natural_height = _vala_natural_height;
	}
}

void
display_display_widget_get_geometry (DisplayDisplayWidget* self,
                                     gint* x,
                                     gint* y,
                                     gint* width,
                                     gint* height)
{
	gint _vala_x = 0;
	gint _vala_y = 0;
	gint _vala_width = 0;
	gint _vala_height = 0;
	DisplayVirtualMonitor* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	DisplayVirtualMonitor* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_virtual_monitor;
	_tmp1_ = display_virtual_monitor_get_x (_tmp0_);
	_tmp2_ = _tmp1_;
	_vala_x = _tmp2_;
	_tmp3_ = self->priv->_virtual_monitor;
	_tmp4_ = display_virtual_monitor_get_y (_tmp3_);
	_tmp5_ = _tmp4_;
	_vala_y = _tmp5_;
	_vala_width = self->priv->real_width;
	_vala_height = self->priv->real_height;
	if (x) {
		*x = _vala_x;
	}
	if (y) {
		*y = _vala_y;
	}
	if (width) {
		*width = _vala_width;
	}
	if (height) {
		*height = _vala_height;
	}
}

void
display_display_widget_set_geometry (DisplayDisplayWidget* self,
                                     gint x,
                                     gint y,
                                     gint width,
                                     gint height)
{
	DisplayVirtualMonitor* _tmp0_;
	DisplayVirtualMonitor* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_virtual_monitor;
	display_virtual_monitor_set_x (_tmp0_, x);
	_tmp1_ = self->priv->_virtual_monitor;
	display_virtual_monitor_set_y (_tmp1_, y);
	self->priv->real_width = width;
	self->priv->real_height = height;
}

gboolean
display_display_widget_equals (DisplayDisplayWidget* self,
                               DisplayDisplayWidget* sibling)
{
	DisplayVirtualMonitor* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	DisplayVirtualMonitor* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gboolean _tmp8_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (sibling != NULL, FALSE);
	_tmp0_ = self->priv->_virtual_monitor;
	_tmp1_ = display_virtual_monitor_get_id (_tmp0_);
	_tmp2_ = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp4_ = sibling->priv->_virtual_monitor;
	_tmp5_ = display_virtual_monitor_get_id (_tmp4_);
	_tmp6_ = _tmp5_;
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strcmp0 (_tmp3_, _tmp7_) == 0;
	_g_free0 (_tmp7_);
	_g_free0 (_tmp3_);
	result = _tmp8_;
	return result;
}

DisplayVirtualMonitor*
display_display_widget_get_virtual_monitor (DisplayDisplayWidget* self)
{
	DisplayVirtualMonitor* result;
	DisplayVirtualMonitor* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_virtual_monitor;
	result = _tmp0_;
	return result;
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
display_display_widget_set_virtual_monitor (DisplayDisplayWidget* self,
                                            DisplayVirtualMonitor* value)
{
	DisplayVirtualMonitor* old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_virtual_monitor (self);
	if (old_value != value) {
		DisplayVirtualMonitor* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_virtual_monitor);
		self->priv->_virtual_monitor = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY]);
	}
}

gdouble
display_display_widget_get_window_ratio (DisplayDisplayWidget* self)
{
	gdouble result;
	g_return_val_if_fail (self != NULL, 0.0);
	result = self->priv->_window_ratio;
	return result;
}

static void
display_display_widget_set_window_ratio (DisplayDisplayWidget* self,
                                         gdouble value)
{
	gdouble old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_window_ratio (self);
	if (old_value != value) {
		self->priv->_window_ratio = value;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY]);
	}
}

gint
display_display_widget_get_delta_x (DisplayDisplayWidget* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_delta_x;
	return result;
}

void
display_display_widget_set_delta_x (DisplayDisplayWidget* self,
                                    gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_delta_x (self);
	if (old_value != value) {
		self->priv->_delta_x = value;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY]);
	}
}

gint
display_display_widget_get_delta_y (DisplayDisplayWidget* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_delta_y;
	return result;
}

void
display_display_widget_set_delta_y (DisplayDisplayWidget* self,
                                    gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_delta_y (self);
	if (old_value != value) {
		self->priv->_delta_y = value;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY]);
	}
}

gboolean
display_display_widget_get_only_display (DisplayDisplayWidget* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_only_display;
	return result;
}

void
display_display_widget_set_only_display (DisplayDisplayWidget* self,
                                         gboolean value)
{
	gboolean old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_only_display (self);
	if (old_value != value) {
		self->priv->_only_display = value;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY]);
	}
}

GtkButton*
display_display_widget_get_primary_image (DisplayDisplayWidget* self)
{
	GtkButton* result;
	GtkButton* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_primary_image;
	result = _tmp0_;
	return result;
}

static void
display_display_widget_set_primary_image (DisplayDisplayWidget* self,
                                          GtkButton* value)
{
	GtkButton* old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_primary_image (self);
	if (old_value != value) {
		GtkButton* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_primary_image);
		self->priv->_primary_image = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY]);
	}
}

GtkMenuButton*
display_display_widget_get_toggle_settings (DisplayDisplayWidget* self)
{
	GtkMenuButton* result;
	GtkMenuButton* _tmp0_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->_toggle_settings;
	result = _tmp0_;
	return result;
}

static void
display_display_widget_set_toggle_settings (DisplayDisplayWidget* self,
                                            GtkMenuButton* value)
{
	GtkMenuButton* old_value;
	g_return_if_fail (self != NULL);
	old_value = display_display_widget_get_toggle_settings (self);
	if (old_value != value) {
		GtkMenuButton* _tmp0_;
		_tmp0_ = _g_object_ref0 (value);
		_g_object_unref0 (self->priv->_toggle_settings);
		self->priv->_toggle_settings = _tmp0_;
		g_object_notify_by_pspec ((GObject *) self, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY]);
	}
}

static void
g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__DOUBLE_DOUBLE) (gpointer data1, gdouble arg_1, gdouble arg_2, gpointer data2);
	register GMarshalFunc_VOID__DOUBLE_DOUBLE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__DOUBLE_DOUBLE) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_double (param_values + 1), g_value_get_double (param_values + 2), data2);
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
}

static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
	g_atomic_int_inc (&_data7_->_ref_count_);
	return _data7_;
}

static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
		DisplayDisplayWidget* self;
		self = _data7_->self;
		_g_object_unref0 (_data7_->label);
		_g_free0 (_data7_->virtual_monitor_name);
		_g_object_unref0 (self);
		g_slice_free (Block7Data, _data7_);
	}
}

static void
_display_display_widget___lambda8_ (DisplayDisplayWidget* self)
{
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_SET_AS_PRIMARY_SIGNAL], 0);
}

static void
__display_display_widget___lambda8__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
	_display_display_widget___lambda8_ ((DisplayDisplayWidget*) self);
}

static gint
_display_monitor_mode_resolution_compare_func_gcompare_data_func (gconstpointer a,
                                                                  gconstpointer b,
                                                                  gpointer self)
{
	gint result;
	result = display_monitor_mode_resolution_compare_func ((DisplayMonitorMode*) a, (DisplayMonitorMode*) b);
	return result;
}

static void
_vala_array_add4 (DisplayResolution* * array,
                  gint* length,
                  gint* size,
                  const DisplayResolution* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DisplayResolution, *array, *size);
	}
	(*array)[(*length)++] = *value;
}

static void
_vala_array_add5 (DisplayResolution* * array,
                  gint* length,
                  gint* size,
                  const DisplayResolution* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DisplayResolution, *array, *size);
	}
	(*array)[(*length)++] = *value;
}

static void
_vala_array_add6 (DisplayResolution* * array,
                  gint* length,
                  gint* size,
                  const DisplayResolution* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (DisplayResolution, *array, *size);
	}
	(*array)[(*length)++] = *value;
}

static void
_display_display_widget___lambda9_ (DisplayDisplayWidget* self)
{
	GtkComboBox* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GtkComboBox* _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	GtkComboBox* _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	GtkSwitch* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	_tmp0_ = self->priv->rotation_combobox;
	_tmp1_ = gtk_combo_box_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ == -1) {
		GtkComboBox* _tmp3_;
		_tmp3_ = self->priv->rotation_combobox;
		gtk_combo_box_set_active (_tmp3_, 0);
	}
	_tmp4_ = self->priv->resolution_combobox;
	_tmp5_ = gtk_combo_box_get_active (_tmp4_);
	_tmp6_ = _tmp5_;
	if (_tmp6_ == -1) {
		GtkComboBox* _tmp7_;
		_tmp7_ = self->priv->resolution_combobox;
		gtk_combo_box_set_active (_tmp7_, 0);
	}
	_tmp8_ = self->priv->refresh_combobox;
	_tmp9_ = gtk_combo_box_get_active (_tmp8_);
	_tmp10_ = _tmp9_;
	if (_tmp10_ == -1) {
		GtkComboBox* _tmp11_;
		_tmp11_ = self->priv->refresh_combobox;
		gtk_combo_box_set_active (_tmp11_, 0);
	}
	_tmp12_ = self->priv->use_switch;
	_tmp13_ = gtk_switch_get_active (_tmp12_);
	_tmp14_ = _tmp13_;
	if (_tmp14_) {
		gtk_widget_remove_css_class ((GtkWidget*) self, "disabled");
	} else {
		gtk_widget_add_css_class ((GtkWidget*) self, "disabled");
	}
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_ACTIVE_CHANGED_SIGNAL], 0);
}

static void
__display_display_widget___lambda9__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_display_display_widget___lambda9_ ((DisplayDisplayWidget*) self);
}

static void
_display_display_widget___lambda10_ (DisplayDisplayWidget* self)
{
	gint active_width = 0;
	gint active_height = 0;
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	DisplayVirtualMonitor* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	DisplayVirtualMonitor* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	DisplayMonitorMode* new_mode = NULL;
	DisplayVirtualMonitor* _tmp13_;
	DisplayMonitorMode* _tmp14_;
	DisplayMonitorMode* _tmp15_;
	DisplayVirtualMonitor* _tmp16_;
	DisplayMonitorMode* _tmp17_;
	GtkComboBox* _tmp18_;
	_tmp0_ = self->priv->resolution_combobox;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkTreeStore* _tmp3_;
		GtkTreeIter _tmp4_;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		_tmp3_ = self->priv->resolution_tree_store;
		_tmp4_ = iter;
		gtk_tree_model_get ((GtkTreeModel*) _tmp3_, &_tmp4_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, &_tmp5_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, &_tmp6_, -1);
		active_width = _tmp5_;
		active_height = _tmp6_;
	} else {
		return;
	}
	_tmp7_ = self->priv->_virtual_monitor;
	_tmp8_ = display_virtual_monitor_get_x (_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp10_ = self->priv->_virtual_monitor;
	_tmp11_ = display_virtual_monitor_get_y (_tmp10_);
	_tmp12_ = _tmp11_;
	display_display_widget_set_geometry (self, _tmp9_, _tmp12_, active_width, active_height);
	_tmp13_ = self->priv->_virtual_monitor;
	_tmp14_ = display_virtual_monitor_get_mode_for_resolution (_tmp13_, active_width, active_height);
	new_mode = _tmp14_;
	_tmp15_ = new_mode;
	if (_tmp15_ == NULL) {
		_g_object_unref0 (new_mode);
		return;
	}
	_tmp16_ = self->priv->_virtual_monitor;
	_tmp17_ = new_mode;
	display_virtual_monitor_set_current_mode (_tmp16_, _tmp17_);
	_tmp18_ = self->priv->rotation_combobox;
	gtk_combo_box_set_active (_tmp18_, 0);
	display_display_widget_populate_refresh_rates (self);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
	_g_object_unref0 (new_mode);
}

static void
__display_display_widget___lambda10__gtk_combo_box_changed (GtkComboBox* _sender,
                                                            gpointer self)
{
	_display_display_widget___lambda10_ ((DisplayDisplayWidget*) self);
}

static void
_display_display_widget___lambda11_ (Block7Data* _data7_)
{
	DisplayDisplayWidget* self;
	GValue val = {0};
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	GtkListStore* _tmp2_;
	GtkTreeIter _tmp3_;
	GValue _tmp4_ = {0};
	DisplayTransform transform = 0;
	GValue _tmp5_;
	DisplayVirtualMonitor* _tmp6_;
	self = _data7_->self;
	_tmp0_ = self->priv->rotation_combobox;
	gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	_tmp2_ = self->priv->rotation_list_store;
	_tmp3_ = iter;
	gtk_tree_model_get_value ((GtkTreeModel*) _tmp2_, &_tmp3_, (gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, &_tmp4_);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
	val = _tmp4_;
	_tmp5_ = val;
	transform = (DisplayTransform) g_value_get_int (&_tmp5_);
	_tmp6_ = self->priv->_virtual_monitor;
	display_virtual_monitor_set_transform (_tmp6_, transform);
	switch (transform) {
		case DISPLAY_TRANSFORM_NORMAL:
		{
			DisplayVirtualMonitor* _tmp7_;
			gint _tmp8_ = 0;
			gint _tmp9_ = 0;
			GtkLabel* _tmp10_;
			const gchar* _tmp11_;
			_tmp7_ = self->priv->_virtual_monitor;
			display_virtual_monitor_get_current_mode_size (_tmp7_, &_tmp8_, &_tmp9_);
			self->priv->real_width = _tmp8_;
			self->priv->real_height = _tmp9_;
			_tmp10_ = _data7_->label;
			_tmp11_ = _data7_->virtual_monitor_name;
			gtk_label_set_label (_tmp10_, _tmp11_);
			break;
		}
		case DISPLAY_TRANSFORM_ROTATION_90:
		{
			DisplayVirtualMonitor* _tmp12_;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			GtkLabel* _tmp15_;
			const gchar* _tmp16_;
			_tmp12_ = self->priv->_virtual_monitor;
			display_virtual_monitor_get_current_mode_size (_tmp12_, &_tmp13_, &_tmp14_);
			self->priv->real_height = _tmp13_;
			self->priv->real_width = _tmp14_;
			_tmp15_ = _data7_->label;
			_tmp16_ = _data7_->virtual_monitor_name;
			gtk_label_set_label (_tmp15_, _tmp16_);
			break;
		}
		case DISPLAY_TRANSFORM_ROTATION_180:
		{
			DisplayVirtualMonitor* _tmp17_;
			gint _tmp18_ = 0;
			gint _tmp19_ = 0;
			GtkLabel* _tmp20_;
			const gchar* _tmp21_;
			_tmp17_ = self->priv->_virtual_monitor;
			display_virtual_monitor_get_current_mode_size (_tmp17_, &_tmp18_, &_tmp19_);
			self->priv->real_width = _tmp18_;
			self->priv->real_height = _tmp19_;
			_tmp20_ = _data7_->label;
			_tmp21_ = _data7_->virtual_monitor_name;
			gtk_label_set_label (_tmp20_, _tmp21_);
			break;
		}
		case DISPLAY_TRANSFORM_ROTATION_270:
		{
			DisplayVirtualMonitor* _tmp22_;
			gint _tmp23_ = 0;
			gint _tmp24_ = 0;
			GtkLabel* _tmp25_;
			const gchar* _tmp26_;
			_tmp22_ = self->priv->_virtual_monitor;
			display_virtual_monitor_get_current_mode_size (_tmp22_, &_tmp23_, &_tmp24_);
			self->priv->real_height = _tmp23_;
			self->priv->real_width = _tmp24_;
			_tmp25_ = _data7_->label;
			_tmp26_ = _data7_->virtual_monitor_name;
			gtk_label_set_label (_tmp25_, _tmp26_);
			break;
		}
		default:
		break;
	}
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

static void
__display_display_widget___lambda11__gtk_combo_box_changed (GtkComboBox* _sender,
                                                            gpointer self)
{
	_display_display_widget___lambda11_ (self);
}

static void
_display_display_widget___lambda12_ (DisplayDisplayWidget* self)
{
	GValue val = {0};
	GtkTreeIter iter = {0};
	GtkComboBox* _tmp0_;
	GtkTreeIter _tmp1_ = {0};
	gboolean _tmp2_;
	_tmp0_ = self->priv->refresh_combobox;
	_tmp2_ = gtk_combo_box_get_active_iter (_tmp0_, &_tmp1_);
	iter = _tmp1_;
	if (_tmp2_) {
		GtkListStore* _tmp3_;
		GtkTreeIter _tmp4_;
		GValue _tmp5_ = {0};
		DisplayMonitorMode* new_mode = NULL;
		GValue _tmp6_;
		DisplayMonitorMode* _tmp7_;
		DisplayVirtualMonitor* _tmp8_;
		DisplayMonitorMode* _tmp9_;
		GtkComboBox* _tmp10_;
		_tmp3_ = self->priv->refresh_list_store;
		_tmp4_ = iter;
		gtk_tree_model_get_value ((GtkTreeModel*) _tmp3_, &_tmp4_, (gint) DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_VALUE, &_tmp5_);
		G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
		val = _tmp5_;
		_tmp6_ = val;
		_tmp7_ = _g_object_ref0 (g_value_get_object (&_tmp6_));
		new_mode = _tmp7_;
		_tmp8_ = self->priv->_virtual_monitor;
		_tmp9_ = new_mode;
		display_virtual_monitor_set_current_mode (_tmp8_, _tmp9_);
		_tmp10_ = self->priv->rotation_combobox;
		gtk_combo_box_set_active (_tmp10_, 0);
		g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
		g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
		_g_object_unref0 (new_mode);
	}
	G_IS_VALUE (&val) ? (g_value_unset (&val), NULL) : NULL;
}

static void
__display_display_widget___lambda12__gtk_combo_box_changed (GtkComboBox* _sender,
                                                            gpointer self)
{
	_display_display_widget___lambda12_ ((DisplayDisplayWidget*) self);
}

static void
_display_display_widget_on_monitor_modes_changed_display_virtual_monitor_modes_changed (DisplayVirtualMonitor* _sender,
                                                                                        gpointer self)
{
	display_display_widget_on_monitor_modes_changed ((DisplayDisplayWidget*) self);
}

static void
_display_display_widget_on_vm_transform_changed_g_object_notify (GObject* _sender,
                                                                 GParamSpec* pspec,
                                                                 gpointer self)
{
	display_display_widget_on_vm_transform_changed ((DisplayDisplayWidget*) self);
}

static GObject *
display_display_widget_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayDisplayWidget * self;
	Block7Data* _data7_;
	DisplayVirtualMonitor* _tmp0_;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GtkButton* _tmp4_ = NULL;
	GtkButton* _tmp5_;
	GtkButton* _tmp6_;
	GtkButton* _tmp7_;
	DisplayVirtualMonitor* _tmp8_;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gboolean _tmp11_ = FALSE;
	const gchar* _tmp12_;
	GtkLabel* _tmp13_ = NULL;
	GtkSwitch* _tmp14_ = NULL;
	HeSettingsRow* use_row = NULL;
	GtkSwitch* _tmp15_;
	HeSettingsRow* _tmp16_;
	DisplayVirtualMonitor* _tmp17_;
	GtkSwitch* _tmp18_;
	GtkTreeStore* _tmp19_;
	GtkTreeStore* _tmp20_;
	GtkComboBox* _tmp21_;
	HeSettingsRow* resolution_row = NULL;
	GtkComboBox* _tmp22_;
	HeSettingsRow* _tmp23_;
	GtkCellRendererText* text_renderer = NULL;
	GtkCellRendererText* _tmp24_;
	GtkComboBox* _tmp25_;
	GtkCellRendererText* _tmp26_;
	GtkComboBox* _tmp27_;
	GtkCellRendererText* _tmp28_;
	GtkListStore* _tmp29_;
	GtkListStore* _tmp30_;
	GtkComboBox* _tmp31_;
	HeSettingsRow* rotation_row = NULL;
	GtkComboBox* _tmp32_;
	HeSettingsRow* _tmp33_;
	GtkCellRendererText* _tmp34_;
	GtkComboBox* _tmp35_;
	GtkCellRendererText* _tmp36_;
	GtkComboBox* _tmp37_;
	GtkCellRendererText* _tmp38_;
	GtkListStore* _tmp39_;
	GtkListStore* _tmp40_;
	GtkComboBox* _tmp41_;
	HeSettingsRow* refresh_row = NULL;
	GtkComboBox* _tmp42_;
	HeSettingsRow* _tmp43_;
	GtkCellRendererText* _tmp44_;
	GtkComboBox* _tmp45_;
	GtkCellRendererText* _tmp46_;
	GtkComboBox* _tmp47_;
	GtkCellRendererText* _tmp48_;
	DisplayResolution* resolutions = NULL;
	DisplayResolution* _tmp57_;
	gint resolutions_length1;
	gint _resolutions_size_;
	DisplayResolution* recommended_resolutions = NULL;
	DisplayResolution* _tmp58_;
	gint recommended_resolutions_length1;
	gint _recommended_resolutions_size_;
	DisplayResolution* other_resolutions = NULL;
	DisplayResolution* _tmp59_;
	gint other_resolutions_length1;
	gint _other_resolutions_size_;
	gint max_width = 0;
	gint max_height = 0;
	guint usable_resolutions = 0U;
	gint current_width = 0;
	gint current_height = 0;
	DisplayVirtualMonitor* _tmp60_;
	gint _tmp61_ = 0;
	gint _tmp62_ = 0;
	GeeTreeSet* resolution_set = NULL;
	GeeTreeSet* _tmp63_;
	gint native_ratio = 0;
	DisplayResolution* _tmp97_;
	gint _tmp97__length1;
	DisplayResolution* _tmp109_;
	gint _tmp109__length1;
	DisplayResolution* _tmp120_;
	gint _tmp120__length1;
	GtkComboBox* _tmp138_;
	gint _tmp139_ = 0;
	GtkGrid* popover_grid = NULL;
	GtkGrid* _tmp140_ = NULL;
	GtkGrid* _tmp141_;
	HeSettingsRow* _tmp142_;
	GtkGrid* _tmp143_;
	HeSettingsRow* _tmp144_;
	GtkGrid* _tmp145_;
	HeSettingsRow* _tmp146_;
	GtkGrid* _tmp147_;
	HeSettingsRow* _tmp148_;
	GtkGrid* _tmp149_;
	GtkPopover* popover = NULL;
	GtkPopover* _tmp150_ = NULL;
	GtkPopover* _tmp151_;
	GtkGrid* _tmp152_;
	gint _tmp153_ = 0;
	gchar* _tmp154_;
	GtkPopover* _tmp155_;
	GtkPopover* _tmp156_;
	gchar* _tmp157_;
	GtkMenuButton* _tmp158_ = NULL;
	GtkMenuButton* _tmp159_;
	GtkMenuButton* _tmp160_;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp161_;
	GtkGrid* _tmp162_;
	GtkButton* _tmp163_;
	GtkGrid* _tmp164_;
	GtkMenuButton* _tmp165_;
	GtkGrid* _tmp166_;
	GtkLabel* _tmp167_;
	DisplayVirtualMonitor* _tmp168_;
	gboolean _tmp169_;
	gboolean _tmp170_;
	GtkGrid* _tmp171_;
	GtkSwitch* _tmp172_;
	GtkComboBox* _tmp173_;
	GtkSwitch* _tmp174_;
	GtkComboBox* _tmp175_;
	GtkSwitch* _tmp176_;
	GtkComboBox* _tmp177_;
	GtkSwitch* _tmp178_;
	DisplayVirtualMonitor* _tmp179_;
	gboolean _tmp180_;
	gboolean _tmp181_;
	GtkComboBox* _tmp182_;
	GtkComboBox* _tmp183_;
	GtkComboBox* _tmp184_;
	GtkComboBox* _tmp185_;
	DisplayVirtualMonitor* _tmp186_;
	DisplayTransform _tmp187_;
	DisplayTransform _tmp188_;
	DisplayVirtualMonitor* _tmp189_;
	DisplayVirtualMonitor* _tmp190_;
	parent_class = G_OBJECT_CLASS (display_display_widget_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
	_data7_ = g_slice_new0 (Block7Data);
	_data7_->_ref_count_ = 1;
	_data7_->self = g_object_ref (self);
	_tmp0_ = self->priv->_virtual_monitor;
	display_virtual_monitor_get_current_mode_size (_tmp0_, &_tmp1_, &_tmp2_);
	self->priv->real_width = _tmp1_;
	self->priv->real_height = _tmp2_;
	_tmp3_ = 6;
	_tmp4_ = (GtkButton*) gtk_button_new_from_icon_name ("non-starred-symbolic");
	gtk_widget_set_halign ((GtkWidget*) _tmp4_, GTK_ALIGN_START);
	gtk_widget_set_valign ((GtkWidget*) _tmp4_, GTK_ALIGN_START);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, _tmp3_);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp4_, _tmp3_);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp4_, _tmp3_);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp4_, _tmp3_);
	g_object_ref_sink (_tmp4_);
	_tmp5_ = _tmp4_;
	display_display_widget_set_primary_image (self, _tmp5_);
	_g_object_unref0 (_tmp5_);
	_tmp6_ = self->priv->_primary_image;
	gtk_widget_add_css_class ((GtkWidget*) _tmp6_, "disclosure-button");
	_tmp7_ = self->priv->_primary_image;
	g_signal_connect_object (_tmp7_, "clicked", (GCallback) __display_display_widget___lambda8__gtk_button_clicked, self, 0);
	_tmp8_ = self->priv->_virtual_monitor;
	_tmp9_ = display_virtual_monitor_get_display_name (_tmp8_);
	_tmp10_ = g_strdup (_tmp9_);
	_data7_->virtual_monitor_name = _tmp10_;
	_tmp11_ = TRUE;
	_tmp12_ = _data7_->virtual_monitor_name;
	_tmp13_ = (GtkLabel*) gtk_label_new (_tmp12_);
	gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
	gtk_widget_set_valign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
	gtk_widget_set_vexpand ((GtkWidget*) _tmp13_, _tmp11_);
	gtk_widget_set_hexpand ((GtkWidget*) _tmp13_, _tmp11_);
	g_object_ref_sink (_tmp13_);
	_data7_->label = _tmp13_;
	_tmp14_ = (GtkSwitch*) gtk_switch_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_START);
	g_object_ref_sink (_tmp14_);
	_g_object_unref0 (self->priv->use_switch);
	self->priv->use_switch = _tmp14_;
	_tmp15_ = self->priv->use_switch;
	_tmp16_ = he_settings_row_new_with_details (_ ("Use Display"), NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, HE_TYPE_BUTTON, HeButton));
	g_object_ref_sink (_tmp16_);
	use_row = _tmp16_;
	_tmp17_ = self->priv->_virtual_monitor;
	_tmp18_ = self->priv->use_switch;
	g_object_bind_property_with_closures ((GObject*) _tmp17_, "is-active", (GObject*) _tmp18_, "active", G_BINDING_SYNC_CREATE | G_BINDING_BIDIRECTIONAL, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp19_ = gtk_tree_store_new ((gint) DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_TOTAL, G_TYPE_STRING, G_TYPE_INT, G_TYPE_INT);
	_g_object_unref0 (self->priv->resolution_tree_store);
	self->priv->resolution_tree_store = _tmp19_;
	_tmp20_ = self->priv->resolution_tree_store;
	_tmp21_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp20_);
	g_object_ref_sink (_tmp21_);
	_g_object_unref0 (self->priv->resolution_combobox);
	self->priv->resolution_combobox = _tmp21_;
	_tmp22_ = self->priv->resolution_combobox;
	_tmp23_ = he_settings_row_new_with_details (_ ("Display Resolution"), NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp22_, HE_TYPE_BUTTON, HeButton));
	g_object_ref_sink (_tmp23_);
	resolution_row = _tmp23_;
	_tmp24_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp24_);
	text_renderer = _tmp24_;
	_tmp25_ = self->priv->resolution_combobox;
	_tmp26_ = text_renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp25_, (GtkCellRenderer*) _tmp26_, TRUE);
	_tmp27_ = self->priv->resolution_combobox;
	_tmp28_ = text_renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp27_, (GtkCellRenderer*) _tmp28_, "text", (gint) DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME);
	_tmp29_ = gtk_list_store_new ((gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_TOTAL, G_TYPE_STRING, G_TYPE_INT, -1);
	_g_object_unref0 (self->priv->rotation_list_store);
	self->priv->rotation_list_store = _tmp29_;
	_tmp30_ = self->priv->rotation_list_store;
	_tmp31_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp30_);
	g_object_ref_sink (_tmp31_);
	_g_object_unref0 (self->priv->rotation_combobox);
	self->priv->rotation_combobox = _tmp31_;
	_tmp32_ = self->priv->rotation_combobox;
	_tmp33_ = he_settings_row_new_with_details (_ ("Display Rotation"), NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp32_, HE_TYPE_BUTTON, HeButton));
	g_object_ref_sink (_tmp33_);
	rotation_row = _tmp33_;
	_tmp34_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp34_);
	_g_object_unref0 (text_renderer);
	text_renderer = _tmp34_;
	_tmp35_ = self->priv->rotation_combobox;
	_tmp36_ = text_renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp35_, (GtkCellRenderer*) _tmp36_, TRUE);
	_tmp37_ = self->priv->rotation_combobox;
	_tmp38_ = text_renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp37_, (GtkCellRenderer*) _tmp38_, "text", (gint) DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME);
	_tmp39_ = gtk_list_store_new ((gint) DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_TOTAL, G_TYPE_STRING, DISPLAY_TYPE_MONITOR_MODE, -1);
	_g_object_unref0 (self->priv->refresh_list_store);
	self->priv->refresh_list_store = _tmp39_;
	_tmp40_ = self->priv->refresh_list_store;
	_tmp41_ = (GtkComboBox*) gtk_combo_box_new_with_model ((GtkTreeModel*) _tmp40_);
	g_object_ref_sink (_tmp41_);
	_g_object_unref0 (self->priv->refresh_combobox);
	self->priv->refresh_combobox = _tmp41_;
	_tmp42_ = self->priv->refresh_combobox;
	_tmp43_ = he_settings_row_new_with_details (_ ("Display Refresh Rate"), NULL, G_TYPE_CHECK_INSTANCE_CAST (_tmp42_, HE_TYPE_BUTTON, HeButton));
	g_object_ref_sink (_tmp43_);
	refresh_row = _tmp43_;
	_tmp44_ = (GtkCellRendererText*) gtk_cell_renderer_text_new ();
	g_object_ref_sink (_tmp44_);
	_g_object_unref0 (text_renderer);
	text_renderer = _tmp44_;
	_tmp45_ = self->priv->refresh_combobox;
	_tmp46_ = text_renderer;
	gtk_cell_layout_pack_start ((GtkCellLayout*) _tmp45_, (GtkCellRenderer*) _tmp46_, TRUE);
	_tmp47_ = self->priv->refresh_combobox;
	_tmp48_ = text_renderer;
	gtk_cell_layout_add_attribute ((GtkCellLayout*) _tmp47_, (GtkCellRenderer*) _tmp48_, "text", (gint) DISPLAY_DISPLAY_WIDGET_REFRESH_COLUMNS_NAME);
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp49_ = FALSE;
			_tmp49_ = TRUE;
			while (TRUE) {
				GtkTreeIter iter = {0};
				GtkListStore* _tmp51_;
				GtkTreeIter _tmp52_ = {0};
				GtkListStore* _tmp53_;
				GtkTreeIter _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
				if (!_tmp49_) {
					gint _tmp50_;
					_tmp50_ = i;
					i = _tmp50_ + 1;
				}
				_tmp49_ = FALSE;
				if (!(i <= ((gint) DISPLAY_TRANSFORM_ROTATION_270))) {
					break;
				}
				_tmp51_ = self->priv->rotation_list_store;
				gtk_list_store_append (_tmp51_, &_tmp52_);
				iter = _tmp52_;
				_tmp53_ = self->priv->rotation_list_store;
				_tmp54_ = iter;
				_tmp55_ = display_transform_to_string ((DisplayTransform) i);
				_tmp56_ = _tmp55_;
				gtk_list_store_set (_tmp53_, &_tmp54_, DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_NAME, _tmp56_, DISPLAY_DISPLAY_WIDGET_ROTATION_COLUMNS_VALUE, i, -1);
				_g_free0 (_tmp56_);
			}
		}
	}
	_tmp57_ = g_new0 (DisplayResolution, 0);
	resolutions = _tmp57_;
	resolutions_length1 = 0;
	_resolutions_size_ = resolutions_length1;
	_tmp58_ = g_new0 (DisplayResolution, 0);
	recommended_resolutions = _tmp58_;
	recommended_resolutions_length1 = 0;
	_recommended_resolutions_size_ = recommended_resolutions_length1;
	_tmp59_ = g_new0 (DisplayResolution, 0);
	other_resolutions = _tmp59_;
	other_resolutions_length1 = 0;
	_other_resolutions_size_ = other_resolutions_length1;
	max_width = -1;
	max_height = -1;
	usable_resolutions = (guint) 0;
	_tmp60_ = self->priv->_virtual_monitor;
	display_virtual_monitor_get_current_mode_size (_tmp60_, &_tmp61_, &_tmp62_);
	current_width = _tmp61_;
	current_height = _tmp62_;
	_tmp63_ = gee_tree_set_new (DISPLAY_TYPE_MONITOR_MODE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, _display_monitor_mode_resolution_compare_func_gcompare_data_func, NULL, NULL);
	resolution_set = _tmp63_;
	{
		GeeLinkedList* _mode_list = NULL;
		DisplayVirtualMonitor* _tmp64_;
		GeeLinkedList* _tmp65_;
		gint _mode_size = 0;
		GeeLinkedList* _tmp66_;
		gint _tmp67_;
		gint _tmp68_;
		gint _mode_index = 0;
		_tmp64_ = self->priv->_virtual_monitor;
		_tmp65_ = display_virtual_monitor_get_available_modes (_tmp64_);
		_mode_list = _tmp65_;
		_tmp66_ = _mode_list;
		_tmp67_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp66_);
		_tmp68_ = _tmp67_;
		_mode_size = _tmp68_;
		_mode_index = -1;
		while (TRUE) {
			gint _tmp69_;
			gint _tmp70_;
			DisplayMonitorMode* mode = NULL;
			GeeLinkedList* _tmp71_;
			gpointer _tmp72_;
			GeeTreeSet* _tmp73_;
			DisplayMonitorMode* _tmp74_;
			_mode_index = _mode_index + 1;
			_tmp69_ = _mode_index;
			_tmp70_ = _mode_size;
			if (!(_tmp69_ < _tmp70_)) {
				break;
			}
			_tmp71_ = _mode_list;
			_tmp72_ = gee_abstract_list_get ((GeeAbstractList*) _tmp71_, _mode_index);
			mode = (DisplayMonitorMode*) _tmp72_;
			_tmp73_ = resolution_set;
			_tmp74_ = mode;
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp73_, _tmp74_);
			_g_object_unref0 (mode);
		}
		_g_object_unref0 (_mode_list);
	}
	{
		GeeIterator* _mode_it = NULL;
		GeeTreeSet* _tmp75_;
		GeeIterator* _tmp76_;
		_tmp75_ = resolution_set;
		_tmp76_ = gee_abstract_collection_iterator ((GeeAbstractCollection*) _tmp75_);
		_mode_it = _tmp76_;
		while (TRUE) {
			GeeIterator* _tmp77_;
			DisplayMonitorMode* mode = NULL;
			GeeIterator* _tmp78_;
			gpointer _tmp79_;
			gint mode_width = 0;
			DisplayMonitorMode* _tmp80_;
			gint _tmp81_;
			gint _tmp82_;
			gint mode_height = 0;
			DisplayMonitorMode* _tmp83_;
			gint _tmp84_;
			gint _tmp85_;
			DisplayMonitorMode* _tmp86_;
			gboolean _tmp87_;
			gboolean _tmp88_;
			DisplayResolution res = {0};
			DisplayMonitorMode* _tmp89_;
			gboolean _tmp90_;
			gboolean _tmp91_;
			DisplayMonitorMode* _tmp92_;
			gboolean _tmp93_;
			gboolean _tmp94_;
			DisplayResolution _tmp95_ = {0};
			DisplayResolution _tmp96_;
			_tmp77_ = _mode_it;
			if (!gee_iterator_next (_tmp77_)) {
				break;
			}
			_tmp78_ = _mode_it;
			_tmp79_ = gee_iterator_get (_tmp78_);
			mode = (DisplayMonitorMode*) _tmp79_;
			_tmp80_ = mode;
			_tmp81_ = display_monitor_mode_get_width (_tmp80_);
			_tmp82_ = _tmp81_;
			mode_width = _tmp82_;
			_tmp83_ = mode;
			_tmp84_ = display_monitor_mode_get_height (_tmp83_);
			_tmp85_ = _tmp84_;
			mode_height = _tmp85_;
			_tmp86_ = mode;
			_tmp87_ = display_monitor_mode_get_is_preferred (_tmp86_);
			_tmp88_ = _tmp87_;
			if (_tmp88_) {
				max_width = MAX (max_width, mode_width);
				max_height = MAX (max_height, mode_height);
			}
			_tmp89_ = mode;
			_tmp90_ = display_monitor_mode_get_is_preferred (_tmp89_);
			_tmp91_ = _tmp90_;
			_tmp92_ = mode;
			_tmp93_ = display_monitor_mode_get_is_current (_tmp92_);
			_tmp94_ = _tmp93_;
			_tmp95_.width = mode_width;
			_tmp95_.height = mode_height;
			_tmp95_.aspect = (mode_width * 10) / mode_height;
			_tmp95_.is_preferred = _tmp91_;
			_tmp95_.is_current = _tmp94_;
			res = _tmp95_;
			_tmp96_ = res;
			_vala_array_add4 (&resolutions, &resolutions_length1, &_resolutions_size_, &_tmp96_);
			_g_object_unref0 (mode);
		}
		_g_object_unref0 (_mode_it);
	}
	native_ratio = (max_width * 10) / max_height;
	_tmp97_ = resolutions;
	_tmp97__length1 = resolutions_length1;
	{
		DisplayResolution* resolution_collection = NULL;
		gint resolution_collection_length1 = 0;
		gint _resolution_collection_size_ = 0;
		gint resolution_it = 0;
		resolution_collection = _tmp97_;
		resolution_collection_length1 = _tmp97__length1;
		for (resolution_it = 0; resolution_it < resolution_collection_length1; resolution_it = resolution_it + 1) {
			DisplayResolution resolution = {0};
			resolution = resolution_collection[resolution_it];
			{
				gboolean _tmp98_ = FALSE;
				DisplayResolution _tmp99_;
				gboolean _tmp101_ = FALSE;
				gboolean _tmp102_ = FALSE;
				DisplayResolution _tmp103_;
				guint _tmp108_;
				_tmp99_ = resolution;
				if (_tmp99_.width < 1024) {
					_tmp98_ = TRUE;
				} else {
					DisplayResolution _tmp100_;
					_tmp100_ = resolution;
					_tmp98_ = _tmp100_.height < 768;
				}
				if (_tmp98_) {
					continue;
				}
				_tmp103_ = resolution;
				if (_tmp103_.is_preferred) {
					_tmp102_ = TRUE;
				} else {
					DisplayResolution _tmp104_;
					_tmp104_ = resolution;
					_tmp102_ = _tmp104_.is_current;
				}
				if (_tmp102_) {
					_tmp101_ = TRUE;
				} else {
					DisplayResolution _tmp105_;
					_tmp105_ = resolution;
					_tmp101_ = _tmp105_.aspect == native_ratio;
				}
				if (_tmp101_) {
					DisplayResolution _tmp106_;
					_tmp106_ = resolution;
					_vala_array_add5 (&recommended_resolutions, &recommended_resolutions_length1, &_recommended_resolutions_size_, &_tmp106_);
				} else {
					DisplayResolution _tmp107_;
					_tmp107_ = resolution;
					_vala_array_add6 (&other_resolutions, &other_resolutions_length1, &_other_resolutions_size_, &_tmp107_);
				}
				_tmp108_ = usable_resolutions;
				usable_resolutions = _tmp108_ + 1;
			}
		}
	}
	_tmp109_ = recommended_resolutions;
	_tmp109__length1 = recommended_resolutions_length1;
	{
		DisplayResolution* resolution_collection = NULL;
		gint resolution_collection_length1 = 0;
		gint _resolution_collection_size_ = 0;
		gint resolution_it = 0;
		resolution_collection = _tmp109_;
		resolution_collection_length1 = _tmp109__length1;
		for (resolution_it = 0; resolution_it < resolution_collection_length1; resolution_it = resolution_it + 1) {
			DisplayResolution resolution = {0};
			resolution = resolution_collection[resolution_it];
			{
				GtkTreeIter iter = {0};
				GtkTreeStore* _tmp110_;
				GtkTreeIter _tmp111_ = {0};
				GtkTreeStore* _tmp112_;
				GtkTreeIter _tmp113_;
				DisplayResolution _tmp114_;
				DisplayResolution _tmp115_;
				gchar* _tmp116_;
				gchar* _tmp117_;
				DisplayResolution _tmp118_;
				DisplayResolution _tmp119_;
				_tmp110_ = self->priv->resolution_tree_store;
				gtk_tree_store_append (_tmp110_, &_tmp111_, NULL);
				iter = _tmp111_;
				_tmp112_ = self->priv->resolution_tree_store;
				_tmp113_ = iter;
				_tmp114_ = resolution;
				_tmp115_ = resolution;
				_tmp116_ = display_monitor_mode_get_resolution_string (_tmp114_.width, _tmp115_.height, FALSE);
				_tmp117_ = _tmp116_;
				_tmp118_ = resolution;
				_tmp119_ = resolution;
				gtk_tree_store_set (_tmp112_, &_tmp113_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, _tmp117_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, _tmp118_.width, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, _tmp119_.height, -1);
				_g_free0 (_tmp117_);
			}
		}
	}
	_tmp120_ = other_resolutions;
	_tmp120__length1 = other_resolutions_length1;
	if (_tmp120__length1 > 0) {
		GtkTreeIter iter = {0};
		GtkTreeIter parent_iter = {0};
		GtkTreeStore* _tmp121_;
		GtkTreeIter _tmp122_ = {0};
		GtkTreeStore* _tmp123_;
		GtkTreeIter _tmp124_;
		DisplayResolution* _tmp125_;
		gint _tmp125__length1;
		_tmp121_ = self->priv->resolution_tree_store;
		gtk_tree_store_append (_tmp121_, &_tmp122_, NULL);
		parent_iter = _tmp122_;
		_tmp123_ = self->priv->resolution_tree_store;
		_tmp124_ = parent_iter;
		gtk_tree_store_set (_tmp123_, &_tmp124_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, _ ("Other…"), DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, -1, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, -1, -1);
		_tmp125_ = other_resolutions;
		_tmp125__length1 = other_resolutions_length1;
		{
			DisplayResolution* resolution_collection = NULL;
			gint resolution_collection_length1 = 0;
			gint _resolution_collection_size_ = 0;
			gint resolution_it = 0;
			resolution_collection = _tmp125_;
			resolution_collection_length1 = _tmp125__length1;
			for (resolution_it = 0; resolution_it < resolution_collection_length1; resolution_it = resolution_it + 1) {
				DisplayResolution resolution = {0};
				resolution = resolution_collection[resolution_it];
				{
					GtkTreeStore* _tmp126_;
					GtkTreeIter _tmp127_;
					GtkTreeIter _tmp128_ = {0};
					GtkTreeStore* _tmp129_;
					GtkTreeIter _tmp130_;
					DisplayResolution _tmp131_;
					DisplayResolution _tmp132_;
					gchar* _tmp133_;
					gchar* _tmp134_;
					DisplayResolution _tmp135_;
					DisplayResolution _tmp136_;
					_tmp126_ = self->priv->resolution_tree_store;
					_tmp127_ = parent_iter;
					gtk_tree_store_append (_tmp126_, &_tmp128_, &_tmp127_);
					iter = _tmp128_;
					_tmp129_ = self->priv->resolution_tree_store;
					_tmp130_ = iter;
					_tmp131_ = resolution;
					_tmp132_ = resolution;
					_tmp133_ = display_monitor_mode_get_resolution_string (_tmp131_.width, _tmp132_.height, TRUE);
					_tmp134_ = _tmp133_;
					_tmp135_ = resolution;
					_tmp136_ = resolution;
					gtk_tree_store_set (_tmp129_, &_tmp130_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_NAME, _tmp134_, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_WIDTH, _tmp135_.width, DISPLAY_DISPLAY_WIDGET_RESOLUTION_COLUMNS_HEIGHT, _tmp136_.height, -1);
					_g_free0 (_tmp134_);
				}
			}
		}
	}
	if (!display_display_widget_set_active_resolution_from_current_mode (self)) {
		GtkComboBox* _tmp137_;
		_tmp137_ = self->priv->resolution_combobox;
		gtk_combo_box_set_active (_tmp137_, 0);
	}
	_tmp138_ = self->priv->resolution_combobox;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp138_, usable_resolutions > ((guint) 1));
	display_display_widget_populate_refresh_rates (self);
	_tmp139_ = 12;
	_tmp140_ = (GtkGrid*) gtk_grid_new ();
	gtk_grid_set_column_spacing (_tmp140_, 12);
	gtk_grid_set_row_spacing (_tmp140_, 6);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp140_, _tmp139_);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp140_, _tmp139_);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp140_, _tmp139_);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp140_, _tmp139_);
	g_object_ref_sink (_tmp140_);
	popover_grid = _tmp140_;
	_tmp141_ = popover_grid;
	_tmp142_ = use_row;
	gtk_grid_attach (_tmp141_, (GtkWidget*) _tmp142_, 0, 0, 1, 1);
	_tmp143_ = popover_grid;
	_tmp144_ = resolution_row;
	gtk_grid_attach (_tmp143_, (GtkWidget*) _tmp144_, 0, 1, 1, 1);
	_tmp145_ = popover_grid;
	_tmp146_ = rotation_row;
	gtk_grid_attach (_tmp145_, (GtkWidget*) _tmp146_, 0, 2, 1, 1);
	_tmp147_ = popover_grid;
	_tmp148_ = refresh_row;
	gtk_grid_attach (_tmp147_, (GtkWidget*) _tmp148_, 0, 3, 1, 1);
	_tmp149_ = popover_grid;
	gtk_widget_add_css_class ((GtkWidget*) _tmp149_, "content-list");
	_tmp150_ = (GtkPopover*) gtk_popover_new ();
	gtk_popover_set_position (_tmp150_, GTK_POS_BOTTOM);
	gtk_popover_set_has_arrow (_tmp150_, FALSE);
	g_object_ref_sink (_tmp150_);
	popover = _tmp150_;
	_tmp151_ = popover;
	_tmp152_ = popover_grid;
	gtk_popover_set_child (_tmp151_, (GtkWidget*) _tmp152_);
	_tmp153_ = 6;
	_tmp154_ = g_strdup ("open-menu-symbolic");
	_tmp155_ = popover;
	_tmp156_ = _g_object_ref0 (_tmp155_);
	_tmp157_ = g_strdup (_ ("Configure display"));
	_tmp158_ = (GtkMenuButton*) gtk_menu_button_new ();
	gtk_widget_set_halign ((GtkWidget*) _tmp158_, GTK_ALIGN_END);
	gtk_widget_set_valign ((GtkWidget*) _tmp158_, GTK_ALIGN_START);
	gtk_menu_button_set_icon_name (_tmp158_, _tmp154_);
	_g_free0 (_tmp154_);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp158_, _tmp153_);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp158_, _tmp153_);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp158_, _tmp153_);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp158_, _tmp153_);
	gtk_menu_button_set_popover (_tmp158_, _tmp156_);
	_g_object_unref0 (_tmp156_);
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp158_, _tmp157_);
	_g_free0 (_tmp157_);
	g_object_ref_sink (_tmp158_);
	_tmp159_ = _tmp158_;
	display_display_widget_set_toggle_settings (self, _tmp159_);
	_g_object_unref0 (_tmp159_);
	_tmp160_ = self->priv->_toggle_settings;
	gtk_widget_add_css_class ((GtkWidget*) _tmp160_, "disclosure-button");
	_tmp161_ = (GtkGrid*) gtk_grid_new ();
	g_object_ref_sink (_tmp161_);
	grid = _tmp161_;
	_tmp162_ = grid;
	_tmp163_ = self->priv->_primary_image;
	gtk_grid_attach (_tmp162_, (GtkWidget*) _tmp163_, 0, 0, 1, 1);
	_tmp164_ = grid;
	_tmp165_ = self->priv->_toggle_settings;
	gtk_grid_attach (_tmp164_, (GtkWidget*) _tmp165_, 2, 0, 1, 1);
	_tmp166_ = grid;
	_tmp167_ = _data7_->label;
	gtk_grid_attach (_tmp166_, (GtkWidget*) _tmp167_, 0, 0, 3, 2);
	_tmp168_ = self->priv->_virtual_monitor;
	_tmp169_ = display_virtual_monitor_get_primary (_tmp168_);
	_tmp170_ = _tmp169_;
	display_display_widget_set_primary (self, _tmp170_);
	g_object_set ((GtkWidget*) self, "height-request", 300, NULL);
	g_object_set ((GtkWidget*) self, "width-request", 540, NULL);
	gtk_widget_set_valign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	gtk_widget_set_halign ((GtkWidget*) self, GTK_ALIGN_CENTER);
	_tmp171_ = grid;
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp171_);
	_tmp172_ = self->priv->use_switch;
	_tmp173_ = self->priv->resolution_combobox;
	g_object_bind_property_with_closures ((GObject*) _tmp172_, "active", (GObject*) _tmp173_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp174_ = self->priv->use_switch;
	_tmp175_ = self->priv->rotation_combobox;
	g_object_bind_property_with_closures ((GObject*) _tmp174_, "active", (GObject*) _tmp175_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp176_ = self->priv->use_switch;
	_tmp177_ = self->priv->refresh_combobox;
	g_object_bind_property_with_closures ((GObject*) _tmp176_, "active", (GObject*) _tmp177_, "sensitive", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
	_tmp178_ = self->priv->use_switch;
	g_signal_connect_object ((GObject*) _tmp178_, "notify::active", (GCallback) __display_display_widget___lambda9__g_object_notify, self, 0);
	_tmp179_ = self->priv->_virtual_monitor;
	_tmp180_ = display_virtual_monitor_get_is_active (_tmp179_);
	_tmp181_ = _tmp180_;
	if (!_tmp181_) {
		gtk_widget_add_css_class ((GtkWidget*) self, "disabled");
	}
	_tmp182_ = self->priv->resolution_combobox;
	g_signal_connect_object (_tmp182_, "changed", (GCallback) __display_display_widget___lambda10__gtk_combo_box_changed, self, 0);
	_tmp183_ = self->priv->rotation_combobox;
	g_signal_connect_data (_tmp183_, "changed", (GCallback) __display_display_widget___lambda11__gtk_combo_box_changed, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
	_tmp184_ = self->priv->refresh_combobox;
	g_signal_connect_object (_tmp184_, "changed", (GCallback) __display_display_widget___lambda12__gtk_combo_box_changed, self, 0);
	_tmp185_ = self->priv->rotation_combobox;
	_tmp186_ = self->priv->_virtual_monitor;
	_tmp187_ = display_virtual_monitor_get_transform (_tmp186_);
	_tmp188_ = _tmp187_;
	gtk_combo_box_set_active (_tmp185_, (gint) _tmp188_);
	display_display_widget_on_vm_transform_changed (self);
	_tmp189_ = self->priv->_virtual_monitor;
	g_signal_connect_object (_tmp189_, "modes-changed", (GCallback) _display_display_widget_on_monitor_modes_changed_display_virtual_monitor_modes_changed, self, 0);
	_tmp190_ = self->priv->_virtual_monitor;
	g_signal_connect_object ((GObject*) _tmp190_, "notify::transform", (GCallback) _display_display_widget_on_vm_transform_changed_g_object_notify, self, 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL], 0);
	g_signal_emit (self, display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL], 0);
	_g_object_unref0 (grid);
	_g_object_unref0 (popover);
	_g_object_unref0 (popover_grid);
	_g_object_unref0 (resolution_set);
	other_resolutions = (g_free (other_resolutions), NULL);
	recommended_resolutions = (g_free (recommended_resolutions), NULL);
	resolutions = (g_free (resolutions), NULL);
	_g_object_unref0 (refresh_row);
	_g_object_unref0 (rotation_row);
	_g_object_unref0 (text_renderer);
	_g_object_unref0 (resolution_row);
	_g_object_unref0 (use_row);
	block7_data_unref (_data7_);
	_data7_ = NULL;
	return obj;
}

static void
display_display_widget_class_init (DisplayDisplayWidgetClass * klass,
                                   gpointer klass_data)
{
	display_display_widget_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DisplayDisplayWidget_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_display_display_widget_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_display_display_widget_set_property;
	G_OBJECT_CLASS (klass)->constructor = display_display_widget_constructor;
	G_OBJECT_CLASS (klass)->finalize = display_display_widget_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY] = g_param_spec_object ("virtual-monitor", "virtual-monitor", "virtual-monitor", DISPLAY_TYPE_VIRTUAL_MONITOR, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY] = g_param_spec_double ("window-ratio", "window-ratio", "window-ratio", -G_MAXDOUBLE, G_MAXDOUBLE, 1.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY] = g_param_spec_int ("delta-x", "delta-x", "delta-x", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY] = g_param_spec_int ("delta-y", "delta-y", "delta-y", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY] = g_param_spec_boolean ("only-display", "only-display", "only-display", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY] = g_param_spec_object ("primary-image", "primary-image", "primary-image", gtk_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY, display_display_widget_properties[DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY] = g_param_spec_object ("toggle-settings", "toggle-settings", "toggle-settings", gtk_menu_button_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_SET_AS_PRIMARY_SIGNAL] = g_signal_new ("set-as-primary", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_MOVE_DISPLAY_SIGNAL] = g_signal_new ("move-display", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__DOUBLE_DOUBLE, G_TYPE_NONE, 2, G_TYPE_DOUBLE, G_TYPE_DOUBLE);
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_END_GRAB_SIGNAL] = g_signal_new ("end-grab", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CHECK_POSITION_SIGNAL] = g_signal_new ("check-position", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_CONFIGURATION_CHANGED_SIGNAL] = g_signal_new ("configuration-changed", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	display_display_widget_signals[DISPLAY_DISPLAY_WIDGET_ACTIVE_CHANGED_SIGNAL] = g_signal_new ("active-changed", DISPLAY_TYPE_DISPLAY_WIDGET, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
display_display_widget_instance_init (DisplayDisplayWidget * self,
                                      gpointer klass)
{
	self->priv = display_display_widget_get_instance_private (self);
	self->priv->_window_ratio = 1.0;
	self->priv->_delta_x = 0;
	self->priv->_delta_y = 0;
	self->priv->_only_display = FALSE;
	self->priv->real_width = 0;
	self->priv->real_height = 0;
}

static void
display_display_widget_finalize (GObject * obj)
{
	DisplayDisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
	_g_object_unref0 (self->priv->_virtual_monitor);
	_g_object_unref0 (self->priv->_primary_image);
	_g_object_unref0 (self->priv->_toggle_settings);
	_g_object_unref0 (self->priv->use_switch);
	_g_object_unref0 (self->priv->resolution_combobox);
	_g_object_unref0 (self->priv->resolution_tree_store);
	_g_object_unref0 (self->priv->rotation_combobox);
	_g_object_unref0 (self->priv->rotation_list_store);
	_g_object_unref0 (self->priv->refresh_combobox);
	_g_object_unref0 (self->priv->refresh_list_store);
	G_OBJECT_CLASS (display_display_widget_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
display_display_widget_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplayWidgetClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_display_widget_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplayWidget), 0, (GInstanceInitFunc) display_display_widget_instance_init, NULL };
	GType display_display_widget_type_id;
	display_display_widget_type_id = g_type_register_static (gtk_box_get_type (), "DisplayDisplayWidget", &g_define_type_info, 0);
	DisplayDisplayWidget_private_offset = g_type_add_instance_private (display_display_widget_type_id, sizeof (DisplayDisplayWidgetPrivate));
	return display_display_widget_type_id;
}

GType
display_display_widget_get_type (void)
{
	static gsize display_display_widget_type_id__once = 0;
	if (g_once_init_enter (&display_display_widget_type_id__once)) {
		GType display_display_widget_type_id;
		display_display_widget_type_id = display_display_widget_get_type_once ();
		g_once_init_leave (&display_display_widget_type_id__once, display_display_widget_type_id);
	}
	return display_display_widget_type_id__once;
}

static void
_vala_display_display_widget_get_property (GObject * object,
                                           guint property_id,
                                           GValue * value,
                                           GParamSpec * pspec)
{
	DisplayDisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
	switch (property_id) {
		case DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY:
		g_value_set_object (value, display_display_widget_get_virtual_monitor (self));
		break;
		case DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY:
		g_value_set_double (value, display_display_widget_get_window_ratio (self));
		break;
		case DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY:
		g_value_set_int (value, display_display_widget_get_delta_x (self));
		break;
		case DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY:
		g_value_set_int (value, display_display_widget_get_delta_y (self));
		break;
		case DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY:
		g_value_set_boolean (value, display_display_widget_get_only_display (self));
		break;
		case DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY:
		g_value_set_object (value, display_display_widget_get_primary_image (self));
		break;
		case DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY:
		g_value_set_object (value, display_display_widget_get_toggle_settings (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_display_display_widget_set_property (GObject * object,
                                           guint property_id,
                                           const GValue * value,
                                           GParamSpec * pspec)
{
	DisplayDisplayWidget * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget);
	switch (property_id) {
		case DISPLAY_DISPLAY_WIDGET_VIRTUAL_MONITOR_PROPERTY:
		display_display_widget_set_virtual_monitor (self, g_value_get_object (value));
		break;
		case DISPLAY_DISPLAY_WIDGET_WINDOW_RATIO_PROPERTY:
		display_display_widget_set_window_ratio (self, g_value_get_double (value));
		break;
		case DISPLAY_DISPLAY_WIDGET_DELTA_X_PROPERTY:
		display_display_widget_set_delta_x (self, g_value_get_int (value));
		break;
		case DISPLAY_DISPLAY_WIDGET_DELTA_Y_PROPERTY:
		display_display_widget_set_delta_y (self, g_value_get_int (value));
		break;
		case DISPLAY_DISPLAY_WIDGET_ONLY_DISPLAY_PROPERTY:
		display_display_widget_set_only_display (self, g_value_get_boolean (value));
		break;
		case DISPLAY_DISPLAY_WIDGET_PRIMARY_IMAGE_PROPERTY:
		display_display_widget_set_primary_image (self, g_value_get_object (value));
		break;
		case DISPLAY_DISPLAY_WIDGET_TOGGLE_SETTINGS_PROPERTY:
		display_display_widget_set_toggle_settings (self, g_value_get_object (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

