/* DisplaysOverlay.c generated by valac 0.56.13, the Vala compiler
 * generated from DisplaysOverlay.vala, do not modify */

/*-
 * Copyright (c) 2023 Fyra Labs
 * Copyright (c) 2014-2018 elementary LLC.
 *
 * This software is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this software; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301, USA.
 */

#include "fuse-display.h"
#include <glib.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <glib-object.h>
#include <libhelium-1.h>
#include <gdk/gdk.h>
#include <string.h>
#include <gee.h>
#include <stdlib.h>
#include <cairo-gobject.h>

#define DISPLAY_DISPLAYS_OVERLAY_SNAP_LIMIT (G_MAXINT - 1)
#define DISPLAY_DISPLAYS_OVERLAY_MINIMUM_WIDGET_OFFSET 50

enum  {
	DISPLAY_DISPLAYS_OVERLAY_0_PROPERTY,
	DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY,
	DISPLAY_DISPLAYS_OVERLAY_NUM_PROPERTIES
};
static GParamSpec* display_displays_overlay_properties[DISPLAY_DISPLAYS_OVERLAY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block8Data Block8Data;
enum  {
	DISPLAY_DISPLAYS_OVERLAY_CONFIGURATION_CHANGED_SIGNAL,
	DISPLAY_DISPLAYS_OVERLAY_NUM_SIGNALS
};
static guint display_displays_overlay_signals[DISPLAY_DISPLAYS_OVERLAY_NUM_SIGNALS] = {0};

struct _DisplayDisplaysOverlayPrivate {
	gboolean scanning;
	gdouble current_ratio;
	gint current_allocated_width;
	gint current_allocated_height;
	gint default_x_margin;
	gint default_y_margin;
	DisplayMonitorManager* monitor_manager;
	gint _active_displays;
	GtkBox* overlay;
};

struct _Block8Data {
	int _ref_count_;
	DisplayDisplaysOverlay* self;
	DisplayDisplayWidget* display_widget;
	DisplayVirtualMonitor* virtual_monitor;
};

static gint DisplayDisplaysOverlay_private_offset;
static gpointer display_displays_overlay_parent_class = NULL;

static void __lambda5_ (DisplayDisplaysOverlay* self);
static gboolean display_displays_overlay_get_child_position (DisplayDisplaysOverlay* self,
                                                      GtkWidget* widget,
                                                      GdkRectangle* allocation);
static void ___lambda5__g_object_notify (GObject* _sender,
                                  GParamSpec* pspec,
                                  gpointer self);
static void __lambda13_ (DisplayDisplaysOverlay* self);
static void ___lambda13__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void display_displays_overlay_calculate_ratio (DisplayDisplaysOverlay* self);
static void display_displays_overlay_add_output (DisplayDisplaysOverlay* self,
                                          DisplayVirtualMonitor* virtual_monitor);
static void display_displays_overlay_change_active_displays_sensitivity (DisplayDisplaysOverlay* self);
static void display_displays_overlay_check_configuration_changed (DisplayDisplaysOverlay* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void __lambda14_ (Block8Data* _data8_);
static void display_displays_overlay_set_as_primary (DisplayDisplaysOverlay* self,
                                              DisplayVirtualMonitor* new_primary);
static void ___lambda14__display_display_widget_set_as_primary (DisplayDisplayWidget* _sender,
                                                         gpointer self);
static void __lambda15_ (Block8Data* _data8_);
static void display_displays_overlay_close_gaps (DisplayDisplaysOverlay* self);
static void display_displays_overlay_verify_global_positions (DisplayDisplaysOverlay* self);
static void ___lambda15__display_display_widget_check_position (DisplayDisplayWidget* _sender,
                                                         gpointer self);
static void display_displays_overlay_move_display (DisplayDisplaysOverlay* self,
                                            DisplayDisplayWidget* display_widget,
                                            gdouble diff_x,
                                            gdouble diff_y);
static void _display_displays_overlay_move_display_display_display_widget_move_display (DisplayDisplayWidget* _sender,
                                                                                 gdouble diff_x,
                                                                                 gdouble diff_y,
                                                                                 gpointer self);
static void _display_displays_overlay_check_configuration_changed_display_display_widget_configuration_changed (DisplayDisplayWidget* _sender,
                                                                                                         gpointer self);
static void __lambda16_ (Block8Data* _data8_);
static void ___lambda16__display_display_widget_active_changed (DisplayDisplayWidget* _sender,
                                                         gpointer self);
static void __lambda17_ (Block8Data* _data8_,
                  gint delta_x,
                  gint delta_y);
static void ___lambda17__display_display_widget_end_grab (DisplayDisplayWidget* _sender,
                                                   gint delta_x,
                                                   gint delta_y,
                                                   gpointer self);
static void display_displays_overlay_align_edges (DisplayDisplaysOverlay* self,
                                           DisplayDisplayWidget* display_widget);
static gboolean display_displays_overlay_is_connected (DisplayDisplaysOverlay* self,
                                                DisplayDisplayWidget* display_widget,
                                                GList* other_display_widgets);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void display_displays_overlay_snap_widget (DisplayDisplaysOverlay* self,
                                           DisplayDisplayWidget* widget,
                                           GList* anchors);
static void display_displays_overlay_finalize (GObject * obj);
static GType display_displays_overlay_get_type_once (void);
static void _vala_display_displays_overlay_get_property (GObject * object,
                                                  guint property_id,
                                                  GValue * value,
                                                  GParamSpec * pspec);
static void _vala_display_displays_overlay_set_property (GObject * object,
                                                  guint property_id,
                                                  const GValue * value,
                                                  GParamSpec * pspec);

static inline gpointer
display_displays_overlay_get_instance_private (DisplayDisplaysOverlay* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayDisplaysOverlay_private_offset);
}

static void
__lambda5_ (DisplayDisplaysOverlay* self)
{
}

static void
___lambda5__g_object_notify (GObject* _sender,
                             GParamSpec* pspec,
                             gpointer self)
{
	__lambda5_ ((DisplayDisplaysOverlay*) self);
}

static void
__lambda13_ (DisplayDisplaysOverlay* self)
{
	display_displays_overlay_rescan_displays (self);
}

static void
___lambda13__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
	__lambda13_ ((DisplayDisplaysOverlay*) self);
}

DisplayDisplaysOverlay*
display_displays_overlay_construct (GType object_type)
{
	DisplayDisplaysOverlay * self = NULL;
	GtkBox* _tmp0_;
	GtkBox* _tmp1_;
	GtkScrolledWindow* sw = NULL;
	GtkScrolledWindow* _tmp2_ = NULL;
	GtkBox* _tmp3_;
	DisplayMonitorManager* _tmp4_;
	DisplayMonitorManager* _tmp5_;
	self = (DisplayDisplaysOverlay*) he_bin_construct (object_type);
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->priv->overlay);
	self->priv->overlay = _tmp0_;
	_tmp1_ = self->priv->overlay;
	g_signal_connect_object ((GObject*) _tmp1_, "notify::get-child-position", (GCallback) ___lambda5__g_object_notify, self, 0);
	_tmp2_ = (GtkScrolledWindow*) gtk_scrolled_window_new ();
	gtk_scrolled_window_set_max_content_height (_tmp2_, 360);
	gtk_scrolled_window_set_min_content_height (_tmp2_, 360);
	g_object_set (_tmp2_, "vscrollbar-policy", GTK_POLICY_NEVER, NULL);
	gtk_widget_set_valign ((GtkWidget*) _tmp2_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp2_);
	sw = _tmp2_;
	_tmp3_ = self->priv->overlay;
	gtk_scrolled_window_set_child (sw, (GtkWidget*) _tmp3_);
	he_bin_set_child ((HeBin*) self, (GtkWidget*) sw);
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
	gtk_widget_set_vexpand ((GtkWidget*) self, TRUE);
	_tmp4_ = display_monitor_manager_get_default ();
	self->priv->monitor_manager = _tmp4_;
	_tmp5_ = self->priv->monitor_manager;
	g_signal_connect_object ((GObject*) _tmp5_, "notify::virtual-monitor-number", (GCallback) ___lambda13__g_object_notify, self, 0);
	display_displays_overlay_rescan_displays (self);
	_g_object_unref0 (sw);
	return self;
}

DisplayDisplaysOverlay*
display_displays_overlay_new (void)
{
	return display_displays_overlay_construct (DISPLAY_TYPE_DISPLAYS_OVERLAY);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static gboolean
display_displays_overlay_get_child_position (DisplayDisplaysOverlay* self,
                                             GtkWidget* widget,
                                             GdkRectangle* allocation)
{
	GdkRectangle _vala_allocation = {0};
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (widget != NULL, FALSE);
	memset (&_vala_allocation, 0, sizeof (GdkRectangle));
	if (self->priv->current_allocated_width != gtk_widget_get_allocated_width ((GtkWidget*) self)) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = self->priv->current_allocated_height != gtk_widget_get_allocated_height ((GtkWidget*) self);
	}
	if (_tmp0_) {
		display_displays_overlay_calculate_ratio (self);
	}
	if (DISPLAY_IS_DISPLAY_WIDGET (widget)) {
		DisplayDisplayWidget* display_widget = NULL;
		DisplayDisplayWidget* _tmp1_;
		gint x = 0;
		gint y = 0;
		gint width = 0;
		gint height = 0;
		DisplayDisplayWidget* _tmp2_;
		gint _tmp3_ = 0;
		gint _tmp4_ = 0;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		DisplayDisplayWidget* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		DisplayDisplayWidget* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint x_start = 0;
		gint y_start = 0;
		gint x_end = 0;
		gint y_end = 0;
		_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (widget, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
		display_widget = _tmp1_;
		_tmp2_ = display_widget;
		display_display_widget_get_geometry (_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_);
		x = _tmp3_;
		y = _tmp4_;
		width = _tmp5_;
		height = _tmp6_;
		_tmp7_ = display_widget;
		_tmp8_ = display_display_widget_get_delta_x (_tmp7_);
		_tmp9_ = _tmp8_;
		x += _tmp9_;
		_tmp10_ = display_widget;
		_tmp11_ = display_display_widget_get_delta_y (_tmp10_);
		_tmp12_ = _tmp11_;
		y += _tmp12_;
		x_start = (gint) round (x * self->priv->current_ratio);
		y_start = (gint) round (y * self->priv->current_ratio);
		x_end = (gint) round ((x + width) * self->priv->current_ratio);
		y_end = (gint) round ((y + height) * self->priv->current_ratio);
		_vala_allocation.x = self->priv->default_x_margin + x_start;
		_vala_allocation.y = self->priv->default_y_margin + y_start;
		_vala_allocation.width = x_end - x_start;
		_vala_allocation.height = y_end - y_start;
		result = TRUE;
		_g_object_unref0 (display_widget);
		if (allocation) {
			*allocation = _vala_allocation;
		}
		return result;
	}
	result = FALSE;
	if (allocation) {
		*allocation = _vala_allocation;
	}
	return result;
}

void
display_displays_overlay_rescan_displays (DisplayDisplaysOverlay* self)
{
	GtkWidget* child = NULL;
	g_return_if_fail (self != NULL);
	self->priv->scanning = TRUE;
	{
		GtkBox* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
		_tmp0_ = self->priv->overlay;
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (child);
		child = _tmp2_;
		_tmp3_ = TRUE;
		while (TRUE) {
			GtkWidget* _tmp7_;
			GtkWidget* _tmp8_;
			if (!_tmp3_) {
				GtkWidget* _tmp4_;
				GtkWidget* _tmp5_;
				GtkWidget* _tmp6_;
				_tmp4_ = child;
				_tmp5_ = gtk_widget_get_next_sibling (_tmp4_);
				_tmp6_ = _g_object_ref0 (_tmp5_);
				_g_object_unref0 (child);
				child = _tmp6_;
			}
			_tmp3_ = FALSE;
			_tmp7_ = child;
			if (!(_tmp7_ != NULL)) {
				break;
			}
			_tmp8_ = child;
			if (DISPLAY_IS_DISPLAY_WIDGET (_tmp8_)) {
				GtkWidget* _tmp9_;
				_tmp9_ = child;
				g_object_run_dispose ((GObject*) _tmp9_);
			}
		}
	}
	display_displays_overlay_set_active_displays (self, 0);
	{
		GeeLinkedList* _virtual_monitor_list = NULL;
		DisplayMonitorManager* _tmp10_;
		GeeLinkedList* _tmp11_;
		GeeLinkedList* _tmp12_;
		gint _virtual_monitor_size = 0;
		GeeLinkedList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _virtual_monitor_index = 0;
		_tmp10_ = self->priv->monitor_manager;
		_tmp11_ = display_monitor_manager_get_virtual_monitors (_tmp10_);
		_tmp12_ = _tmp11_;
		_virtual_monitor_list = _tmp12_;
		_tmp13_ = _virtual_monitor_list;
		_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
		_tmp15_ = _tmp14_;
		_virtual_monitor_size = _tmp15_;
		_virtual_monitor_index = -1;
		while (TRUE) {
			gint _tmp16_;
			gint _tmp17_;
			DisplayVirtualMonitor* virtual_monitor = NULL;
			GeeLinkedList* _tmp18_;
			gpointer _tmp19_;
			gint _tmp20_ = 0;
			DisplayVirtualMonitor* _tmp21_;
			gboolean _tmp22_;
			gboolean _tmp23_;
			gint _tmp24_;
			DisplayVirtualMonitor* _tmp25_;
			_virtual_monitor_index = _virtual_monitor_index + 1;
			_tmp16_ = _virtual_monitor_index;
			_tmp17_ = _virtual_monitor_size;
			if (!(_tmp16_ < _tmp17_)) {
				break;
			}
			_tmp18_ = _virtual_monitor_list;
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _virtual_monitor_index);
			virtual_monitor = (DisplayVirtualMonitor*) _tmp19_;
			_tmp21_ = virtual_monitor;
			_tmp22_ = display_virtual_monitor_get_is_active (_tmp21_);
			_tmp23_ = _tmp22_;
			if (_tmp23_) {
				_tmp20_ = 1;
			} else {
				_tmp20_ = 0;
			}
			_tmp24_ = self->priv->_active_displays;
			display_displays_overlay_set_active_displays (self, _tmp24_ + _tmp20_);
			_tmp25_ = virtual_monitor;
			display_displays_overlay_add_output (self, _tmp25_);
			_g_object_unref0 (virtual_monitor);
		}
	}
	display_displays_overlay_change_active_displays_sensitivity (self);
	display_displays_overlay_calculate_ratio (self);
	self->priv->scanning = FALSE;
	_g_object_unref0 (child);
}

static void
display_displays_overlay_change_active_displays_sensitivity (DisplayDisplaysOverlay* self)
{
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	DisplayVirtualMonitor* _tmp2_;
	DisplayVirtualMonitor* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->overlay;
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
	_tmp2_ = display_display_widget_get_virtual_monitor (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
	_tmp3_ = _tmp2_;
	_tmp4_ = display_virtual_monitor_get_is_active (_tmp3_);
	_tmp5_ = _tmp4_;
	if (_tmp5_) {
		GtkBox* _tmp6_;
		GtkWidget* _tmp7_;
		gint _tmp8_;
		_tmp6_ = self->priv->overlay;
		_tmp7_ = gtk_widget_get_first_child ((GtkWidget*) _tmp6_);
		_tmp8_ = self->priv->_active_displays;
		display_display_widget_set_only_display (G_TYPE_CHECK_INSTANCE_CAST (_tmp7_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget), _tmp8_ == 1);
	}
}

static void
display_displays_overlay_check_configuration_changed (DisplayDisplaysOverlay* self)
{
	g_return_if_fail (self != NULL);
	g_signal_emit (self, display_displays_overlay_signals[DISPLAY_DISPLAYS_OVERLAY_CONFIGURATION_CHANGED_SIGNAL], 0, TRUE);
}

static void
display_displays_overlay_calculate_ratio (DisplayDisplaysOverlay* self)
{
	gint added_width = 0;
	gint added_height = 0;
	gint max_width = 0;
	gint max_height = 0;
	GtkWidget* child = NULL;
	g_return_if_fail (self != NULL);
	added_width = 0;
	added_height = 0;
	max_width = G_MININT;
	max_height = G_MININT;
	{
		GtkBox* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
		_tmp0_ = self->priv->overlay;
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (child);
		child = _tmp2_;
		_tmp3_ = TRUE;
		while (TRUE) {
			GtkWidget* _tmp7_;
			DisplayDisplayWidget* display_widget = NULL;
			GtkWidget* _tmp8_;
			DisplayDisplayWidget* _tmp9_;
			gint x = 0;
			gint y = 0;
			gint width = 0;
			gint height = 0;
			DisplayDisplayWidget* _tmp10_;
			gint _tmp11_ = 0;
			gint _tmp12_ = 0;
			gint _tmp13_ = 0;
			gint _tmp14_ = 0;
			if (!_tmp3_) {
				GtkWidget* _tmp4_;
				GtkWidget* _tmp5_;
				GtkWidget* _tmp6_;
				_tmp4_ = child;
				_tmp5_ = gtk_widget_get_next_sibling (_tmp4_);
				_tmp6_ = _g_object_ref0 (_tmp5_);
				_g_object_unref0 (child);
				child = _tmp6_;
			}
			_tmp3_ = FALSE;
			_tmp7_ = child;
			if (!(_tmp7_ != NULL)) {
				break;
			}
			_tmp8_ = child;
			_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
			display_widget = _tmp9_;
			_tmp10_ = display_widget;
			display_display_widget_get_geometry (_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
			x = _tmp11_;
			y = _tmp12_;
			width = _tmp13_;
			height = _tmp14_;
			added_width += width;
			added_height += height;
			max_width = MAX (max_width, x + width);
			max_height = MAX (max_height, y + height);
			_g_object_unref0 (display_widget);
		}
	}
	self->priv->current_allocated_width = gtk_widget_get_allocated_width ((GtkWidget*) self);
	self->priv->current_allocated_height = gtk_widget_get_allocated_height ((GtkWidget*) self);
	self->priv->current_ratio = MIN (((gdouble) (gtk_widget_get_allocated_width ((GtkWidget*) self) - 24)) / ((gdouble) added_width), ((gdouble) (gtk_widget_get_allocated_height ((GtkWidget*) self) - 24)) / ((gdouble) added_height));
	self->priv->default_x_margin = (gint) ((gtk_widget_get_allocated_width ((GtkWidget*) self) - (max_width * self->priv->current_ratio)) / 2);
	self->priv->default_y_margin = (gint) ((gtk_widget_get_allocated_height ((GtkWidget*) self) - (max_height * self->priv->current_ratio)) / 2);
	_g_object_unref0 (child);
}

static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
	g_atomic_int_inc (&_data8_->_ref_count_);
	return _data8_;
}

static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
		DisplayDisplaysOverlay* self;
		self = _data8_->self;
		_g_object_unref0 (_data8_->display_widget);
		_g_object_unref0 (_data8_->virtual_monitor);
		_g_object_unref0 (self);
		g_slice_free (Block8Data, _data8_);
	}
}

static void
__lambda14_ (Block8Data* _data8_)
{
	DisplayDisplaysOverlay* self;
	DisplayVirtualMonitor* _tmp0_;
	DisplayVirtualMonitor* _tmp1_;
	self = _data8_->self;
	_tmp0_ = display_display_widget_get_virtual_monitor (_data8_->display_widget);
	_tmp1_ = _tmp0_;
	display_displays_overlay_set_as_primary (self, _tmp1_);
}

static void
___lambda14__display_display_widget_set_as_primary (DisplayDisplayWidget* _sender,
                                                    gpointer self)
{
	__lambda14_ (self);
}

static void
__lambda15_ (Block8Data* _data8_)
{
	DisplayDisplaysOverlay* self;
	self = _data8_->self;
	display_displays_overlay_check_intersects (self, _data8_->display_widget, 0, 0, 0);
	display_displays_overlay_close_gaps (self);
	display_displays_overlay_verify_global_positions (self);
	display_displays_overlay_calculate_ratio (self);
}

static void
___lambda15__display_display_widget_check_position (DisplayDisplayWidget* _sender,
                                                    gpointer self)
{
	__lambda15_ (self);
}

static void
_display_displays_overlay_move_display_display_display_widget_move_display (DisplayDisplayWidget* _sender,
                                                                            gdouble diff_x,
                                                                            gdouble diff_y,
                                                                            gpointer self)
{
	display_displays_overlay_move_display ((DisplayDisplaysOverlay*) self, _sender, diff_x, diff_y);
}

static void
_display_displays_overlay_check_configuration_changed_display_display_widget_configuration_changed (DisplayDisplayWidget* _sender,
                                                                                                    gpointer self)
{
	display_displays_overlay_check_configuration_changed ((DisplayDisplaysOverlay*) self);
}

static void
__lambda16_ (Block8Data* _data8_)
{
	DisplayDisplaysOverlay* self;
	gint _tmp0_ = 0;
	gboolean _tmp1_;
	gboolean _tmp2_;
	gint _tmp3_;
	self = _data8_->self;
	_tmp1_ = display_virtual_monitor_get_is_active (_data8_->virtual_monitor);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		_tmp0_ = 1;
	} else {
		_tmp0_ = -1;
	}
	_tmp3_ = self->priv->_active_displays;
	display_displays_overlay_set_active_displays (self, _tmp3_ + _tmp0_);
	display_displays_overlay_change_active_displays_sensitivity (self);
	display_displays_overlay_check_configuration_changed (self);
	display_displays_overlay_calculate_ratio (self);
}

static void
___lambda16__display_display_widget_active_changed (DisplayDisplayWidget* _sender,
                                                    gpointer self)
{
	__lambda16_ (self);
}

static void
__lambda17_ (Block8Data* _data8_,
             gint delta_x,
             gint delta_y)
{
	DisplayDisplaysOverlay* self;
	gboolean _tmp0_ = FALSE;
	gint x = 0;
	gint y = 0;
	gint width = 0;
	gint height = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_ = 0;
	self = _data8_->self;
	if (delta_x == 0) {
		_tmp0_ = delta_y == 0;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		return;
	}
	display_display_widget_get_geometry (_data8_->display_widget, &_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_);
	x = _tmp1_;
	y = _tmp2_;
	width = _tmp3_;
	height = _tmp4_;
	display_display_widget_set_geometry (_data8_->display_widget, delta_x + x, delta_y + y, width, height);
	gtk_widget_queue_resize ((GtkWidget*) _data8_->display_widget);
	display_displays_overlay_check_configuration_changed (self);
	display_displays_overlay_check_intersects (self, _data8_->display_widget, 0, 0, 0);
	display_displays_overlay_snap_edges (self, _data8_->display_widget);
	display_displays_overlay_close_gaps (self);
	display_displays_overlay_verify_global_positions (self);
	display_displays_overlay_calculate_ratio (self);
}

static void
___lambda17__display_display_widget_end_grab (DisplayDisplayWidget* _sender,
                                              gint delta_x,
                                              gint delta_y,
                                              gpointer self)
{
	__lambda17_ (self, delta_x, delta_y);
}

static void
display_displays_overlay_add_output (DisplayDisplaysOverlay* self,
                                     DisplayVirtualMonitor* virtual_monitor)
{
	Block8Data* _data8_;
	DisplayVirtualMonitor* _tmp0_;
	DisplayDisplayWidget* _tmp1_;
	GtkBox* _tmp2_;
	gint old_delta_x = 0;
	gint _tmp3_;
	gint _tmp4_;
	gint old_delta_y = 0;
	gint _tmp5_;
	gint _tmp6_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (virtual_monitor != NULL);
	_data8_ = g_slice_new0 (Block8Data);
	_data8_->_ref_count_ = 1;
	_data8_->self = g_object_ref (self);
	_tmp0_ = _g_object_ref0 (virtual_monitor);
	_g_object_unref0 (_data8_->virtual_monitor);
	_data8_->virtual_monitor = _tmp0_;
	_tmp1_ = display_display_widget_new (_data8_->virtual_monitor);
	g_object_ref_sink (_tmp1_);
	_data8_->display_widget = _tmp1_;
	self->priv->current_allocated_width = 0;
	self->priv->current_allocated_height = 0;
	_tmp2_ = self->priv->overlay;
	gtk_box_append (_tmp2_, (GtkWidget*) _data8_->display_widget);
	gtk_widget_add_css_class ((GtkWidget*) _data8_->display_widget, "colored");
	g_signal_connect_data (_data8_->display_widget, "set-as-primary", (GCallback) ___lambda14__display_display_widget_set_as_primary, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	g_signal_connect_data (_data8_->display_widget, "check-position", (GCallback) ___lambda15__display_display_widget_check_position, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	g_signal_connect_object (_data8_->display_widget, "move-display", (GCallback) _display_displays_overlay_move_display_display_display_widget_move_display, self, 0);
	g_signal_connect_object (_data8_->display_widget, "configuration-changed", (GCallback) _display_displays_overlay_check_configuration_changed_display_display_widget_configuration_changed, self, 0);
	g_signal_connect_data (_data8_->display_widget, "active-changed", (GCallback) ___lambda16__display_display_widget_active_changed, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	g_signal_connect_data (_data8_->display_widget, "end-grab", (GCallback) ___lambda17__display_display_widget_end_grab, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
	display_displays_overlay_check_intersects (self, _data8_->display_widget, 0, 0, 0);
	_tmp3_ = display_display_widget_get_delta_x (_data8_->display_widget);
	_tmp4_ = _tmp3_;
	old_delta_x = _tmp4_;
	_tmp5_ = display_display_widget_get_delta_y (_data8_->display_widget);
	_tmp6_ = _tmp5_;
	old_delta_y = _tmp6_;
	display_display_widget_set_delta_x (_data8_->display_widget, 0);
	display_display_widget_set_delta_y (_data8_->display_widget, 0);
	g_signal_emit_by_name (_data8_->display_widget, "end-grab", old_delta_x, old_delta_y);
	block8_data_unref (_data8_);
	_data8_ = NULL;
}

static void
display_displays_overlay_set_as_primary (DisplayDisplaysOverlay* self,
                                         DisplayVirtualMonitor* new_primary)
{
	DisplayDisplayWidget* display_widget = NULL;
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	DisplayDisplayWidget* _tmp2_;
	DisplayVirtualMonitor* virtual_monitor = NULL;
	DisplayDisplayWidget* _tmp3_;
	DisplayVirtualMonitor* _tmp4_;
	DisplayVirtualMonitor* _tmp5_;
	DisplayVirtualMonitor* _tmp6_;
	gboolean is_primary = FALSE;
	DisplayVirtualMonitor* _tmp7_;
	DisplayDisplayWidget* _tmp8_;
	DisplayVirtualMonitor* _tmp9_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (new_primary != NULL);
	_tmp0_ = self->priv->overlay;
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
	_tmp2_ = _g_object_ref0 (DISPLAY_IS_DISPLAY_WIDGET (_tmp1_) ? ((DisplayDisplayWidget*) _tmp1_) : NULL);
	display_widget = _tmp2_;
	_tmp3_ = display_widget;
	_tmp4_ = display_display_widget_get_virtual_monitor (_tmp3_);
	_tmp5_ = _tmp4_;
	_tmp6_ = _g_object_ref0 (_tmp5_);
	virtual_monitor = _tmp6_;
	_tmp7_ = virtual_monitor;
	is_primary = _tmp7_ == new_primary;
	_tmp8_ = display_widget;
	display_display_widget_set_primary (_tmp8_, is_primary);
	_tmp9_ = virtual_monitor;
	display_virtual_monitor_set_primary (_tmp9_, is_primary);
	{
		GeeLinkedList* _vm_list = NULL;
		DisplayMonitorManager* _tmp10_;
		GeeLinkedList* _tmp11_;
		GeeLinkedList* _tmp12_;
		gint _vm_size = 0;
		GeeLinkedList* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _vm_index = 0;
		_tmp10_ = self->priv->monitor_manager;
		_tmp11_ = display_monitor_manager_get_virtual_monitors (_tmp10_);
		_tmp12_ = _tmp11_;
		_vm_list = _tmp12_;
		_tmp13_ = _vm_list;
		_tmp14_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp13_);
		_tmp15_ = _tmp14_;
		_vm_size = _tmp15_;
		_vm_index = -1;
		while (TRUE) {
			gint _tmp16_;
			gint _tmp17_;
			DisplayVirtualMonitor* vm = NULL;
			GeeLinkedList* _tmp18_;
			gpointer _tmp19_;
			DisplayVirtualMonitor* _tmp20_;
			DisplayVirtualMonitor* _tmp21_;
			_vm_index = _vm_index + 1;
			_tmp16_ = _vm_index;
			_tmp17_ = _vm_size;
			if (!(_tmp16_ < _tmp17_)) {
				break;
			}
			_tmp18_ = _vm_list;
			_tmp19_ = gee_abstract_list_get ((GeeAbstractList*) _tmp18_, _vm_index);
			vm = (DisplayVirtualMonitor*) _tmp19_;
			_tmp20_ = virtual_monitor;
			_tmp21_ = vm;
			display_virtual_monitor_set_primary (_tmp20_, _tmp21_ == new_primary);
			_g_object_unref0 (vm);
		}
	}
	display_displays_overlay_check_configuration_changed (self);
	_g_object_unref0 (virtual_monitor);
	_g_object_unref0 (display_widget);
}

static void
display_displays_overlay_move_display (DisplayDisplaysOverlay* self,
                                       DisplayDisplayWidget* display_widget,
                                       gdouble diff_x,
                                       gdouble diff_y)
{
	g_return_if_fail (self != NULL);
	g_return_if_fail (display_widget != NULL);
	display_display_widget_set_delta_x (display_widget, (gint) (diff_x / self->priv->current_ratio));
	display_display_widget_set_delta_y (display_widget, (gint) (diff_y / self->priv->current_ratio));
	display_displays_overlay_align_edges (self, display_widget);
	gtk_widget_queue_resize ((GtkWidget*) display_widget);
}

static void
display_displays_overlay_align_edges (DisplayDisplaysOverlay* self,
                                      DisplayDisplayWidget* display_widget)
{
	gint aligned_delta[2] = {0};
	gint _tmp0_[2] = {0};
	gint current_delta[2] = {0};
	gint _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_[2] = {0};
	gint x = 0;
	gint y = 0;
	gint width = 0;
	gint height = 0;
	gint _tmp6_ = 0;
	gint _tmp7_ = 0;
	gint _tmp8_ = 0;
	gint _tmp9_ = 0;
	gint widget_points[6] = {0};
	gint anchor_points[6] = {0};
	GtkWidget* child = NULL;
	gint _tmp40_;
	gint _tmp42_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (display_widget != NULL);
	_tmp0_[0] = G_MAXINT;
	_tmp0_[1] = G_MAXINT;
	memcpy (aligned_delta, _tmp0_, 2 * sizeof (gint));
	_tmp1_ = display_display_widget_get_delta_x (display_widget);
	_tmp2_ = _tmp1_;
	_tmp3_ = display_display_widget_get_delta_y (display_widget);
	_tmp4_ = _tmp3_;
	_tmp5_[0] = _tmp2_;
	_tmp5_[1] = _tmp4_;
	memcpy (current_delta, _tmp5_, 2 * sizeof (gint));
	display_display_widget_get_geometry (display_widget, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
	x = _tmp6_;
	y = _tmp7_;
	width = _tmp8_;
	height = _tmp9_;
	widget_points[0] = x;
	widget_points[1] = (x + (width / 2)) - 1;
	widget_points[2] = (x + width) - 1;
	widget_points[3] = y;
	widget_points[4] = (y + (height / 2)) - 1;
	widget_points[5] = (y + height) - 1;
	{
		GtkBox* _tmp10_;
		GtkWidget* _tmp11_;
		GtkWidget* _tmp12_;
		gboolean _tmp13_ = FALSE;
		_tmp10_ = self->priv->overlay;
		_tmp11_ = gtk_widget_get_first_child ((GtkWidget*) _tmp10_);
		_tmp12_ = _g_object_ref0 (_tmp11_);
		_g_object_unref0 (child);
		child = _tmp12_;
		_tmp13_ = TRUE;
		while (TRUE) {
			GtkWidget* _tmp17_;
			gboolean _tmp18_ = FALSE;
			GtkWidget* _tmp19_;
			DisplayDisplayWidget* anchor = NULL;
			GtkWidget* _tmp21_;
			DisplayDisplayWidget* _tmp22_;
			DisplayDisplayWidget* _tmp23_;
			gint _tmp24_ = 0;
			gint _tmp25_ = 0;
			gint _tmp26_ = 0;
			gint _tmp27_ = 0;
			gint threshold = 0;
			if (!_tmp13_) {
				GtkWidget* _tmp14_;
				GtkWidget* _tmp15_;
				GtkWidget* _tmp16_;
				_tmp14_ = child;
				_tmp15_ = gtk_widget_get_next_sibling (_tmp14_);
				_tmp16_ = _g_object_ref0 (_tmp15_);
				_g_object_unref0 (child);
				child = _tmp16_;
			}
			_tmp13_ = FALSE;
			_tmp17_ = child;
			if (!(_tmp17_ != NULL)) {
				break;
			}
			_tmp19_ = child;
			if (!DISPLAY_IS_DISPLAY_WIDGET (_tmp19_)) {
				_tmp18_ = TRUE;
			} else {
				GtkWidget* _tmp20_;
				_tmp20_ = child;
				_tmp18_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp20_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget) == display_widget;
			}
			if (_tmp18_) {
				continue;
			}
			_tmp21_ = child;
			_tmp22_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
			anchor = _tmp22_;
			_tmp23_ = anchor;
			display_display_widget_get_geometry (_tmp23_, &_tmp24_, &_tmp25_, &_tmp26_, &_tmp27_);
			x = _tmp24_;
			y = _tmp25_;
			width = _tmp26_;
			height = _tmp27_;
			anchor_points[0] = x;
			anchor_points[1] = (x + (width / 2)) - 1;
			anchor_points[2] = (x + width) - 1;
			anchor_points[3] = y;
			anchor_points[4] = (y + (height / 2)) - 1;
			anchor_points[5] = (y + height) - 1;
			threshold = MIN (width, height) / 10;
			{
				gint u = 0;
				u = 0;
				{
					gboolean _tmp28_ = FALSE;
					_tmp28_ = TRUE;
					while (TRUE) {
						if (!_tmp28_) {
							gint _tmp29_;
							_tmp29_ = u;
							u = _tmp29_ + 1;
						}
						_tmp28_ = FALSE;
						if (!(u < 2)) {
							break;
						}
						{
							gint i = 0;
							i = 0;
							{
								gboolean _tmp30_ = FALSE;
								_tmp30_ = TRUE;
								while (TRUE) {
									if (!_tmp30_) {
										gint _tmp31_;
										_tmp31_ = i;
										i = _tmp31_ + 1;
									}
									_tmp30_ = FALSE;
									if (!(i < 3)) {
										break;
									}
									{
										gint j = 0;
										j = 0;
										{
											gboolean _tmp32_ = FALSE;
											_tmp32_ = TRUE;
											while (TRUE) {
												gint test_delta = 0;
												gint _tmp34_;
												gint _tmp35_;
												gint _tmp36_;
												if (!_tmp32_) {
													gint _tmp33_;
													_tmp33_ = j;
													j = _tmp33_ + 1;
												}
												_tmp32_ = FALSE;
												if (!(j < 3)) {
													break;
												}
												_tmp34_ = anchor_points[i + (3 * u)];
												_tmp35_ = widget_points[j + (3 * u)];
												test_delta = _tmp34_ - _tmp35_;
												_tmp36_ = current_delta[u];
												if (threshold > abs (test_delta - _tmp36_)) {
													gint _tmp37_;
													_tmp37_ = aligned_delta[u];
													if (abs (test_delta) < abs (_tmp37_)) {
														gboolean _tmp38_ = FALSE;
														aligned_delta[u] = test_delta;
														if (i == 0) {
															_tmp38_ = j != i;
														} else {
															_tmp38_ = FALSE;
														}
														if (_tmp38_) {
															aligned_delta[u] -= 1;
														} else {
															gboolean _tmp39_ = FALSE;
															if (j == 0) {
																_tmp39_ = i != j;
															} else {
																_tmp39_ = FALSE;
															}
															if (_tmp39_) {
																aligned_delta[u] += 1;
															}
														}
													}
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
			_g_object_unref0 (anchor);
		}
	}
	_tmp40_ = aligned_delta[0];
	if (_tmp40_ != G_MAXINT) {
		gint _tmp41_;
		_tmp41_ = aligned_delta[0];
		display_display_widget_set_delta_x (display_widget, _tmp41_);
	}
	_tmp42_ = aligned_delta[1];
	if (_tmp42_ != G_MAXINT) {
		gint _tmp43_;
		_tmp43_ = aligned_delta[1];
		display_display_widget_set_delta_y (display_widget, _tmp43_);
	}
	_g_object_unref0 (child);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static void
display_displays_overlay_close_gaps (DisplayDisplaysOverlay* self)
{
	GList* display_widgets = NULL;
	GtkBox* _tmp0_;
	GtkWidget* _tmp1_;
	DisplayDisplayWidget* _tmp2_;
	GList* _tmp3_;
	g_return_if_fail (self != NULL);
	display_widgets = NULL;
	_tmp0_ = self->priv->overlay;
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
	display_widgets = g_list_append (display_widgets, _tmp2_);
	_tmp3_ = display_widgets;
	{
		GList* display_widget_collection = NULL;
		GList* display_widget_it = NULL;
		display_widget_collection = _tmp3_;
		for (display_widget_it = display_widget_collection; display_widget_it != NULL; display_widget_it = display_widget_it->next) {
			DisplayDisplayWidget* _tmp4_;
			DisplayDisplayWidget* display_widget = NULL;
			_tmp4_ = _g_object_ref0 ((DisplayDisplayWidget*) display_widget_it->data);
			display_widget = _tmp4_;
			{
				DisplayDisplayWidget* _tmp5_;
				GList* _tmp6_;
				_tmp5_ = display_widget;
				_tmp6_ = display_widgets;
				if (!display_displays_overlay_is_connected (self, _tmp5_, _tmp6_)) {
					DisplayDisplayWidget* _tmp7_;
					_tmp7_ = display_widget;
					display_displays_overlay_snap_edges (self, _tmp7_);
				}
				_g_object_unref0 (display_widget);
			}
		}
	}
	(display_widgets == NULL) ? NULL : (display_widgets = (_g_list_free__g_object_unref0_ (display_widgets), NULL));
}

static gboolean
display_displays_overlay_is_connected (DisplayDisplaysOverlay* self,
                                       DisplayDisplayWidget* display_widget,
                                       GList* other_display_widgets)
{
	gint x = 0;
	gint y = 0;
	gint width = 0;
	gint height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GdkRectangle rect = {0};
	GdkRectangle _tmp4_ = {0};
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (display_widget != NULL, FALSE);
	display_display_widget_get_geometry (display_widget, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
	x = _tmp0_;
	y = _tmp1_;
	width = _tmp2_;
	height = _tmp3_;
	_tmp4_.x = x - 1;
	_tmp4_.y = y - 1;
	_tmp4_.width = width + 2;
	_tmp4_.height = height + 2;
	rect = _tmp4_;
	{
		GList* other_display_widget_collection = NULL;
		GList* other_display_widget_it = NULL;
		other_display_widget_collection = other_display_widgets;
		for (other_display_widget_it = other_display_widget_collection; other_display_widget_it != NULL; other_display_widget_it = other_display_widget_it->next) {
			DisplayDisplayWidget* _tmp5_;
			DisplayDisplayWidget* other_display_widget = NULL;
			_tmp5_ = _g_object_ref0 ((DisplayDisplayWidget*) other_display_widget_it->data);
			other_display_widget = _tmp5_;
			{
				DisplayDisplayWidget* _tmp6_;
				gint other_x = 0;
				gint other_y = 0;
				gint other_width = 0;
				gint other_height = 0;
				DisplayDisplayWidget* _tmp7_;
				gint _tmp8_ = 0;
				gint _tmp9_ = 0;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				GdkRectangle other_rect = {0};
				GdkRectangle _tmp12_ = {0};
				GdkRectangle intersection = {0};
				gboolean is_connected = FALSE;
				GdkRectangle _tmp13_;
				GdkRectangle _tmp14_ = {0};
				gboolean _tmp15_;
				gboolean _tmp16_ = FALSE;
				GdkRectangle _tmp17_;
				gboolean is_diagonal = FALSE;
				gboolean _tmp19_ = FALSE;
				_tmp6_ = other_display_widget;
				if (_tmp6_ == display_widget) {
					_g_object_unref0 (other_display_widget);
					continue;
				}
				_tmp7_ = other_display_widget;
				display_display_widget_get_geometry (_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
				other_x = _tmp8_;
				other_y = _tmp9_;
				other_width = _tmp10_;
				other_height = _tmp11_;
				_tmp12_.x = other_x;
				_tmp12_.y = other_y;
				_tmp12_.width = other_width;
				_tmp12_.height = other_height;
				other_rect = _tmp12_;
				_tmp13_ = other_rect;
				_tmp15_ = gdk_rectangle_intersect (&rect, &_tmp13_, &_tmp14_);
				intersection = _tmp14_;
				is_connected = _tmp15_;
				_tmp17_ = intersection;
				if (_tmp17_.height == 1) {
					GdkRectangle _tmp18_;
					_tmp18_ = intersection;
					_tmp16_ = _tmp18_.width == 1;
				} else {
					_tmp16_ = FALSE;
				}
				is_diagonal = _tmp16_;
				if (is_connected) {
					_tmp19_ = !is_diagonal;
				} else {
					_tmp19_ = FALSE;
				}
				if (_tmp19_) {
					result = TRUE;
					_g_object_unref0 (other_display_widget);
					return result;
				}
				_g_object_unref0 (other_display_widget);
			}
		}
	}
	result = FALSE;
	return result;
}

static void
display_displays_overlay_verify_global_positions (DisplayDisplaysOverlay* self)
{
	gint min_x = 0;
	gint min_y = 0;
	GtkWidget* child = NULL;
	gboolean _tmp16_ = FALSE;
	g_return_if_fail (self != NULL);
	min_x = G_MAXINT;
	min_y = G_MAXINT;
	{
		GtkBox* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
		_tmp0_ = self->priv->overlay;
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (child);
		child = _tmp2_;
		_tmp3_ = TRUE;
		while (TRUE) {
			GtkWidget* _tmp7_;
			GtkWidget* _tmp8_;
			if (!_tmp3_) {
				GtkWidget* _tmp4_;
				GtkWidget* _tmp5_;
				GtkWidget* _tmp6_;
				_tmp4_ = child;
				_tmp5_ = gtk_widget_get_next_sibling (_tmp4_);
				_tmp6_ = _g_object_ref0 (_tmp5_);
				_g_object_unref0 (child);
				child = _tmp6_;
			}
			_tmp3_ = FALSE;
			_tmp7_ = child;
			if (!(_tmp7_ != NULL)) {
				break;
			}
			_tmp8_ = child;
			if (DISPLAY_IS_DISPLAY_WIDGET (_tmp8_)) {
				DisplayDisplayWidget* display_widget = NULL;
				GtkWidget* _tmp9_;
				DisplayDisplayWidget* _tmp10_;
				gint x = 0;
				gint y = 0;
				gint width = 0;
				gint height = 0;
				DisplayDisplayWidget* _tmp11_;
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				gint _tmp14_ = 0;
				gint _tmp15_ = 0;
				_tmp9_ = child;
				_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
				display_widget = _tmp10_;
				_tmp11_ = display_widget;
				display_display_widget_get_geometry (_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
				x = _tmp12_;
				y = _tmp13_;
				width = _tmp14_;
				height = _tmp15_;
				min_x = MIN (min_x, x);
				min_y = MIN (min_y, y);
				_g_object_unref0 (display_widget);
			}
		}
	}
	if (min_x == 0) {
		_tmp16_ = min_y == 0;
	} else {
		_tmp16_ = FALSE;
	}
	if (_tmp16_) {
		_g_object_unref0 (child);
		return;
	}
	{
		GtkBox* _tmp17_;
		GtkWidget* _tmp18_;
		GtkWidget* _tmp19_;
		gboolean _tmp20_ = FALSE;
		_tmp17_ = self->priv->overlay;
		_tmp18_ = gtk_widget_get_first_child ((GtkWidget*) _tmp17_);
		_tmp19_ = _g_object_ref0 (_tmp18_);
		_g_object_unref0 (child);
		child = _tmp19_;
		_tmp20_ = TRUE;
		while (TRUE) {
			GtkWidget* _tmp24_;
			GtkWidget* _tmp25_;
			if (!_tmp20_) {
				GtkWidget* _tmp21_;
				GtkWidget* _tmp22_;
				GtkWidget* _tmp23_;
				_tmp21_ = child;
				_tmp22_ = gtk_widget_get_next_sibling (_tmp21_);
				_tmp23_ = _g_object_ref0 (_tmp22_);
				_g_object_unref0 (child);
				child = _tmp23_;
			}
			_tmp20_ = FALSE;
			_tmp24_ = child;
			if (!(_tmp24_ != NULL)) {
				break;
			}
			_tmp25_ = child;
			if (DISPLAY_IS_DISPLAY_WIDGET (_tmp25_)) {
				DisplayDisplayWidget* display_widget = NULL;
				GtkWidget* _tmp26_;
				DisplayDisplayWidget* _tmp27_;
				gint x = 0;
				gint y = 0;
				gint width = 0;
				gint height = 0;
				DisplayDisplayWidget* _tmp28_;
				gint _tmp29_ = 0;
				gint _tmp30_ = 0;
				gint _tmp31_ = 0;
				gint _tmp32_ = 0;
				DisplayDisplayWidget* _tmp33_;
				_tmp26_ = child;
				_tmp27_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp26_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
				display_widget = _tmp27_;
				_tmp28_ = display_widget;
				display_display_widget_get_geometry (_tmp28_, &_tmp29_, &_tmp30_, &_tmp31_, &_tmp32_);
				x = _tmp29_;
				y = _tmp30_;
				width = _tmp31_;
				height = _tmp32_;
				_tmp33_ = display_widget;
				display_display_widget_set_geometry (_tmp33_, x - min_x, y - min_y, width, height);
				_g_object_unref0 (display_widget);
			}
		}
	}
	_g_object_unref0 (child);
}

void
display_displays_overlay_check_intersects (DisplayDisplaysOverlay* self,
                                           DisplayDisplayWidget* source_display_widget,
                                           gint level,
                                           gint distance_x,
                                           gint distance_y)
{
	gint source_x = 0;
	gint source_y = 0;
	gint source_width = 0;
	gint source_height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	GdkRectangle src_rect = {0};
	GdkRectangle _tmp4_ = {0};
	GtkWidget* child = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (source_display_widget != NULL);
	if (level > 10) {
		g_warning ("DisplaysOverlay.vala:346: Maximum level of recursion reached! Could no" \
"t fix intersects!");
		return;
	}
	display_display_widget_get_geometry (source_display_widget, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
	source_x = _tmp0_;
	source_y = _tmp1_;
	source_width = _tmp2_;
	source_height = _tmp3_;
	_tmp4_.x = source_x;
	_tmp4_.y = source_y;
	_tmp4_.width = source_width;
	_tmp4_.height = source_height;
	src_rect = _tmp4_;
	{
		GtkBox* _tmp5_;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
		gboolean _tmp8_ = FALSE;
		_tmp5_ = self->priv->overlay;
		_tmp6_ = gtk_widget_get_first_child ((GtkWidget*) _tmp5_);
		_tmp7_ = _g_object_ref0 (_tmp6_);
		_g_object_unref0 (child);
		child = _tmp7_;
		_tmp8_ = TRUE;
		while (TRUE) {
			GtkWidget* _tmp12_;
			gboolean _tmp13_ = FALSE;
			GtkWidget* _tmp14_;
			DisplayDisplayWidget* other_display_widget = NULL;
			GtkWidget* _tmp16_;
			DisplayDisplayWidget* _tmp17_;
			gint other_x = 0;
			gint other_y = 0;
			gint other_width = 0;
			gint other_height = 0;
			DisplayDisplayWidget* _tmp18_;
			gint _tmp19_ = 0;
			gint _tmp20_ = 0;
			gint _tmp21_ = 0;
			gint _tmp22_ = 0;
			GdkRectangle test_rect = {0};
			GdkRectangle _tmp23_ = {0};
			GdkRectangle _tmp24_;
			if (!_tmp8_) {
				GtkWidget* _tmp9_;
				GtkWidget* _tmp10_;
				GtkWidget* _tmp11_;
				_tmp9_ = child;
				_tmp10_ = gtk_widget_get_next_sibling (_tmp9_);
				_tmp11_ = _g_object_ref0 (_tmp10_);
				_g_object_unref0 (child);
				child = _tmp11_;
			}
			_tmp8_ = FALSE;
			_tmp12_ = child;
			if (!(_tmp12_ != NULL)) {
				break;
			}
			_tmp14_ = child;
			if (!DISPLAY_IS_DISPLAY_WIDGET (_tmp14_)) {
				_tmp13_ = TRUE;
			} else {
				GtkWidget* _tmp15_;
				_tmp15_ = child;
				_tmp13_ = G_TYPE_CHECK_INSTANCE_CAST (_tmp15_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget) == source_display_widget;
			}
			if (_tmp13_) {
				continue;
			}
			_tmp16_ = child;
			_tmp17_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
			other_display_widget = _tmp17_;
			_tmp18_ = other_display_widget;
			display_display_widget_get_geometry (_tmp18_, &_tmp19_, &_tmp20_, &_tmp21_, &_tmp22_);
			other_x = _tmp19_;
			other_y = _tmp20_;
			other_width = _tmp21_;
			other_height = _tmp22_;
			_tmp23_.x = other_x;
			_tmp23_.y = other_y;
			_tmp23_.width = other_width;
			_tmp23_.height = other_height;
			test_rect = _tmp23_;
			_tmp24_ = test_rect;
			if (gdk_rectangle_intersect (&src_rect, &_tmp24_, NULL)) {
				DisplayDisplayWidget* _tmp28_;
				DisplayDisplayWidget* _tmp29_;
				DisplayDisplayWidget* _tmp30_;
				if (level == 0) {
					gint distance_left = 0;
					gint distance_right = 0;
					gint distance_top = 0;
					gint distance_bottom = 0;
					gint _tmp25_ = 0;
					gint test_distance_x = 0;
					gint _tmp26_ = 0;
					gint test_distance_y = 0;
					gboolean _tmp27_ = FALSE;
					distance_left = (source_x - other_x) - other_width;
					distance_right = (source_x - other_x) + source_width;
					distance_top = (source_y - other_y) - other_height;
					distance_bottom = (source_y - other_y) + source_height;
					if (distance_right < (-distance_left)) {
						_tmp25_ = distance_right;
					} else {
						_tmp25_ = distance_left;
					}
					test_distance_x = _tmp25_;
					if (distance_bottom < (-distance_top)) {
						_tmp26_ = distance_bottom;
					} else {
						_tmp26_ = distance_top;
					}
					test_distance_y = _tmp26_;
					if (abs (test_distance_x) <= abs (test_distance_y)) {
						_tmp27_ = TRUE;
					} else {
						_tmp27_ = distance_top == (-distance_bottom);
					}
					if (_tmp27_) {
						distance_x = test_distance_x;
					} else {
						distance_y = test_distance_y;
					}
				}
				_tmp28_ = other_display_widget;
				display_display_widget_set_geometry (_tmp28_, other_x + distance_x, other_y + distance_y, other_width, other_height);
				_tmp29_ = other_display_widget;
				gtk_widget_queue_resize ((GtkWidget*) _tmp29_);
				_tmp30_ = other_display_widget;
				display_displays_overlay_check_intersects (self, _tmp30_, level + 1, distance_x, distance_y);
			}
			_g_object_unref0 (other_display_widget);
		}
	}
	_g_object_unref0 (child);
}

void
display_displays_overlay_snap_edges (DisplayDisplaysOverlay* self,
                                     DisplayDisplayWidget* last_moved)
{
	GList* anchors = NULL;
	GtkWidget* child = NULL;
	GList* _tmp13_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (last_moved != NULL);
	if (self->priv->scanning) {
		return;
	}
	g_debug ("DisplaysOverlay.vala:391: Snapping displays");
	anchors = NULL;
	{
		GtkBox* _tmp0_;
		GtkWidget* _tmp1_;
		GtkWidget* _tmp2_;
		gboolean _tmp3_ = FALSE;
		_tmp0_ = self->priv->overlay;
		_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
		_tmp2_ = _g_object_ref0 (_tmp1_);
		_g_object_unref0 (child);
		child = _tmp2_;
		_tmp3_ = TRUE;
		while (TRUE) {
			GtkWidget* _tmp7_;
			gboolean _tmp8_ = FALSE;
			GtkWidget* _tmp9_;
			GtkWidget* _tmp11_;
			DisplayDisplayWidget* _tmp12_;
			if (!_tmp3_) {
				GtkWidget* _tmp4_;
				GtkWidget* _tmp5_;
				GtkWidget* _tmp6_;
				_tmp4_ = child;
				_tmp5_ = gtk_widget_get_next_sibling (_tmp4_);
				_tmp6_ = _g_object_ref0 (_tmp5_);
				_g_object_unref0 (child);
				child = _tmp6_;
			}
			_tmp3_ = FALSE;
			_tmp7_ = child;
			if (!(_tmp7_ != NULL)) {
				break;
			}
			_tmp9_ = child;
			if (!DISPLAY_IS_DISPLAY_WIDGET (_tmp9_)) {
				_tmp8_ = TRUE;
			} else {
				GtkWidget* _tmp10_;
				_tmp10_ = child;
				_tmp8_ = display_display_widget_equals (last_moved, G_TYPE_CHECK_INSTANCE_CAST (_tmp10_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
			}
			if (_tmp8_) {
				_g_object_unref0 (child);
				(anchors == NULL) ? NULL : (anchors = (_g_list_free__g_object_unref0_ (anchors), NULL));
				return;
			}
			_tmp11_ = child;
			_tmp12_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp11_, DISPLAY_TYPE_DISPLAY_WIDGET, DisplayDisplayWidget));
			anchors = g_list_append (anchors, _tmp12_);
		}
	}
	_tmp13_ = anchors;
	display_displays_overlay_snap_widget (self, last_moved, _tmp13_);
	_g_object_unref0 (child);
	(anchors == NULL) ? NULL : (anchors = (_g_list_free__g_object_unref0_ (anchors), NULL));
}

static void
display_displays_overlay_snap_widget (DisplayDisplaysOverlay* self,
                                      DisplayDisplayWidget* widget,
                                      GList* anchors)
{
	gint widget_x = 0;
	gint widget_y = 0;
	gint widget_width = 0;
	gint widget_height = 0;
	gint _tmp0_ = 0;
	gint _tmp1_ = 0;
	gint _tmp2_ = 0;
	gint _tmp3_ = 0;
	gint _tmp4_;
	gint _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	gint shortest_distance = 0;
	gint shortest_distance_x = 0;
	gint shortest_distance_y = 0;
	g_return_if_fail (self != NULL);
	g_return_if_fail (widget != NULL);
	if (g_list_length (anchors) == ((guint) 0)) {
		return;
	}
	display_display_widget_get_geometry (widget, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
	widget_x = _tmp0_;
	widget_y = _tmp1_;
	widget_width = _tmp2_;
	widget_height = _tmp3_;
	_tmp4_ = display_display_widget_get_delta_x (widget);
	_tmp5_ = _tmp4_;
	widget_x += _tmp5_;
	_tmp6_ = display_display_widget_get_delta_y (widget);
	_tmp7_ = _tmp6_;
	widget_y += _tmp7_;
	shortest_distance = G_MAXINT;
	shortest_distance_x = 0;
	shortest_distance_y = 0;
	{
		GList* anchor_collection = NULL;
		GList* anchor_it = NULL;
		anchor_collection = anchors;
		for (anchor_it = anchor_collection; anchor_it != NULL; anchor_it = anchor_it->next) {
			DisplayDisplayWidget* _tmp8_;
			DisplayDisplayWidget* anchor = NULL;
			_tmp8_ = _g_object_ref0 ((DisplayDisplayWidget*) anchor_it->data);
			anchor = _tmp8_;
			{
				gint anchor_x = 0;
				gint anchor_y = 0;
				gint anchor_width = 0;
				gint anchor_height = 0;
				DisplayDisplayWidget* _tmp9_;
				gint _tmp10_ = 0;
				gint _tmp11_ = 0;
				gint _tmp12_ = 0;
				gint _tmp13_ = 0;
				gint distance_origin_x = 0;
				gint distance_origin_y = 0;
				gint distance_left = 0;
				gint distance_right = 0;
				gint distance_top = 0;
				gint distance_bottom = 0;
				gint _tmp14_ = 0;
				gint distance_widget_anchor_x = 0;
				gint _tmp15_ = 0;
				gint distance_widget_anchor_y = 0;
				gboolean _tmp16_ = FALSE;
				gint shortest_distance_candidate = 0;
				_tmp9_ = anchor;
				display_display_widget_get_geometry (_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_, &_tmp13_);
				anchor_x = _tmp10_;
				anchor_y = _tmp11_;
				anchor_width = _tmp12_;
				anchor_height = _tmp13_;
				distance_origin_x = anchor_x - widget_x;
				distance_origin_y = anchor_y - widget_y;
				distance_left = distance_origin_x + anchor_width;
				distance_right = distance_origin_x - widget_width;
				distance_top = distance_origin_y + anchor_height;
				distance_bottom = distance_origin_y - widget_height;
				if (distance_right > (-distance_left)) {
					_tmp14_ = distance_right;
				} else {
					_tmp14_ = distance_left;
				}
				distance_widget_anchor_x = _tmp14_;
				if (distance_bottom > (-distance_top)) {
					_tmp15_ = distance_bottom;
				} else {
					_tmp15_ = distance_top;
				}
				distance_widget_anchor_y = _tmp15_;
				if (distance_left > 0) {
					_tmp16_ = distance_right < 0;
				} else {
					_tmp16_ = FALSE;
				}
				if (_tmp16_) {
					distance_widget_anchor_x = 0;
				} else {
					gboolean _tmp17_ = FALSE;
					if (distance_top > 0) {
						_tmp17_ = distance_bottom < 0;
					} else {
						_tmp17_ = FALSE;
					}
					if (_tmp17_) {
						distance_widget_anchor_y = 0;
					} else {
						if (abs (distance_widget_anchor_x) >= abs (distance_widget_anchor_y)) {
							gint _tmp18_ = 0;
							if (distance_origin_x > 0) {
								_tmp18_ = 1;
							} else {
								_tmp18_ = -1;
							}
							distance_widget_anchor_x += _tmp18_ * DISPLAY_DISPLAYS_OVERLAY_MINIMUM_WIDGET_OFFSET;
						} else {
							gint _tmp19_ = 0;
							if (distance_origin_y > 0) {
								_tmp19_ = 1;
							} else {
								_tmp19_ = -1;
							}
							distance_widget_anchor_y += _tmp19_ * DISPLAY_DISPLAYS_OVERLAY_MINIMUM_WIDGET_OFFSET;
						}
					}
				}
				shortest_distance_candidate = (distance_widget_anchor_x * distance_widget_anchor_x) + (distance_widget_anchor_y * distance_widget_anchor_y);
				if (shortest_distance_candidate < shortest_distance) {
					shortest_distance = shortest_distance_candidate;
					shortest_distance_x = distance_widget_anchor_x;
					shortest_distance_y = distance_widget_anchor_y;
				}
				_g_object_unref0 (anchor);
			}
		}
	}
	display_display_widget_set_geometry (widget, widget_x + shortest_distance_x, widget_y + shortest_distance_y, widget_width, widget_height);
}

gint
display_displays_overlay_get_active_displays (DisplayDisplaysOverlay* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_active_displays;
	return result;
}

void
display_displays_overlay_set_active_displays (DisplayDisplaysOverlay* self,
                                              gint value)
{
	gint old_value;
	g_return_if_fail (self != NULL);
	old_value = display_displays_overlay_get_active_displays (self);
	if (old_value != value) {
		self->priv->_active_displays = value;
		g_object_notify_by_pspec ((GObject *) self, display_displays_overlay_properties[DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY]);
	}
}

static void
display_displays_overlay_class_init (DisplayDisplaysOverlayClass * klass,
                                     gpointer klass_data)
{
	display_displays_overlay_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DisplayDisplaysOverlay_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_display_displays_overlay_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_display_displays_overlay_set_property;
	G_OBJECT_CLASS (klass)->finalize = display_displays_overlay_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY, display_displays_overlay_properties[DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY] = g_param_spec_int ("active-displays", "active-displays", "active-displays", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	display_displays_overlay_signals[DISPLAY_DISPLAYS_OVERLAY_CONFIGURATION_CHANGED_SIGNAL] = g_signal_new ("configuration-changed", DISPLAY_TYPE_DISPLAYS_OVERLAY, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
}

static void
display_displays_overlay_instance_init (DisplayDisplaysOverlay * self,
                                        gpointer klass)
{
	self->priv = display_displays_overlay_get_instance_private (self);
	self->priv->scanning = FALSE;
	self->priv->current_ratio = (gdouble) 1.0f;
	self->priv->current_allocated_width = 0;
	self->priv->current_allocated_height = 0;
	self->priv->default_x_margin = 0;
	self->priv->default_y_margin = 0;
	self->priv->_active_displays = 0;
}

static void
display_displays_overlay_finalize (GObject * obj)
{
	DisplayDisplaysOverlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAYS_OVERLAY, DisplayDisplaysOverlay);
	_g_object_unref0 (self->priv->overlay);
	G_OBJECT_CLASS (display_displays_overlay_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
display_displays_overlay_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplaysOverlayClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_displays_overlay_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplaysOverlay), 0, (GInstanceInitFunc) display_displays_overlay_instance_init, NULL };
	GType display_displays_overlay_type_id;
	display_displays_overlay_type_id = g_type_register_static (HE_TYPE_BIN, "DisplayDisplaysOverlay", &g_define_type_info, 0);
	DisplayDisplaysOverlay_private_offset = g_type_add_instance_private (display_displays_overlay_type_id, sizeof (DisplayDisplaysOverlayPrivate));
	return display_displays_overlay_type_id;
}

GType
display_displays_overlay_get_type (void)
{
	static gsize display_displays_overlay_type_id__once = 0;
	if (g_once_init_enter (&display_displays_overlay_type_id__once)) {
		GType display_displays_overlay_type_id;
		display_displays_overlay_type_id = display_displays_overlay_get_type_once ();
		g_once_init_leave (&display_displays_overlay_type_id__once, display_displays_overlay_type_id);
	}
	return display_displays_overlay_type_id__once;
}

static void
_vala_display_displays_overlay_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec)
{
	DisplayDisplaysOverlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAYS_OVERLAY, DisplayDisplaysOverlay);
	switch (property_id) {
		case DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY:
		g_value_set_int (value, display_displays_overlay_get_active_displays (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_display_displays_overlay_set_property (GObject * object,
                                             guint property_id,
                                             const GValue * value,
                                             GParamSpec * pspec)
{
	DisplayDisplaysOverlay * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, DISPLAY_TYPE_DISPLAYS_OVERLAY, DisplayDisplaysOverlay);
	switch (property_id) {
		case DISPLAY_DISPLAYS_OVERLAY_ACTIVE_DISPLAYS_PROPERTY:
		display_displays_overlay_set_active_displays (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

