/* MouseFuse.c generated by valac 0.56.13, the Vala compiler
 * generated from MouseFuse.vala, do not modify */

/*-
 * Copyright (c) 2022 Fyra Labs
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "fuse-mouse.h"
#include <gtk/gtk.h>
#include "fusebox-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <libhelium-1.h>
#include <gmodule.h>

enum  {
	MOUSE_FUSE_0_PROPERTY,
	MOUSE_FUSE_NUM_PROPERTIES
};
static GParamSpec* mouse_fuse_properties[MOUSE_FUSE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _MouseFuseSearchData MouseFuseSearchData;

struct _MouseFusePrivate {
	GtkGrid* main_grid;
	GtkStack* stack;
};

struct _MouseFuseSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	MouseFuse* self;
	gchar* search;
	GHashTable* result;
	GHashTable* search_results;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
};

static gint MouseFuse_private_offset;
static gpointer mouse_fuse_parent_class = NULL;
GSettings* mouse_fuse_ibus_general_settings = NULL;

static void _g_free0_ (gpointer var);
static GtkWidget* mouse_fuse_real_get_widget (FuseboxFuse* base);
static void mouse_fuse_real_shown (FuseboxFuse* base);
static void mouse_fuse_real_hidden (FuseboxFuse* base);
static void mouse_fuse_real_search_callback (FuseboxFuse* base,
                                      const gchar* location);
static void mouse_fuse_real_search_data_free (gpointer _data);
static void mouse_fuse_real_search (FuseboxFuse* base,
                             const gchar* search,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
static gboolean mouse_fuse_real_search_co (MouseFuseSearchData* _data_);
static void mouse_fuse_finalize (GObject * obj);
static GType mouse_fuse_get_type_once (void);

static inline gpointer
mouse_fuse_get_instance_private (MouseFuse* self)
{
	return G_STRUCT_MEMBER_P (self, MouseFuse_private_offset);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

MouseFuse*
mouse_fuse_construct (GType object_type)
{
	MouseFuse * self = NULL;
	GHashTable* _tmp0_;
	GHashTable* _tmp1_;
	GHashTable* _tmp2_;
	GHashTable* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_free0_);
	_tmp1_ = _tmp0_;
	self = (MouseFuse*) g_object_new (object_type, "category", FUSEBOX_FUSE_CATEGORY_SYSTEM, "code-name", "mouse-fuse", "display-name", _ ("Mouse & Keyboard"), "description", _ ("Settings for mice, keyboards and touchpads."), "icon", "settings-mouse-symbolic", "supported-settings", _tmp1_, "index", 5, NULL);
	_g_hash_table_unref0 (_tmp1_);
	_tmp2_ = fusebox_fuse_get_supported_settings ((FuseboxFuse*) self);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strdup ("input/pointer");
	_tmp5_ = g_strdup ("clicking");
	g_hash_table_insert (_tmp3_, _tmp4_, _tmp5_);
	return self;
}

MouseFuse*
mouse_fuse_new (void)
{
	return mouse_fuse_construct (MOUSE_TYPE_FUSE);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkWidget*
mouse_fuse_real_get_widget (FuseboxFuse* base)
{
	MouseFuse * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp22_;
	GtkWidget* _tmp23_;
	GtkWidget* result;
	self = (MouseFuse*) base;
	_tmp0_ = self->priv->main_grid;
	if (_tmp0_ == NULL) {
		MouseMouseView* mouse_view = NULL;
		MouseMouseView* _tmp1_;
		MouseTouchpadView* touchpad_view = NULL;
		MouseTouchpadView* _tmp2_;
		MouseKeyboardView* keyboard_view = NULL;
		MouseKeyboardView* _tmp3_;
		GtkStack* _tmp4_ = NULL;
		HeViewSwitcher* stack_switcher = NULL;
		GtkStack* _tmp5_;
		GtkStack* _tmp6_;
		HeViewSwitcher* _tmp7_ = NULL;
		GtkStack* _tmp8_;
		MouseMouseView* _tmp9_;
		GtkStack* _tmp10_;
		MouseTouchpadView* _tmp11_;
		GtkStack* _tmp12_;
		MouseKeyboardView* _tmp13_;
		HeAppBar* appbar = NULL;
		HeViewSwitcher* _tmp14_;
		GtkWidget* _tmp15_;
		HeAppBar* _tmp16_ = NULL;
		GtkGrid* _tmp17_ = NULL;
		GtkGrid* _tmp18_;
		HeAppBar* _tmp19_;
		GtkGrid* _tmp20_;
		GtkStack* _tmp21_;
		_tmp1_ = mouse_mouse_view_new ();
		g_object_ref_sink (_tmp1_);
		mouse_view = _tmp1_;
		_tmp2_ = mouse_touchpad_view_new ();
		g_object_ref_sink (_tmp2_);
		touchpad_view = _tmp2_;
		_tmp3_ = mouse_keyboard_view_new ();
		g_object_ref_sink (_tmp3_);
		keyboard_view = _tmp3_;
		_tmp4_ = (GtkStack*) gtk_stack_new ();
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp4_, 24);
		gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 24);
		gtk_widget_set_margin_end ((GtkWidget*) _tmp4_, 24);
		gtk_stack_set_vhomogeneous (_tmp4_, FALSE);
		gtk_stack_set_transition_type (_tmp4_, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT);
		gtk_stack_set_transition_duration (_tmp4_, (guint) 400);
		g_object_ref_sink (_tmp4_);
		_g_object_unref0 (self->priv->stack);
		self->priv->stack = _tmp4_;
		_tmp5_ = self->priv->stack;
		_tmp6_ = _g_object_ref0 (_tmp5_);
		_tmp7_ = he_view_switcher_new ();
		he_view_switcher_set_stack (_tmp7_, _tmp6_);
		_g_object_unref0 (_tmp6_);
		g_object_ref_sink (_tmp7_);
		stack_switcher = _tmp7_;
		_tmp8_ = self->priv->stack;
		_tmp9_ = mouse_view;
		gtk_stack_add_titled (_tmp8_, (GtkWidget*) _tmp9_, "mouse", _ ("Mouse"));
		_tmp10_ = self->priv->stack;
		_tmp11_ = touchpad_view;
		gtk_stack_add_titled (_tmp10_, (GtkWidget*) _tmp11_, "touchpad", _ ("Touchpad"));
		_tmp12_ = self->priv->stack;
		_tmp13_ = keyboard_view;
		gtk_stack_add_titled (_tmp12_, (GtkWidget*) _tmp13_, "keyboard", _ ("Keyboard"));
		_tmp14_ = stack_switcher;
		_tmp15_ = _g_object_ref0 ((GtkWidget*) _tmp14_);
		_tmp16_ = he_app_bar_new ();
		he_app_bar_set_viewtitle_widget (_tmp16_, _tmp15_);
		_g_object_unref0 (_tmp15_);
		he_app_bar_set_show_back (_tmp16_, FALSE);
		_tmp16_->flat = TRUE;
		g_object_ref_sink (_tmp16_);
		appbar = _tmp16_;
		_tmp17_ = (GtkGrid*) gtk_grid_new ();
		gtk_grid_set_row_spacing (_tmp17_, 12);
		g_object_ref_sink (_tmp17_);
		_g_object_unref0 (self->priv->main_grid);
		self->priv->main_grid = _tmp17_;
		_tmp18_ = self->priv->main_grid;
		_tmp19_ = appbar;
		gtk_grid_attach (_tmp18_, (GtkWidget*) _tmp19_, 0, 0, 1, 1);
		_tmp20_ = self->priv->main_grid;
		_tmp21_ = self->priv->stack;
		gtk_grid_attach (_tmp20_, (GtkWidget*) _tmp21_, 0, 1, 1, 1);
		_g_object_unref0 (appbar);
		_g_object_unref0 (stack_switcher);
		_g_object_unref0 (keyboard_view);
		_g_object_unref0 (touchpad_view);
		_g_object_unref0 (mouse_view);
	}
	_tmp22_ = self->priv->main_grid;
	_tmp23_ = _g_object_ref0 ((GtkWidget*) _tmp22_);
	result = _tmp23_;
	return result;
}

static void
mouse_fuse_real_shown (FuseboxFuse* base)
{
	MouseFuse * self;
	self = (MouseFuse*) base;
}

static void
mouse_fuse_real_hidden (FuseboxFuse* base)
{
	MouseFuse * self;
	self = (MouseFuse*) base;
}

static void
mouse_fuse_real_search_callback (FuseboxFuse* base,
                                 const gchar* location)
{
	MouseFuse * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	static GQuark _tmp1_label0 = 0;
	self = (MouseFuse*) base;
	g_return_if_fail (location != NULL);
	_tmp0_ = location;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("touchpad")))) {
		switch (0) {
			default:
			{
				GtkStack* _tmp3_;
				_tmp3_ = self->priv->stack;
				gtk_stack_set_visible_child_name (_tmp3_, "touchpad");
				break;
			}
		}
	} else {
		switch (0) {
			default:
			{
				GtkStack* _tmp4_;
				_tmp4_ = self->priv->stack;
				gtk_stack_set_visible_child_name (_tmp4_, "mouse");
				break;
			}
		}
	}
}

static void
mouse_fuse_real_search_data_free (gpointer _data)
{
	MouseFuseSearchData* _data_;
	_data_ = _data;
	_g_free0 (_data_->search);
	_g_hash_table_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (MouseFuseSearchData, _data_);
}

static void
mouse_fuse_real_search (FuseboxFuse* base,
                        const gchar* search,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	MouseFuse * self;
	MouseFuseSearchData* _data_;
	MouseFuse* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (search != NULL);
	self = (MouseFuse*) base;
	_data_ = g_slice_new0 (MouseFuseSearchData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, mouse_fuse_real_search_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (search);
	_g_free0 (_data_->search);
	_data_->search = _tmp1_;
	mouse_fuse_real_search_co (_data_);
}

static GHashTable*
mouse_fuse_search_finish (FuseboxFuse* base,
                          GAsyncResult* _res_)
{
	GHashTable* result;
	MouseFuseSearchData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static gboolean
mouse_fuse_real_search_co (MouseFuseSearchData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_free0_);
	_data_->search_results = _data_->_tmp0_;
	_data_->_tmp1_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = g_strdup_printf ("%s → %s", _data_->_tmp2_, _ ("Primary button"));
	_data_->_tmp4_ = g_strdup ("clicking");
	g_hash_table_insert (_data_->search_results, _data_->_tmp3_, _data_->_tmp4_);
	_data_->_tmp5_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp6_ = _data_->_tmp5_;
	_data_->_tmp7_ = g_strdup_printf ("%s → %s", _data_->_tmp6_, _ ("Mouse"));
	_data_->_tmp8_ = g_strdup ("mouse");
	g_hash_table_insert (_data_->search_results, _data_->_tmp7_, _data_->_tmp8_);
	_data_->_tmp9_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp10_ = _data_->_tmp9_;
	_data_->_tmp11_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp10_, _ ("Mouse"), _ ("Pointer speed"));
	_data_->_tmp12_ = g_strdup ("mouse");
	g_hash_table_insert (_data_->search_results, _data_->_tmp11_, _data_->_tmp12_);
	_data_->_tmp13_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp14_ = _data_->_tmp13_;
	_data_->_tmp15_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp14_, _ ("Mouse"), _ ("Pointer acceleration"));
	_data_->_tmp16_ = g_strdup ("mouse");
	g_hash_table_insert (_data_->search_results, _data_->_tmp15_, _data_->_tmp16_);
	_data_->_tmp17_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp18_ = _data_->_tmp17_;
	_data_->_tmp19_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp18_, _ ("Mouse"), _ ("Natural scrolling"));
	_data_->_tmp20_ = g_strdup ("mouse");
	g_hash_table_insert (_data_->search_results, _data_->_tmp19_, _data_->_tmp20_);
	_data_->result = _data_->search_results;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
mouse_fuse_class_init (MouseFuseClass * klass,
                       gpointer klass_data)
{
	GSettings* _tmp0_;
	mouse_fuse_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &MouseFuse_private_offset);
	((FuseboxFuseClass *) klass)->get_widget = (GtkWidget* (*) (FuseboxFuse*)) mouse_fuse_real_get_widget;
	((FuseboxFuseClass *) klass)->shown = (void (*) (FuseboxFuse*)) mouse_fuse_real_shown;
	((FuseboxFuseClass *) klass)->hidden = (void (*) (FuseboxFuse*)) mouse_fuse_real_hidden;
	((FuseboxFuseClass *) klass)->search_callback = (void (*) (FuseboxFuse*, const gchar*)) mouse_fuse_real_search_callback;
	((FuseboxFuseClass *) klass)->search = (void (*) (FuseboxFuse*, const gchar*, GAsyncReadyCallback, gpointer)) mouse_fuse_real_search;
	((FuseboxFuseClass *) klass)->search_finish = (GHashTable* (*) (FuseboxFuse*, GAsyncResult*)) mouse_fuse_search_finish;
	G_OBJECT_CLASS (klass)->finalize = mouse_fuse_finalize;
	_tmp0_ = g_settings_new ("org.freedesktop.ibus.general");
	_g_object_unref0 (mouse_fuse_ibus_general_settings);
	mouse_fuse_ibus_general_settings = _tmp0_;
}

static void
mouse_fuse_instance_init (MouseFuse * self,
                          gpointer klass)
{
	self->priv = mouse_fuse_get_instance_private (self);
}

static void
mouse_fuse_finalize (GObject * obj)
{
	MouseFuse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, MOUSE_TYPE_FUSE, MouseFuse);
	_g_object_unref0 (self->priv->main_grid);
	_g_object_unref0 (self->priv->stack);
	G_OBJECT_CLASS (mouse_fuse_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
mouse_fuse_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MouseFuseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) mouse_fuse_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (MouseFuse), 0, (GInstanceInitFunc) mouse_fuse_instance_init, NULL };
	GType mouse_fuse_type_id;
	mouse_fuse_type_id = g_type_register_static (FUSEBOX_TYPE_FUSE, "MouseFuse", &g_define_type_info, 0);
	MouseFuse_private_offset = g_type_add_instance_private (mouse_fuse_type_id, sizeof (MouseFusePrivate));
	return mouse_fuse_type_id;
}

GType
mouse_fuse_get_type (void)
{
	static gsize mouse_fuse_type_id__once = 0;
	if (g_once_init_enter (&mouse_fuse_type_id__once)) {
		GType mouse_fuse_type_id;
		mouse_fuse_type_id = mouse_fuse_get_type_once ();
		g_once_init_leave (&mouse_fuse_type_id__once, mouse_fuse_type_id);
	}
	return mouse_fuse_type_id__once;
}

FuseboxFuse*
get_fuse (GModule* module)
{
	MouseFuse* fuse = NULL;
	MouseFuse* _tmp0_;
	FuseboxFuse* result;
	g_return_val_if_fail (module != NULL, NULL);
	g_debug ("MouseFuse.vala:113: Activating Mouse fuse");
	_tmp0_ = mouse_fuse_new ();
	fuse = _tmp0_;
	result = (FuseboxFuse*) fuse;
	return result;
}

