/* StartupFuse.c generated by valac 0.56.13, the Vala compiler
 * generated from StartupFuse.vala, do not modify */

/*-
 * Copyright (c) 2023 Fyra Labs
 * Copyright (c) 2015-2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 * //////////////////////////////////////////////////////////////////////////
 *
 * Fusebox startup applications fuse (plugin)
 *
 * Author: Pornpipat "Cappy" Popum <cappy@cappuchino.xyz>
 * This file is part of Fusebox.
 *
 * This Fusebox fuse manages startup applications.
 * These startup applications are in XDG autostart format. See
 * https://specifications.freedesktop.org/autostart-spec/autostart-spec-latest.html
 * for more information.
 * This fuse allows users to add, remove and edit startup applications.
 * It also allows the ablity to create a custom startup shortcut with custom commands and arguments.
 *
 * The XDG autostart parser is based on code from elementary OS's Startup Applications plug.
 */

#include "fuse-startup.h"
#include <gtk/gtk.h>
#include "fusebox-1.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <libhelium-1.h>
#include <gmodule.h>

#define STARTUP_FUSE_STARTUP "startup"

enum  {
	STARTUP_FUSE_0_PROPERTY,
	STARTUP_FUSE_NUM_PROPERTIES
};
static GParamSpec* startup_fuse_properties[STARTUP_FUSE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _StartupFuseSearchData StartupFuseSearchData;

struct _StartupFusePrivate {
	GtkGrid* main_grid;
};

struct _StartupFuseSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	StartupFuse* self;
	gchar* search;
	GHashTable* result;
	GHashTable* search_results;
	GHashTable* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
};

static gint StartupFuse_private_offset;
static gpointer startup_fuse_parent_class = NULL;

static void _g_free0_ (gpointer var);
static GtkWidget* startup_fuse_real_get_widget (FuseboxFuse* base);
static void startup_fuse_real_shown (FuseboxFuse* base);
static void startup_fuse_real_hidden (FuseboxFuse* base);
static void startup_fuse_real_search_callback (FuseboxFuse* base,
                                        const gchar* location);
static void startup_fuse_real_search_data_free (gpointer _data);
static void startup_fuse_real_search (FuseboxFuse* base,
                               const gchar* search,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
static gboolean startup_fuse_real_search_co (StartupFuseSearchData* _data_);
static void startup_fuse_finalize (GObject * obj);
static GType startup_fuse_get_type_once (void);

static inline gpointer
startup_fuse_get_instance_private (StartupFuse* self)
{
	return G_STRUCT_MEMBER_P (self, StartupFuse_private_offset);
}

static void
_g_free0_ (gpointer var)
{
	var = (g_free (var), NULL);
}

StartupFuse*
startup_fuse_construct (GType object_type)
{
	StartupFuse * self = NULL;
	GHashTable* settings = NULL;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_free0_);
	settings = _tmp0_;
	_tmp1_ = g_strdup ("startup");
	_tmp2_ = g_strdup (STARTUP_FUSE_STARTUP);
	g_hash_table_insert (settings, _tmp1_, _tmp2_);
	self = (StartupFuse*) g_object_new (object_type, "category", FUSEBOX_FUSE_CATEGORY_SYSTEM, "code-name", "com.fyralabs.Fusebox.Startup", "display-name", _ ("App Autostart"), "description", _ ("Manage applications that start automatically"), "icon", "settings-applications-symbolic", "supported-settings", settings, "index", 6, NULL);
	_g_hash_table_unref0 (settings);
	return self;
}

StartupFuse*
startup_fuse_new (void)
{
	return startup_fuse_construct (STARTUP_TYPE_FUSE);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static GtkWidget*
startup_fuse_real_get_widget (FuseboxFuse* base)
{
	StartupFuse * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp12_;
	GtkWidget* _tmp13_;
	GtkWidget* result;
	self = (StartupFuse*) base;
	_tmp0_ = self->priv->main_grid;
	if (_tmp0_ == NULL) {
		StartupView* startup_view = NULL;
		StartupView* _tmp1_;
		GtkGrid* _tmp2_ = NULL;
		GtkLabel* view_label = NULL;
		GtkLabel* _tmp3_ = NULL;
		GtkLabel* _tmp4_;
		HeAppBar* appbar = NULL;
		GtkLabel* _tmp5_;
		GtkWidget* _tmp6_;
		HeAppBar* _tmp7_ = NULL;
		GtkGrid* _tmp8_;
		HeAppBar* _tmp9_;
		GtkGrid* _tmp10_;
		StartupView* _tmp11_;
		_tmp1_ = startup_view_new ((FuseboxFuse*) self);
		g_object_ref_sink (_tmp1_);
		startup_view = _tmp1_;
		_tmp2_ = (GtkGrid*) gtk_grid_new ();
		gtk_grid_set_row_spacing (_tmp2_, 12);
		g_object_ref_sink (_tmp2_);
		_g_object_unref0 (self->priv->main_grid);
		self->priv->main_grid = _tmp2_;
		_tmp3_ = (GtkLabel*) gtk_label_new ("App Autostart");
		gtk_widget_set_halign ((GtkWidget*) _tmp3_, GTK_ALIGN_START);
		g_object_ref_sink (_tmp3_);
		view_label = _tmp3_;
		_tmp4_ = view_label;
		gtk_widget_add_css_class ((GtkWidget*) _tmp4_, "view-title");
		_tmp5_ = view_label;
		_tmp6_ = _g_object_ref0 ((GtkWidget*) _tmp5_);
		_tmp7_ = he_app_bar_new ();
		he_app_bar_set_viewtitle_widget (_tmp7_, _tmp6_);
		_g_object_unref0 (_tmp6_);
		he_app_bar_set_show_back (_tmp7_, FALSE);
		g_object_ref_sink (_tmp7_);
		appbar = _tmp7_;
		_tmp8_ = self->priv->main_grid;
		_tmp9_ = appbar;
		gtk_grid_attach (_tmp8_, (GtkWidget*) _tmp9_, 0, 0, 1, 1);
		_tmp10_ = self->priv->main_grid;
		_tmp11_ = startup_view;
		gtk_grid_attach (_tmp10_, (GtkWidget*) _tmp11_, 0, 1, 1, 1);
		_g_object_unref0 (appbar);
		_g_object_unref0 (view_label);
		_g_object_unref0 (startup_view);
	}
	_tmp12_ = self->priv->main_grid;
	_tmp13_ = _g_object_ref0 ((GtkWidget*) _tmp12_);
	result = _tmp13_;
	return result;
}

static void
startup_fuse_real_shown (FuseboxFuse* base)
{
	StartupFuse * self;
	self = (StartupFuse*) base;
}

static void
startup_fuse_real_hidden (FuseboxFuse* base)
{
	StartupFuse * self;
	self = (StartupFuse*) base;
}

static void
startup_fuse_real_search_callback (FuseboxFuse* base,
                                   const gchar* location)
{
	StartupFuse * self;
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
	self = (StartupFuse*) base;
	g_return_if_fail (location != NULL);
	_tmp0_ = location;
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
}

static void
startup_fuse_real_search_data_free (gpointer _data)
{
	StartupFuseSearchData* _data_;
	_data_ = _data;
	_g_free0 (_data_->search);
	_g_hash_table_unref0 (_data_->result);
	_g_object_unref0 (_data_->self);
	g_slice_free (StartupFuseSearchData, _data_);
}

static void
startup_fuse_real_search (FuseboxFuse* base,
                          const gchar* search,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	StartupFuse * self;
	StartupFuseSearchData* _data_;
	StartupFuse* _tmp0_;
	gchar* _tmp1_;
	g_return_if_fail (search != NULL);
	self = (StartupFuse*) base;
	_data_ = g_slice_new0 (StartupFuseSearchData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, startup_fuse_real_search_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	_tmp1_ = g_strdup (search);
	_g_free0 (_data_->search);
	_data_->search = _tmp1_;
	startup_fuse_real_search_co (_data_);
}

static GHashTable*
startup_fuse_search_finish (FuseboxFuse* base,
                            GAsyncResult* _res_)
{
	GHashTable* result;
	StartupFuseSearchData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
	result = _data_->result;
	_data_->result = NULL;
	return result;
}

static gboolean
startup_fuse_real_search_co (StartupFuseSearchData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->_tmp0_ = g_hash_table_new_full (NULL, NULL, _g_free0_, _g_free0_);
	_data_->search_results = _data_->_tmp0_;
	_data_->_tmp1_ = fusebox_fuse_get_display_name ((FuseboxFuse*) _data_->self);
	_data_->_tmp2_ = _data_->_tmp1_;
	_data_->_tmp3_ = g_strdup_printf ("%s → %s", _data_->_tmp2_, _ ("Startup"));
	_data_->_tmp4_ = g_strdup (STARTUP_FUSE_STARTUP);
	g_hash_table_insert (_data_->search_results, _data_->_tmp3_, _data_->_tmp4_);
	_data_->result = _data_->search_results;
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

static void
startup_fuse_class_init (StartupFuseClass * klass,
                         gpointer klass_data)
{
	startup_fuse_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &StartupFuse_private_offset);
	((FuseboxFuseClass *) klass)->get_widget = (GtkWidget* (*) (FuseboxFuse*)) startup_fuse_real_get_widget;
	((FuseboxFuseClass *) klass)->shown = (void (*) (FuseboxFuse*)) startup_fuse_real_shown;
	((FuseboxFuseClass *) klass)->hidden = (void (*) (FuseboxFuse*)) startup_fuse_real_hidden;
	((FuseboxFuseClass *) klass)->search_callback = (void (*) (FuseboxFuse*, const gchar*)) startup_fuse_real_search_callback;
	((FuseboxFuseClass *) klass)->search = (void (*) (FuseboxFuse*, const gchar*, GAsyncReadyCallback, gpointer)) startup_fuse_real_search;
	((FuseboxFuseClass *) klass)->search_finish = (GHashTable* (*) (FuseboxFuse*, GAsyncResult*)) startup_fuse_search_finish;
	G_OBJECT_CLASS (klass)->finalize = startup_fuse_finalize;
}

static void
startup_fuse_instance_init (StartupFuse * self,
                            gpointer klass)
{
	self->priv = startup_fuse_get_instance_private (self);
}

static void
startup_fuse_finalize (GObject * obj)
{
	StartupFuse * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, STARTUP_TYPE_FUSE, StartupFuse);
	_g_object_unref0 (self->priv->main_grid);
	G_OBJECT_CLASS (startup_fuse_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
startup_fuse_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (StartupFuseClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) startup_fuse_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (StartupFuse), 0, (GInstanceInitFunc) startup_fuse_instance_init, NULL };
	GType startup_fuse_type_id;
	startup_fuse_type_id = g_type_register_static (FUSEBOX_TYPE_FUSE, "StartupFuse", &g_define_type_info, 0);
	StartupFuse_private_offset = g_type_add_instance_private (startup_fuse_type_id, sizeof (StartupFusePrivate));
	return startup_fuse_type_id;
}

GType
startup_fuse_get_type (void)
{
	static gsize startup_fuse_type_id__once = 0;
	if (g_once_init_enter (&startup_fuse_type_id__once)) {
		GType startup_fuse_type_id;
		startup_fuse_type_id = startup_fuse_get_type_once ();
		g_once_init_leave (&startup_fuse_type_id__once, startup_fuse_type_id);
	}
	return startup_fuse_type_id__once;
}

FuseboxFuse*
get_fuse (GModule* module)
{
	StartupFuse* fuse = NULL;
	StartupFuse* _tmp0_;
	FuseboxFuse* result;
	g_return_val_if_fail (module != NULL, NULL);
	g_debug ("StartupFuse.vala:100: Activating Startup Fuse");
	_tmp0_ = startup_fuse_new ();
	fuse = _tmp0_;
	result = (FuseboxFuse*) fuse;
	return result;
}

