/* Utils.c generated by valac 0.56.13, the Vala compiler
 * generated from Utils.vala, do not modify */

/*-
 * Copyright (c) 2023 Fyra Labs
 * Copyright (c) 2015-2016 elementary LLC.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include "fuse-startup.h"
#include <glib/gstdio.h>
#include <gio/gio.h>
#include <glib-object.h>

#define STARTUP_UTILS_AUTOSTART_DIR "autostart"

#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR (startup_backend_desktop_file_enumerator_get_type ())
#define STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumerator))
#define STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumeratorClass))
#define STARTUP_BACKEND_IS_DESKTOP_FILE_ENUMERATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR))
#define STARTUP_BACKEND_IS_DESKTOP_FILE_ENUMERATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR))
#define STARTUP_BACKEND_DESKTOP_FILE_ENUMERATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), STARTUP_BACKEND_TYPE_DESKTOP_FILE_ENUMERATOR, StartupBackendDesktopFileEnumeratorClass))

typedef struct _StartupBackendDesktopFileEnumerator StartupBackendDesktopFileEnumerator;
typedef struct _StartupBackendDesktopFileEnumeratorClass StartupBackendDesktopFileEnumeratorClass;

VALA_EXTERN GType startup_backend_desktop_file_enumerator_get_type (void) G_GNUC_CONST ;
VALA_EXTERN StartupBackendDesktopFileEnumerator* startup_backend_desktop_file_enumerator_new (gchar** dirs,
                                                                                  gint dirs_length1);
VALA_EXTERN StartupBackendDesktopFileEnumerator* startup_backend_desktop_file_enumerator_construct (GType object_type,
                                                                                        gchar** dirs,
                                                                                        gint dirs_length1);
VALA_EXTERN gchar** startup_backend_desktop_file_enumerator_get_desktop_files (StartupBackendDesktopFileEnumerator* self,
                                                                   gint* result_length1);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

gchar*
startup_utils_get_autostart_dir (void)
{
	gchar* config_dir = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* startup_dir = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GError* _inner_error0_ = NULL;
	gchar* result;
	_tmp0_ = g_get_user_config_dir ();
	_tmp1_ = g_strdup (_tmp0_);
	config_dir = _tmp1_;
	_tmp2_ = config_dir;
	_tmp3_ = g_build_filename (_tmp2_, STARTUP_UTILS_AUTOSTART_DIR, NULL);
	startup_dir = _tmp3_;
	_tmp4_ = startup_dir;
	if (g_file_test (_tmp4_, G_FILE_TEST_EXISTS) == FALSE) {
		GFile* file = NULL;
		const gchar* _tmp5_;
		GFile* _tmp6_;
		_tmp5_ = startup_dir;
		_tmp6_ = g_file_new_for_path (_tmp5_);
		file = _tmp6_;
		{
			GFile* _tmp7_;
			_tmp7_ = file;
			g_file_make_directory_with_parents (_tmp7_, NULL, &_inner_error0_);
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				goto __catch0_g_error;
			}
		}
		goto __finally0;
		__catch0_g_error:
		{
			GError* e = NULL;
			GError* _tmp8_;
			const gchar* _tmp9_;
			e = _inner_error0_;
			_inner_error0_ = NULL;
			_tmp8_ = e;
			_tmp9_ = _tmp8_->message;
			g_warning ("Utils.vala:32: %s", _tmp9_);
			_g_error_free0 (e);
		}
		__finally0:
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			_g_object_unref0 (file);
			_g_free0 (startup_dir);
			_g_free0 (config_dir);
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
			g_clear_error (&_inner_error0_);
			return NULL;
		}
		_g_object_unref0 (file);
	}
	result = startup_dir;
	_g_free0 (config_dir);
	return result;
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (needle != NULL, FALSE);
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
	result = _tmp0_ != NULL;
	return result;
}

gboolean
startup_utils_is_desktop_file (const gchar* name)
{
	gboolean _tmp0_ = FALSE;
	gboolean result;
	g_return_val_if_fail (name != NULL, FALSE);
	if (!string_contains (name, "~")) {
		_tmp0_ = g_str_has_suffix (name, ".desktop");
	} else {
		_tmp0_ = FALSE;
	}
	result = _tmp0_;
	return result;
}

gchar**
startup_utils_get_autostart_files (gint* result_length1)
{
	gchar* startup_dir = NULL;
	gchar* _tmp0_;
	StartupBackendDesktopFileEnumerator* enumerator = NULL;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	gint _tmp3__length1;
	StartupBackendDesktopFileEnumerator* _tmp4_;
	StartupBackendDesktopFileEnumerator* _tmp5_;
	gint _tmp6_ = 0;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gchar** result;
	_tmp0_ = startup_utils_get_autostart_dir ();
	startup_dir = _tmp0_;
	_tmp1_ = g_strdup (startup_dir);
	_tmp2_ = g_new0 (gchar*, 1 + 1);
	_tmp2_[0] = _tmp1_;
	_tmp3_ = _tmp2_;
	_tmp3__length1 = 1;
	_tmp4_ = startup_backend_desktop_file_enumerator_new (_tmp3_, 1);
	_tmp5_ = _tmp4_;
	_tmp3_ = (_vala_array_free (_tmp3_, _tmp3__length1, (GDestroyNotify) g_free), NULL);
	enumerator = _tmp5_;
	_tmp7_ = startup_backend_desktop_file_enumerator_get_desktop_files (enumerator, &_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp8__length1 = _tmp6_;
	if (result_length1) {
		*result_length1 = _tmp8__length1;
	}
	result = _tmp8_;
	_g_object_unref0 (enumerator);
	_g_free0 (startup_dir);
	return result;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

