/* FusesManager.c generated by valac 0.56.13, the Vala compiler
 * generated from FusesManager.vala, do not modify */

/*-
 * Copyright (c) 2022 Fyra Labs
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Library General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "fusebox-1.h"
#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include "config.h"
#include <stdlib.h>
#include <string.h>
#include <gmodule.h>

enum  {
	FUSEBOX_FUSES_MANAGER_0_PROPERTY,
	FUSEBOX_FUSES_MANAGER_NUM_PROPERTIES
};
static GParamSpec* fusebox_fuses_manager_properties[FUSEBOX_FUSES_MANAGER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_module_close0(var) ((var == NULL) ? NULL : (var = (g_module_close (var), NULL)))
typedef FuseboxFuse* (*FuseboxFusesManagerRegisterPluginFunction) (GModule* module);
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	FUSEBOX_FUSES_MANAGER_FUSE_ADDED_SIGNAL,
	FUSEBOX_FUSES_MANAGER_NUM_SIGNALS
};
static guint fusebox_fuses_manager_signals[FUSEBOX_FUSES_MANAGER_NUM_SIGNALS] = {0};

struct _FuseboxFusesManagerPrivate {
	GList* fuses;
};

static gint FuseboxFusesManager_private_offset;
static gpointer fusebox_fuses_manager_parent_class = NULL;
static FuseboxFusesManager* fusebox_fuses_manager_fuses_manager;
static FuseboxFusesManager* fusebox_fuses_manager_fuses_manager = NULL;

static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static FuseboxFusesManager* fusebox_fuses_manager_new (void);
static FuseboxFusesManager* fusebox_fuses_manager_construct (GType object_type);
static void fusebox_fuses_manager_find_fuseins (FuseboxFusesManager* self,
                                         GFile* base_folder);
static void fusebox_fuses_manager_load (FuseboxFusesManager* self,
                                 const gchar* path);
static void fusebox_fuses_manager_register_fuse (FuseboxFusesManager* self,
                                          FuseboxFuse* fuse);
static void fusebox_fuses_manager_finalize (GObject * obj);
static GType fusebox_fuses_manager_get_type_once (void);

static inline gpointer
fusebox_fuses_manager_get_instance_private (FuseboxFusesManager* self)
{
	return G_STRUCT_MEMBER_P (self, FuseboxFusesManager_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

FuseboxFusesManager*
fusebox_fuses_manager_get_default (void)
{
	FuseboxFusesManager* _tmp0_;
	FuseboxFusesManager* _tmp2_;
	FuseboxFusesManager* _tmp3_;
	FuseboxFusesManager* result;
	_tmp0_ = fusebox_fuses_manager_fuses_manager;
	if (_tmp0_ == NULL) {
		FuseboxFusesManager* _tmp1_;
		_tmp1_ = fusebox_fuses_manager_new ();
		_g_object_unref0 (fusebox_fuses_manager_fuses_manager);
		fusebox_fuses_manager_fuses_manager = _tmp1_;
	}
	_tmp2_ = fusebox_fuses_manager_fuses_manager;
	_tmp3_ = _g_object_ref0 (_tmp2_);
	result = _tmp3_;
	return result;
}

static FuseboxFusesManager*
fusebox_fuses_manager_construct (GType object_type)
{
	FuseboxFusesManager * self = NULL;
	GFile* base_folder = NULL;
	GFile* _tmp0_;
	self = (FuseboxFusesManager*) g_object_new (object_type, NULL);
	(self->priv->fuses == NULL) ? NULL : (self->priv->fuses = (_g_list_free__g_object_unref0_ (self->priv->fuses), NULL));
	self->priv->fuses = NULL;
	_tmp0_ = g_file_new_for_path (FUSES_DIR);
	base_folder = _tmp0_;
	fusebox_fuses_manager_find_fuseins (self, base_folder);
	_g_object_unref0 (base_folder);
	return self;
}

static FuseboxFusesManager*
fusebox_fuses_manager_new (void)
{
	return fusebox_fuses_manager_construct (FUSEBOX_TYPE_FUSES_MANAGER);
}

static void
fusebox_fuses_manager_load (FuseboxFusesManager* self,
                            const gchar* path)
{
	GModule* module = NULL;
	GModule* _tmp0_;
	GModule* _tmp1_;
	void* function = NULL;
	GModule* _tmp3_;
	void* _tmp4_ = NULL;
	void* _tmp5_;
	FuseboxFusesManagerRegisterPluginFunction register_fusein = NULL;
	void* _tmp6_;
	FuseboxFuse* fuse = NULL;
	FuseboxFusesManagerRegisterPluginFunction _tmp7_;
	GModule* _tmp8_;
	FuseboxFuse* _tmp9_;
	FuseboxFuse* _tmp10_;
	GModule* _tmp11_;
	FuseboxFuse* _tmp12_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (path != NULL);
	if (g_module_supported () == FALSE) {
		g_error ("FusesManager.vala:43: Fusebox is not supported by this system!");
	}
	_tmp0_ = g_module_open (path, G_MODULE_BIND_LAZY);
	module = _tmp0_;
	_tmp1_ = module;
	if (_tmp1_ == NULL) {
		const gchar* _tmp2_;
		_tmp2_ = g_module_error ();
		g_critical ("FusesManager.vala:48: %s", _tmp2_);
		_g_module_close0 (module);
		return;
	}
	_tmp3_ = module;
	g_module_symbol (_tmp3_, "get_fuse", &_tmp4_);
	function = _tmp4_;
	_tmp5_ = function;
	if (_tmp5_ == NULL) {
		g_critical ("FusesManager.vala:55: get_fuse () not found in %s", path);
		_g_module_close0 (module);
		return;
	}
	_tmp6_ = function;
	register_fusein = (FuseboxFusesManagerRegisterPluginFunction) _tmp6_;
	_tmp7_ = register_fusein;
	_tmp8_ = module;
	_tmp9_ = _tmp7_ (_tmp8_);
	fuse = _tmp9_;
	_tmp10_ = fuse;
	if (_tmp10_ == NULL) {
		g_critical ("FusesManager.vala:62: Unknown fusein type for %s !", path);
		_g_object_unref0 (fuse);
		_g_module_close0 (module);
		return;
	}
	_tmp11_ = module;
	g_module_make_resident (_tmp11_);
	_tmp12_ = fuse;
	fusebox_fuses_manager_register_fuse (self, _tmp12_);
	_g_object_unref0 (fuse);
	_g_module_close0 (module);
}

static void
fusebox_fuses_manager_find_fuseins (FuseboxFusesManager* self,
                                    GFile* base_folder)
{
	GFileInfo* file_info = NULL;
	GError* _inner_error0_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (base_folder != NULL);
	file_info = NULL;
	{
		GFileEnumerator* enumerator = NULL;
		GFileEnumerator* _tmp0_;
		_tmp0_ = g_file_enumerate_children (base_folder, G_FILE_ATTRIBUTE_STANDARD_NAME "," G_FILE_ATTRIBUTE_STANDARD_TYPE "," G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE, 0, NULL, &_inner_error0_);
		enumerator = _tmp0_;
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		while (TRUE) {
			GFileInfo* _tmp1_ = NULL;
			GFileEnumerator* _tmp2_;
			GFileInfo* _tmp3_;
			GFileInfo* _tmp4_;
			GFileInfo* _tmp5_;
			GFile* file = NULL;
			GFileInfo* _tmp6_;
			const gchar* _tmp7_;
			GFile* _tmp8_;
			gboolean _tmp9_ = FALSE;
			GFileInfo* _tmp10_;
			_tmp2_ = enumerator;
			_tmp3_ = g_file_enumerator_next_file (_tmp2_, NULL, &_inner_error0_);
			_tmp1_ = _tmp3_;
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
				_g_object_unref0 (enumerator);
				goto __catch0_g_error;
			}
			_tmp4_ = _tmp1_;
			_tmp1_ = NULL;
			_g_object_unref0 (file_info);
			file_info = _tmp4_;
			_tmp5_ = file_info;
			if (!(_tmp5_ != NULL)) {
				_g_object_unref0 (_tmp1_);
				break;
			}
			_tmp6_ = file_info;
			_tmp7_ = g_file_info_get_name (_tmp6_);
			_tmp8_ = g_file_get_child (base_folder, _tmp7_);
			file = _tmp8_;
			_tmp10_ = file_info;
			if (g_file_info_get_file_type (_tmp10_) == G_FILE_TYPE_REGULAR) {
				GFileInfo* _tmp11_;
				const gchar* _tmp12_;
				_tmp11_ = file_info;
				_tmp12_ = g_file_info_get_content_type (_tmp11_);
				_tmp9_ = g_content_type_equals (_tmp12_, "application/x-sharedlib");
			} else {
				_tmp9_ = FALSE;
			}
			if (_tmp9_) {
				gchar* path = NULL;
				GFile* _tmp13_;
				gchar* _tmp14_;
				const gchar* _tmp15_;
				_tmp13_ = file;
				_tmp14_ = g_file_get_path (_tmp13_);
				path = _tmp14_;
				_tmp15_ = path;
				if (g_str_has_suffix (_tmp15_, G_MODULE_SUFFIX)) {
					const gchar* _tmp16_;
					_tmp16_ = path;
					fusebox_fuses_manager_load (self, _tmp16_);
				}
				_g_free0 (path);
			} else {
				GFileInfo* _tmp17_;
				_tmp17_ = file_info;
				if (g_file_info_get_file_type (_tmp17_) == G_FILE_TYPE_DIRECTORY) {
					GFile* _tmp18_;
					_tmp18_ = file;
					fusebox_fuses_manager_find_fuseins (self, _tmp18_);
				}
			}
			_g_object_unref0 (file);
			_g_object_unref0 (_tmp1_);
		}
		_g_object_unref0 (enumerator);
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* err = NULL;
		gchar* _tmp19_;
		gchar* _tmp20_;
		GError* _tmp21_;
		const gchar* _tmp22_;
		err = _inner_error0_;
		_inner_error0_ = NULL;
		_tmp19_ = g_file_get_path (base_folder);
		_tmp20_ = _tmp19_;
		_tmp21_ = err;
		_tmp22_ = _tmp21_->message;
		g_warning ("FusesManager.vala:86: Unable to scan fuses folder %s: %s\n", _tmp20_, _tmp22_);
		_g_free0 (_tmp20_);
		_g_error_free0 (err);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
		_g_object_unref0 (file_info);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
		g_clear_error (&_inner_error0_);
		return;
	}
	_g_object_unref0 (file_info);
}

static void
fusebox_fuses_manager_register_fuse (FuseboxFusesManager* self,
                                     FuseboxFuse* fuse)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GList* _tmp2_;
	GList* _tmp3_;
	FuseboxFuse* _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (fuse != NULL);
	_tmp0_ = fusebox_fuse_get_code_name (fuse);
	_tmp1_ = _tmp0_;
	g_debug ("FusesManager.vala:91: %s registered", _tmp1_);
	_tmp2_ = self->priv->fuses;
	_tmp3_ = g_list_find (_tmp2_, fuse);
	if (_tmp3_ != NULL) {
		return;
	}
	_tmp4_ = _g_object_ref0 (fuse);
	self->priv->fuses = g_list_append (self->priv->fuses, _tmp4_);
	g_signal_emit (self, fusebox_fuses_manager_signals[FUSEBOX_FUSES_MANAGER_FUSE_ADDED_SIGNAL], 0, fuse);
}

gboolean
fusebox_fuses_manager_has_fuses (FuseboxFusesManager* self)
{
	GList* _tmp0_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->fuses;
	result = g_list_length (_tmp0_) != ((guint) 0);
	return result;
}

GList*
fusebox_fuses_manager_get_fuses (FuseboxFusesManager* self)
{
	GList* _tmp0_;
	GList* result;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->fuses;
	result = _tmp0_;
	return result;
}

static void
fusebox_fuses_manager_class_init (FuseboxFusesManagerClass * klass,
                                  gpointer klass_data)
{
	fusebox_fuses_manager_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &FuseboxFusesManager_private_offset);
	G_OBJECT_CLASS (klass)->finalize = fusebox_fuses_manager_finalize;
	fusebox_fuses_manager_signals[FUSEBOX_FUSES_MANAGER_FUSE_ADDED_SIGNAL] = g_signal_new ("fuse-added", FUSEBOX_TYPE_FUSES_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, FUSEBOX_TYPE_FUSE);
}

static void
fusebox_fuses_manager_instance_init (FuseboxFusesManager * self,
                                     gpointer klass)
{
	self->priv = fusebox_fuses_manager_get_instance_private (self);
}

static void
fusebox_fuses_manager_finalize (GObject * obj)
{
	FuseboxFusesManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FUSEBOX_TYPE_FUSES_MANAGER, FuseboxFusesManager);
	(self->priv->fuses == NULL) ? NULL : (self->priv->fuses = (_g_list_free__g_object_unref0_ (self->priv->fuses), NULL));
	G_OBJECT_CLASS (fusebox_fuses_manager_parent_class)->finalize (obj);
}

 G_GNUC_NO_INLINE static GType
fusebox_fuses_manager_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FuseboxFusesManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) fusebox_fuses_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FuseboxFusesManager), 0, (GInstanceInitFunc) fusebox_fuses_manager_instance_init, NULL };
	GType fusebox_fuses_manager_type_id;
	fusebox_fuses_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "FuseboxFusesManager", &g_define_type_info, 0);
	FuseboxFusesManager_private_offset = g_type_add_instance_private (fusebox_fuses_manager_type_id, sizeof (FuseboxFusesManagerPrivate));
	return fusebox_fuses_manager_type_id;
}

GType
fusebox_fuses_manager_get_type (void)
{
	static gsize fusebox_fuses_manager_type_id__once = 0;
	if (g_once_init_enter (&fusebox_fuses_manager_type_id__once)) {
		GType fusebox_fuses_manager_type_id;
		fusebox_fuses_manager_type_id = fusebox_fuses_manager_get_type_once ();
		g_once_init_leave (&fusebox_fuses_manager_type_id__once, fusebox_fuses_manager_type_id);
	}
	return fusebox_fuses_manager_type_id__once;
}

